# SmallCollections.jl

This package offers vector, set and dictionary types that can hold
any number of elements up to some (small) limit. Most of these types come
in a mutable and an immutable version. With bit type elements, the immutable
versions don't allocate. The mutable ones usually require bit type elements
for full functionality.
This approach leads to significant speed-ups compared to the standard types.
For example, the performance of the vector types `SmallVector` and `MutableSmallVector`
is close to that to `SVector` and `MVector` from
[StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl).
The most extreme performance gain is with `SmallBitSet`, which can be 100x faster than `BitSet`.
(The exact speed-ups depend much on your processor.)

**Note:** The former submodule `Combinatorics` has been turned into the separate package
[SmallCombinatorics.jl](https://github.com/matthias314/SmallCombinatorics.jl).

The full documentation for `SmallCollections` is available
[here](https://matthias314.github.io/SmallCollections.jl/).

## New types

### `(Mutable)SmallVector` and `(Mutable)FixedVector`

The types
[`SmallVector{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/capacityvector/#SmallCollections.SmallVector)
and
[`MutableSmallVector{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/capacityvector/#SmallCollections.MutableSmallVector)
can hold up to `N` elements of type `T`.
In many cases they are almost as fast as fixed-length vectors.
Internally, these types use fixed-length vectors and fill the unused elements with some
[`default`](https://matthias314.github.io/SmallCollections.jl/stable/nonexported/#SmallCollections.default)
value. The underlying types
[`FixedVector{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/fixedvector/#SmallCollections.FixedVector)
and
[`MutableFixedVector{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/fixedvector/#SmallCollections.MutableFixedVector)
store exactly `N` elements of type `T`.
Up to a few implementation details, they are analogous to `SVector` and `MVector`.
(However, broadcasting with assignment is currently much faster for `MutableSmallVector` than for `MVector`.)

<details>
<summary>Benchmarks for <code>(Mutable)SmallVector</code> and <code>(Mutable)FixedVector</code></summary>

The timings are for **1000** operations of the given type on vectors having between 1 and 31 elements
(or exactly 32 elements for fixed-length vectors). If possible, mutating operations were used.

| `N = 32`, `T = Int16` | `v + w` | `v .+= w` |`sum` | `push(!)` | `count(>(c), v)` |
| --- | --- | --- | --- | --- | --- |
| `Vector{T}` | 45.893 μs | 20.441 μs | 8.403 μs | 5.104 μs | 9.860 μs |
| `MVector{N,T}` | 5.770 μs | 19.196 μs | 2.370 μs | 9.866 μs | 2.801 μs |
| **`MutableFixedVector{N,T}`** | 2.932 μs | 4.494 μs | 3.086 μs | n/a | 1.492 μs |
| **`MutableSmallVector{N,T}`** | 3.276 μs | 4.975 μs | 2.977 μs | 3.154 μs | 1.871 μs |
| `SVector{N,T}` | 1.979 μs | n/a | 1.396 μs | 1.988 μs | 1.218 μs |
| **`FixedVector{N,T}`** | 2.054 μs | n/a | 2.661 μs | n/a | 1.217 μs |
| **`SmallVector{N,T}`** | 2.517 μs | n/a | 2.661 μs | 6.408 μs | 1.617 μs |

Notes: `sum` for `SVector` and `MVector` returns an `Int16` instead of `Int`. `SmallCollections`
has a separate function `sum_fast` for this. Addition allocates for `Vector`. To avoid this for
`MVector`, the result was transformed to `SVector`. `push!` for `MVector` and `push` for `SVector`
are not directly comparable to the others because they change the type of the returned vector,
which leads to type instabilities in cases like loops.

For the benchmark code see the file `benchmark/benchmark_vec.jl` in the repository.

</details>

How broadcasting or functions like
[`map`](https://matthias314.github.io/SmallCollections.jl/stable/capacityvector/#Base.map)
or
[`any`](https://matthias314.github.io/SmallCollections.jl/stable/capacityvector/#Base.any-Tuple{Function,%20AbstractSmallVector})
deal with default values for a `(Mutable)SmallVector` is governed by a trait called
[`MapStyle`](https://matthias314.github.io/SmallCollections.jl/stable/nonexported/#SmallCollections.MapStyle).
Except for broadcasting one can override the automatically chosen style.

### `PackedVector`

A
[`PackedVector{U,M,T}`](https://matthias314.github.io/SmallCollections.jl/stable/capacityvector/#SmallCollections.PackedVector)
uses the unsigned integer type `U` to store integers with `M` bits,
which to the outside appear as having integer type `T`. For example, a `PackedVector{UInt128,5,Int8}`
can store `25` (`128÷5`) signed integers with `5` bits. When retrieving them, they are of type `Int8`.
Indexing and algebraic operations are usually slower for `PackedVector` than for `SmallVector`,
while `push`/`pushfirst` and `pop`/`popfirst` may be faster.

### `(Mutable)SmallSet` and `SmallBitSet`

The types
[`SmallSet{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/smallset/#SmallCollections.SmallSet)
and
[`MutableSmallSet{N,T}`](https://matthias314.github.io/SmallCollections.jl/stable/smallset/#SmallCollections.MutableSmallSet)
 can hold up to `N` elements of type `T`. The type
[`SmallBitSet{U}`](https://matthias314.github.io/SmallCollections.jl/stable/smallbitset/#SmallCollections.SmallBitSet)
can hold integers between `1` and `M` where `M` is the bit size of the unsigned integer type `U`
(taken to be `UInt` if omitted).
For small integers, `MutableSmallSet` is as fast (or even faster than) `BitSet`.
`SmallBitSet` can be up to 100x faster than `BitSet`.

<details>
<summary>Benchmarks for <code>SmallSet</code>, <code>MutableSmallSet</code> and <code>SmallBitSet</code></summary>

The timings are for **1000** operations of the given type on sets having between 1 and 8 elements.
If possible, mutating operations were used.
Note that while a `BitSet` can hold arbitrarily many elements, the timings for `MutableSmallSet`
wouldn't change if the elements were drawn from `Int16` without restrictions.

| `N = 16`, `T = Int16` | `push(!)` | `intersect(!)` | `issubset` | `in` |
| --- | --- | --- | --- | --- |
| `Set{T}` | 15.669 μs | 88.370 μs | 23.482 μs | 1.610 μs |
| `MutableSmallSet{N,T}` | 8.269 μs | 14.422 μs | 4.357 μs | 1.658 μs |
| `SmallSet{N,T}` | 12.688 μs | 15.011 μs | 10.234 μs | 2.122 μs |
| `BitSet` | 17.481 μs | 23.403 μs | 7.407 μs | 1.836 μs |
| `SmallBitSet{UInt16}` | 1.377 μs | 31.240 **ns** | 56.226 **ns** | 1.067 μs |

For the benchmark code see the file `benchmark/benchmark_set.jl` in the repository.

</details>

### `(Mutable)SmallDict`

The types
[`SmallDict{N,K,V}`](https://matthias314.github.io/SmallCollections.jl/stable/smalldict/#SmallCollections.SmallDict)
and
[`MutableSmallDict{N,K,V}`](https://matthias314.github.io/SmallCollections.jl/stable/smalldict/#SmallCollections.MutableSmallDict)
can hold up to `N` entries with key type `K` and value type `V`.

Operations for `MutableSmallDict` are typically faster than for `Dict`.
For `SmallDict` this holds often, but not always.
Since keys and values are stored as small vectors, inverse lookup with
[`invget`](https://matthias314.github.io/SmallCollections.jl/stable/smalldict/#SmallCollections.invget)
should be as fast as regular lookup.

<details>
<summary>Benchmarks for <code>SmallDict</code> and <code>MutableSmallDict</code></summary>

The timings are for **1000** operations of the given type on dictionaries created with 30
randomly chosen key-value pairs. If possible, mutating operations were used.

| `N = 32`, `K = V = Int8` | `getindex` | `invget` | `setindex(!)` | `pop(!)` | `iterate` |
| --- | --- | --- | --- | --- | --- |
| `Dict{K,V}` | 10.799 μs | n/a | 26.992 μs | 18.931 μs | 404.342 μs |
| `MutableSmallDict{N,K,V}` | 4.273 μs | 5.325 μs | 8.900 μs | 7.213 μs | 17.104 μs |
| `SmallDict{N,K,V}` | 1.856 μs | 8.775 μs | 9.823 | 20.368 μs | 15.840 μs |

Note: For `SmallDict`, `invget` appears much slower than `getindex` in this benchmark.
(This started with commit [#8f6b498](https://github.com/matthias314/SmallCollections.jl/commit/8f6b4987dfeca26297a4d98a0a5b068c6ae74886).)
I don't know the reason for this. The code shown by `@code_native` for these two functions looks identical,
and the timings for a single call to `getindex` and `invget` are identical, too.

For the benchmark code see the file `benchmark/benchmark_dict.jl` in the repository.

</details>

using Base: haslength

import Base:
    copy, copyto!, unsafe_copyto!, resize!, similar,
    strides, elsize, unsafe_convert,
    getindex, setindex!, insert!, deleteat!, pop!, popfirst!, popat!,
    append!, prepend!, push!, pushfirst!, empty, empty!, map!, filter!, replace!,
    circshift!, reverse!

export duplicate!, unsafe_circshift!

# functions also for MutableFixedVector

@inline function unsafe_shl!(v::AbstractVector{T}, N, i, xs::Vararg{Any,M}) where {T,M}
    GC.@preserve v begin
        unsafe_copyto!(pointer(v, i+M), pointer(v, i), (N-(i+M-1)) % UInt)
        unsafe_store!(Ptr{NTuple{M,T}}(pointer(v, i)), xs)
    end
    v
end

@inline function unsafe_shr!(v::AbstractVector{T}, N, i, xs::Vararg{Any,M}) where {T,M}
    GC.@preserve v begin
        unsafe_copyto!(pointer(v, i), pointer(v, i+M), (N-(i+M-1)) % UInt)
        unsafe_store!(Ptr{NTuple{M,T}}(pointer(v, N-M+1)), xs)
    end
    v
end

@inline function insert_pop!(v::MutableFixedVector{N}, i::Integer, xs::Vararg{Any,M}) where {N,M}
    @boundscheck checkbounds(v, i+M-1)
    unsafe_shl!(v, N, i, xs...)
end

@inline function deleteat_push!(v::MutableFixedVector{N}, i::Integer, xs::Vararg{Any,M}) where {N,M}
    @boundscheck checkbounds(v, i+M-1)
    unsafe_shr!(v, N, i, xs...)
end

# MutableSmallVector

export MutableSmallVector

"""
    MutableSmallVector{N,T} <: AbstractSmallVector{N,T}

    MutableSmallVector{N,T}()
    MutableSmallVector{N,T}(iter)
    MutableSmallVector{N}(iter)
    MutableSmallVector(v::PackedVector)
    MutableSmallVector(v::Union{AbstractSmallVector, AbstractFixedVector})

    MutableSmallVector{N,T}(undef, n::Integer)

`MutableSmallVector{N,T}` is a mutable vector type that can hold up to `N` elements of type `T`.
It is the mutable analog of `SmallVector{N,T}`.

Note that setting individual vector elements (via `setindex!`) is only supported for `isbits`
element types.

The special form `MutableSmallVector{N,T}(undef, n)` returns a non-initialized vector of length `n`.

See also [`SmallVector`](@ref), `Base.isbitstype`.
"""
mutable struct MutableSmallVector{N,T} <: AbstractSmallVector{N,T}
    b::FixedVector{N,T}
    n::SmallLength
    MutableSmallVector{N,T}(v::FixedVector{N}, n::Integer) where {N,T} = new{N,T}(v, n % SmallLength)
    global _MutableSmallVector(::Val{N}, ::Type{T}) where {N,T} = new{N,T}()
end

function MutableSmallVector{N,T}(::UndefInitializer, n::Integer) where {N,T}
    0 <= n <= N || error(LazyString("length must be between 0 and ", N))
    v = _MutableSmallVector(Val(N), T)
    for i in n+1:N
        unsafe_setindex!(v, default(T), i)
    end
    v.n = n % SmallLength
    v
end

MutableSmallVector{N,T}(v::AbstractSmallVector{N}) where {N,T} = MutableSmallVector{N,T}(v.b, v.n)

@propagate_inbounds function MutableSmallVector{N,T}(v::AbstractFixedOrSmallVector{M}) where {N,T,M}
    MutableSmallVector{N,T}(SmallVector{N,T}(v))
end

@inline function MutableSmallVector{N,T}(itr) where {N,T}
    isbitstype(T) || return MutableSmallVector(SmallVector{N,T}(itr))
    @boundscheck !haslength(itr) || length(itr) <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    v = MutableSmallVector{N,T}()
    i = 0
    for ix in enumerate(itr)
        i, x = ix
        @boundscheck haslength(itr) || i <= N || error(LazyString("vector cannot have more than ", N, " elements"))
        unsafe_setindex!(v, x, i)
    end
    v.n = i % SmallLength
    v
end

@inline function unsafe_getindex(v::MutableSmallVector, i::Int)
    GC.@preserve v unsafe_load(pointer(v, i))
end

@inline function getindex(v::MutableSmallVector{N,T}, i::Int) where {N,T}
    @boundscheck checkbounds(v, i)
    isbitstype(T) ? unsafe_getindex(v, i) : @inbounds v.b[i]
end

@inline function unsafe_setindex!(v::MutableSmallVector{N,T}, x, i) where {N,T}
    isbitstype(T) || error(LazyString("setindex! is only supported for isbits element types, not for ", T))
    GC.@preserve v unsafe_store!(pointer(v, i), x)
    v
end

@inline function setindex!(v::MutableSmallVector, x, i::Int)
    @boundscheck checkbounds(v, i)
    unsafe_setindex!(v, x, i)
end

copy(v::MutableSmallVector{N,T}) where {N,T} = MutableSmallVector{N,T}(v.b, v.n)

@inline function copyto!(w::MutableSmallVector{N,T}, v::AbstractFixedOrSmallVector) where {N,T}
    if length(v) == length(w)
        u = @inbounds SmallVector{N,T}(v)
        unsafe_copyto!(w, u.b)
    else
        mutablesmallvector_copyto!(w, v)
    end
end

function mutablesmallvector_copyto!(w::MutableSmallVector{N,T}, v::AbstractFixedOrSmallVector) where {N,T}
    @boundscheck length(w) >= length(v) || error("destination vector too short")
    U = sizeof(T) == 1 && N <= typemax(Int8) ? Int8 : SmallLength  # UInt8 leads to poor LLVM IR
    @inbounds u = SmallVector{N,T}(v)
    w.b = ntuple(Val(N % U)) do i
            ifelse(i <= length(v) % U, u.b[i], w.b[i])
    end
    w
end

"""
    unsafe_copyto!(w::MutableSmallVector{N}, v::AbstractSmallVector{N}) where N -> w

Copy the vector `v` to `w`. Both are assumed to have the same length.

See also [`unsafe_copyto!(::MutableSmallVector, ::Union{NTuple, AbstractFixedVector})`](@ref)
"""
@inline function unsafe_copyto!(w::MutableSmallVector{N}, v::AbstractSmallVector{N}) where N
    w.b = v.b
    w
end

"""
    unsafe_copyto!(w::MutableSmallVector, v::NTuple) -> w
    unsafe_copyto!(w::MutableSmallVector, v::AbstractFixedVector) -> w

Copy the vector or tuple `v` to `w`. The length of `w` is not changed.
The elements in `v` past the length of `w` are assumed to be default values.
Moreover, the capacity of `w` must not be smaller than the length of `v`
(`NTuple` case) or the capacity `v` (`AbstractFixedVector` case).

See also [`unsafe_copyto!(::MutableSmallVector{N}, ::AbstractSmallVector{N}) where N`](@ref), [`$(@__MODULE__).default`](@ref).

"""
unsafe_copyto!(::MutableSmallVector, ::Union{NTuple, AbstractFixedVector})

@inline function unsafe_copyto!(w::MutableSmallVector{N,T}, v::NTuple{M}) where {N,T,M}
    @assert M <= N
    if M == N
        w.b = v
    elseif isbitstype(T)
        GC.@preserve w unsafe_store!(Ptr{NTuple{M,T}}(pointer(w)), Tuple(v))
    else
        for i in eachindex(w)
            @inbounds w[i] = v[i]
        end
    end
    w
end

@inline unsafe_copyto!(w::MutableSmallVector, v::AbstractFixedVector) = unsafe_copyto!(w, Tuple(v))

function unsafe_copyto!(w::MutableSmallVector, wo, v::MutableSmallVector, vo, n::Integer)
    GC.@preserve w unsafe_copyto!(pointer(w, wo), pointer(v, vo), n)
end

function assignto!(w::MutableSmallVector{N,T}, v::AbstractFixedVector{N,T}, n::Integer) where {N,T}
    w.b, w.n = v, n % SmallLength
    w
end

assignto!(w::MutableSmallVector{N,T}, v::AbstractSmallVector{N,T}) where {N,T} = assignto!(w, v.b, v.n)

similar(v::AbstractSmallVector{N}, ::Type{T}, (n,)::Tuple{Int}) where {N,T} =
    isbitstype(T) ? MutableSmallVector{N,T}(undef, n) : Vector{T}(undef, n)

strides(::MutableSmallVector) = (1,)
elsize(::Type{MutableSmallVector{N,T}}) where {N,T} = elsize(MutableFixedVector{N,T})

unsafe_convert(::Type{Ptr{T}}, v::MutableSmallVector{N,T}) where {N,T} =
    Ptr{T}(pointer_from_objref(v))

empty(v::MutableSmallVector{N,T}, ::Type{U} = T) where {N,T,U} = MutableSmallVector{N,U}()

empty!(v::MutableSmallVector) = resize!(v, 0)

@inline function resize!(v::MutableSmallVector{N,T}, n::Integer) where {N,T}
    @boundscheck 0 <= n <= N || error(LazyString("length must be between 0 and ", N))
    v.n = n % SmallLength
    for i in n+1:length(v)
        @inbounds v[i] = default(T)
    end
    v
end

function replace!(v::MutableSmallVector{N,T}, ps::Vararg{Pair,M}; kw...) where {N,T,M}
    if isfasttype(T) && isempty(kw)
        v.b = replace(v, ps...).b
        v
    else
        invoke(replace!, Tuple{AbstractVector,Vararg{Pair,M}}, v, ps...; kw...)
    end
end

@propagate_inbounds deleteat!(v::MutableSmallVector, i::Integer) = deleteat!(v, i, 1)

@inline function deleteat!(v::MutableSmallVector{N,T}, i::Integer, n::Integer) where {N,T}
    @boundscheck (1 <= i <= length(v)-n+1 && n >= 0) || throw(BoundsError(v, i))
    b = sizeof(T)
    GC.@preserve v begin
        unsafe_copyto!(pointer(v, i), pointer(v, i+n), (length(v)-(i+n-1)) % UInt)
        for j in length(v)-n+1:length(v)
            unsafe_store!(pointer(v, j), default(T))
        end
    end
    v.n -= n % SmallLength
    v
end

@inline function pop!(v::MutableSmallVector{N,T}) where {N,T}
    @boundscheck isempty(v) && error("vector must not be empty")
    n = length(v)
    @inbounds x, v[n] = v[n], default(T)
    v.n -= 1 % SmallLength
    x
end

@inline function popfirst!(v::MutableSmallVector{N,T}) where {N,T}
    @boundscheck isempty(v) && error("vector must not be empty")
    ishwtype(T) || return @inbounds popat!(v, 1)
    v.n -= 1 % SmallLength
    vec_circshift!(pointer(v), Val(N), Val(-1))
    unsafe_swap!(pointer(v, N), default(T))
end

@inline function popat!(v::MutableSmallVector, i::Integer)
    @boundscheck checkbounds(v, i)
    @inbounds (x = v[i]; deleteat!(v, i))
    x
end

@inline function insert!(v::MutableSmallVector{N,T}, i::Integer, xs::Vararg{Any,M}) where {N,T,M}
    @boundscheck 1 <= i <= length(v)+1 <= N-M+1 || throw(BoundsError(v, i))
    v.n += M % SmallLength
    unsafe_shl!(v, v.n, i, xs...)
end

if VERSION < v"1.11-"
    const MemoryVector{T} = Union{MutableFixedVector{<:Any,T}, MutableSmallVector{<:Any,T}, Vector{T}}
else
    const MemoryVector{T} = Union{MutableFixedVector{<:Any,T}, MutableSmallVector{<:Any,T}, Vector{T}, Memory{T}}
end

@inline function append!(v::MutableSmallVector{N,T}, w::MemoryVector{T}) where {N,T}
    n = length(v)+length(w)
    @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    GC.@preserve v unsafe_copyto!(pointer(v, length(v)+1), pointer(w), length(w))
    v.n = n % SmallLength
    v
end

@inline function push!(v::MutableSmallVector{N}, x) where N
    @boundscheck v.n < N || error(LazyString("vector cannot have more than ", N, " elements"))
    v.n += 1 % SmallLength
    @inbounds v[v.n] = x
    v
end

@propagate_inbounds pushfirst!(v::MutableSmallVector, xs::Vararg{Any,M}) where M = prepend!(v, xs)

@inline function prepend!(v::MutableSmallVector{N,T}, w::MemoryVector{T}) where {N,T}
    n = length(v)+length(w)
    @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    GC.@preserve v begin
        unsafe_copyto!(pointer(v, length(w)+1), pointer(v), length(v))
        unsafe_copyto!(pointer(v), pointer(w), length(w))
    end
    v.n = n % SmallLength
    v
end

@inline function prepend!(v::MutableSmallVector{N,T}, w) where {N,T}
    if w isa Tuple && ishwtype(T)
        M = length(w)
        n = length(v) + M
        @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
        v.n = n % SmallLength
        vec_circshift!(pointer(v), Val(N), Val(M))
        unsafe_copyto!(v, NTuple{M,T}(w))
        v
    elseif haslength(w)
        n = length(v)+length(w)
        @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
        GC.@preserve v unsafe_copyto!(pointer(v, length(w)+1), pointer(v), length(v))
        v.n = n % SmallLength
        for (i, x) in enumerate(w)
            @inbounds v[i] = x
        end
        v
    else
        n = length(v)
        foldl(pushfirst!, w; init = v)
        reverse!(v, 1, length(v)-n)
    end
end

@inline function duplicate!(v::MutableSmallVector{N}, i::Integer) where N
    @boundscheck begin
        checkbounds(v, i)
        @boundscheck length(v) < N || error(LazyString("vector cannot have more than ", N, " elements"))
    end
    if hasshuffle(v, Val(false))
        @inbounds assignto!(v, duplicate(v, i))
    else
        GC.@preserve v unsafe_copyto!(pointer(v, i+1), pointer(v, i), (length(v)-(i-1)) % UInt)
        v.n += 1 % SmallLength
        v
    end
end

reverse!(v::MutableSmallVector) = @inbounds reverse!(v, 1)

@propagate_inbounds function reverse!(v::MutableSmallVector, start::Integer)
    if hasshuffle(v, Val(true))
        unsafe_copyto!(v, reverse(v, start))
    else
        invoke(reverse!, Tuple{AbstractVector,Integer}, v, start)
    end
end

"""
    unsafe_circshift(v::AbstractSmallVector{N,T}, k::Integer) where {N,T} -> SmallVector{N,T}
    unsafe_circshift!(v::MutableSmallVector, k::Integer) -> v

These are faster versions of `circshift` and `circshift!`. They assume `-length(v) ≤ k < length(v)`.
This avoids the comparatively costly integer division with remainder.

See also `Base.circshift`, `Base.circshift!`.
"""
unsafe_circshift(::AbstractSmallVector, ::Integer),
unsafe_circshift!(::MutableSmallVector, ::Integer)

@inline function unsafe_circshift!(v::MutableSmallVector{N,T}, k::Integer) where {N,T}
    if hasshuffle(v, Val(true))
        w = unsafe_circshift(v, k)
    elseif N <= 16 || !isbits(T)
        n1 = length(v)
        k1 = ifelse(signbit(k), (k % SmallLength) + v.n, k % SmallLength)
        w = ntuple(Val(N % SmallLength)) do i
            @inbounds if i <= k1
                v[(i-k1)+n1]
            elseif i <= n1 % SmallLength
                v[i-k1]
            else
                default(T)
            end
        end
    else
        n2 = length(v)
        k2 = ifelse(signbit(k), (k % Int) + n2, k % Int)
        w = similar(v)
        unsafe_copyto!(pointer(w, k2+1), pointer(v, 1), n2-k2)
        unsafe_copyto!(pointer(w, 1), pointer(v, n2-k2+1), k2)
    end
    unsafe_copyto!(v, w)
end

function circshift!(v::MutableSmallVector{N,T}, k::Integer) where {N,T}
    if isempty(v)
        v
    else
        unsafe_circshift!(v, unsafe_rem(k, unsigned(v.n)))
    end
end

function filter!(f::F, v::MutableSmallVector{N,T}; style::MapStyle = MapStyle(f, T)) where {F,N,T}
    @inline
    if style isa LazyStyle
        j = 1
        @inbounds for i in eachindex(v)
            f(v[i]) || continue
            v[j] = v[i]
            j += 1
        end
        @inbounds resize!(v, j-1)
    else
        w = filter(f, v; style)
        v.b, v.n = w.b, w.n
        v
    end
end

function Random.rand(rng::AbstractRNG, ::SamplerType{MutableSmallVector{N,T}}) where {N,T}
    MutableSmallVector(rand(rng, SmallVector{N,T}))
end

"""
    map!(f, w::MutableSmallVector, v::AbstractSmallVector...; [style::MapStyle]) -> w

Apply `f` to the argument vectors elementwise and store the result in `w`.
Stop when one of the arguments is exhausted.

The `style` keyword argument determines how `map!` treats the padding used for
`AbstractSmallVector`. As discussed under `MapStyle`, the default value is based on
a list of known functions.

See also `Base.map!(f, w::AbstractVector, v::AbstractVector...)`,
[`$(@__MODULE__).MapStyle`](@ref), [Section "Broadcasting"](@ref sec-broadcasting).
"""
@inline function map!(f::F, w::MutableSmallVector, vs::Vararg{AbstractSmallVector,M};
        style::MapStyle = MapStyle(f, map(eltype, vs)...)) where {F,M}
    @inline
    copyto!(w, map(f, vs...; style))
end

# broadcast

using Base.Broadcast: Broadcasted
import Base.Broadcast: materialize!

@propagate_inbounds function materialize!(v::MutableSmallVector, bc::Broadcasted{SmallVectorStyle})
    # the size of the resulting vector is determined later in `copyto!` with `copy(bc)`
    copyto!(v, bc)
end

@propagate_inbounds function copyto!(v::MutableSmallVector{N,T}, bc::Broadcasted{SmallVectorStyle}) where {N,T}
    w = copy(bc)
    @boundscheck length(v) == length(w) || dimensionmismatch("vectors must have the same length")
    unsafe_copyto!(v, SmallVector{N,T}(w))
end

export AbstractFixedVector, FixedVector, MutableFixedVector, fixedvector,
    sum_fast, dot_fast, extrema_fast, bits, fasthash

using Base: tail, haslength, IteratorEltype, HasEltype, Generator

import Base: Tuple, ==, isequal, size,
    IndexStyle, getindex, setindex!, iterate, iszero, zero, +, -, *, map, map!,
    minimum, maximum, extrema, in, reverse, reverse!,
    vcat, copyto!, convert,
    strides, elsize, unsafe_convert, muladd, replace, replace!

"""
    AbstractFixedVector{N,T} <: AbstractVector{T}

`AbstractFixedVector{N,T}` is the supertype of `FixedVector{N,T}` and `MutableFixedVector{N,T}`.

See also [`FixedVector`](@ref), [`MutableFixedVector`](@ref).
"""
abstract type AbstractFixedVector{N,T} <: AbstractVector{T} end

hasfixedlength(::Type{<:AbstractFixedVector}) = true

"""
    FixedVector{N,T} <: AbstractFixedVector{N,T}

    FixedVector{N,T}(iter)
    FixedVector{N}(iter)
    FixedVector(iter)

`FixedVector{N,T}` is an immutable vector type that holds exactly `N` elements of type `T`.
(It is analogous to `StaticArrays.SVector` and `StaticVectors.Values`.)
The size `N` can be any (small) positive integer. However, at least for bit integer
and hardware float types, one usually takes `N` to be a power of `2`.

If the element type `T` or the size `N` are omitted, they are determined from the iterator
given as argument. Performance degrades if this is not possible at compile time.
(For tuples, the element type is determined via `promote_type`.)
As a rule of thumb, the size should only be omitted for `Tuple` arguments.

See also [`MutableFixedVector`](@ref), `Base.promote_type`.
"""
struct FixedVector{N,T} <: AbstractFixedVector{N,T}
    t::NTuple{N,T}
    FixedVector{N,T}(t::NTuple{N,Any}) where {N,T} = new{N,T}(t)
end

"""
    MutableFixedVector{N,T} <: AbstractFixedVector{N,T}

    MutableFixedVector{N,T}(iter)
    MutableFixedVector{N}(iter)
    MutableFixedVector(iter)

    MutableFixedVector{N,T}(undef)

`MutableFixedVector{N,T}` is a mutable vector type that holds exactly `N` elements of type `T`.
(It is analogous to `StaticArrays.MVector` and `StaticVectors.Variables`.)
The size `N` can be any (small) positive integer. However, at least for bit integer
and hardware float types, one usually takes `N` to be a power of `2`.

If the element type `T` or the size `N` are omitted, they are determined from the iterator
given as argument. Performance degrades if this is not possible at compile time.
As a rule of thumb, the size should only be omitted for `Tuple` arguments.

Note that setting individual vector elements (via `setindex!`) is only supported for `isbits`
element types.

The special form `MutableFixedVector{N,T}(undef)` returns a non-initialized vector.

See also [`FixedVector`](@ref), `Base.isbitstype`.
"""
mutable struct MutableFixedVector{N,T} <: AbstractFixedVector{N,T}
    t::NTuple{N,T}
    MutableFixedVector{N,T}(t::NTuple{N,Any}) where {N,T} = new{N,T}(t)
    MutableFixedVector{N,T}(::UndefInitializer) where {N,T} = new{N,T}()
end

@inline function FixedVector{N,T}(v::AbstractVector) where {N,T}
    @boundscheck length(v) == N || error("argument is not of length ", N)
    t = ntuple(i -> convert(T, @inbounds v[i+firstindex(v)-1]), Val(N))
    FixedVector{N,T}(t)
end

@propagate_inbounds function MutableFixedVector{N,T}(v::AbstractVector) where {N,T}
    w = FixedVector{N,T}(v)
    MutableFixedVector{N,T}(w.t)
end

@inline function FixedVector{N,T}(r::OrdinalRange) where {N, T <: Integer}
    T <: HWType || return invoke(FixedVector{N,T}, Tuple{AbstractVector{T}}, r)
    @boundscheck begin
        T(first(r)), T(last(r))  # check if we can convert
        length(r) == N || error("argument is not of length ", N)
    end
    fixedvector_range(Val(N), first(r) % T, step(r) % T)
end

function FixedVector{N,T}(itr::Generator) where {N,T}
    if isfasttype(eltype(itr.iter))
        v = @inline FixedVector{N}(itr.iter)
        map(Fix1(convert, T) ∘ itr.f, v)
    else
        invoke(FixedVector{N,T}, Tuple{Any}, itr)
    end
end

function MutableFixedVector{N,T}(itr::Generator) where {N,T}
    if IteratorEltype(itr.iter) isa HasEltype
        MutableFixedVector(FixedVector{N,T}(itr))
    else
        invoke(MutableFixedVector{N,T}, Tuple{Any}, itr)
    end
end

@generated function FixedVector{N,T}(itr) where {N,T}
    ex1 = (quote
        xs = iterate(itr, $((k == 1 ? () : (:s,))...))
        xs === nothing && @goto err
        $(Symbol(:x, k))::T, s = xs
    end for k in 1:N)
    ex2 = Expr(:tuple, (Symbol(:x, k) for k in 1:N)...)
    quote
        $(ex1...)
        iterate(itr, s) === nothing && return FixedVector{N,T}($ex2)
        @label err
        error("argument is not of length ", N)
    end
end

#=
@generated function MutableFixedVector{N,T}(itr) where {N,T}
    ex = (quote v[$k], s = iterate(itr, $((k == 1 ? () : (:s,))...))::Tuple end for k in 1:N)
    quote
        isbitstype(T) || return MutableFixedVector(FixedVector{N,T}(itr))
        !haslength(itr) || length(itr) == N || error("argument is not of length ", N)
        v = MutableFixedVector{N,T}(undef)
        $(ex...)
        haslength(itr) || iterate(itr, s) === nothing || error("argument is not of length ", N)
        v
    end
end
=#

function MutableFixedVector{N,T}(itr) where {N,T}
    isbitstype(T) || return MutableFixedVector(FixedVector{N,T}(itr))
    v = MutableFixedVector{N,T}(undef)
    i = 0
    xs = iterate(itr)
    while i < N && xs !== nothing
        i += 1
        x, s = xs
        @inbounds v[i] = x
        xs = iterate(itr, s)
    end
    (i == N && xs === nothing) || error("argument is not of length ", N)
    v
end

@inline function (::Type{V})(t) where {N,V<:AbstractFixedVector{N}}
    if Base.IteratorEltype(t) isa Base.HasEltype
        T = element_type(t)
        @inline V{T}(t)
    else
        V(NTuple{N}(t))
    end
end

@inline function (::Type{V})(t) where {V<:AbstractFixedVector}
    if haslength(t)
        N = length(t)
        V{N}(t)
    else
        V(Tuple(t))
    end
end

"""
    fixedvector(v::AbstractFixedVector{N,T}) where {N,T} -> FixedVector{N,T}

Returns the argument as a `FixedVector`. The purpose of this function is to make is easier
to write code that works for both `AbstractFixedVector` and `AbstractSmallVector`.

See also [`fixedvector(::AbstractSmallVector)`](@ref).
"""
fixedvector(v::AbstractFixedVector{N,T}) where {N,T} = FixedVector{N,T}(v.t)

"""
    fixedvector(v::AbstractFixedVector{N,T}, ::Val{M}) where {N,T,M} -> FixedVector{M,T}

Returns the argument as a `FixedVector`, resized to length `M`.
Appended elements, if any, are equal to `default(T)`.

The purpose of this function is to make is easier to write code
that works for both `AbstractFixedVector` and `AbstractSmallVector`.

See also [`$(@__MODULE__).default`](@ref), [`fixedvector(::AbstractFixedVector)`](@ref),
[`fixedvector(::AbstractSmallVector, ::Val)`](@ref).
"""
fixedvector(::AbstractFixedVector, ::Val)

"""
    capacity(::Type{<:AbstractFixedVector{N}}) where N -> N
    capacity(v::AbstractFixedVector{N}) where N -> N

Return the number `N` of elements this vector type holds.
This function is useful when writing code that works for both
`AbstractFixedVector` and `AbstractSmallVector`.

See also [`capacity(::AbstractSmallVector)`](@ref capacity(::Type{<:AbstractSmallVector})).
"""
capacity(::Type{<:AbstractFixedVector}),
capacity(::AbstractFixedVector)

convert(::Type{V}, v::V) where V <: AbstractFixedVector = v
convert(::Type{V}, v::Union{AbstractVector,Tuple}) where V <: AbstractFixedVector = V(v)

copyto!(v::MutableFixedVector{N}, t::Tuple{Vararg{Any,N}}) where N = (v.t = t; v)

copyto!(v::MutableFixedVector{N}, w::AbstractFixedVector{N}) where N = copyto!(v, Tuple(w))

Tuple(v::AbstractFixedVector) = v.t

size(v::AbstractFixedVector{N}) where N = (N,)

strides(::MutableFixedVector) = (1,)

elsize(::Type{MutableFixedVector{N,T}}) where {N,T} = elsize(Vector{T})

unsafe_convert(::Type{Ptr{T}}, v::MutableFixedVector{N,T}) where {N,T} =
    Ptr{T}(pointer_from_objref(v))

"""
    fasthash(v::AbstractFixedVector [, h0::UInt]) -> UInt

Return a hash for `v` that may be computed faster than the standard `hash`
for vectors. This new hash is consistent across all `AbstractFixedVector`s
of the same element type, but it may not be compatible with `hash` or
with `fasthash` for a `AbstractFixedVector` having a different element type.

Currently, `fasthash` differs from `hash` only if the element type of `v`
is a bit integer type with at most 32 bits, `Bool` or `Char`.

See also `Base.hash`.
"""
fasthash(::AbstractFixedVector, ::UInt)

function fasthash(v::AbstractFixedVector{N,T}, h0::UInt) where {N,T}
    if ishwtype(T)
        Base.hash_integer(bits(v), h0)
    else
        hash(v, h0)
    end
end

IndexStyle(::Type{<:AbstractFixedVector}) = IndexLinear()

@propagate_inbounds getindex(v::AbstractFixedVector, i::Int) = v.t[i]

@inline function unsafe_getindex(v::MutableFixedVector, i::Int)
    GC.@preserve v unsafe_load(pointer(v, i))
end

@inline function getindex(v::MutableFixedVector{N,T}, i::Int) where {N,T}
    @boundscheck checkbounds(v, i)
    isbitstype(T) ? unsafe_getindex(v, i) : @inbounds v.t[i]
end

@propagate_inbounds function setindex!(v::MutableFixedVector{N,T}, x, i::Int) where {N,T}
    @boundscheck checkbounds(v, i)
    isbitstype(T) || error(LazyString("setindex! is only supported for isbits element types, not for ", T))
    GC.@preserve v unsafe_store!(Ptr{T}(pointer_from_objref(v)), x, i)
    return v
end

iterate(v::AbstractFixedVector, state...) = iterate(v.t, state...)

zero(::Type{V}) where {N,T,V<:AbstractFixedVector{N,T}} = V(ntuple(Returns(zero(T)), Val(N)))
zero(::V) where V <: AbstractFixedVector = zero(V)

@inline +(v::AbstractFixedVector) = map(+, v)  # +true = 1::Int
@inline -(v::AbstractFixedVector) = map(-, v)

@inline +(v::AbstractFixedVector{N}, w::AbstractFixedVector{N}) where N = map(+, v, w)
@inline -(v::AbstractFixedVector{N}, w::AbstractFixedVector{N}) where N = map(-, v, w)

@inline *(c::Number, v::AbstractFixedVector) = FixedVector(c .* v.t)
*(v::AbstractFixedVector, c::Number) = c*v

@inline muladd(c::Number, v::AbstractFixedVector{N}, w::AbstractFixedVector{N}) where N =
    FixedVector(muladd.(c, Tuple(v), Tuple(w)))

muladd(v::AbstractFixedVector{N}, c::Number, w::AbstractFixedVector{N}) where N = muladd(c, v, w)

_capacity(::Type) = typemax(Int)
_capacity(::Type{T}) where T <: AbstractFixedVector = capacity(T)
_capacity(::Type{T}) where T <: Tuple = fieldcount(T)

_getindex(v::Union{AbstractFixedVector,Tuple}, i) = v[i]
_getindex(x::Base.RefValue, i) = x[]
_getindex(x, i) = x

@inline @generated function map_fixedvector(f, xs::Vararg{Any,M}) where M
    N = minimum(_capacity, xs)
    fcalls = (Expr(:call, :f, (:(_getindex(xs[$j], $i)) for j in 1:M)...) for i in 1:N)
    Expr(:call, :FixedVector, Expr(:tuple, fcalls...))
end

@inline function map(f::F, vs::Vararg{AbstractFixedVector,N}) where {F,N}
    map_fixedvector(f, vs...)
end

@inline function map!(f::F, w::MutableFixedVector, vs::Vararg{AbstractFixedVector,N}) where {F,N}
    copyto!(w, map(f, vs...))
end

@generated function Base.mapfoldl_impl(f, op, init, v::AbstractFixedVector{N}) where N
    ex, start = init <: Void ? (:(f(v[1])), 2) : (:init, 1)
    for i in start:N
        ex = :(op($ex, f(v[$i])))
    end
    ex
end

@generated function Base.mapfoldr_impl(f, op, init, v::AbstractFixedVector{N}) where N
    ex, start = init <: Void ? (:(f(v[N])), N-1) : (:init, N)
    for i in start:-1:1
        ex = :(op(f(v[$i]), $ex))
    end
    ex
end

function Base._mapreduce_dim(f, op, init::Void, v::AbstractFixedVector, ::Colon)
    Base.mapfoldl_impl(f, op, init, v)
end

for f in [:(==), :isequal]
    @eval $f(v::AbstractFixedVector{N}, w::AbstractFixedVector{N}) where N = all(map($f, v, w))
end

for (g, op, init) in ((:_sum, :+, 0), (:_prod, :*, 1))
    @eval function Base.$g(f::F, v::AbstractFixedVector, ::Colon; kw...) where F
        w = map(f, v)
        T = eltype(w)
        if !(T <: Integer) || bitsize(T) >= bitsize(Int)
            foldl($op, w; kw...)
        elseif T <: Unsigned
            foldl($op, w; init = UInt($init), kw...)
        else
            foldl($op, w; init = Int($init), kw...)
        end
    end
end

"""
    sum_fast(v::AbstractFixedVector; [init])

Return the `@fastmath` sum of the elements of `v`.
Unlike for `sum`, the default return value always has the element type of `v`, even
for small bit integers. This can be changed by supplying an `init` keyword argument.

See also `Base.sum`, `Base.@fastmath`.
"""
sum_fast(v::AbstractFixedVector; init = Base._InitialValue()) = @fastmath foldl(+, v; init)

"""
    dot_fast(v::AbstractFixedVector, w::AbstractFixedVector)

Return the `@fastmath` dot product of `v` and `w`
by recursively applying `dot_fast` to pairs of elements from `v` and `w`.
For elements not supporting `dot_fast` this is the same as applying `dot`.

See also `LinearAlgebra.dot`.
"""
dot_fast(v::AbstractFixedVector, w::AbstractFixedVector) = sum_fast(dot_fast.(v, w))

"""
    any(f::Function, v::AbstractFixedVector; dims = :, [style::MapStyle])
    all(f::Function, v::AbstractFixedVector; dims = :, [style::MapStyle])
    allequal(f, v::AbstractFixedVector; [style::MapStyle})
    allunique(f, v::AbstractFixedVector; [style::MapStyle])
    findfirst(f::Function, v::AbstractFixedVector; [style::MapStyle])
    findlast(f::Function, v::AbstractFixedVector; [style::MapStyle])
    findnext(f::Function, v::AbstractFixedVector, k::Integer; [style::MapStyle])
    findprev(f::Function, v::AbstractFixedVector, k::Integer; [style::MapStyle])

With an `AbstractFixedVector` `v` as second argument, these functions accept
the additional keyword argument `style`. If it equals `LazyStyle()`, then the
function `f` is only evaluated until the result has been determined. For any
other value of `style`, `f` is evaluated on all elements of `v`. This is often
faster for simple functions.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions.

See also [`$(@__MODULE__).MapStyle`](@ref).
"""
any(::Function, ::AbstractFixedVector),
all(::Function, ::AbstractFixedVector),
allequal(::Any, ::AbstractFixedVector),
allunique(::Any, ::AbstractFixedVector),
findfirst(::Function, ::AbstractFixedVector),
findlast(::Function, ::AbstractFixedVector),
findnext(::Function, ::AbstractFixedVector, ::Integer),
findprev(::Function, ::AbstractFixedVector, ::Integer)

Base._minimum(f, v::AbstractFixedVector, ::Colon; kw...) = mapfoldl(f, min, v; kw...)
Base._maximum(f, v::AbstractFixedVector, ::Colon; kw...) = mapfoldl(f, max, v; kw...)
Base._extrema(f, v::AbstractFixedVector, ::Colon; kw...) = mapfoldl(Base.ExtremaMap(f), Base._extrema_rf, v; kw...)

if VERSION < v"1.13.0-DEV.284"
    @fastmath maximum(v::AbstractFixedVector; kw...) = maximum(identity, v; kw...)
    @fastmath function maximum(f::F, v::AbstractFixedVector{N,T}; kw...) where {F,N,T}
        if T <: AbstractFloat && T <: Base.HWReal
            -minimum(-map(f, v); kw...)   # work around LLVM bug for max_fast, see julia#56341
        else
            invoke(maximum, Tuple{F,AbstractVector}, f, v; kw...)
        end
    end
end

"""
    extrema_fast(v::AbstractFixedVector; [init])

Return the `@fastmath` minimum and maximum of the elements of `v`.
The `init` keyword argument may not be used.

See also `Base.extrema`, `Base.@fastmath`.
"""
extrema_fast(v::AbstractFixedVector; kw...) = extrema_fast(identity, v; kw...)

"""
    extrema_fast(f, v::AbstractFixedVector; [init])

Return the `@fastmath` minimum and maximum of the values of `f` applied to the elements of `v`.
The `init` keyword argument may not be used.

See also `Base.extrema`, `Base.@fastmath`.
"""
function extrema_fast(f::F, v::AbstractFixedVector; init::Tuple{Any,Any} = (missing, missing)) where F
    if init === (missing, missing)
        @fastmath (minimum(f, v), maximum(f, v))
    else
        @fastmath (minimum(f, v; init = init[1]), maximum(f, v; init = init[2]))
    end
end

@inline function reverse(v::AbstractFixedVector{N,T}, start::Integer, stop::Integer) where {N,T}
    @boundscheck 0 < start <= stop+1 <= N+1 || Base.throw_boundserror(v, start:stop)
    t = ntuple(Val(N)) do i
        @inbounds start <= i <= stop ? v[start+stop-i] : v[i]
    end
    FixedVector{N,T}(t)
end

@inline function reverse(v::AbstractFixedVector{N,T}, start::Integer = 1) where {N,T}
    if hasshuffle(v, Val(true))
        @boundscheck 0 < start <= length(v)+1 || Base.throw_boundserror(v, start)
        U = N <= typemax(Int8) ? inttype(T) : uinttype(T)  # `uinttype` somehow leads to slower code
        iszero(N % U) && start-1 == N && return FixedVector(v)
        k = (start-1) % U
        l = (N-1) % U + k
        u = FixedVector{N,U}(0:N-1)
        p = ifelse.(u .< k, u, l .- u)
        shuffle(v, p, Val(true))
    else
        reverse(v, start, N)
    end
end

@propagate_inbounds function reverse!(v::MutableFixedVector, start::Integer)
    if hasshuffle(v, Val(true))
        copyto!(v, reverse(v, start))
    else
        invoke(reverse!, Tuple{AbstractVector,Integer}, v, start)
    end
end

vcat(v::AbstractFixedVector) = v

function vcat(v1::AbstractFixedVector{N1,T1}, v2::AbstractFixedVector{N2,T2}, vs::AbstractFixedVector...) where {N1,T1,N2,T2}
    T = promote_type(T1, T2)
    vcat(FixedVector{N1+N2,T}((v1..., v2...)), vs...)
 end

Base.hasfastin(::Type{<:AbstractFixedVector{N,T}}) where {N,T} = isfasttype(T)

if VERSION < v"1.14-"
    in(x, v::AbstractFixedVector) = any(==(x), v)
end

@inline replace_pair(v::AbstractFixedVector, w::AbstractFixedVector, p::Pair, ::Type{T}) where T =
    map((x, y) -> isequal(x, p[1]) ? convert(T, p[2]) : convert(T, y), v, w)

function replace(v::AbstractFixedVector{N,T}, ps::Vararg{Pair,M}; kw...) where {N,T,M}
    if isfasttype(T) && isempty(kw)
        foldl(ps; init = FixedVector(v)) do w, p
            U = promote_type(eltype(w), typeof(p[2]))
            replace_pair(v, w, p, U)  # separate function for type stability
        end
    else
        FixedVector(invoke(replace, Tuple{AbstractVector,Vararg{Pair,M}}, v, ps...; kw...))
    end
end

function replace!(v::MutableFixedVector{N,T}, ps::Vararg{Pair,M}; kw...) where {N,T,M}
    if isfasttype(T) && isempty(kw)
        v .= replace(v, ps...)
    else
        invoke(replace!, Tuple{AbstractVector,Vararg{Pair,M}}, v, ps...; kw...)
    end
end

"""
    support(v::AbstractFixedVector) -> SmallBitSet

Return the `SmallBitSet` with the indices of the non-zero elements of `v`.
If `v` has `Bool` elements, then this means the elements that are `true`.

See also [`SmallBitSet`](@ref), [`support(::Any, ::AbstractFixedVector)`](@ref).

# Example
```jldoctest
julia> v = FixedVector{4,Int8}([1, 0, 0, 3]);

julia> support(v)
SmallBitSet{UInt8} with 2 elements:
  1
  4
```
"""
support(v::AbstractFixedVector)

"""
    support(f, v::AbstractFixedVector) -> SmallBitSet

Return the `SmallBitSet` with the indices of the elements `x` of `v` for which `f(x)` is non-zero.
If `f` has `Bool` values, then this means that `f(x)` has to be `true`.

See also [`SmallBitSet`](@ref), [`support(::AbstractFixedVector)`](@ref).

# Example
```jldoctest
julia> v = FixedVector{4,Int8}(3:6);

julia> support(isodd, v)
SmallBitSet{UInt8} with 2 elements:
  1
  3
```
"""
support(::Any, ::AbstractFixedVector)

@inline support(f::F, v::AbstractFixedVector) where F = support(@inline map(f, v))

function Random.rand(rng::AbstractRNG, ::SamplerType{V}) where {N,T,V<:AbstractFixedVector{N,T}}
    @static if VERSION >= v"1.11"
        V(rand(rng, NTuple{N,T}))
    else
        V(ntuple(_ -> rand(rng, T), Val(N)))
    end
end

#
# broadcast
#

using Base.Broadcast: AbstractArrayStyle, DefaultArrayStyle, Broadcasted, flatten
import Base.Broadcast: BroadcastStyle
import Base: copy, copyto!

"""
    $(@__MODULE__).FixedVectorStyle <: Broadcast.AbstractArrayStyle{1}

The broadcasting style used for `AbstractFixedVector`.

See also [`AbstractFixedVector`](@ref), `Broadcast.AbstractArrayStyle`.
"""
struct FixedVectorStyle <: AbstractArrayStyle{1} end

BroadcastStyle(::Type{<:AbstractFixedVector}) = FixedVectorStyle()
BroadcastStyle(::FixedVectorStyle, ::DefaultArrayStyle{0}) = FixedVectorStyle()
BroadcastStyle(::FixedVectorStyle, ::DefaultArrayStyle{N}) where N = DefaultArrayStyle{N}()

@inline function copy(bc::Broadcasted{FixedVectorStyle})
    bcflat = flatten(bc)
    map_fixedvector(bcflat.f, bcflat.args...)
end

@inline copyto!(v::MutableFixedVector, bc::Broadcasted{FixedVectorStyle}) = copyto!(v, copy(bc))

using SmallCollections: bitsize, uinttype

unsigned_types = (UInt8, UInt64, UInt256, UInt440)

@testset "SmallBitSet" begin
    @test_inferred SmallBitSet([1,2,3]) SmallBitSet{UInt64}([1,2,3])
    for U in unsigned_types
        s = SmallBitSet{U}()
        @test_inferred isempty(s) true
        @test_inferred empty(s) SmallBitSet{U}()
        @test_inferred first_as_set(s) s
        m = bitsize(U)
        @test_throws Exception SmallBitSet{U}([1, 2, 'x'])
        @test_throws Exception SmallBitSet{U}([1, 2, m+1])
        @test_throws Exception SmallBitSet{U}([0, 1, 2])
        t = Set{Int}(rand(1:m, rand(0:m)))
        s = @inferred SmallBitSet{U}(t)
        @test_inferred capacity(s) m
        @test_inferred isempty(s) isempty(t)
        @test_inferred length(s) == length(t) true
        @test_inferred s == t true
        @test_inferred copy(s) === s true
        @test_inferred s == s true
        @test_inferred first_as_set(s) isempty(s) ? s : SmallBitSet{U}((first(s),))
        v = collect(Float32, t)
        @test_inferred SmallBitSet{U}(v) s
        s3 = @inferred SmallBitSet{UInt512}(s)
        @test s3 == s
        @test_inferred hash(s) hash(t)
        @test_inferred fasthash(s) fasthash(s3)
        @test_inferred Set(s) t
    end

    @test_inferred smallbitsettype(Val(2)) SmallBitSet{UInt8}
    @test_inferred smallbitsettype(Val(20)) SmallBitSet{UInt32}
    @test_inferred smallbitsettype(Val(200)) SmallBitSet{UInt256}
end

@testset "SmallBitSet first/min etc" begin
    for U in unsigned_types
        m = bitsize(U)
        t = Set{Int}(rand(1:m, rand(1:m)))
        s = @inferred SmallBitSet{U}(t)
        if isempty(t)
            @test_throws Exception minimum(s)
            @test_inferred minimum(s; init = m+1) minimum(t; init = m+1)
            @test_throws Exception maximum(s)
            @test_inferred maximum(s; init = 0) maximum(t; init = 0)
            @test_throws Exception extrema(s)
            @test_inferred extrema(s; init = (m+1, 0)) extrema(t; init = (m+1, 0))
        else
            @test_inferred first(s) minimum(t)
            @test_inferred minimum(s) minimum(t)
            @test_inferred last(s) maximum(t)
            @test_inferred maximum(s) maximum(t)
            @test_inferred extrema(s) extrema(t)
        end
    end
end

@testset "SmallBitSet in/subset" begin
    for U in unsigned_types
        m = bitsize(U)
        t = Set{Int}(rand(1:m, rand(0:m)))
        s = @inferred SmallBitSet{U}(t)
        for i in 1:m
            @test_inferred i in s i in t
            @test_inferred Int16(i) in s i in t
            @test_inferred Float64(i) in s i in t
        end
        @test_inferred 1.5 in s false
        @test_inferred 'x' in s false
        t2 = Set{Int}(rand(1:m, rand(0:2)))
        s2 = @inferred SmallBitSet{U}(t2)
        @test_inferred issubset(s2, s) issubset(t2, t)
        @test_inferred issubset(s2, t) issubset(t2, t)
        @test_inferred issubset(t2, s) issubset(t2, t)
        @test_inferred s2 ⊊ s t2 ⊊ t
        @test_inferred s2 ⊊ t t2 ⊊ t
        @test_inferred t2 ⊊ s t2 ⊊ t
    end
end

@testset "SmallBitSet push/pop etc" begin
    for U in unsigned_types
        m = bitsize(U)
        t = Set{Int}(rand(1:m, rand(0:m)))
        s = @inferred SmallBitSet{U}(t)
        i = rand(1:m)
        @test_inferred push(s, i) push!(copy(t), i) SmallBitSet{U}
        @test_inferred push(s, Float32(i)) push!(copy(t), i) SmallBitSet{U}
        @test_throws Exception push(s, 0)
        @test_throws Exception push(s, m+1)
        @test_throws Exception push(s, 'x')
        @test_inferred push(s, 3, 4, 5, 6) push!(copy(t), 3, 4, 5, 6) SmallBitSet{U}
        if !isempty(t)
            i = maximum(t)
            @test_inferred pop(s) (delete!(copy(t), i), i) Tuple{SmallBitSet{U}, Int}
            i = rand(t)
            @test_inferred pop(s, i) (delete!(copy(t), i), i) Tuple{SmallBitSet{U}, Int}
            @test_inferred pop(s, Float64(i)) (delete!(copy(t), i), i) Tuple{SmallBitSet{U}, Int}
            @test_inferred pop(s, 0, -1) (s, -1)
            @test_throws KeyError pop(s, 0)
            @test_throws KeyError pop(s, 'x')
            @test_inferred delete(s, i) delete!(copy(t), i) SmallBitSet{U}
            @test_inferred delete(s, m+1) s
        end
        @test_inferred filter(isodd, s) filter(isodd, t) s
    end
end

@testset "SmallBitSet union etc" begin
    for U1 in unsigned_types, U2 in unsigned_types
        m1 = bitsize(U1)
        m2 = bitsize(U2)
        U = promote_type(U1, U2)
        t1 = Set{Int}(rand(1:m1, rand(0:m1)))
        s1 = @inferred SmallBitSet{U1}(t1)
        t2 = Set{Int}(rand(1:m2, rand(0:m2)))
        s2 = @inferred SmallBitSet{U2}(t2)
        @test_inferred union(s1, s2) union(t1, t2) SmallBitSet{U}
        @test_inferred intersect(s1, s2) intersect(t1, t2) SmallBitSet{U1}
        @test_inferred intersect(s1, t2) intersect(t1, t2) SmallBitSet{U1}
        @test_inferred setdiff(s1, s2) setdiff(t1, t2) SmallBitSet{U1}
        @test_inferred setdiff(s1, t2) setdiff(t1, t2) SmallBitSet{U1}
        @test_inferred symdiff(s1, s2) symdiff(t1, t2) SmallBitSet{U}
    end
end

@testset "SmallBitSet invreplace" begin
    for U in [UInt8, UInt32, UInt128]  # UInt256 leads to a freeze
        N = bitsize(U)
        S = SmallBitSet{uinttype(Val(N))}
        s = rand(SmallBitSet{U})
        v = N < 128 ? FixedVector{N,Int8}(rand(1:N, N)) : FixedVector{N,UInt16}(rand(1:N, N))
        @test_inferred invreplace(s, v) Set(i for (i, j) in enumerate(v) if j in s) S
        v = SmallVector{N-2,Int16}(rand(1:N, N-4))
        @test_inferred invreplace(s, v) Set(i for (i, j) in enumerate(v) if j in s) S
    end
end

@testset "SmallBitSet rand" begin
    for U in unsigned_types
        s = @inferred rand(SmallBitSet{U})
        @test s isa SmallBitSet{U}
    end
    s = @inferred rand(SmallBitSet)
    @test s isa SmallBitSet{UInt}
end

@testset "SmallBitSet checkbounds" begin
    for V in [FixedVector{16,Int16}, MutableSmallVector{22,Int8}, PackedVector{UInt32,5,Int8}]
        v = rand(V)
        for s in [SmallBitSet(), SmallBitSet{UInt32}(1:3:length(v)), SmallBitSet{UInt128}((1, length(v)+1))]
            @test_inferred checkbounds(Bool, v, s) checkbounds(Bool, v, collect(s))
        end
    end
end

@testset "SmallBitSet orderings" begin
    using SmallCollections: Lex, Colex, GradedLex, GradedColex
    using Base.Order: ForwardOrdering, lt
    lex_lt(s, t) = collect(s) < collect(t)
    colex_lt(s, t) = reverse!(collect(s)) < reverse!(collect(t))
    graded_lex_lt(s, t) = length(s) < length(t) || (length(s) == length(t) && lex_lt(s, t))
    graded_colex_lt(s, t) = length(s) < length(t) || (length(s) == length(t) && colex_lt(s, t))
    for a in UInt(0):UInt(63), b in UInt(0):UInt(63)
        s = convert(SmallBitSet{UInt8}, a)
        t = convert(SmallBitSet{UInt32}, b)
        @test_inferred lt(Lex, s, t) lex_lt(s, t)
        @test_inferred lt(Colex, s, t) colex_lt(s, t)
        @test_inferred lt(GradedLex, s, t) graded_lex_lt(s, t)
        @test_inferred lt(GradedColex, s, t) graded_colex_lt(s, t)
        @test_inferred isless(s, t) lt(Colex, s, t)
    end

    @test_inferred Base.Sort.UIntMappable(UInt16, ForwardOrdering()) UInt16
    v = rand(SmallBitSet{UInt16}, 50)
    @test sort(v) == sort(v; lt = colex_lt)  # does UIntMappable work?
end

using Chairmarks

function pretty_time(sample)
    io = IOBuffer()
    Chairmarks.print_time(io, sample)
    String(take!(io))
end

macro bstr(ex...)
    esc(:(pretty_time((@b $(ex...)).time)))
end

using SmallCollections, StaticArrays, StaticVectors, SIMD, BitIntegers, BangBang

const n = 1000

s = """
## Benchmarks

### `SmallVector`

The timings are for pairwise adding the elements of two `Vector`s,
each containing $n vectors with element type `T`.
For `Vector` and `SmallVector` the length of each pair of elements is **variable** and
chosen randomly between 1 and `N`. For `SVector{N,T}` (from StaticArrays.jl),
`Values{N,T}` (from StaticVectors.jl) and `Vec{N,T}` (from SIMD.jl) the vectors have
**fixed** length `N`.

| `(N, T)` | `Vector{T}` | `SmallVector{N,T}` | `SVector{N,T}` | `Values{N,T}` | `Vec{N,T}` |
| ---: | ---: | ---: | ---: | ---: | ---: |
"""
for (N, T) in [(8, Float64), (8, Int64), (16, Int32), (32, Int16)]
    # @show N T
    v1 = [rand(T, rand(1:N)) for _ in 1:n]
    w1 = [rand(T, length(v1[i])) for i in 1:n]
    v2 = map(SmallVector{N,T}, v1)
    w2 = map(SmallVector{N,T}, w1)
    v3 = [Values{N,T}(rand(T, N)) for _ in 1:n]
    w3 = [Values{N,T}(rand(T, N)) for _ in 1:n]
    v4 = map(SVector{N,T}, v3)
    w4 = map(SVector{N,T}, w3)
    v5 = map(x -> Vec{N,T}(Tuple(x)), v3)
    w5 = map(x -> Vec{N,T}(Tuple(x)), w3)

    # @show typeof(v1) typeof(v2) typeof(v3) typeof(v4) typeof(v5)

    t1 = @bstr map(+, $v1, $w1)
    t2 = @bstr map(+, $v2, $w2)
    t3 = @bstr map(+, $v3, $w3)
    t4 = @bstr map(+, $v4, $w4)
    t5 = @bstr map(+, $v5, $w5)
    s0 = "| ($N, $T) | $t1 | $t2 | $t4 | $t3 | $t5 |\n"

    print(stderr, s0)
    global s *= s0
end

mul!!(v::Vector, x) = v .*= x
mul!!(v::AbstractCapacityVector, x) = x * v

insert!!(v::Vector, i, x) = insert!(v, i, x)
insert!!(v::AbstractCapacityVector, i, x) = SmallCollections.insert(v, i, x)

@inline function duplicate!!(v::Vector, i)
    @boundscheck checkbounds(v, i)
    @inbounds insert!(v, i+1, v[i])
end

duplicate!!(v::AbstractCapacityVector, i) = duplicate(v, i)

let
    m = 30
    U = UInt128
    M = 4
    N = SmallCollections.bitsize(U) ÷ M
    r = Int8(-2^(M-1)):Int8(2^(M-1)-1)
    v1 = rand(r, m)
    w1 = rand(r, m)
    v2 = PackedVector{U,M,Int8}(v1)
    w2 = PackedVector{U,M,Int8}(w1)
    v3 = SmallVector{N,Int8}(v1)
    w3 = SmallVector{N,Int8}(w1)
    types = [Vector{Int8}, SmallVector{N,Int8}, PackedVector{U,M,Int8}]

    global s *= """

### `PackedVector`

Here we compare a `$(types[3])` (that can hold $N elements) to a `$(types[2])`
and to a `$(types[1])` with $m elements.
The function `duplicate(v, i)` is equivalent to `insert(v, i+1, v[i])`.
For the operations listed in the table below we have chosen the mutating variant for `Vector`.

"""

    c = Int8(3)
    i = m ÷ 2
    t = Dict{Any,String}()
    for (v, w) in [(v1, w1), (v2, w2), (v3, w3)]
        T = typeof(v)
        println(stderr, T)
        t[T, :getindex] = @bstr $v[$i]
        t[T, :setindex] = @bstr copy(v) setindex!!(_, $c, $i)
        t[T, :add] = @bstr copy(v) add!!(_, $w)
        t[T, :scalar_mul] = @bstr copy(v) mul!!(_, $c)
        t[T, :pushfirst] = @bstr copy(v) pushfirst!!(_, $c)
        t[T, :push] = @bstr copy(v) push!!(_, $c)
        t[T, :popfirst] = @bstr copy(v) popfirst!!(_) evals = i
        t[T, :pop] = @bstr copy(v) pop!!(_) evals = i
        t[T, :insert] = @bstr copy(v) insert!!(_, $i, $c)
        t[T, :deleteat] = @bstr copy(v) deleteat!!(_, $i) evals = i
        t[T, :duplicate] = @bstr copy(v) duplicate!!(_, $i)
    end

    global s *= """
    | operation | `Vector` | `SmallVector` | `PackedVector` |
    | ---: | ---: | ---: | ---: |
    """

    for f in [:getindex, :setindex, :add, :scalar_mul, :push, :pushfirst, :pop, :popfirst, :insert, :deleteat, :duplicate]
        global s *= "| $f | " * join((t[T, f] for T in types), " | ") * " |\n"
    end

end

s *= """

### `SmallBitSet`

The timings are for taking the pairwise union of the elements of two `Vector`s,
each containing $n sets of the indicated type.
Each set contains up to `b` integers between 1 and `b = 8*sizeof(U)-1`.

| `U` | `Set{Int16}` | `BitSet` | `SmallBitSet` |
| ---: | ---: | ---: | ---: |
"""
for U in (UInt8, UInt16, UInt32, UInt64, UInt128, UInt256, UInt512)
    b = 8*sizeof(U)-1
    s1 = [Set{Int16}(rand(1:b) for _ in 1:b) for _ in 1:n]
    u1 = [Set{Int16}(rand(1:b) for _ in 1:b) for _ in 1:n]
    s2 = map(BitSet, s1)
    u2 = map(BitSet, u1)
    s3 = map(SmallBitSet{U}, s1)
    u3 = map(SmallBitSet{U}, u1)

    # @show typeof(s1) typeof(s2) typeof(s3)

    t1 = @bstr map(union, $s1, $u1)
    t2 = @bstr map(union, $s2, $u2)
    t3 = @bstr map(union, $s3, $u3)
    s0 = "| $U | $t1 | $t2 | $t3 |\n"

    print(stderr, s0)
    global s *= s0
end

s *= """

Versions: Julia v$VERSION,
"""

w = map([Chairmarks, SmallCollections, StaticArrays, StaticVectors, SIMD, BitIntegers]) do M
    v = pkgversion(M)
    "$M v$v"
end

s *= join(w, ",\n")

println(s)

using CpuId: cpufeature, CpuFeature, __ECX

if cpufeature(:BMI1)
    const llvm_bextr = "llvm.x86.bmi.bextr.$(bitsize(UInt))"

    bextr(x::U, y::Unsigned) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_bextr,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    const HAS_BEXTR = true
else
    const HAS_BEXTR = false
end

if cpufeature(:BMI2)
    const llvm_pdep = "llvm.x86.bmi.pdep.$(bitsize(UInt))"
    const llvm_pext = "llvm.x86.bmi.pext.$(bitsize(UInt))"

    pdep(x::Unsigned, y::U) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_pdep,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    pext(x::Unsigned, y::U) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_pext,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    const HAS_PEXT = true
else
    const HAS_PEXT = false
end

const AVX512VBMI2 = CpuFeature(0x0000_0007, 0x00, __ECX, 6)
const HAS_COMPRESS = cpufeature(:AVX512VL) || cpufeature(AVX512VBMI2)

#
# fast types
#

"""
    $(@__MODULE__).isfasttype(::Type{T}) where T -> Bool

Return `true` if elements of type `T` permit fast (for instance, vectorized) operations.

By default, this holds for all primitive types except `String` and `Symbol`
and for all `struct` and `mutable struct` types whose fields have bits type
and recursively satisfy `isfasttype`.
"""
@assume_effects :total function isfasttype(::Type{T}) where T
# all non-struct types should be covered by the methods below
    isstructtype(T) && all(isfastfield, fieldtypes(T))
end

isfastfield(::Type{T}) where T = isbitstype(T) && isfasttype(T)

isfasttype(::Type{<:HWType}) = true
isfasttype(::Type{<:Union{Symbol,String}}) = false

#
# MapStyle definitions
#

using Base.FastMath: abs2_fast, abs_fast, add_fast, cmp_fast, conj_fast,
    eq_fast, ge_fast, gt_fast, inv_fast, isfinite_fast, isinf_fast,
    isnan_fast, issubnormal_fast, le_fast, lt_fast, max_fast, min_fast,
    minmax_fast, mul_fast, ne_fast, sign_fast, sqrt_fast, sub_fast

"""
    $(@__MODULE__).MapStyle

    MapStyle(f, types::Type...) -> MapStyle


A `MapStyle` determines how `$(@__MODULE__)` evaluates certain functions like
`map` or `findfirst` that take a function `f` as argument. The available subtypes
of `MapStyle` are as follows, from the least to the most efficient:

- `LazyStyle`: the function `f` is only evaluated when strictly necessary,
  and it is not assumed to be defined for default values. This is the default
  `MapStyle` for unknown functions.

- `EagerStyle`: `f` may be evaluated more often than strictly necessary,
  and it is assumed to be defined for default values. However, it need not
  map default values to default values.

- `RigidStyle`: `f` may be evaluated more often than strictly necessary. It is
  assumed to be defined for default values and to return a default value if all
  arguments are default values.

- `StrictStyle`: `f` may be evaluated more often than strictly necessary. It is
  assumed to be defined for default values and to return a default value if at
  least one argument is a default value. (This is the same as `RigidStyle` for
  functions with a single argument.)

The `MapStyle` is predefined for many functions from `Base` as well as for operations
that produce new functions out of old. Unnamed functions are not recognized. However,
several functions from `$(@__MODULE__)` allow to specify a `MapStyle` as keyword argument.
In addition, users can define a `MapStyle` for their own types.

See also [`$(@__MODULE__).default`](@ref), [`$(@__MODULE__).isfasttype`](@ref).

# Examples
```jldoctest
julia> using $(@__MODULE__): MapStyle

julia> MapStyle(iszero, Int)   # not RigidStyle: iszero(0) is true, not false
$(@__MODULE__).EagerStyle()

julia> MapStyle(+, Int, Int)
$(@__MODULE__).RigidStyle()

julia> MapStyle(*, Int, Float64)   # not StrictStyle: 0 * Inf is NaN, not 0.0
$(@__MODULE__).RigidStyle()

julia> MapStyle(*, Int, Int)
$(@__MODULE__).StrictStyle()

julia> MapStyle(-, Int)
$(@__MODULE__).StrictStyle()

julia> MapStyle(x -> -x, Int)   # not StrictStyle: anonymous function not recognized
$(@__MODULE__).LazyStyle()

julia> MapStyle(-, Int128)   # Int128 is not a fast type, so better be lazy
$(@__MODULE__).LazyStyle()

julia> MapStyle(isfinite∘inv, Float64)   # function composition is recognized
$(@__MODULE__).EagerStyle()

julia> MapStyle(!isodd, Int)  # function composition again
$(@__MODULE__).EagerStyle()

julia> MapStyle(!iszero, Int)   # separately defined to override EagerStyle
$(@__MODULE__).StrictStyle()

julia> MapStyle(>=(1), Int)   # >=(1) is Base.Fix2(>=, 1), which is recognized
$(@__MODULE__).EagerStyle()
```
"""
abstract type MapStyle end,
struct LazyStyle <: MapStyle end,
struct EagerStyle <: MapStyle end,
struct RigidStyle <: MapStyle end,
struct StrictStyle <: MapStyle end

iffasttypes(style::MapStyle) = style

function iffasttypes(style::MapStyle, ::Type{T}, types::Type...) where T
    isfasttype(T) ? iffasttypes(style, types...) : LazyStyle()
end

MapStyle(::Any, ::Type...) = LazyStyle()
# MapStyle(f, args...) = MapStyle(f, map(typeof, args)...)

MapStyle(::Union{typeof.(
        (-, identity, signbit, isodd, isone, isinf, isinf_fast, isnan, isnan_fast,
            issubnormal, issubnormal_fast, zero, round, floor, ceil, trunc,
            abs, abs_fast, sign, sign_fast, sqrt, sqrt_fast, conj, conj_fast,
            length, first, last, capacity)
    )...}, ::Type{T}) where T = iffasttypes(StrictStyle(), T)
MapStyle(::Union{typeof.(
        (&,)
    )...}, types::Type...) = iffasttypes(StrictStyle(), types...)
MapStyle(::Fix2{<:Union{typeof.(
        (<<, >>, >>>)
    )...}, S}, ::Type{T}) where {S <: Integer, T} = iffasttypes(StrictStyle(), S, T)

MapStyle(::Union{typeof.(
        (!==, !=, <, >, ne_fast, lt_fast, gt_fast, cmp_fast, -, abs2, abs2_fast)
    )...}, ::Type{T1}, ::Type{T2}) where {T1,T2} = iffasttypes(RigidStyle(), T1, T2)
MapStyle(::Union{typeof.(
        (|, xor, +, add_fast, min, min_fast, max, max_fast, minmax, minmax_fast)
    )...}, types::Type...) = iffasttypes(RigidStyle(), types...)
MapStyle(::typeof(ifelse), ::Type{Bool}, ::Type{T1}, ::Type{T2}) where {T1,T2} = iffasttypes(RigidStyle(), T1, T2)

MapStyle(::Union{typeof.(
        (!, ~, iseven, iszero, isfinite, isfinite_fast, one, inv, inv_fast)
    )...}, ::Type{T}) where T = iffasttypes(EagerStyle(), T)
MapStyle(::Union{typeof.(
        # note: 1/0 = Inf
        (===, ==, <=, >=, isequal, eq_fast, le_fast, ge_fast, /)
    )...}, ::Type{T1}, ::Type{T2}) where {T1,T2} = iffasttypes(EagerStyle(), T1, T2)
MapStyle(::Union{typeof.(
        (nand, nor)
    )...}, types::Type...) = iffasttypes(EagerStyle(), types...)

# definitions depending on specific types

MapStyle(::Fix1{typeof(<), U}, ::Type{T}) where {T, U <: Unsigned} = iffasttypes(StrictStyle(), T, U)
MapStyle(::Fix2{typeof(>), U}, ::Type{T}) where {T, U <: Unsigned} = iffasttypes(StrictStyle(), T, U)

MapStyle(::typeof(rem), ::Type{T}, ::Type{Type{U}}) where {T,U} = iffasttypes(StrictStyle(), T, U)
MapStyle(::Fix2{typeof(rem),U}, ::Type{T}) where {T,U} = iffasttypes(StrictStyle(), T, U)

MapStyle(::typeof(min), types::Type{<:Unsigned}...) = iffasttypes(StrictStyle(), types...)

hasfloats(::Type) = false
hasfloats(::Type{<:AbstractFloat}) = true
hasfloats(::Type{<:Complex{T}}) where T = hasfloats(T)
@generated hasfloats(::Type{T}) where T <: Tuple = any(hasfloats, fieldtypes(T))
hasfloats(::Type{<:AbstractArray{T}}) where T = hasfloats(T)
hasfloats(::Type{<:Ref{T}}) where T = hasfloats(T)

# -(0.0) === -0.0, not 0.0
MapStyle(::typeof(-), ::Type{T}) where T = iffasttypes(hasfloats(T) ? EagerStyle() : StrictStyle(), T)

MapStyle(::Union{typeof.(
        (cmp, isless)
    )...}, ::Type{T1}, ::Type{T2}) where {T1,T2} = hasfloats(Tuple{T1,T2}) ? LazyStyle() : iffasttypes(RigidStyle(), T1, T2)

hasfixedlength(::Type) = false
hasfixedlength(::Type{<:Number}) = true

# (-1) * 0.0 === -0.0, not 0.0
# also, 0 * [1] is not a vector of length 0
@assume_effects :total function MapStyle(::Union{typeof.(
        (*, mul_fast, dot, dot_fast)
    )...}, types::Type...)
    style = if !all(hasfixedlength, types)
        EagerStyle()
    elseif hasfloats(Tuple{types...})
        RigidStyle()
    else
        StrictStyle()
    end
    iffasttypes(style, types...)
end

function MapStyle(::typeof(Base.literal_pow), ::Type{typeof(^)}, ::Type{T}, ::Type{Val{N}}) where {T,N}
    if 1 <= N <= 3
        iffasttypes(StrictStyle(), T)
    elseif -2 <= N <= 0
        iffasttypes(EagerStyle(), T)
    else
        LazyStyle()
    end
end

MapStyle(::typeof(in), ::Type{S}, ::Type{T}) where {S, T <: AbstractSet} = iffasttypes(StrictStyle(), T, S)

MapStyle(::typeof(intersect), ::Type{T}, types::Type...) where T <: AbstractSet = iffasttypes(StrictStyle(), T, types...)

MapStyle(::Union{typeof.(
        (union, setdiff, symdiff)
    )...}, ::Type{T}, types::Type...) where T <: AbstractSet = iffasttypes(RigidStyle(), T, types...)

MapStyle(::Union{typeof.(
        (<, >, ⊊, ⊋)
    )...}, ::Type{T1}, ::Type{T2}) where {T1 <: AbstractSet, T2 <: AbstractSet} = iffasttypes(RigidStyle(), T1, T2)

MapStyle(::Union{
        Fix2{typeof(setdiff), U}, Fix1{typeof(<), U}, Fix2{typeof(>), U}
    }, ::Type{T}) where {T <: AbstractSet, U <: AbstractSet} = iffasttypes(StrictStyle(), T, U)

MapStyle(::Union{typeof.(
        (issubset, ⊇)
    )...}, ::Type{T1}, ::Type{T2}) where {T1 <: AbstractSet, T2 <: AbstractSet} = iffasttypes(EagerStyle(), T1, T2)

# definitions for constructors

MapStyle(::Type{Ref}, ::Type{T}) where T = iffasttypes(StrictStyle(), S, T)
MapStyle(::Type{Ref{S}}, ::Type{T}) where {S,T} = iffasttypes(StrictStyle(), S, T)
MapStyle(::Type{<:AbstractOneTo}, ::Type{T}) where T = iffasttypes(StrictStyle(), T)
MapStyle(::Type{<:AbstractOneTo{S}}, ::Type{T}) where {S,T} = iffasttypes(StrictStyle(), S, T)

# definitions for constructors of new functions

MapStyle(f::Returns{T}, types::Type...) where T = iffasttypes(EagerStyle(), T)

function MapStyle(f::ComposedFunction, types::Type...)
    istyle = MapStyle(f.inner, types...)
    istyle isa LazyStyle && return LazyStyle()
    T = Core.Compiler.return_type(f.inner, Tuple{types...})
    isconcretetype(T) || return LazyStyle()
    ostyle = MapStyle(f.outer, T)
    if ostyle isa Union{LazyStyle, EagerStyle}
        ostyle
    elseif istyle isa Union{EagerStyle, RigidStyle}
        istyle
    else
        StrictStyle()
    end
end

MapStyle(::ComposedFunction{typeof(!), <:Union{typeof.(
        (~, iseven, iszero, isfinite, isfinite_fast)
    )...}}, ::Type{T}) where T = iffasttypes(StrictStyle(), T)

MapStyle(f::Base.Splat, ::Type{T}) where T <: Tuple = MapStyle(f.f, fieldtypes(T)...)

# TODO: use StrictStyle
if VERSION > v"1.12-alpha"
    function MapStyle(g::Base.Fix{N,F,T}, types::Type...) where {N,F,T}
        style = MapStyle(g.f, types[1:N-1]..., T, types[N:end]...)
        style isa RigidStyle ? EagerStyle() : style
    end
else
    function MapStyle(g::Fix1{F,T}, types::Type...) where {F,T}
        style = MapStyle(g.f, T, types...)
        style isa RigidStyle ? EagerStyle() : style
    end
    function MapStyle(g::Fix2{F,T}, type1::Type, types::Type...) where {F,T}
        style = MapStyle(g.f, type1, T, types...)
        style isa RigidStyle ? EagerStyle() : style
    end
end

# Inbounds

"""
    $(@__MODULE__).Inbounds(f)

Returns a callable object for calling `f` in an `@inbounds` context.
This is useful for `map` and broadcasting, for instance.

See also `Base.@inbounds`.

# Example
```jldoctest
julia> using $(@__MODULE__): Inbounds

julia> @inline f(x) = (@boundscheck @assert x < 3; -x);

julia> v = FixedVector{4}(1:4);

julia> f.(v)
ERROR: AssertionError: x < 3
[...]

julia> Inbounds(f).(v)
4-element FixedVector{4, Int64}:
 -1
 -2
 -3
 -4
```
"""
struct Inbounds{F}
    f::F
end

Inbounds(::Type{T}) where T = Inbounds{Type{T}}(T)

(inb::Inbounds)(xs...; kw...) = @inbounds inb.f(xs...; kw...)

MapStyle(inb::Inbounds, types::Type...) = MapStyle(inb.f, types...)

#
# PackedVector
#

import Base: ==, getindex, setindex, length, size, empty, iterate, rest, split_rest,
    iszero, zero, +, -, *, convert, circshift, filter, reverse, copy, zeros, ones

export PackedVector, bits, capacity, support,
    setindex, addindex, push, pop, pushfirst, popfirst,
    insert, duplicate, deleteat, popat, append, prepend

"""
    PackedVector{U<:Unsigned,M,T<:Union{Base.BitInteger,Bool}} <: AbstractVector{T}

    PackedVector{U,M,T}()
    PackedVector{U,M,T}(iter)
    PackedVector{U,M}(v::AbstractVector{T})
    PackedVector{U,M}(t::Tuple)
    PackedVector(v::AbstractSmallVector{M,T})

This type of immutable vector stores the elements in a common bit mask of type `U`
with `M` bits for each entry. The range of allowed values is `-2^(M-1):2^(M-1)-1`
if `T <: Signed`, `0:2^M-1` if `T <: Unsigned` and `false:true` if `T == Bool`.
Apart from that, the official element type `T` is only used when retrieving an entry.
 The capacity, that is, the number of elements that can be stored, is given
by `bitsize(U)÷M`.

The element type `T` can be omitted when creating the `PackedVector` from an `AbstractVector`
or from a tuple. In the latter case, `T` is determined by promoting the element types of the tuple.
If no argument is given, then an empty vector is returned.
If the `PackedVector` is created from a `AbstractSmallVector` `v` and the parameters `U` and `M`
are omitted, then `M` is set to `bitsize(T)` and `U` is chosen such that the capacity
of the resulting vector is at least the capacity of `v`.

Overflow or underflow during addition or subtraction of vectors do not throw an error.
The same applies to multiplication by a scalar of type `T`. Scalar multiplication by
other types returns a `Vector`.

Compared to a `SmallVector`, a `PackedVector` may have faster insert and delete operations.
Arithmetic operations are usually slower unless `M` is the size of a hardware integer.

See also [`capacity`](@ref capacity(::Type{<:PackedVector})), [`$(@__MODULE__).bitsize`](@ref).

# Examples
```jldoctest
julia> v = PackedVector{UInt,5,Int8}(-5:5:10)
4-element PackedVector{$UInt, 5, Int8}:
 -5
  0
  5
 10

julia> capacity(v)
12

julia> w = PackedVector{UInt,5,Int8}([1, 2, 3, 4])
4-element PackedVector{$UInt, 5, Int8}:
 1
 2
 3
 4

julia> v+w
4-element PackedVector{$UInt, 5, Int8}:
 -4
  2
  8
 14

julia> Int8(2)*v
4-element PackedVector{$UInt, 5, Int8}:
 -10
   0
  10
 -12
```
"""
struct PackedVector{U<:Unsigned,M,T<:Union{BitInteger,Bool}} <: AbstractVector{T}
    m::U
    n::Int
    function PackedVector{U,M,T}(m::U, n::Int) where {U <: Unsigned, M, T <: Union{BitInteger,Bool}}
        bitsize(T) < M && error(LazyString("type ", T, " has fewer than ", M, " bits"))
        new{U,M,T}(m, n)
    end
end

PackedVector{U,M,T}(v::PackedVector{U,M,T}) where {U,M,T} = v

@inline function PackedVector{U,M,T}(w::Union{AbstractVector,Tuple}) where {U,M,T}
    v = PackedVector{U,M,T}()
    @boundscheck if !isempty(w)
        checklength(v, length(w))
        x, y = extrema(w)
        checkvalue(M, convert(T, x))
        checkvalue(M, convert(T, y))
    end
    for x in Iterators.reverse(w)
        @inbounds v = pushfirst(v, x)
    end
    v
end

@propagate_inbounds function PackedVector{U,M,T}(iter) where {U,M,T}
    v = PackedVector{U,M,T}()
    for x in iter
        v = push(v, x)
    end
    v
end

PackedVector{U,M}(v::AbstractVector{T}) where {U,M,T} = PackedVector{U,M,T}(v)

function PackedVector{U,M}(v::V) where {U, M, V <: Tuple}
    T = promote_type(fieldtypes(V)...)
    PackedVector{U,M,T}(v)
end

@propagate_inbounds function PackedVector{U,M,S}(v::AbstractSmallVector{N,T}) where {U,M,S,N, T <: BitInteger}
    if bitsize(T) == M && (T <: Signed) == (S <: Signed)
        @boundscheck begin
            c = capacity(PackedVector{U,M,S})
            c >= N || length(v) <= c || error(LazyString("vector cannot have more than ", c, " elements"))
        end
        PackedVector{U,M,S}(bits(v.b) % U, length(v))
    else
        invoke(PackedVector{U,M,S}, Tuple{AbstractVector{T}}, v)
    end
end

function PackedVector(v::AbstractSmallVector{N,T}) where {N, T <: BitInteger}
    m = bits(v.b)
    M = bitsize(T)
    U = typeof(m)
    PackedVector{U,M,T}(v)
end

(::Type{V})() where V <: PackedVector = zeros(V, 0)

"""
    bits(v::PackedVector{U}) where U -> U

Return the bit mask used internally to store the elements of the vector `v`.
"""
bits(v::PackedVector) = v.m

length(v::PackedVector) = v.n

size(v::PackedVector) = (length(v),)

"""
    capacity(::Type{<:PackedVector}) -> Int
    capacity(v::PackedVector) -> Int

Return the largest number of elements this vector type can hold.
"""
capacity(::Type{<:PackedVector}),
capacity(::PackedVector)

capacity(::Type{<:PackedVector{U,M}}) where {U,M} = bitsize(U) ÷ M

copy(v::PackedVector) = v

==(v::PackedVector{U,M,T}, w::PackedVector{U,M,T}) where {U,M,T} =
    v.n == w.n && v.m == w.m

"""
    fasthash(v::PackedVector [, h0::UInt]) -> UInt

Return a hash for `v` that may be computed faster than the standard `hash`
for vectors. This new hash is consistent across all `PackedVector{U,M,T}`
of the same internal bit size `M`, but it may not be compatible with `hash`
or with `fasthash` for a `PackedVector` having a different bit size.
However, using `fasthash` for two `PackedVector`s with the same `M`, but
both signed and unsigned element types `T` may lead to hash collisions.

See also `Base.hash`.

# Examples
```jldoctest
julia> v = PackedVector{UInt64,5,Int8}([1, 5, 6]);

julia> fasthash(v)
0x11e89b9d8f3daac6

julia> fasthash(v) == hash(v)
false

julia> w = PackedVector{UInt128,5,Int8}(v); fasthash(v) == fasthash(w)
true

julia> w = PackedVector{UInt64,4,Int8}(v); fasthash(v) == fasthash(w)
false

julia> w = PackedVector{UInt64,5,UInt8}(v); fasthash(v) == fasthash(w)
true
```
"""
fasthash(v::PackedVector, h0::UInt) = Base.hash_integer(bits(v), hash(length(v), h0))

"""
    empty(v::V) where V <: PackedVector -> V
    empty(v::PackedVector{U,M}, T::Type) where {U,M,T} -> PackedVector{U,M,T}

In the first form, return an empty `PackedVector` of the same type as `v`.
In the second form, the bit mask type and the bit size are the same as for `v`,
but the element type is `T`.
"""
empty(::PackedVector),
empty(::PackedVector, ::Type)

empty(v::PackedVector{U,M,T}, ::Type{S} = T) where {U,M,T,S} = PackedVector{U,M,S}()

iszero(v::PackedVector) = iszero(v.m)

zero(v::V) where V <: PackedVector = zeros(V, length(v))

"""
    zeros(::Type{V}, n::Integer) where V <: PackedVector -> V

Return a `PackedVector` of type `V` containing `n` zeros.

See also [`ones`](@ref ones(::Type{<:PackedVector}, ::Integer)).
"""
zeros(::Type{<:PackedVector}, ::Integer)

function zeros(::Type{V}, n::Integer) where {U, V <: PackedVector{U}}
    n <= capacity(V) || error(LazyString("vector cannot have more than ", capacity(V), " elements"))
    V(zero(U), n)
end

@assume_effects :total all_ones(::Type{U}, M) where U =
    foldl((m, i) -> m | unsafe_shl(one(U), i), 0:M:bitsize(U)-1; init = zero(U))

"""
    ones(::Type{V}, n::Integer) where V <: PackedVector -> V

Return a `PackedVector` of type `V` containing `n` ones.

See also [`zeros`](@ref zeros(::Type{<:PackedVector}, ::Integer)).
"""
ones(::Type{<:PackedVector}, ::Integer)

function ones(::Type{V}, n::Integer) where {U, M, V <: PackedVector{U,M}}
    n <= capacity(V) || error(LazyString("vector cannot have more than ", capacity(V), " elements"))
    mask = one(U) << unsigned(M*n) - one(U)
    m = all_ones(U, M) & mask
    V(m, n)
end

function iterate(v::PackedVector, w = v)
    if isempty(w)
        nothing
    else
        w, x = popfirst(w)
        x, w
    end
end

rest(v::PackedVector, w = v) = w

if VERSION >= v"1.9"
    @inline function split_rest(v::PackedVector, n::Int, w = v)
        m = length(w)-n
        @boundscheck (n >= 0 && m >= 0) || error("impossible number of elements requested")
        @inbounds w[1:m], w[m+1:end]
    end
end

@inline function checkvalue(M, x::T) where T
    bitsize(T) == M && return
    if T <: Signed
        -one(T) << (M-1) <= x < one(T) << (M-1) || error(LazyString("value ", x, " out of range for ", M, " bits signed integer"))
    else
        x < one(T) << M || error(LazyString("value ", x, " out of range for ", M, " bits unsigned integer"))
    end
    nothing
end

function checklength(v::PackedVector, m = 1)
    c = capacity(v)
    length(v) <= c-m || error(LazyString("vector cannot have more than ", c, " elements"))
    nothing
end

# TODO: can we omit the conversion to U?
@inline maskvalue(::Type{U}, M, x::Union{Unsigned,Bool}) where U = x % U

@inline function maskvalue(::Type{U}, M, x::T) where {U, T <: Signed}
    mask = one(T) << M - one(T)
    unsigned(x & mask) % U
end

@inline function getindex(v::PackedVector{U,M,T}, i::Int) where {U,M,T}
    @boundscheck checkbounds(v, i)
    if HAS_BEXTR && bitsize(U) <= bitsize(UInt)
        x = bextr(v.m, M*(i+UInt(255))) % T
        if T <: Union{Unsigned, Bool}
            return x
        else
            signbit = one(T) << (M-1)
            return x | -(x & signbit)
        end
    end
    x = unsafe_lshr(v.m, M*(i-1)) % T
    mask = one(T) << M - one(T)
    signbit = one(T) << (M-1)
    if T == Bool
        x
    elseif T <: Unsigned || iszero(x & signbit)
        x & mask
    else
        x | ~mask
    end
end

@inline function getindex(v::V, r::AbstractUnitRange{<:Integer}) where {U <: Unsigned, M, V <: PackedVector{U,M}}
    @boundscheck checkbounds(v, r)
    l = length(r)
    l == capacity(v) && return v
    mask = unsafe_shl(one(U), M*l) - one(U)
    m = unsafe_lshr(v.m, M*(first(r)-1)) & mask
    V(m, l)
end

@inline function getindex(v::V, ii::OrdinalRange{<:Integer}) where V <: PackedVector
    @boundscheck checkbounds(v, ii)
    @inbounds V(v[i] for i in ii)
end

"""
    getindex(v::V, s::SmallBitSet) where V <: PackedVector -> V

Returns the vector with elements `v[i]` where `i` runs through the elements of `s` in increasing order.
This operation is analogous to `v[collect(s)]`, but faster.

See also [`checkbounds`](@ref).

# Example
```jldoctest
julia> v = PackedVector{UInt,6,Int8}(-2:2)
5-element PackedVector{$UInt, 6, Int8}:
 -2
 -1
  0
  1
  2

julia> s = SmallBitSet((1, 3, 4))
SmallBitSet{$UInt} with 3 elements:
  1
  3
  4

julia> v[s]
3-element PackedVector{$UInt, 6, Int8}:
 -2
  0
  1
```
"""
getindex(v::PackedVector, s::SmallBitSet)

@inline function getindex(v::V, s::SmallBitSet{U}) where {W, M, V <: PackedVector{W, M}, U}
    @boundscheck checkbounds(v, s)
    if HAS_PEXT && M == 1 && bitsize(U) < bitsize(UInt)
        m = pext(v.m, bits(s))
        V(m % W, length(s))
    else
        V(@inbounds v[i] for i in s)
    end
end

"""
    setindex(v::V, x, i::Integer) where V <: PackedVector -> V

Substitute `x` for the `i`-th component of `v` and return the new vector.

See also `Base.setindex`, [`addindex`](@ref addindex(::PackedVector, ::Any, ::Integer)).
"""
@inline function setindex(v::PackedVector{U,M,T}, x, i::Integer) where {U,M,T}
    x = convert(T, x)
    @boundscheck begin
        checkbounds(v, i)
        checkvalue(M, x)
    end
    s = M*(i-1)
    mask = one(U) << M - one(U)
    y = maskvalue(U, M, x)
    m = (v.m & ~unsafe_shl(mask, s)) | unsafe_shl(y, s)
    PackedVector{U,M,T}(m, v.n)
end

"""
    addindex(v::V, x, i::Integer) where V <: PackedVector -> V

Add `x` to the `i`-th component of `v` and return the new vector.

See also [`setindex`](@ref setindex(::PackedVector, ::Any, ::Integer)).
"""
@propagate_inbounds addindex(v::PackedVector, x, i::Integer) =
    setindex(v, v[i]+x, i)

"""
    insert(v::V, i::Integer, x) where V <: PackedVector -> V

Return the `PackedVector` obtained from `v` by inserting `x` at position `i`.
The position `i` must be between `1` and `length(v)+1`.

This is the non-mutating analog of `Base.insert!`.

See also [`duplicate`](@ref duplicate(::PackedVector, ::Integer)).
"""
@inline function insert(v::PackedVector{U,M,T}, i::Integer, x) where {U,M,T}
    x = convert(T, x)
    @boundscheck begin
        isone(i) || checkbounds(v, i-1)
        checklength(v)
        checkvalue(M, x)
    end
    s = M*(i-1)
    mask = unsafe_shl(one(U), s) - one(U)
    m1 = v.m & mask
    m2 = (v.m & ~mask) << M
    y = maskvalue(U, M, x)
    m = m1 | m2 | unsafe_shl(y, s)
    PackedVector{U,M,T}(m, v.n+1)
end

"""
    deleteat(v::V, i::Integer) where V <: PackedVector -> V

Return the `PackedVector` obtained from `v` by deleting the element at position `i`.
The latter must be between `1` and `length(v)`.

See also `Base.deleteat!`, `BangBang.deleteat!!`.
"""
@inline function deleteat(v::PackedVector{U,M,T}, i::Integer) where {U,M,T}
    @boundscheck checkbounds(v, i)
    s = M*(i-1)
    mask = unsafe_shl(one(U), s) - one(U)
    m1 = v.m >> M & ~mask
    m2 = v.m & mask
    PackedVector{U,M,T}(m1 | m2, v.n-1)
end

"""
    popat(v::PackedVector{U,M,T}, i::Integer) where {U,M,T} -> Tuple{PackedVector{U,M,T}, T}

Return the tuple `(w, x)` where `w` obtained from `v` by deleting the element `x`
at position `i`. The latter must be between `1` and `length(v)`.

See also `Base.popat!`, `BangBang.popat!!`.
"""
@propagate_inbounds popat(v::PackedVector, i::Integer) =
    deleteat(v, i), @inbounds v[i]

"""
    push(v::V, xs...) where V <: PackedVector -> V

Return the `PackedVector` obtained from `v` by appending the arguments `xs`.

See also `Base.push!`, `BangBang.push!!`.
"""
@propagate_inbounds push(v::PackedVector, xs...) = append(v, xs)

# TODO: needed?
@inline function push(v::PackedVector{U,M,T}, x) where {U,M,T}
    x = convert(T, x)
    @boundscheck begin
        checklength(v)
        checkvalue(M, x)
    end
    s = M*v.n
    y = maskvalue(U, M, x)
    m = v.m | unsafe_shl(y, s)
    PackedVector{U,M,T}(m, v.n+1)
end

"""
    pop(v::PackedVector{U,M,T}) where {U,M,T} -> Tuple{PackedVector{U,M,T}, T}

Return the tuple `(w, x)` where `x` is the last element of `v`
and `w` obtained from `v` by dropping this element.
The vector `v` must not be empty.

See also `Base.pop!`, `BangBang.pop!!`.
"""
pop(::PackedVector)

@inline function pop(v::PackedVector{U,M,T}) where {U,M,T}
    @boundscheck checkbounds(v, 1)
    s = M*(v.n-1)
    mask = unsafe_shl(one(U), s) - one(U)
    m = v.m & mask
    PackedVector{U,M,T}(m, v.n-1), @inbounds v[v.n]
end

pushfirst(v::PackedVector) = v

@inline function pushfirst(v::PackedVector{U,M,T}, x) where {U <: Unsigned, M, T <: Union{BitInteger,Bool}}
    x = convert(T, x)
    @boundscheck begin
        checklength(v)
        checkvalue(M, x)
    end
    y = maskvalue(U, M, x)
    m = v.m << M | y
    PackedVector{U,M,T}(m, v.n+1)
end

"""
    pushfirst((v::V, xs...) where V <: PackedVector -> V

Return the `PackedVector` obtained from `v` by prepending the arguments `xs`.

See also `Base.pushfirst!`, `BangBang.pushfirst!!`.
"""
@propagate_inbounds pushfirst(v::PackedVector, xs...) = prepend(v, xs)

"""
    popfirst(v::PackedVector{U,M,T}) where {U,M,T} -> Tuple{PackedVector{U,M,T}, T}

Return the tuple `(w, x)` where `x` is the first element of `v`
and `w` obtained from `v` by dropping this element.
The vector `v` must not be empty.

See also `Base.popfirst!`, `BangBang.popfirst!!`.
"""
@inline function popfirst(v::PackedVector{U,M,T}) where {U,M,T}
    @boundscheck checkbounds(v, 1)
    PackedVector{U,M,T}(v.m >> M, v.n-1), @inbounds v[1]
end

"""
    append(v::V, ws...) where V <: PackedVector -> V

Append all elements of the collections `ws` to `v` and return the new vector.
Note that the resulting `PackedVector` has the same capacity as `v`.

See also `Base.append!`, `BangBang.append!!`.
"""
append(v::PackedVector, ws...) = foldl(append, ws; init = v)

@propagate_inbounds append(v::V, w) where V <: PackedVector = append(v, V(w))

@inline function append(v::PackedVector{U,M,T}, w::PackedVector{W,M,T}) where {U <: Unsigned, M, T <: Union{BitInteger,Bool}, W}
    @boundscheck checklength(v, w.n)
    m = v.m | (w.m % U) << unsigned(M*v.n)
    PackedVector{U,M,T}(m, v.n+w.n)
end

"""
    prepend(v::V, ws...) where V <: PackedVector -> V

Prepend all elements of the collections `ws` to `v` and return the new vector.
Note that the resulting `PackedVector` has the same capacity as `v`.

See also `Base.prepend!`.
"""
prepend(v::PackedVector, ws...) = foldr((w, v) -> prepend(v, w), ws; init = v)

@propagate_inbounds prepend(v::V, w) where V <: PackedVector = append(V(w), v)

"""
    duplicate(v::V, i::Integer) where V <: PackedVector -> V

Duplicate the `i`-th entry of `v` by inserting it at position `i+1` and return the new vector.

See also [`insert`](@ref).

# Example
```jldoctest
julia> v = PackedVector{UInt,5,Int8}(1:3)
3-element PackedVector{$UInt, 5, Int8}:
 1
 2
 3

julia> duplicate(v, 2)
4-element PackedVector{$UInt, 5, Int8}:
 1
 2
 2
 3
```
"""
@inline function duplicate(v::PackedVector{U,M,T}, i::Integer) where {U,M,T}
    @boundscheck begin
        checkbounds(v, i)
        checklength(v)
    end
    mask = unsafe_shl(one(U), M*i) - one(U)
    m1 = v.m & mask
    m2 = (v.m & ~(mask >>> M)) << M
    PackedVector{U,M,T}(m1 | m2, v.n+1)
end

function reverse(v::P, start::Integer = 1, stop::Integer = length(v)) where P <: PackedVector
    @inbounds P(start <= i <= stop ? v[stop+start-i] : v[i] for i in eachindex(v))
end

function reverse(v::PackedVector{U,1,T}) where {U,T}
    m = unsafe_lshr(bitreverse(v.m), bitsize(U)-length(v))  # this is safe: if length(v) == 0, then also v.m == 0
    PackedVector{U,1,T}(m, v.n)
end

function circshift(v::PackedVector{U,M,T}, k::Integer) where {U,M,T}
    v.n <= 1 && return v
    k = unsafe_mod(k, v.n % UInt16) % Int
    mask = one(U) << ((M*v.n) % UInt) - one(U)
    PackedVector{U,M,T}((unsafe_shl(v.m, M*k) | unsafe_lshr(v.m, M*v.n-M*k)) & mask, v.n)
end

function filter(f::F, v::PackedVector) where F
    w = empty(v)
    for x in v
        if f(x)
            @inbounds w = push(w, x)
        end
    end
    w
end

@generated function bitcast_add(v::PackedVector{U,M,T}, w::PackedVector{U,M,T}) where {U,M,T}
    b = bitsize(U)
    n = b ÷ M
    c = n * M
    ir = c == b ? """
        %a2 = bitcast i$c %0 to <$n x i$M>
        %b2 = bitcast i$c %1 to <$n x i$M>
        %c2 = add <$n x i$M> %a2, %b2
        %c1 = bitcast <$n x i$M> %c2 to i$c
        ret i$b %c1
    """ : """
        %a1 = trunc i$b %0 to i$c
        %a2 = bitcast i$c %a1 to <$n x i$M>
        %b1 = trunc i$b %1 to i$c
        %b2 = bitcast i$c %b1 to <$n x i$M>
        %c2 = add <$n x i$M> %a2, %b2
        %c1 = bitcast <$n x i$M> %c2 to i$c
        %c0 = zext i$c %c1 to i$b
        ret i$b %c0
    """
    quote
        $(Expr(:meta, :inline))
        m = Base.llvmcall($ir, U, Tuple{U, U}, v.m, w.m)
        PackedVector{U,M,T}(m, v.n)
    end
end

@generated function bitcast_sub(v::PackedVector{U,M,T}, w::PackedVector{U,M,T}) where {U,M,T}
    b = bitsize(U)
    n = b ÷ M
    c = n * M
    ir = c == b ? """
        %a2 = bitcast i$c %0 to <$n x i$M>
        %b2 = bitcast i$c %1 to <$n x i$M>
        %c2 = sub <$n x i$M> %a2, %b2
        %c1 = bitcast <$n x i$M> %c2 to i$c
        ret i$b %c1
    """ : """
        %a1 = trunc i$b %0 to i$c
        %a2 = bitcast i$c %a1 to <$n x i$M>
        %b1 = trunc i$b %1 to i$c
        %b2 = bitcast i$c %b1 to <$n x i$M>
        %c2 = sub <$n x i$M> %a2, %b2
        %c1 = bitcast <$n x i$M> %c2 to i$c
        %c0 = zext i$c %c1 to i$b
        ret i$b %c0
    """
    quote
        $(Expr(:meta, :inline))
        m = Base.llvmcall($ir, U, Tuple{U, U}, v.m, w.m)
        PackedVector{U,M,T}(m, v.n)
    end
end

@generated function bitcast_mul(c::T, v::PackedVector{U,M,T}) where {U,M,T}
    b = bitsize(U)
    n = b ÷ M
    (bitsize(T) == M && n*M == b) || error("not implemented")
    ir = """
        %a = bitcast i$b %1 to <$n x i$M>
        %b1 = insertelement <$n x i$M> poison, i$M %0, i32 0
        %b2 = shufflevector <$n x i$M> %b1, <$n x i$M> poison, <$n x i32> zeroinitializer
        %c2 = mul <$n x i$M> %a, %b2
        %c1 = bitcast <$n x i$M> %c2 to i$b
        ret i$b %c1
    """
    quote
        $(Expr(:meta, :inline))
        m = Base.llvmcall($ir, U, Tuple{T, U}, c, v.m)
        PackedVector{U,M,T}(m, v.n)
    end
end

+(v::PackedVector) = v

@inline function +(v::V, w::V) where {U, M, V <: PackedVector{U,M}}
    @boundscheck length(v) == length(w) || error("vectors must have the same length")
    M >= 8 && ispow2(M) && return bitcast_add(v, w)
    mask = one(U) << M - one(U)
    ones0 = all_ones(U, 2*M)
    ones1 = ones0 << M
    mask0 = mask*ones0
    mask1 = mask*ones1
    m0 = (v.m & mask0 + w.m & mask0) & mask0
    m1 = (v.m & mask1 + w.m & mask1) & mask1
    V(m0 | m1, v.n)
end

@inline function +(v::V, w::V) where {U, V <: PackedVector{U,1,<:BitInteger}}
    @boundscheck length(v) == length(w) || error("vectors must have the same length")
    V(v.m ⊻ w.m, v.n)
end

-(v::PackedVector) = @inbounds zero(v)-v

@inline function -(v::V, w::V) where {U, M, V <: PackedVector{U,M}}
    @boundscheck length(v) == length(w) || error("vectors must have the same length")
    M >= 8 && ispow2(M) && return bitcast_sub(v, w)
    mask = one(U) << M - one(U)
    ones0 = all_ones(U, 2*M)
    ones1 = ones0 << M
    mask0 = mask*ones0
    mask1 = mask*ones1
    wc = ~w.m
    m0 = (v.m & mask0 + wc & mask0 + ones0) & mask0
    m1 = (v.m & mask1 + wc & mask1 + ones1) & mask1
    V(m0 | m1, v.n)
end

-(vs::V...) where {U, V <: PackedVector{U,1,<:BitInteger}} = +(vs...)

@inline function *(c::T, v::PackedVector{U,M,T}) where {U, M, T <: BitInteger}
    @boundscheck checkvalue(M, c)
    bitsize(T) == M && return bitcast_mul(c, v)
    mask = one(U) << M - one(U)
    ones0 = all_ones(U, 2*M)
    ones1 = ones0 << M
    mask0 = mask*ones0
    mask1 = mask*ones1
    cm = maskvalue(U, M, c)
    m0 = (cm * (v.m & mask0)) & mask0
    m1 = (cm * (v.m & mask1)) & mask1
    PackedVector{U,M,T}(m0 | m1, v.n)
end

*(c::T, v::PackedVector{U,1,T}) where {U, T <: BitInteger} = isodd(c) ? v : zero(v)

*(v::PackedVector{U,M,T}, c::T) where {U, M, T <: BitInteger} = c*v

"""
    $(@__MODULE__).unsafe_add(v::V, w::V) where V <: PackedVector -> V

Add `v` and `w` and return the result. It is not checked that `v` and `w` have the same length.
No overflow or underflow is allowed in any component, nor are sign changes in the case of signed integers.

This function is much faster than regular addition.

See also [`unsafe_sub`](@ref).
"""
unsafe_add(v::V, w::V) where V <: PackedVector = V(v.m+w.m, v.n)

"""
    $(@__MODULE__).unsafe_sub(v::V, w::V) where V <: PackedVector -> V

Subtract `w` from `v` and return the result. It is not checked that `v` and `w` have the same length.
No overflow or underflow is allowed in any component, nor are sign changes in the case of signed integers.

This function is much faster than regular addition.

See also [`unsafe_add`](@ref).
"""
unsafe_sub(v::V, w::V) where V <: PackedVector = V(v.m-w.m, v.n)

@generated function sum_split(v::PackedVector{U,M,T}) where {U,M,T}
    @assert M > 1
    c = capacity(v)
    l = top_set_bit(c-1)
    quote
        m = v.m
        Base.Cartesian.@nexprs $l i -> begin
            n = M*2^(i-1)
            ones2 = all_ones(U, 2*n)
            mask = one(U) << n - one(U)
            mask2 = mask * ones2
            m1 = m & mask2
            if T <: Signed && isodd($c >> (i-1))
                m2 = unsigned((signed(m) >> n)) & mask2
            else
                m2 = (m >> n) & mask2
            end
            if T <: Signed
                signmask = ones2 << (M-1 + i-1)
                m1 |= (m1 & signmask) << 1
                m2 |= (m2 & signmask) << 1
            end
            m = m1 + m2
            if T <: Signed
                m &= ~(signmask << 2)
            end
        end
        if bitsize(T) > bitsize(Int)
            TT = T
        elseif T <: Signed
            TT = Int
        else
            TT = UInt
        end
        if T <: Unsigned
            m % TT
        else
            k = bitsize(U) - (M+$l)
            (signed(m << k) >> k) % TT
        end
    end
end

function sum_count(v::PackedVector{U,M,T}) where {U,M,T}
    o = all_ones(U, M)
    t = ntuple(Val(M)) do i
        c = count_ones(v.m & (o << (i-1))) << (i-1)
        T <: Signed && i == M ? -c : c
    end
    s = sum(t)
    if bitsize(T) > bitsize(Int)
        s % T
    elseif T <: Union{Signed, Bool}
        s
    else
        unsigned(s)
    end
end

function sum(v::PackedVector{U,M,T}) where {U,M,T}
    if M >= 8 && M <= 64 && ispow2(M)
        S = T <: Signed ? inttype(Val(M)) : uinttype(Val(M))
        w = PackedVector{U,M,S}(v.m, v.n)
        s = sum(SmallVector(w))
        bitsize(T) <= bitsize(s) ? s : s % T
    else
        log2u = top_set_bit(bitsize(U))-1
        if M <= log2u + (T <: Signed ? 1 : -2)
            sum_count(v)
        else
            sum_split(v)
        end
    end
end

function maximum(v::PackedVector{U,M,T}) where {U,M,T}
    if M >= 8 && ispow2(M)
        S = T <: Signed ? inttype(Val(M)) : uinttype(Val(M))
        w = PackedVector{U,M,S}(v.m, v.n)
        maximum(SmallVector(w)) % T
    else
        invoke(maximum, Tuple{AbstractVector{T}}, v)
    end
end

function minimum(v::PackedVector{U,M,T}) where {U,M,T}
    if M >= 8 && ispow2(M)
        S = T <: Signed ? inttype(Val(M)) : uinttype(Val(M))
        w = PackedVector{U,M,S}(v.m, v.n)
        minimum(SmallVector(w)) % T
    else
        invoke(minimum, Tuple{AbstractVector{T}}, v)
    end
end

"""
    support(v::PackedVector) -> SmallBitSet

Return the `SmallBitSet` with the indices of the non-zero elements of `v`.
If `v` has `Bool` elements, then this means the elements that are `true`.

See also [`SmallBitSet`](@ref).

# Example
```jldoctest
julia> v = PackedVector{UInt,5,Int8}([1, 0, 2, 0, 0, 3]);

julia> support(v)
SmallBitSet{$UInt} with 3 elements:
  1
  3
  6
```
"""
function support(v::PackedVector{U,M}) where {U,M}
    S = SmallBitSet{UInt}
    capacity(v) <= capacity(S) || length(v) <= capacity(S) ||
        error(LazyString(S, " can only contain integers between 1 and ", capacity(S)))
    mask = one(U) << M - one(U)
    m = zero(UInt)
    b = one(m)
    for i in eachindex(v)
        if !iszero(v.m & mask)
            m |= b
        end
        mask <<= M
        b <<= 1
    end
    convert(S, m)
end

support(v::PackedVector{U,1}) where U = convert(SmallBitSet{UInt}, bits(v))

function Random.rand(rng::AbstractRNG, ::SamplerType{PackedVector{U,M,T}}) where {U,M,T}
    n = rand(0:capacity(PackedVector{U,M,T}))
    mask = one(U) << unsigned(M*n) - one(U)
    PackedVector{U,M,T}(rand(U) & mask, n)
end

#
# conversion to SmallVector
#

@propagate_inbounds function SmallVector{N,T}(v::PackedVector{U,M,S}) where {N,T,U,M,S}
    if bitsize(T) == M && (T <: Signed) == (S <: Signed)
        @boundscheck if N < capacity(PackedVector{U,M,S})
            length(v) <= N || error(LazyString("vector cannot have more than ", N, " elements"))
        end
        b = convert(FixedVector{N,T}, v.m)
        SmallVector{N,T}(b, length(v))
    else
        invoke(SmallVector{N,T}, Tuple{AbstractVector{S}}, v)
    end
end

function SmallVector(v::PackedVector{U,M,T}) where {U,M,T}
    N = capacity(v)
    SmallVector{N,T}(v)
end

"""
    $(@__MODULE__).bitsize(T::Type) -> Int
    $(@__MODULE__).bitsize(x::T) where T -> Int

Return the size of the internal binary representation of `T` in bits.
For `Bool` the function returns `1`.

See also `Base.sizeof`.
"""
bitsize(::T) where T = bitsize(T)
bitsize(::Type{T}) where T = 8*sizeof(T)
bitsize(::Type{Bool}) = 1

llvm_type(::Type{Float16}) = "half"
llvm_type(::Type{Float32}) = "float"
llvm_type(::Type{Float64}) = "double"
llvm_type(::Type{T}) where T <: Union{Bool, AbstractBitInteger, Char, Enum} = string('i', 8*sizeof(T))

function llvm_type(N, ::Type{T}) where T
    if T <: AbstractFloat
        string('v', N, 'f', bitsize(T))
    else
        string('v', N, 'i', 8*sizeof(T))
    end
end

if VERSION > v"1.13-"
    @generated function llvm_range(x::T, ::Val{RANGE}) where {T <: AbstractBitInteger, RANGE}
        lo::T, hi::T = extrema(RANGE::UnitRange)
        hi += one(T)
        hi == lo && return :(x)
        L = llvm_type(T)
        ir = """
            define range($L $lo, $hi) $L @f($L %x) alwaysinline {
                ret $L %x
            }
        """
        quote
            Base.llvmcall(($ir, "f"), T, Tuple{T}, x)
        end
    end
else
    llvm_range(x::AbstractBitInteger, @nospecialize ::Val) = x
end

"""
    $(@__MODULE__).top_set_bit(x::AbstractBitInteger) -> Int

Return the position of the highest set bit in `x` (counting from `1`),
or return `0` if `x` is `0`.

This function is analogous to Julia's internal function `Base.top_set_bit`,
but it is also fast and correct for bit integers defined by `BitIntegers.jl`.

See also `Base.top_set_bit`, [`$(@__MODULE__).AbstractBitInteger`](@ref).
"""
top_set_bit(x::T) where T <: AbstractBitInteger = bitsize(T) - leading_zeros(x)

"""
    $(@__MODULE__).unsafe_shl(x::U, i::Integer) where U <: AbstractBitInteger -> U

This is a fast, but unsafe version of the left bit shift operator `x << i`.
The shift `i` is assumed to be between `0` and `bitsize(x)-1`.

See also [`$(@__MODULE__).bitsize`](@ref), [`$(@__MODULE__).AbstractBitInteger`](@ref).
"""
@generated function unsafe_shl(x::U, i::Integer) where U <: AbstractBitInteger
    b = bitsize(U)
    ir = """
        %r = shl i$b %0, %1
        ret i$b %r
    """
    quote
        $(Expr(:meta, :inline))
        Base.llvmcall($ir, U, Tuple{U, U}, x, i % U)
    end
end

"""
    $(@__MODULE__).unsafe_lshr(x::U, i::Integer) where U <: AbstractBitInteger -> U

This is a fast, but unsafe version of the logical (or unsigned) right bit shift operator `x >>> i`.
The shift `i` is assumed to be between `0` and `bitsize(x)-1`.

See also [`$(@__MODULE__).bitsize`](@ref), [`$(@__MODULE__).AbstractBitInteger`](@ref).
"""
@generated function unsafe_lshr(x::U, i::Integer) where U <: AbstractBitInteger
    b = bitsize(U)
    ir = """
        %r = lshr i$b %0, %1
        ret i$b %r
    """
    quote
        $(Expr(:meta, :inline))
        Base.llvmcall($ir, U, Tuple{U, U}, x, i % U)
    end
end

"""
    $(@__MODULE__).blsi(x::T) where T <: Integer -> T

Extract the lowest set bit of `x`.
For hardware integers, this compiles to a single `BLSI` instruction from the
[BMI1](https://en.wikipedia.org/wiki/X86_Bit_manipulation_instruction_set#BMI1_(Bit_Manipulation_Instruction_Set_1))
instruction set on `x86_64` and `i686` machines.

See also [`$(@__MODULE__).blsr`](@ref), [`$(@__MODULE__).blsmsk`](@ref).
"""
blsi(x::Integer) = x & -x

"""
    $(@__MODULE__).blsr(x::T) where T <: Integer -> T

Reset the lowest set bit of `x`.
For hardware integers, this compiles to a single `BLSR` instruction from the
[BMI1](https://en.wikipedia.org/wiki/X86_Bit_manipulation_instruction_set#BMI1_(Bit_Manipulation_Instruction_Set_1))
instruction set on `x86_64` and `i686` machines.

See also [`$(@__MODULE__).blsi`](@ref), [`$(@__MODULE__).blsmsk`](@ref).
"""
blsr(x::Integer) = x & (x-one(x))

"""
    $(@__MODULE__).blsmsk(x::T) where T <: Integer -> T

Get the bit mask up to lowest set bit of `x`.
For hardware integers, this compiles to a single `BLSMSK` instruction from the
[BMI1](https://en.wikipedia.org/wiki/X86_Bit_manipulation_instruction_set#BMI1_(Bit_Manipulation_Instruction_Set_1))
instruction set on `x86_64` and `i686` machines.

See also [`$(@__MODULE__).blsi`](@ref), [`$(@__MODULE__).blsr`](@ref).
"""
blsmsk(x::Integer) = x ⊻ (x-one(x))

"""
    $(@__MODULE__).pdep(x::Unsigned, y::U) where U <: Unsigned -> U

Assume that `y` has exactly `m` `1`-bits. Then `pdep(x, y)` replaces these bits by the `m` lowest bits
of `x` (in order) and returns the result. The remaining bits of `x` are ignored.

On `x86_64` and `i686` machines, this function uses the corresponding instruction from the
[BMI2](https://en.wikipedia.org/wiki/X86_Bit_manipulation_instruction_set#BMI2) instruction set
if possible. Without hardware support it is much slower.
"""
function pdep(x::Unsigned, y::U) where U <: Unsigned
    if HAS_PEXT && ispow2(bitsize(U))
        V = uinttype(Val(bitsize(U) ÷ 2))
        y_lo, y_hi = reinterpret(Tuple{V, V}, y)
        x_lo = x % V
        x_hi = (x >> count_ones(y_lo)) % V
        return reinterpret(U, (pdep(x_lo, y_lo), pdep(x_hi, y_hi)))
    end
    a = zero(U)
    while !iszero(y)
        b = blsi(y)
        a |= b & -(isodd(x) % U)
        y ⊻= b
        x >>>= 1
    end
    a
end

"""
    $(@__MODULE__).pext(x::Unsigned, y::U) where U <: Unsigned -> U

The bits in `x` corresponding to the `1`-bits in `y` are compressed to the lowest bits of the result;
the higher bits are set to `0`.

On `x86_64` and `i686` machines, this function uses the corresponding instruction from the
[BMI2](https://en.wikipedia.org/wiki/X86_Bit_manipulation_instruction_set#BMI2) instruction set
if possible. Without hardware support it is much slower.
"""
function pext(x::Unsigned, y::U) where U <: Unsigned
    if HAS_PEXT && ispow2(bitsize(U))
        V = uinttype(Val(bitsize(U) ÷ 2))
        x_lo, x_hi = reinterpret(Tuple{V, V}, x % U)
        y_lo, y_hi = reinterpret(Tuple{V, V}, y)
        a_lo, a_hi = pext(x_lo, y_lo), pext(x_hi, y_hi)
        return a_lo | (a_hi % U) << count_ones(y_lo)
    end
    a = zero(y)
    c = one(y)
    while !iszero(y)
        b = blsi(y)
        y ⊻= b
        a |= ifelse(iszero(b & x), zero(c), c)
        c <<= 1
    end
    a
end

function unsafe_div(x::U, y::V) where {U <: Unsigned, V <: Unsigned}
    W = promote_type(U, V)
    if W <: Union{UInt8, UInt16, UInt32}
        Base.llvmcall("""
                %a = udiv i32 %0, %1
                ret i32 %a
            """, UInt32, Tuple{UInt32, UInt32}, x % UInt32, y % UInt32) % U
    elseif W == UInt64
        Base.llvmcall("""
                %a = udiv i64 %0, %1
                ret i64 %a
            """, UInt64, Tuple{UInt64, UInt64}, x % UInt64, y % UInt64) % U
    else
        div(x, y)
    end
end

function unsafe_rem(x::BitInteger, y::Base.BitUnsigned32)
    Base.llvmcall("""
            %a = srem i64 %0, %1
            ret i64 %a
        """, Int64, Tuple{Int64, Int64}, x, y % Int64)
end

function unsafe_rem(x::T, y::Union{UInt8, UInt16}) where T <: Base.BitSigned32
    Base.llvmcall("""
            %a = srem i32 %0, %1
            ret i32 %a
        """, Int32, Tuple{Int32, Int32}, x % Int32, y % Int32) % T
end

function unsafe_rem(x::UInt64, y::Base.BitUnsigned32)
    Base.llvmcall("""
            %a = urem i64 %0, %1
            ret i64 %a
        """, UInt64, Tuple{UInt64, UInt64}, x, y % UInt64)
end

function unsafe_rem(x::T, y::Base.BitUnsigned32) where T <: Base.BitUnsigned32
    Base.llvmcall("""
            %a = urem i32 %0, %1
            ret i32 %a
        """, UInt32, Tuple{UInt32, UInt32}, x % UInt32, y % UInt32) % T
end

unsafe_rem(x::Integer, y::Unsigned) = rem(x, y)

function unsafe_mod(x::Integer, y::T) where T <: Unsigned
    r = unsafe_rem(x, y)
    ifelse(r < 0, r % T + y, r % T)
end

function unsafe_mod1(x::Integer, y::T) where T <: Unsigned
    r = unsafe_rem(x, y)
    ifelse(r <= 0, r % T + y, r % T)
end

unsafe_int(x::Integer) = x % Int
unsafe_int(x) = Int(x)

function unsafe_length(r::OrdinalRange{T}) where T <: Union{AbstractBitInteger,Bool,Char}
    r0, s, r1 = ifelse(signbit(step(r)),
        (last(r), unsigned(-step(r)), first(r)),
        (first(r), unsigned(step(r)), last(r)))
    n = unsafe_div(unsigned(r1-r0), s) % Int + 1
    ifelse(r0 <= r1, n, 0)
end

unsafe_length(r::OrdinalRange) = length(r)

using Documenter
using SmallCollections
using StaticArrays: StaticArrays

DocMeta.setdocmeta!(SmallCollections, :DocTestSetup, quote
        using SmallCollections
        # for jldoctest in docstrings
    end; recursive = true)

makedocs(sitename = "SmallCollections.jl",
    modules = [
        SmallCollections,
        Base.get_extension(SmallCollections, :StaticArraysExt),
    ],
    pages = [
        "index.md",
        "fixedvector.md",
        "smallvector.md",
        "packedvector.md",
        "broadcast.md",
        "smalldict.md",
        "smallset.md",
        "smallbitset.md",
        "bangbang.md",
        "nonexported.md",
    ],
    format = Documenter.HTML(),
    warnonly = true)

#
# common definitions for AbstractFixedVector and AbstractSmallVector
#

export fixedvector, support, invreplace

import Base: findall, findfirst, findlast, findprev, findnext, findmin, findmax,
    any, all, allequal, allunique, count, getindex, filter, checkindex, copy,
    issorted, checkbounds, isless, <=

capacity(::Type{<:AbstractFixedOrSmallVector{N}}) where N = N

copy(v::V) where V <: AbstractFixedOrSmallVector = V(v)

function fixedvector(v::AbstractFixedOrSmallVector{N,T}, ::Val{M}) where {N,T,M}
    b = fixedvector(v)
    FixedVector{M,T}(ntuple(i -> i <= N ? b[i] : default(T), Val(M)))
end

function isless(v::V, w::V) where V <: Union{AbstractFixedOrSmallVector{8,UInt8}, AbstractFixedOrSmallVector{16,UInt8}}
    bv = bswap(bits(v))
    bw = bswap(bits(w))
    bv < bw || (bv == bw) & (length(v) < length(w))
end

for T in (:Integer, :AbstractChar, :AbstractString)
    @eval function <=(v::AbstractFixedOrSmallVector{<:Any, <:$T}, w::AbstractFixedOrSmallVector{<:Any, <:$T})
        !(w < v)
    end
end

support(v::AbstractFixedOrSmallVector) = _SmallBitSet(bits(map(!iszero, v)))

@inline _support(f, v::AbstractFixedVector; style) = (@inline; support(f, v))
@inline _support(f, v::AbstractSmallVector; style) = (@inline; support(f, v; style))

_map(f, v::AbstractFixedVector; style) = map(f, v)
_map(f, v::AbstractSmallVector; style) = map(f, v; style)

struct AssertBool{F}
    f::F
end

(ab::AssertBool)(x) = ab.f(x)::Bool

MapStyle(ab::AssertBool, types::Type...) = MapStyle(ab.f, types...)

findall(v::AbstractFixedOrSmallVector; kw...) = findall(identity, v; kw...)

@inline function findall(f::F, v::AbstractFixedOrSmallVector{N}; kw...) where {F <: Function, N}
    @inline
    @inbounds SmallVector{N,SmallLength}(support(AssertBool(f), v; kw...))
end

findfirst(v::AbstractFixedOrSmallVector{N,Bool}) where N = findfirst(identity, v; style = StrictStyle())
findlast(v::AbstractFixedOrSmallVector{N,Bool}) where N = findlast(identity, v; style = StrictStyle())

findnext(v::AbstractFixedOrSmallVector{N,Bool}, k::Integer) where N = findnext(identity, v, k; style = StrictStyle())
findprev(v::AbstractFixedOrSmallVector{N,Bool}, k::Integer) where N = findprev(identity, v, k; style = StrictStyle())

function findfirst(f::F, v::AbstractFixedOrSmallVector{N,T}; style = MapStyle(f, T)) where {F <: Function, N, T}
    findnext(f, v, 1; style)
end

function findnext(f::F, v::AbstractFixedOrSmallVector{N,T}, k::Integer; style = MapStyle(f, T)) where {F<: Function, N, T}
    @inline
    if style isa LazyStyle
        invoke(findnext, Tuple{F,AbstractVector{T},Integer}, f, v, k)
    else
        m = bits(filter(>=(k), @inline support(AssertBool(f), fixedvector(v))))
        i = trailing_zeros(m)+1
        i <= length(v) ? i : nothing
    end
end

function findlast(f::F, v::AbstractFixedOrSmallVector{N,T}; style = MapStyle(f, T)) where {F <: Function, N, T}
    findprev(f, v, length(v); style)
end

function findprev(f::F, v::AbstractFixedOrSmallVector{N,T}, k::Integer; style = MapStyle(f, T)) where {F <: Function, N, T}
    @inline
    if style isa LazyStyle
        invoke(findprev, Tuple{F,AbstractVector{T},Integer}, f, v, k)
    else
        m = bits(filter(<=(k), @inline support(AssertBool(f), fixedvector(v))))
        i = bitsize(m)-leading_zeros(m)
        0 != i <= length(v) ? i : nothing
    end
end

@propagate_inbounds findmin(v::AbstractFixedOrSmallVector) = findmin(identity, v)
@propagate_inbounds findmax(v::AbstractFixedOrSmallVector) = findmax(identity, v)

@inline function findmin(f::F, v::AbstractFixedOrSmallVector{N,T}; style = MapStyle(f, T)) where {F,N,T}
    @boundscheck isempty(v) && error("argument must not be empty")
    y = minimum(f, v)
    y, findfirst(isequal(y)∘f, fixedvector(v); style)::Int
end

@inline function findmax(f::F, v::AbstractFixedOrSmallVector{N,T}; style = MapStyle(f, T)) where {F,N,T}
    @boundscheck isempty(v) && error("argument must not be empty")
    y = maximum(f, v)
    y, findfirst(isequal(y)∘f, fixedvector(v); style)::Int
end

if VERSION < v"1.14-"
    any(v::AbstractFixedOrSmallVector; kw...) = any(identity, v; kw...)
    all(v::AbstractFixedOrSmallVector; kw...) = all(identity, v; kw...)
end

function any(f::F, v::AbstractFixedOrSmallVector{N,T}; dims = :, style::MapStyle = MapStyle(f, T)) where {F<:Function,N,T}
    @inline
    if style isa LazyStyle || !(dims isa Colon)
        invoke(any, Tuple{F,AbstractVector{T}}, f, v; dims)
    else
        u = map(AssertBool(f), fixedvector(v))
        trailing_zeros(bits(u)) < length(v)
    end
end

function all(f::F, v::AbstractFixedOrSmallVector{N,T}; dims = :, style::MapStyle = MapStyle(f, T)) where {F<:Function,N,T}
    @inline
    if style isa LazyStyle || !(dims isa Colon)
        invoke(all, Tuple{F,AbstractVector{T}}, f, v; dims)
    else
        u = map(AssertBool(f), fixedvector(v))
        trailing_ones(bits(u)) >= length(v)
    end
end

allequal(v::AbstractFixedOrSmallVector) = isempty(v) ? true : all(isequal(@inbounds v[1]), v)

function allequal(f::F, v::AbstractFixedOrSmallVector{N,T}; style::MapStyle = MapStyle(f, T)) where {F,N,T}
    @inline
    if style isa LazyStyle
        invoke(allequal, Tuple{F,AbstractVector{T}}, f, v)
    else
        allequal(_map(f, v; style))
    end
end

allunique(v::AbstractFixedOrSmallVector) = all(x -> count(isequal(x), v) == 1, v)

function allunique(f::F, v::AbstractFixedOrSmallVector{N,T}; style::MapStyle = MapStyle(f, T)) where {F,N,T}
    @inline
    if style isa LazyStyle
        invoke(allunique, Tuple{F,AbstractVector{T}}, f, v)
    else
        allunique(_map(f, v; style))
    end
end

count(v::AbstractFixedOrSmallVector; kw...) = count(identity, v; kw...)

@inline function count(f::F, v::AbstractFixedOrSmallVector{N,T}; dims = :, init::S = 0, style = MapStyle(f, T)) where {F,N,T,S}
    @inline
    if style isa LazyStyle || !(dims isa Colon)
        invoke(count, Tuple{Any, AbstractVector}, f, v; dims, init)
    else
        k = length(_support(AssertBool(f), v; style))
        init + (S <: Integer ? k % S : k)
    end
end

"""
    issorted(v::AbstractFixedVector; [strict::Bool = false, style::MapStyle, ...]) -> Bool
    issorted(v::AbstractSmallVector; [strict::Bool = false, style::MapStyle, ...]) -> Bool

Returns `true` is `v` is sorted. In addition to the standard options `lt`, `by`, `rev` and `order`,
this dedicated method supports the keyword arguments `strict` and `style`.
If `style` is not `LazyStyle()`, then more comparisons than strictly necessary may be performed.
Setting `strict` to `true` checks if the vector is strictly sorted.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions. Currently the `order` keyword, if present, enforces `LazyStyle`.

See also [`$(@__MODULE__).MapStyle`](@ref), `Base.issorted(::AbstractVector)`.

# Examples
```jldoctest
julia> v = SmallVector{8,Int8}([3, 2, 2]); issorted(v)
false

julia> v = SmallVector{8,Int8}([3, 2, 2]); issorted(v; rev = true)
true

julia> v = SmallVector{8,Int8}([3, 2, 2]); issorted(v; rev = true, strict = true)
false
```
"""
function issorted(v::AbstractFixedOrSmallVector{N,T};
        lt = isless, by = identity, rev::Union{Bool,Nothing} = nothing,
        order::Base.Order.Ordering = Base.Order.Forward,
        strict::Bool = false,
        style::MapStyle = begin
            U = Core.Compiler.return_type(by, Tuple{T})
            isconcretetype(U) ? MapStyle(lt, U, U) : LazyStyle()
        end) where {N,T}
    @inline
    if order === Base.Order.Forward && style != LazyStyle()
        w = map(by, fixedvector(v))
        u = popfirst(w)[1]
        if rev == true
            w, u = u, w
        end
        b = strict ? map(!lt, w, u) : map(lt, u, w)
        i = findfirst(b)
        i === nothing || i >= length(v)
    elseif strict
        issorted_strict(v, Base.Order.ord(lt, by, rev, order))  # function barrier
    else
        invoke(issorted, Tuple{AbstractVector}, v; lt, by, rev, order)
    end
end

issorted_strict(v, o) = all(i -> @inbounds(Base.Order.lt(o, v[i], v[i+1])), OneTo(length(v)-1))

function checkindex(::Type{Bool}, inds::AbstractUnitRange, v::AbstractFixedOrSmallVector{N,T}) where {N, T <: Base.HWReal}
    if isempty(v)
        true
    else
        min, max = extrema(v)
        first(inds) <= min && max <= last(inds)
    end
end

@inline function getindex(v::AbstractFixedOrSmallVector{N,T}, ii::OrdinalRange{<:Integer}) where {N,T}
    @boundscheck checkbounds(v, ii)
    if ii isa OneTo
        @inbounds resize(v, length(ii))
    elseif ii isa AbstractUnitRange && hasshuffle(v, Val(true))
        w = unsafe_circshift(fixedvector(v), 1-first(ii))
        SmallVector(padtail(w, length(ii)), length(ii))
    else
        @inbounds SmallVector{N,T}(v[i] for i in ii)
    end
end

"""
    getindex(v::Union{AbstractFixedVector{N,T}, AbstractSmallVector{N,T}}, s::SmallBitSet) where {N,T} -> SmallVector{N,T}

Returns the vector with elements `v[i]` where `i` runs through the elements of `s` in increasing order.
This operation is analogous to `v[collect(s)]`, but faster.

See also [`checkbounds`](@ref).

# Example
```jldoctest
julia> v = SmallVector{8}('a':'f'); s = SmallBitSet{UInt16}(1:2:5)
SmallBitSet{UInt16} with 3 elements:
  1
  3
  5

julia> v[s]
3-element SmallVector{8, Char}:
 'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
 'c': ASCII/Unicode U+0063 (category Ll: Letter, lowercase)
 'e': ASCII/Unicode U+0065 (category Ll: Letter, lowercase)
```
"""
getindex(v::AbstractFixedOrSmallVector, s::SmallBitSet)

@inline function getindex(v::AbstractFixedOrSmallVector{N,T}, s::SmallBitSet{U}) where {N,T,U}
    @boundscheck checkbounds(v, s)
    if HAS_PEXT && T == Bool && bitsize(U) <= bitsize(UInt)
        m = pext(bits(fixedvector(v)), bits(s))
        b = convert(FixedVector{N,Bool}, m)
        SmallVector(b, length(s))
    elseif VERSION >= v"1.11" && ishwtype(T) && (HAS_COMPRESS || N <= 32)  # slows down for larger N
        SmallVector(compress(fixedvector(v), s), length(s))
    else
        SmallVector{N,T}(@inbounds v[i] for i in s)
    end
end

const AbstractFixedOrSmallOrPackedVector{T} = Union{AbstractFixedOrSmallVector{<:Any,T},PackedVector{<:Any,<:Any,T}}

"""
    checkbounds(::Type{Bool}, v::Union{AbstractFixedVector, AbstractSmallVector, PackedVector}, s::SmallBitSet) -> Bool

Returns `true` if all elements of `s` are inbounds for `v`.

See alse `Base.checkbounds`.

# Examples
```jldoctest
julia> v = SmallVector{8,Int8}(1:3)
3-element SmallVector{8, Int8}:
 1
 2
 3

julia> s = SmallBitSet{UInt8}((1, 4))
SmallBitSet{UInt8} with 2 elements:
  1
  4

julia> checkbounds(Bool, v, s)
false

julia> checkbounds(v, s)
ERROR: BoundsError: attempt to access 3-element SmallVector{8, Int8} at index [SmallBitSet{UInt8}([1, 4])]
```
"""
function checkbounds(::Type{Bool}, v::AbstractFixedOrSmallOrPackedVector, s::SmallBitSet)
    isempty(s) || checkbounds(Bool, v, last(s))
end

@inline function getindex(v::AbstractFixedOrSmallOrPackedVector, ii::AbstractFixedOrSmallOrPackedVector{Bool})
    @boundscheck checkbounds(v, ii)
    @inbounds v[support(ii)]
end

@inline function getindex(v::V, ii::AbstractFixedOrSmallOrPackedVector{T}) where {V <: AbstractVector, T <: Integer}
    @boundscheck checkbounds(v, ii)
    if T == Bool
        @inbounds invoke(getindex, Tuple{V,AbstractVector{Bool}}, v, ii)
    else
        map(i -> @inbounds(v[i]), ii)
    end
end

@inline function getindex(v::PackedVector, ii::AbstractFixedOrSmallVector{<:Integer})
    @boundscheck checkbounds(v, ii)
    map(i -> @inbounds(v[i]), ii)
end

"""
    $(@__MODULE__).getindex0(
        v::Union{AbstractFixedVector{N,T}, AbstractSmallVector{N,T}},
        ii::AbstractFixedVector{M,S}
    ) where {N, T, M, S <: Integer} -> FixedVector{M,T}

    $(@__MODULE__).getindex0(
        v::Union{AbstractFixedVector{N,T}, AbstractSmallVector{N,T}},
        ii::AbstractSmallVector{M,S}
    ) where {N, T, M, S <: Integer} -> SmallVector{M,T}

This function for vector indexing is analogous to `getindex` with the difference
that the index vector `ii` is assumed to be `0`-based. This is particularly useful
for indexing a vector `v` with capacity `N = 256` efficiently via a vector `ii` with
element type `UInt8`.

See also `Base.getindex(::AbstractVector, ::AbstractVector{<:Integer})`.

# Example
```jldoctest
julia> using $(@__MODULE__): getindex0

julia> v = -FixedVector{8,Int8}(1:8);

julia> ii = FixedVector{4,UInt8}([0, 2, 3, 5]);

julia> getindex0(v, ii)
4-element FixedVector{4, Int8}:
 -1
 -3
 -4
 -6

julia> getindex0(v, ii) == v[ii .+ 1]
true
```
"""
getindex0

@inline function getindex0(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractFixedVector{M,S}) where {N, T, M, S <: Integer}
    @boundscheck begin
        x, y = extrema(ii)
        checkbounds(v, x+1:y+1)
    end
    if hasshuffle(v, ii, Val(true))
        U = uinttype(T)
        shuffle(fixedvector(v), ii .% U, Val(true))
    elseif isbitstype(T)
        w = MutableFixedVector{M,T}(undef)
        for j in 1:M
            @inbounds w[j] = v[ii[j]+1]
        end
        FixedVector(w)
    else
        map(i -> @inbounds(v[i+1]), ii)
    end
end

@inline function getindex0(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractSmallVector{M,S}) where {N, T, M, S <: Integer}
    @boundscheck isempty(ii) || begin
        x, y = extrema(fixedvector(ii))
        checkbounds(v, x+1:y+1)
    end
    @inbounds w = getindex0(v, fixedvector(ii))
    SmallVector(padtail(w, length(ii)), length(ii))
end

@inline function getindex(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractFixedVector{M,S}) where {N, T, M, S <: BitInteger}
    @boundscheck checkbounds(v, ii)
    if hasshuffle(v, ii, Val(true))
        U = uinttype(T)
        shuffle(fixedvector(v), ii .% U .- one(U), Val(true))
    elseif isbitstype(T)
        w = MutableFixedVector{M,T}(undef)
        for j in 1:M
            @inbounds w[j] = v[ii[j]]
        end
        FixedVector(w)
    else
        map(i -> @inbounds(v[i]), ii)
    end
end

@inline function getindex(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractSmallVector{M,S}) where {N, T, M, S <: BitInteger}
    @boundscheck checkbounds(v, ii)
    if hasshuffle(v, ii, Val(false))
        U = inttype(T)
        w = shuffle(fixedvector(v), (fixedvector(ii) .% U) .- one(U), Val(false))
        SmallVector(w, length(ii))
    elseif isbitstype(T)
        w = MutableSmallVector{M,T}(undef, length(ii))
        for j in 1:length(ii)
            @inbounds w[j] = v[ii[j]]
        end
        SmallVector(w)
    else
        map(i -> @inbounds(v[i]), ii)
    end
end

"""
    invreplace(s::SmallBitSet, v::Union{AbstractFixedVector{N,T}, AbstractSmallVector{N,T}}) where {N, T <: Integer} -> SmallBitSet

Returns the set of all integers `i` such that `v[i]` is in `s`. The elements
of `v` must be in the range `1:M` where `M` is the capacity of `s`.
Hence if `p` is a permutation (sending each `i` to `p[i]`), then `invreplace(s, p)`
contains the images of the elements of `s` under the permutation inverse to `p`.

See also `Base.replace`, [`exchange`](@ref), [`capacity`](@ref capacity(::SmallBitSet)).

# Example
```jldoctest
julia> s = SmallBitSet{UInt8}([1, 3, 7]);

julia> p = FixedVector{8,Int8}([3, 1, 2, 8, 4, 5, 6, 7]);

julia> t = invreplace(s, p)
SmallBitSet{UInt8} with 3 elements:
  1
  2
  8

julia> t == replace(s, (j => i for (i, j) in enumerate(p))...)
true

julia> v = SmallVector{16,UInt8}([3, 3, 3, 3]);

julia> invreplace(s, v)
SmallBitSet{UInt16} with 4 elements:
  1
  2
  3
  4
```
"""
@propagate_inbounds function invreplace(s::SmallBitSet, v::AbstractFixedOrSmallVector{N,T}) where {N, T <: Integer}
    M = bitsize(s)
    w = convert(FixedVector{M,Bool}, bits(s))
    _SmallBitSet(bits(w[v]))
end

function filter(f::F, v::AbstractFixedOrSmallVector; kw...) where F
    @inbounds v[support(f, v; kw...)]
end

const avx512_maxbits = 8192

"""
    $(@__MODULE__).hasshuffle(::Val{N}, ::Type{T}, ::Val{INB}) where {N,T,INB}
    $(@__MODULE__).hasshuffle(v::AbstractFixedOrSmallVector{N,T}, ::Val{INB}) where {N,T,INB}
    $(@__MODULE__).hasshuffle(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractFixedOrSmallVector{M}, ::Val{INB}) where {N,T,M,INB}

Returns `true` if there is a hardware-accelerated method
for vector indexing of a vector with element type `T` and capacity (at most) `N`.
The index vector is assumed to have capacity at most `N`, too.
The Boolean parameter `INB` indicates if all indices are within bounds (`INB = true`) or
if negative indices are used to zero entries (`INB = false`).
The 3-argument version is equivalent to `hasshuffle(Val(max(N, M)), T, Val(INB))`.

The currently supported methods are
[AVX](https://en.wikipedia.org/wiki/Advanced_Vector_Extensions) (up to 128 bits),
[AVX2](https://en.wikipedia.org/wiki/AVX2) (up to 256 bits)
and [AVX-512](https://en.wikipedia.org/wiki/AVX-512), more precisely AVX-512_VBMI
(implemented for any bit size, but limited by `hasshuffle` to at most $avx512_maxbits bits).

See also [`$(@__MODULE__).shuffle`](@ref).
"""
hasshuffle

hasshuffle(v::AbstractFixedOrSmallVector{N,T}, inbounds) where {N,T} = hasshuffle(Val(N), T, inbounds)
hasshuffle(v::AbstractFixedOrSmallVector{N,T}, ii::AbstractFixedOrSmallVector{M}, inbounds) where {N,T,M} = hasshuffle(Val(max(N, M)), T, inbounds)

"""
    $(@__MODULE__).shuffle(v::AbstractFixedVector{NT,T}, p::AbstractFixedVector{M}, ::Val{INB}) where {NT,T,M,INB} -> FixedVector{M,T}

Uses hardware acceleration to permute the elements of `v` and returns the new vector `w`, and `false` otherwise.
The permutation `p` must be 0-based. In other words, `w[i] == v[p[i]+1]` for any index `i` of `p`.
If `p[i]` is negative, then `w[i]` is set to `default(T)`.
Bounds are not checked. Moreover, negative indices must be in the range `-M:-1`.
The Boolean parameter `INB` indicates whether all indices are within bounds (`INB = true`) or
if negative indices may occur (`INB = false`).

See also [`$(@__MODULE__).hasshuffle`](@ref), [`$(@__MODULE__).default`](@ref), [`$(@__MODULE__).getindex0`](@ref).
"""
shuffle

using BitPermutations, SmallCollections, Chairmarks
using Base: Fix2
using Random: randperm

@info first(Sys.cpu_info()).model

@inline inbounds_invreplace(s, v) = @inbounds invreplace(s, v)

@info "bitpermute / invreplace"
for U in [UInt8, UInt16, UInt32, UInt64, UInt128]
    print("$U\t")
    N = bitsize(U)
    v = randperm(N)
    p1 = BitPermutation{U}(v)
    p2 = FixedVector{N,UInt8}(v)
    s = rand(SmallBitSet{U})
    x = bits(s)
    @assert bitpermute(x, p1) == bits(inbounds_invreplace(s, p2))
    display(@b bitpermute($x, $p1), inbounds_invreplace($s, $p2))
end

@info "bitpermute! / map bitpermute / map invreplace"
M = 1000
for U in [UInt8, UInt16, UInt32, UInt64, UInt128]
    print("$U\t")
    N = bitsize(U)
    v = randperm(N)
    p1 = BitPermutation{U}(v)
    p2 = FixedVector{N,UInt8}(v)
    q2 = rand(SmallBitSet{U}, M)
    q1 = map(bits, q2)
    @assert map(Fix2(bitpermute, p1), q1) == map(bits∘Fix2(inbounds_invreplace, p2), q2)
    display(@b bitpermute!($q1, $p1), map!(Fix2(bitpermute, $p1), $q1, $q1), map!(Fix2(inbounds_invreplace, $p2), $q2, $q2))
end

using Chairmarks

macro bs(args...)
    b = esc(Expr(:macrocall, Symbol("@b"), __source__, args...))
    quote
        io = IOBuffer()
        show(io, MIME"text/plain"(), $b)
        String(take!(io))
    end
end

using Markdown: parse

using SmallCollections
using Base: Fix1, Fix2

function benchmark_set(::Val{N}, ::Type{U}, ::Type{T}, M) where {N,U,T}
    R = 1:N

    pp = [sizehint!(Set{T}(rand(R, rand(1:N÷2))), N) for M in 1:M]
    qq = [sizehint!(Set{T}(rand(R, rand(1:N÷2))), N) for M in 1:M]

    pq = [(pp, qq),
        (map(MutableSmallSet{N}, pp), map(MutableSmallSet{N}, qq)),
        (map(SmallSet{N}, pp), map(SmallSet{N}, qq)),
        (map(BitSet, pp), map(BitSet, qq)),
        (map(SmallBitSet{U}, pp), map(SmallBitSet{U}, qq)),
    ]

    c = [rand(T(1):T(N)) for _ in 1:M]

    a = fill("", length(pq), 12)

    for (i, (p, q)) in enumerate(pq)
        a[i, 1] = string('`', eltype(p), '`')
        a[i, 2] = @bs sum(sum, $p)
        a[i, 3] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(push, _, $p, $c) evals = 1
        else
            @bs deepcopy(p) foreach(push!,  _, $c) evals = 1
        end
        a[i, 4] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(first∘pop, _, $p) evals = 1
        else
            @bs deepcopy(p) foreach(pop!, _) evals = 1
        end
        a[i, 5] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(union, _, $p, $q)
        else
            @bs foreach(union!, $p, $q) evals = 1
        end
        a[i, 6] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(intersect, _, $p, $q)
        else
            @bs foreach(intersect!, $p, $q) evals = 1
        end
        a[i, 7] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(setdiff, _, $p, $q)
        else
            @bs foreach(setdiff!, $p, $q) evals = 1
        end
        a[i, 8] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!(symdiff, _, $p, $q)
        else
            @bs foreach(symdiff!, $p, $q) evals = 1
        end
        r = deepcopy(p)
        a[i, 9] = @bs similar(p, Bool) map!(issubset, _, $p, $r)
        a[i, 10] = if eltype(p) <: Union{SmallSet,SmallBitSet}
            @bs similar(p) map!((v, x) -> filter(>(x), v), _, $p, $c)
        else
            @bs foreach((v, x) -> filter!(>(x), v), $p, $c) evals = 1
        end
        a[i, 11] = @bs similar(p, Bool) map!(==, _, $p, $r)
        a[i, 12] = @bs similar(p, Bool) map!(in, _, $c, $p)
    end
    return a
end

function make_table_set(a)
    b = ["| " * join(a[i, :], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | sum | push | pop | union | intersect | setdiff | symdiff | issubset | filter | equal | in |
        | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
end

function make_table_set_raw(a)
    cols = [1, 3, 6, 9, 12]
    b = ["| " * join(a[i, cols], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | `push(!)` | `intersect(!)` | `issubset` | `in` |
        | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
end

M = 1000

for (N, U, T) in [(16, UInt16, Int16), (32, UInt32, Int16), (32, UInt32, Int8), (64, UInt64, Int8)]
    bs = benchmark_set(Val(N), U, T, M)
    display(parse(make_table_set(bs)))
    println()
    println(make_table_set_raw(bs))
    println()
end

using Chairmarks

macro bs(args...)
    b = esc(Expr(:macrocall, Symbol("@b"), __source__, args...))
    quote
        io = IOBuffer()
        show(io, MIME"text/plain"(), $b)
        String(take!(io))
    end
end

using Markdown: parse

using SmallCollections

function benchmark_dict(::Val{N}, ::Type{T}, M) where {N,T}
    pp = [MutableSmallDict{N,T,T}(rand(T) => k for k in 1:N-2) for _ in 1:M]

    pq = [map(d -> sizehint!(Dict(d), 2*N), pp), pp, map(SmallDict, pp)]

    k = map(rand, map(collect∘keys, pp))
    v = map(rand, map(collect∘values, pp))
    np = [Pair{T,T}(rand(T), rand(T)) for _ in 1:M]
    npk = map(first, np)
    npv = map(last, np)

    a = fill("", length(pq), 11)

    for (i, p) in enumerate(pq)
        D = eltype(p)

        a[i, 1] = string('`', eltype(p), '`')

        e = [rand(T) for _ in 1:M]
        a[i, 2] = if D <: Dict
            @bs similar(p) map!(y -> Dict{T,T}(k+y => k-y for k in T(1):T(N)), _, $e)
        elseif D <: SmallDict
            @bs similar(p) map!(y -> SmallDict{N,T,T}(k+y => k-y for k in T(1):T(N)), _, $e)
        elseif D <: MutableSmallDict
            @bs similar(p) map!(y -> MutableSmallDict{N,T,T}(k+y => k-y for k in T(1):T(N)), _, $e)
        end

        a[i, 3] = @bs similar(v) map!(getindex, _, $p, $k)

        a[i, 4] = if D <: AbstractSmallDict
            @bs similar(k) map!(invget, _, $p, $v)
            # @bs sum(splat(invget), zip($p, $v))
        else
            "n/a"
        end

        a[i, 5] = if D <: SmallDict
            @bs similar(p) map!(setindex, _, $p, $npv, $npk)
        else
            @bs deepcopy(p) foreach((d, v, k) -> setindex!(d, v, k), _, $npv, $npk) evals = 1
        end

        a[i, 6] = if D <: SmallDict
            @bs similar(p) map!(first∘pop, _, $p, $k)
        else
            @bs deepcopy(p) foreach(pop!, _, $k) evals = 1
        end

        a[i, 7] = @bs similar(p, Int) map!(d -> sum(p -> first(p)+last(p), d), _, $p)
    end

    return a
end

function make_table_dict(a)
    b = ["| " * join(a[i, :], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | create itr | getindex | invget | setindex(!) | pop(!) | iterate |
        | --- | --- | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    # c = replace(c, r"000 allocs: [^)]*" => " A")
    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
    return c
end

function make_table_dict_raw(a)
    cols = [1, 3, 4, 5, 6, 7]
    b = ["| " * join(a[i, cols], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | `getindex` | `invget` | `setindex(!)` | `pop(!)` | `iterate` |
        | --- | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    # c = replace(c, r"000 allocs: [^)]*" => " A")
    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
    return c
end

M = 1000

for (N, T) in [(16, Int16), (32, Int16), (32, Int8), (64, Int8)]
    bs = benchmark_dict(Val(N), T, M)
    display(parse(make_table_dict(bs)))
    println()
    println(make_table_dict_raw(bs))
    println()
end

using SmallCollections: bitsize, top_set_bit

@testset "bitsize" begin
    for T in (Int8, UInt16, Int32, UInt64, Int128, UInt256, Int440)
        @test_inferred bitsize(T) 8*sizeof(T)
    end
end

@testset "top_set_bit" begin
    for T in (UInt8, UInt16, UInt32, UInt64, UInt128, UInt256, UInt512, UInt440)
        @test_inferred top_set_bit(T(0)) 0
        m = bitsize(T)
        x = T(1) << (m-3) - T(3)
        @test_inferred top_set_bit(x) m-3
    end
end

using CpuId: cpufeature

if cpufeature(:BMI1)
    const llvm_bextr = "llvm.x86.bmi.bextr.$(bitsize(UInt))"

    bextr(x::U, y::Unsigned) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_bextr,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    const HAS_BEXTR = true
else
    const HAS_BEXTR = false
end

if cpufeature(:BMI2)
    const llvm_pdep = "llvm.x86.bmi.pdep.$(bitsize(UInt))"
    const llvm_pext = "llvm.x86.bmi.pext.$(bitsize(UInt))"

    pdep(x::Unsigned, y::U) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_pdep,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    pext(x::Unsigned, y::U) where U <: Union{UInt8,UInt16,UInt32,UInt} =
        ccall((llvm_pext,), llvmcall, UInt, (UInt, UInt), x % UInt, y % UInt) % U

    const HAS_PEXT = true
else
    const HAS_PEXT = false
end

using CpuId: CpuFeature, __ECX
const AVX512VBMI2 = CpuFeature(0x0000_0007, 0x00, __ECX, 6)
const HAS_COMPRESS = cpufeature(:AVX512VL) || cpufeature(AVX512VBMI2)

@inline @generated function shuffle(::Val{:avx}, v::AbstractFixedVector{N,T}, p::AbstractFixedVector{N,U}, @nospecialize(_)) where {N, T, U}
    @assert N*sizeof(T) == N*sizeof(U) == 16
    HT = hwtype(T)
    LHT = llvm_type(HT)
    LU = llvm_type(U)
    ir = """
        declare <16 x i8> @llvm.x86.ssse3.pshuf.b.128(<16 x i8>, <16 x i8>)
        define <$N x $LHT> @shuffle(<$N x $LHT>, <$N x $LU>) alwaysinline {
            %v = bitcast <$N x $LHT> %0 to <16 x i8>
            %p = bitcast <$N x $LU> %1 to <16 x i8>
            %w = call <16 x i8> @llvm.x86.ssse3.pshuf.b.128(<16 x i8> %v, <16 x i8> %p)
            %r = bitcast <16 x i8> %w to <$N x $LHT>
            ret <$N x $LHT> %r
        }
    """
    quote
        a = (0x0101010101010101 * sizeof(T)) % U
        b = 0x0706050403020100 % U
        q = p .* a .+ b
        t = Base.llvmcall(($ir, "shuffle"), NTuple{N,VecElement{$HT}},
            Tuple{NTuple{N,VecElement{$HT}}, NTuple{N,VecElement{U}}},
            vec(v), vec(q))
        FixedVector{N,T}(unvec(T, t))
    end
end

@inline @generated function shuffle(::Val{:avx2}, v::AbstractFixedVector{N,T}, p::AbstractFixedVector{N,U}, @nospecialize(_)) where {N, T, U}
    @assert N*sizeof(T) == N*sizeof(U) == 32
    HT = hwtype(T)
    LHT = llvm_type(HT)
    LU = llvm_type(U)
    s1 = join((string("i32 ", i & 15) for i in 0:31), ',')
    s2 = join((string("i32 ", i | 16) for i in 0:31), ',')
    m1 = VERSION >= v"1.12" ? "splat(i8 -1)" : '<' * join(("i8 -1" for i in 0:31), ',') * '>'
    ir = """
        declare <32 x i8> @llvm.x86.avx2.pshuf.b(<32 x i8>, <32 x i8>)
        define <$N x $LHT> @shuffle(<$N x $LHT>, <$N x $LU>) alwaysinline {
            %v = bitcast <$N x $LHT> %0 to <32 x i8>
            %p = bitcast <$N x $LU> %1 to <32 x i8>

            %a = insertelement <32 x i8> poison, i8 16, i32 0
            %b = shufflevector <32 x i8> %a, <32 x i8> poison, <32 x i32> zeroinitializer
            %c = icmp ult <32 x i8> %p, %b

            %q1 = select <32 x i1> %c, <32 x i8> %p, <32 x i8> $m1
            %v1 = shufflevector <32 x i8> %v, <32 x i8> poison, <32 x i32> <$s1>
            %w1 = call <32 x i8> @llvm.x86.avx2.pshuf.b(<32 x i8> %v1, <32 x i8> %q1)

            %q2 = select <32 x i1> %c, <32 x i8> $m1, <32 x i8> %p
            %v2 = shufflevector <32 x i8> %v, <32 x i8> poison, <32 x i32> <$s2>
            %w2 = call <32 x i8> @llvm.x86.avx2.pshuf.b(<32 x i8> %v2, <32 x i8> %q2)

            %w = xor <32 x i8> %w1, %w2
            %r = bitcast <32 x i8> %w to <$N x $LHT>
            ret <$N x $LHT> %r
        }
    """
    quote
        a = (0x0101010101010101 * sizeof(T)) % U
        b = 0x0706050403020100 % U
        q = p .* a .+ b
        t = Base.llvmcall(($ir, "shuffle"), NTuple{N,VecElement{$HT}},
            Tuple{NTuple{N,VecElement{$HT}}, NTuple{N,VecElement{U}}},
            vec(v), vec(q))
        FixedVector{N,T}(unvec(T, t))
    end
end

avx512_suffix(::Type{<:Union{Int8, UInt8, Bool}}) = "qi"
avx512_suffix(::Type{<:Union{Int16, UInt16}}) = "hi"
avx512_suffix(::Type{<:Union{Int32, UInt32, Char}}) = "d"
avx512_suffix(::Type{<:Union{Int64, UInt64}}) = "q"
avx512_suffix(::Type{Float32}) = "ps"
avx512_suffix(::Type{Float64}) = "pd"
avx512_suffix(::Type{<:Enum{T}}) where T = avx512_suffix(T)

@inline @generated function shuffle(::Val{:avx512}, v::AbstractFixedVector{N,T}, p::AbstractFixedVector{N,U}, @nospecialize(_)) where {N,T,U}
    @assert N*sizeof(T) == N*sizeof(U) in (16, 32, 64)
    HT = hwtype(T)
    LHT = llvm_type(HT)
    LU = llvm_type(U)
    LS = avx512_suffix(HT)
    M = 8 * sizeof(HT) * N
    ir = """
        declare <$N x $LHT> @llvm.x86.avx512.vpermi2var.$LS.$M(<$N x $LHT>, <$N x $LU>, <$N x $LHT>)
        define <$N x $LHT> @shuffle(<$N x $LHT>, <$N x $LU>) alwaysinline {
            %w = call <$N x $LHT> @llvm.x86.avx512.vpermi2var.$LS.$M(<$N x $LHT> %0, <$N x $LU> %1, <$N x $LHT> zeroinitializer)
            ret <$N x $LHT> %w
        }
    """
    quote
        # we use `llvmcall` because `ccall` treats `Bool` as `i1`, not `i8`
        t = Base.llvmcall(($ir, "shuffle"),
            NTuple{N, VecElement{$HT}},
            Tuple{NTuple{N, VecElement{$HT}}, NTuple{N, VecElement{U}}},
            vec(v), vec(p))
        FixedVector{N,T}(unvec(T, t))
    end
end

@inline function shuffle(::Val{:avx512}, v::AbstractFixedVector{N,Float16}, p::AbstractFixedVector{N}, inbounds::Val) where N
    u = reinterpret.(UInt16, v)
    w = shuffle(Val(:avx512), u, p, inbounds)
    reinterpret.(Float16, w)
end

function shuffle2ir(M, N, LT, LU, LS)
    if M == 512
        """
            declare <$N x $LT> @llvm.x86.avx512.vpermi2var.$LS.512(<$N x $LT>, <$N x $LU>, <$N x $LT>)
            define <$N x $LT> @shuffle2.512(<$N x $LT>, <$N x $LU>, <$N x $LT>) alwaysinline {
                %w = call <$N x $LT> @llvm.x86.avx512.vpermi2var.$LS.512(<$N x $LT> %0, <$N x $LU> %1, <$N x $LT> %2)
                ret <$N x $LT> %w
            }
        """
    else
        M2 = M ÷ 2
        N2 = N ÷ 2
        t1 = join((string("i32 ", k) for k in 0:N2-1), ", ")
        t2 = join((string("i32 ", k) for k in N2:N-1), ", ")
        m = VERSION >= v"1.12" ? "splat($LU $N)" : '<' * join(("$LU $N" for i in 0:N2-1), ',') * '>'
        shuffle2ir(M2, N2, LT, LU, LS) * """
            define <$N x $LT> @shuffle2.$M(<$N x $LT>, <$N x $LU>, <$N x $LT>) alwaysinline {
                %u1 = shufflevector <$N x $LT> %0, <$N x $LT> poison, <$N2 x i32> <$t1>
                %u2 = shufflevector <$N x $LT> %0, <$N x $LT> poison, <$N2 x i32> <$t2>
                %v1 = shufflevector <$N x $LT> %2, <$N x $LT> poison, <$N2 x i32> <$t1>
                %v2 = shufflevector <$N x $LT> %2, <$N x $LT> poison, <$N2 x i32> <$t2>
                %p1 = shufflevector <$N x $LU> %1, <$N x $LU> poison, <$N2 x i32> <$t1>
                %p2 = shufflevector <$N x $LU> %1, <$N x $LU> poison, <$N2 x i32> <$t2>
                %w11 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %u1, <$N2 x $LU> %p1, <$N2 x $LT> %u2)
                %w12 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %v1, <$N2 x $LU> %p1, <$N2 x $LT> %v2)
                %m1 = and <$N2 x $LU> %p1, $m
                %f1 = icmp ne <$N2 x $LU> %m1, zeroinitializer
                %w1 = select <$N2 x i1> %f1, <$N2 x $LT> %w12, <$N2 x $LT> %w11
                %w21 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %u1, <$N2 x $LU> %p2, <$N2 x $LT> %u2)
                %w22 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %v1, <$N2 x $LU> %p2, <$N2 x $LT> %v2)
                %m2 = and <$N2 x $LU> %p2, $m
                %f2 = icmp ne <$N2 x $LU> %m2, zeroinitializer
                %w2 = select <$N2 x i1> %f2, <$N2 x $LT> %w22, <$N2 x $LT> %w21
                %w = shufflevector <$N2 x $LT> %w1, <$N2 x $LT> %w2, <$N x i32> <$t1, $t2>
                ret <$N x $LT> %w
            }
        """
    end
end

const avx512_maxbits_inline = 2048

@generated function shuffle(::Val{:avx512merge}, v::AbstractFixedVector{N,T}, p::AbstractFixedVector{N,U}, ::Val{INB}) where {N,T,U,INB}
    @assert N*sizeof(T) == N*sizeof(U) >= 128 && ispow2(N)
    HT = hwtype(T)
    LT = llvm_type(HT)
    LU = llvm_type(U)
    LS = avx512_suffix(HT)
    M = 8 * sizeof(HT) * N
    inline = M <= avx512_maxbits_inline ? "alwaysinline" : ""
    M2 = M ÷ 2
    N2 = N ÷ 2
    t1 = join((string("i32 ", k) for k in 0:N2-1), ", ")
    t2 = join((string("i32 ", k) for k in N2:N-1), ", ")
    tail = if INB
        """
            ret <$N x $LT> %w
        """
    else
        """
            %f = icmp sge <$N x $LU> %1, zeroinitializer
            %r = select <$N x i1> %f, <$N x $LT> %w, <$N x $LT> zeroinitializer  ; clear entry if highest bit of mask is set
            ret <$N x $LT> %r
        """
    end
    ir = shuffle2ir(M, N, LT, LU, LS) * """
        define <$N x $LT> @shuffle(<$N x $LT>, <$N x $LU>) $inline {
            %v1 = shufflevector <$N x $LT> %0, <$N x $LT> poison, <$N2 x i32> <$t1>
            %v2 = shufflevector <$N x $LT> %0, <$N x $LT> poison, <$N2 x i32> <$t2>
            %p1 = shufflevector <$N x $LU> %1, <$N x $LU> poison, <$N2 x i32> <$t1>
            %p2 = shufflevector <$N x $LU> %1, <$N x $LU> poison, <$N2 x i32> <$t2>
            %w1 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %v1, <$N2 x $LU> %p1, <$N2 x $LT> %v2)
            %w2 = call <$N2 x $LT> @shuffle2.$M2(<$N2 x $LT> %v1, <$N2 x $LU> %p2, <$N2 x $LT> %v2)
            %w = shufflevector <$N2 x $LT> %w1, <$N2 x $LT> %w2, <$N x i32> <$t1, $t2>
            $tail
        }
    """
    quote
        t = Base.llvmcall(($ir, "shuffle"),
            NTuple{N, VecElement{$HT}},
            Tuple{NTuple{N, VecElement{$HT}}, NTuple{N, VecElement{U}}},
            vec(v), vec(p))
        FixedVector{N,T}(unvec(T, t))
    end
end

@inline function shuffle(::Val{:avx512merge}, v::AbstractFixedVector{N,Float16}, p::AbstractFixedVector{N}, inbounds::Val) where N
    u = reinterpret.(UInt16, v)
    w = shuffle(Val(:avx512merge), u, p, inbounds)
    reinterpret.(Float16, w)
end

@inline function shuffle(v::AbstractFixedVector{NT,T}, p::AbstractFixedVector{NU}, inbounds::Val) where {NT,T,NU}
    @assert ishwtype(T)
    M = max(16, nextpow(2, max(NT,NU) * sizeof(T)))
    if (@static cpufeature(:AVX512VBMI) ? true : false) && M == 16 && sizeof(T) >= 4
        mode = :avx512
    elseif (@static cpufeature(:AVX) ? true : false) && M == 16
        mode = :avx
    elseif (@static cpufeature(:AVX512VBMI) ? true : false)
        mode = M <= 64 ? :avx512 : :avx512merge
    elseif (@static cpufeature(:AVX2) ? true : false) && M == 32
        mode = :avx2
    else
        error("no available shuffle mode")
    end
    N = M ÷ sizeof(T)
    U = uinttype(T)
    vv = fixedvector(v, Val(N))
    pp = fixedvector(p, Val(N)) .% U
    ww = shuffle(Val(mode), vv, pp, inbounds)
    fixedvector(ww, Val(NU))
end

function hasshuffle(::Val{N}, ::Type{T}, ::Val{INB}) where {N,T,INB}
    ishwtype(T) || return false
    N-1 <= typemax(INB ? uinttype(T) : inttype(T)) || return false
    M = N*sizeof(T)
    @static if cpufeature(:AVX)
        M <= 16 && return true
    end
    @static if cpufeature(:AVX512VBMI)
        M <= avx512_maxbits && return true
    end
    @static if cpufeature(:AVX2)
        M <= 32 && return true
    end
    return false
end

using SmallCollections: default, bitsize, getindex0

using Base.FastMath: eq_fast
using LinearAlgebra: dot

@testset "FixedVector" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        u = rand(T, N)
        v = @inferred V{N,T}(u)
        @test_inferred capacity(v) N
        @test_inferred fixedvector(v) FixedVector(v)
        @test_inferred fixedvector(v, Val(N)) fixedvector(v)
        @test_inferred fixedvector(v, Val(N+3)) [i <= length(v) ? v[i] : default(T) for i in 1:N+3] FixedVector{N+3,T}
        if ismutabletype(V)
            @test v !== @inferred copy(v)
        else
            @test v === @inferred copy(v)
        end
        @test_inferred v == u true
        @test_inferred collect(v) u Vector{T}
        @test_inferred V(v) == v true
        @test_inferred FixedVector(v) == v true
        @test_inferred MutableFixedVector(v) == v true
        v2 = V{N,T}(u)
        @test_inferred v == v2 true
        if T <: Number
            @test_inferred eq_fast(v, v2) true
            numerictype(T) <: Integer && bitsize(T) >= bitsize(Float64) && continue
            v4 = V{N,setnumerictype(T, Float64)}(u)
            @test_inferred v == v4 true
            @test_inferred eq_fast(v, v4) true
        end
        if !isempty(u)
            i = rand(1:N)
            x = rand(T)
            while x == v[i]
                x = rand(T)
            end
            v5 = setindex(v, x, i)
            @test_inferred v == v5 false
            if T <: Number
                @test_inferred eq_fast(v, v5) false
            end
        end
        @test_inferred hash(v) hash(u)
        @test_inferred length(v) N
    end
end

@testset "FixedVector indices" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        u = rand(T, N)
        v = @inferred V{N,T}(u)
        if isempty(u)
            @test_throws Exception first(v)
            @test_throws Exception last(v)
        else
            @test_inferred first(v) first(u) T
            @test_inferred last(v) last(u) T
        end
        x = rand(T)
        for i in -1:length(u)+1
            if 1 <= i <= length(u)
                @test_inferred v[i] u[i] T
                w = @test_inferred setindex(v, x, i) setindex!(copy(u), x, i) FixedVector(v)
                if T <: Number
                    w = @test_inferred addindex(v, x, i) setindex!(copy(u), u[i]+x, i) FixedVector(v)
                end
            else
                @test_throws Exception v[i]
                @test_throws Exception setindex(v, x, i)
                T <: Number && @test_throws Exception addindex(v, x, i)
            end
            (V == MutableFixedVector && isbitstype(T)) || continue
            if 1 <= i <= length(u)
                w = @test_inferred setindex!(copy(v), x, i) setindex!(copy(u), x, i) v
            else
                @test_throws Exception setindex!(copy(v), x, i)
            end
        end
    end
    for T in test_types, V in (FixedVector, MutableFixedVector)
        N = 256
        u = rand(T, N)
        v = @inferred V{N,T}(u)
        isbitstype(T) && bitsize(T) > bitsize(Int) && continue  # work around an LLVM (?) bug making Julia 1.10 hang
        x = rand(T)
        w = @test_inferred setindex(v, x, N) setindex!(u, x, N) FixedVector(v)
    end
end

@testset "FixedVector bool inds" begin
    for N in (1, 2, 9, 16), T in (Bool, Int16), V in (FixedVector, MutableFixedVector)
        u = rand(T, N)
        v = V{N,T}(u)

        jj = rand(Bool, N-1)
        iis = Any[SmallVector{N+2}(jj), PackedVector{UInt32,1,Bool}(jj)]
        N > 1 && pushfirst!(iis, FixedVector{N-1}(jj))
        for ii in iis
            @test_throws Exception v[ii]
        end

        jj = rand(Bool, N)
        for ii in [FixedVector{N}(jj), SmallVector{N+2}(jj), PackedVector{UInt32,1,Bool}(jj)]
            @test_inferred v[ii] u[jj] SmallVector{N,T}
        end
    end
end

@testset "FixedVector vec inds" begin
    for N in (1, 2, 9, 16, 25, 64), T in (Bool, Int16, UInt64), V in (FixedVector, MutableFixedVector)
        N*sizeof(T) <= 256 || continue
        u = rand(T, N)
        v = V{N,T}(u)

        ii = 1:max(0, N-2)
        @test_inferred v[ii] u[ii] SmallVector{N,T}
        ii = collect(ii)
        @test_inferred v[ii] u[ii] Vector{T}

        M = 7
        jj = rand(UInt8(1):UInt8(N), M)
        ii = jj
        @test_inferred v[ii] u[ii] u
        ii = FixedVector{M}(jj)
        @test_inferred v[ii] u[ii] FixedVector{M,T}
        ii0 = FixedVector{M}(jj .- UInt8(1))
        @test_inferred getindex0(v, ii0) u[ii] FixedVector{M,T}
        ii = SmallVector{M+1}(jj)
        @test_inferred v[ii] u[ii] SmallVector{M+1,T}
        ii = PackedVector{UInt128,7,UInt8}(jj)
        @test_inferred v[ii] u[ii] u
        ii = 2:min(N, 5)
        @test_inferred v[ii] u[ii] SmallVector{N,T}
        ii = 1:2:min(N, 7)
        @test_inferred v[ii] u[ii] SmallVector{N,T}
    end
end

@testset "FixedVector reverse" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        u = rand(T, N)
        v = @inferred V{N,T}(u)
        @test_inferred reverse(v) reverse(u) FixedVector(v)
        for i in 0:N+2
            if 1 <= i <= N+1
                @test_inferred reverse(v, i) reverse(u, i) FixedVector(v)
            else
                @test_throws Exception reverse(v, i)
            end
            for j in i-2:N+1
                if 1 <= i <= N+1 && i-1 <= j <= N
                    @test_inferred reverse(v, i, j) reverse(u, i, j) FixedVector(v)
                else
                    @test_throws Exception reverse(v, i, j)
                end
            end
        end
    end
end

@testset "FixedVector bits" begin
    for N in [1, 2, 7, 8, 21, 64, 150], V in (FixedVector, MutableFixedVector)
        for T in test_types
            v = V{N,T}(rand(T, N))
            if !SmallCollections.ishwtype(T)
                @test_throws Exception bits(v)
                continue
            end
            b = nextpow(2, N*bitsize(T))
            b <= 1024 || continue
            m = @inferred bits(v)
            U = eval(Symbol(:UInt, b))
            @test m isa U
            W = eval(Symbol(:UInt, bitsize(T)))
            for (i, x) in enumerate(v)
                @test m % W == htol(reinterpret(W, x))
                m >>= bitsize(T)
            end
            @test iszero(m)
        end

        # Bool
        v = V{N,Bool}(rand(Bool, N))
        m = @inferred bits(v)
        @test m isa Unsigned && bitsize(m) == max(8, nextpow(2, N))
        for (i, x) in enumerate(v)
            isodd(m) == x
            m >>= 1
        end
        @test iszero(m)
    end
end

@testset "FixedVector cmp" begin
    base_isless(v, w) = invoke(isless, Tuple{AbstractVector{UInt8},AbstractVector{UInt8}}, v, w)
    base_le(v::AbstractVector{T}, w::AbstractVector{T}) where T = invoke(<=, Tuple{AbstractVector{T},AbstractVector{T}}, v, w)

    for N in [8, 16], _ in 1:250
        v = FixedVector{N,UInt8}(rand((0, 255), N))
        w = MutableFixedVector{N,UInt8}(rand((0, 255), N))
        @test_inferred isless(v, w) base_isless(v, w)
        @test_inferred isless(v, v) base_isless(v, v)
    end

    for T in [UInt8, Int32, Char], N in [8, 13]
        v = rand(FixedVector{N,T})
        w = rand(FixedVector{N+2,T})
        @test_inferred v <= w base_le(v, w)
        @test_inferred v <= v base_le(v, v)
    end
end

@testset "FixedVector circshift" begin
    for N in [1, 4, 7, 16], V in (FixedVector, MutableFixedVector)
        for T in test_types
            u = rand(T, N)
            v = V{N,T}(u)
            for k in (-2*N, -2*N+1, -3, -1, 0, 1, 7, N+5, 2*N+7)
                @test_inferred circshift(v, k) circshift(u, k) FixedVector{N,T}
                -N < k < N && @test_inferred circshift(v, Val(k)) circshift(u, k) FixedVector{N,T}
                (V <: MutableFixedVector && isbitstype(T)) || continue
                v2 = copy(v)
                v3 = @test_inferred circshift!(v2, k) circshift(u, k) v2
                @test v3 === v2
                -N < k < N || continue
                v2 = copy(v)
                v3 = @test_inferred circshift!(v2, Val(k)) circshift(u, k) v2
                @test v3 === v2
            end
        end
    end
end

@testset "FixedVector shuffle 256" begin
    T = Int8
    U = UInt8
    for N in [128, 127, 256, 255]
        v = rand(FixedVector{N,T})
        vv = collect(v)
        for k in [-N, -N+1, -N+2, -2, -1, 0, 1, 2, N-2, N-1, N]
            @test circshift(v, k) == circshift(vv, k)
            @test circshift!(MutableFixedVector(v), k) == circshift(vv, k)
        end
        for k in [1, 2, 3, N-1, N, N+1]
            @test reverse(v, k) == reverse(vv, k)
            @test reverse!(MutableFixedVector(v), k) == reverse(vv, k)
        end
        @test first(popfirst(v)) == push!(deleteat!(copy(vv), 1), default(T))
        for k in [1, 2, 3, N-2, N-1, N]
            @test duplicate(v, k) == [vv[1:k]; vv[k:N-1]]
            @test first(popat(v, k)) == push!(deleteat!(copy(vv), k), default(T))
        end
        for k in [1, 2, 3, N-2, N-1, N], l in [k-1, k, N-1, N]
            @test v[k:l] == vv[k:l]
        end
        for M in [128, 127, 256, 255]
            ii = FixedVector{M,U}(rand(0:N-1, M))
            @test getindex0(v, ii) == vv[ii .+ 1]
            N < typemax(U) || continue
            @test v[ii .+ U(1)] == vv[ii .+ 1]
        end
    end
end

@testset "FixedVector sum/max" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        T <: Number || continue
        r = T <: Unsigned ? unitrange(T(1), T(9)) : unitrange(T(-9), T(9))
        u = rand(r, N)
        v = V{N}(u)
        for f in (maximum, minimum)
            if isempty(u)
                @test_throws Exception f(v)
                @test_inferred f(v; init = zero(T)) f(u; init = zero(T))
            else
                @test_inferred f(v) f(u)
            end
        end
        if isempty(u)
            @test_throws Exception extrema(v)
            @test_inferred extrema(v; init = (one(T), zero(T))) extrema(u; init = (one(T), zero(T)))
        else
            @test_inferred extrema(v) extrema(u)
        end
        @test_inferred sum(v) sum(u)
        s = @inferred sum_fast(v)
        @test s ≈ sum(u)
        if T <: SmallCollections.AbstractBitInteger
            @test_inferred sum_fast(v; init = Int32(0)) sum(v) promote_type(T, Int32)
        end
        @test_inferred prod(v) prod(u)

        u2 = rand(r, N) * im
        v2 = V{N}(u2)
        du = dot(u2, u)
        d = @inferred dot_fast(v2, v)
        @test d ≈ du && typeof(d) == typeof(du)

        T <: AbstractFloat || continue
        u = fill(-T(0), N)
        v = V{N}(u)
        @test_inferred sum(v) sum(u)
        @test_inferred prod(-v) prod(-u)
    end
    for T in (Float32, Float64), V in (FixedVector, MutableFixedVector), x in (Inf, -Inf, NaN)
        u = T[x, -1, 0, 1]
        v = V{4}(u)
        @test_inferred maximum(v) maximum(u)
        @test_inferred minimum(v) minimum(u)
        @test_inferred sum(v) sum(u)
        if isnan(prod(u))
            @test_inferred isnan(prod(v)) true
        else
            @test_inferred prod(v) prod(u)
        end
    end
    for T in (Float32, Float64), V in (FixedVector, MutableFixedVector)
        u = T[NaN, -1, 0, 1]
        v = V{4}(u)
        @test_inferred isnan(maximum(v)) true
        @test_inferred isnan(minimum(v)) true
        @test_inferred isnan(sum(v)) true
        @test_inferred isnan(prod(v)) true
    end
end

@testset "FixedVector overflow" begin
    for N in (1, 8, 13, 16, 25, 32), T in (Int8, UInt16, Int32)
        S = smallbitsettype(Val(N))
        vv = rand(T, N)
        vv[1] = rand((typemin(T), zero(T)))
        v = MutableFixedVector{N}(vv)
        w = FixedVector{N}(rand(T, N))

        u = -v
        uu = -collect(Int, v)
        s = S(i for i in 1:N if u[i] != uu[i])
        if isempty(s)
            @test_inferred Base.Checked.checked_neg(v) u
        else
            @test_throws OverflowError Base.Checked.checked_neg(v)
        end

        u = v+w
        uu = collect(Int, v) + collect(Int, w)
        s = S(i for i in 1:N if u[i] != uu[i])
        @test_inferred Base.Checked.add_with_overflow(v, w) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_add(v, w) u
        else
            @test_throws OverflowError Base.Checked.checked_add(v, w)
        end

        u = v+w+v
        uu = collect(Int, v) + collect(Int, w) + collect(Int, v)
        s = S(i for i in 1:N if u[i] != uu[i])
        if isempty(s)
            @test_inferred Base.Checked.checked_add(v, w, v) u
        else
            @test_throws OverflowError Base.Checked.checked_add(v, w, v)
        end

        u = v-w
        uu = collect(Int, v) - collect(Int, w)
        s = S(i for i in 1:N if u[i] != uu[i])
        @test_inferred Base.Checked.sub_with_overflow(v, w) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_sub(v, w) u
        else
            @test_throws OverflowError Base.Checked.checked_sub(v, w)
        end

        c = T(2)
        u = c*v
        uu = Int(c) * v
        s = S(i for i in 1:N if u[i] != uu[i])
        @test_inferred Base.Checked.mul_with_overflow(c, v) (u, s)
        @test_inferred Base.Checked.mul_with_overflow(v, c) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_mul(c, v) u
            @test_inferred Base.Checked.checked_mul(v, c) u
        else
            @test_throws OverflowError Base.Checked.checked_mul(c, v)
            @test_throws OverflowError Base.Checked.checked_mul(v, c)
        end
    end
end

@testset "FixedVector map" begin
    f(x) = Int32(2)*x
    f(x, y) = 2*x + y
    g(x) = iszero(x) ? 1 : 1.0
    for N in (1, 2, 9, 16), T1 in test_types, V in (FixedVector, MutableFixedVector)
        T1 <: Number || continue
        u1 = rand(T1, N)
        v1 = V{N}(u1)
        u3 = map(f, u1)
        w = @test_inferred map(f, v1) u3 FixedVector{N,eltype(u3)}
        for T2 in test_types
            (T2 <: Number && dimension(T1) == dimension(T2)) || continue
            u2 = rand(T2, N+1)
            v2 = V{N+1}(u2)
            u4 = map(f, u1, u2)
            w = @test_inferred map(f, v1, v2) u4 FixedVector{N,eltype(u4)}
        end
    end
    v = FixedVector{8}(1:8)
    u = collect(v)
    u5 = map(g, u)
    w = map(g, v)
    @test w == u5
    @test eltype(w) == eltype(u5)
end

@testset "FixedVector find" begin
    for N in (1, 2, 9, 16), T in [Bool, test_types...], V in (FixedVector, MutableFixedVector)
        T <: Number || continue
        k = max(N ÷ 2, 1)
        for u in (rand(T(0):oneunit(T):(T == Bool ? true : T(2)), N), zeros(T, N), ones(T, N))
            v = V{N,T}(u)
            @test_inferred support(iszero, v) Set(findall(iszero, u)) SmallBitSet
            for style in (LazyStyle(), EagerStyle(), RigidStyle(), StrictStyle())
                i = @inferred Nothing findfirst(!iszero, v; style)
                @test i == findfirst(!iszero, u)
                i = @inferred Nothing findlast(!iszero, v; style)
                @test i == findlast(!iszero, u)
                i = @inferred Nothing findnext(!iszero, v, k; style)
                @test i == findnext(!iszero, u, k)
                i = @inferred Nothing findprev(!iszero, v, k; style)
                @test i == findprev(!iszero, u, k)
            end
            @test_inferred findmin(v) findmin(u) Tuple{T, Int}
            @test_inferred findmax(v) findmax(u) Tuple{T, Int}
            if T != Bool
                @test_inferred findmin(-, v) findmin(-, u) Tuple{T, Int}
                @test_inferred findmax(-, v) findmax(-, u) Tuple{T, Int}
            end
            @test_inferred allequal(v) allequal(u) Bool
            VERSION >= v"1.11" && @test_inferred allequal(isodd, v) allequal(isodd, u) Bool
            @test_inferred allunique(v) allunique(u) Bool
            VERSION >= v"1.11" && @test_inferred allunique(-, v) allunique(-, u) Bool
            @test_inferred findall(!iszero, v) findall(!iszero, u) SmallVector{N,SmallLength}
            @test_inferred count(!iszero, v; init = 0.0) count(!iszero, u; init = 0.0) Float64
            @test_inferred any(isodd, v) any(isodd, u) Bool
            @test_inferred all(isodd, v) all(isodd, u) Bool
            if T == Bool
                @test_inferred support(v) Set(findall(u)) SmallBitSet
                @test_inferred findall(v) findall(u) SmallVector{N,SmallLength}
                @test_inferred any(v) any(u) Bool
                @test_inferred all(v) all(u) Bool
                @test_inferred count(v) count(u) Int
            end
        end
    end
end

@testset "FixedVector issorted" begin
    for T in [Int8, Float32, BigInt, Char], u in [[1], [1,2,3], [1,2,2], [1,2,1], [3,2,1], [3,2,2], [1,1,1,1]]
        v = FixedVector{length(u),T}(u)
        w = collect(T, u)
        bys = T == Char ? (identity, uppercase) : (identity, -, x -> 2.0*x)
        for lt in (isless, >), by in bys, rev in (false, true), strict in (false, true)
            if strict
                @test_inferred issorted(v; lt, by, rev, strict) issorted(w; lt, by, rev) & allunique(w)
            else
                @test_inferred issorted(v; lt, by, rev, strict) issorted(w; lt, by, rev)
            end
        end
    end
end

@testset "FixedVector support" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        T <: Number || continue
        u = rand(unitrange(T(0), T(2)), N)
        v = V{N,T}(u)
        @test_inferred support(v) Set{Int}(i for i in 1:N if !iszero(u[i])) SmallBitSet
    end
end

@testset "FixedVector rand" begin
    for N in (1, 2, 9, 16), T in test_types, V in (FixedVector, MutableFixedVector)
        v = @inferred rand(V{N,T})
        @test v isa V{N,T}
    end
end

DS = (SmallDict, MutableSmallDict)

key_types = [Int8, typeof(UInt32(1)u"m"), Float64, String, TestEnum]
val_types = [Bool, Int64, Char, TestStruct2]

@testset "SmallDict" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        d = @inferred D{N,K,V}()
        @test d isa D{N,K,V} && isempty(d)

        itr = ((rand(K), rand(V)) for _ in 1:m)
        d = @inferred D{N,K,V}(itr)
        @test d == Dict(d)

        kv = collect(Tuple{K,V}, itr)
        d = @inferred D{N}(kv)
        e = Dict(kv)
        @test d == e

        itr = (rand(K) => rand(V) for _ in 1:m)
        d = @inferred D{N,K,V}(itr)
        @test d == Dict(d)

        kv = collect(Pair{K,V}, itr)
        d = @inferred D{N}(kv)
        e = Dict(kv)
        @test d == e

        @test_inferred capacity(d) N
        @test_inferred length(d) length(e)
        @test_inferred isempty(d) isempty(e)

        @test_inferred SmallDict(d) d SmallDict{N,K,V}
        @test_inferred MutableSmallDict(d) d MutableSmallDict{N,K,V}

        @test_inferred D{N}(e) e D{N,K,V}
        @test_inferred D{N,K,V}(e) e D{N,K,V}

        e = @test_inferred copy(d) d
        D == MutableSmallDict && @test e !== d
        @test_inferred Set(d) Set(e)   # iteration
        @test_inferred Set(keys(d)) Set(keys(e))
        @test_inferred collect(values(d)) V[d[k] for k in keys(d)]
    end
end

VERSION > v"1.13-" && @testset "SmallDict nth" begin
    e = Dict{Real,Integer}(1 => 2, 3.0 => Int8(4))
    d = SmallDict{4,Real,Integer}(e)
    for i in 1:length(d)
        @test_inferred Iterators.nth(d, i) Iterators.nth(e, i)
    end
    @test_throws BoundsError Iterators.nth(d, 0)
    @test_throws BoundsError Iterators.nth(d, length(d)+1)
end

@testset "SmallDict getindex/setindex" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        K == TestEnum && length(instances(K)) <= m && continue
        K == Bool && m >= 2 && continue
        d = D{N,K,V}(rand(K) => rand(V) for _ in 1:m)
        (isempty(d) || m == N) && continue

        k = rand(keys(d))
        v = rand(V)
        @test_inferred setindex(d, v, k) setindex!(Dict(d), v, k) SmallDict(d)
        k0 = rand_notin(K, keys(d))
        v0 = rand(V)
        @test_inferred setindex(d, v0, k0) setindex!(Dict(d), v0, k0) SmallDict(d)

        D == MutableSmallDict || continue
        e = @test_inferred setindex!(d, v, k) setindex!(Dict(d), v, k) d
        @test e === d
        e = @test_inferred setindex!(d, v0, k0) setindex!(Dict(d), v0, k0) d
        @test e === d
    end
end

@testset "SmallDict in/get/getkey" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        K == TestEnum && length(instances(K)) <= m && continue
        (K == Bool || V == Bool) && m >= 2 && continue
        kvs = [rand(K) => rand(V) for _ in 1:m]
        d = D{N,K,V}(kvs)
        @test_inferred Base.hasfastin(d) Base.hasfastin(d.keys)
        k0 = rand_notin(K, keys(d))
        v0 = rand_notin(V, values(d))
        for (k, v) in d
            @test_inferred (k => v) in d true
            @test_inferred (k => v0) in d false
            @test_inferred (k0 => v) in d false
            @test_inferred haskey(d, k) true
            @test_inferred getkey(d, k, k0) k
            @test_inferred d[k] v
            @test_inferred get(d, k, v0) v
        end
        @test_inferred (k0 => v0) in d false
        @test_inferred haskey(d, k0) false
        @test_throws KeyError d[k0]
        @test_inferred get(d, k0, v0) v0

        D == MutableSmallDict || continue
        e = copy(d)
        if !isempty(d)
            k = rand(keys(d))
            @test_inferred get!(e, k, v0) d[k]
            @test e == d
        end
        m < N || continue
        @test_inferred get!(e, k0, v0) v0
        @test (k0 => v0) in e
    end

    d = SmallDict{4,Float32,Int8}(0.0 => 1, -0.0 => 2, 1.0 => 3, NaN => 4)
    @test_inferred d[0.0] Int8(1)
    @test_inferred d[-0.0] Int8(2)
    @test_inferred d[NaN] Int8(4)
    @test_inferred getkey(d, 1, Float32(0.0)) Float32(1.0)
end

@testset "SmallDict empty" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        d = D{N,K,V}(rand(K) => rand(V) for _ in 1:m)
        @test_inferred empty(d) D{N,K,V}()
        @test_inferred empty(d, Char) D{N,K,Char}()
        @test_inferred empty(d, UInt, Char) D{N,UInt,Char}()
        D == MutableSmallDict || continue
        e = @inferred empty!(d)
        @test isempty(e) && e === d
    end
end

@testset "SmallDict push!/pop!" begin
    for D in (MutableSmallDict,), N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        (isbitstype(K) && isbitstype(V)) || continue
        K == TestEnum && length(instances(K)) <= m && continue
        (K == Bool || V == Bool) && m >= 2 && continue
        kvs = [rand(K) => rand(V) for _ in 1:m]
        d = D{N,K,V}(kvs)
        isempty(d) && continue

        e = D{N,K,V}()
        # kvs must not be empty because Base.push!(e) is not defined except for AbstractArray
        @test_inferred push!(e, kvs...) d
        @test_inferred push!(e, kvs...) e
        e = copy(d)
        kv = @inferred pop!(e)
        @test kv in d && !(kv in e)
        @test_inferred push!(e, kv) d

        e = copy(d)
        k = rand(keys(d))
        v = @inferred pop!(e, k)
        kv = k => v
        @test kv in d && !(kv in e)
        @test_inferred push!(e, kv) d

        e = copy(d)
        v0 = rand_notin(V, values(d))
        v = @test_inferred pop!(e, k, v0) d[k]
        kv = k => v
        @test !(kv in e)
        @test_inferred push!(e, kv) d

        e = copy(d)
        k0 = rand_notin(K, keys(d))
        @test_throws KeyError pop!(e, k0)
        @test_inferred pop!(e, k0, v0) v0
        @test e == d
    end
end

@testset "SmallDict push/pop" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        K == TestEnum && length(instances(K)) <= m && continue
        (K == Bool || V == Bool) && m >= 2 && continue
        kvs = [rand(K) => rand(V) for _ in 1:m]
        d = D{N,K,V}(kvs)

        e = D{N,K,V}()
        @test_inferred push(e, kvs...) SmallDict(d)
        @test_inferred push(d, kvs...) SmallDict(d)

        isempty(d) && continue

        e, kv = @inferred pop(d)
        @test kv in d && !(kv in e)
        @test_inferred push(e, kv) SmallDict(d)

        k = rand(keys(d))
        e, v = @inferred pop(d, k)
        kv = k => v
        @test kv in d && !(kv in e)
        @test_inferred push(e, kv) SmallDict(d)

        v0 = rand_notin(V, values(d))
        e, v = @inferred pop(d, k, v0)
        kv = k => v
        @test kv in d && !(kv in e)
        @test_inferred push(e, kv) SmallDict(d)

        k0 = rand_notin(K, keys(d))
        @test_throws KeyError pop(d, k0)
        @test_inferred pop(d, k0, v0) (SmallDict(d), v0)
    end
end

@testset "SmallDict findmin/popmin" begin
    N = 16
    for D in DS, K in (Int8, UInt16), V in (UInt8, Int32), m in (0, 1, N-2)
        d = D{N,K,V}(rand(K) => rand(V) for _ in 1:m)
        w = collect(d)
        if m == 0
            @test_throws Exception findmin(d)
            @test_throws Exception findmax(d)
            @test_throws Exception findmin(-, d)
            @test_throws Exception findmax(-, d)
            @test_throws Exception popmin(d)
            @test_throws Exception popmax(d)
            D <: MutableSmallDict || continue
            @test_throws Exception popmin!(d)
            @test_throws Exception popmax!(d)
        else
            v1 = minimum(last, w)
            k1 = invget(d, v1)
            kv1 = k1 => v1
            v2 = maximum(last, w)
            k2 = invget(d, v2)
            kv2 = k2 => v2
            @test_inferred findmin(d) last(kv1), first(kv1)
            @test_inferred findmax(d) last(kv2), first(kv2)
            if V <: Signed
                @test_inferred findmin(-, d) -last(kv2), first(kv2)
                @test_inferred findmax(-, d) -last(kv1), first(kv1)
            end
            @test_inferred popmin(d) (first(pop(d, k1)), kv1)
            @test_inferred popmax(d) (first(pop(d, k2)), kv2)
            D <: MutableSmallDict || continue
            e = copy(d)
            @test_inferred popmin!(e) kv1
            @test e == first(pop(d, k1))
            e = copy(d)
            @test_inferred popmax!(e) kv2
            @test e == first(pop(d, k2))
        end
    end
end

@testset "SmallDict filter" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        (isbitstype(K) && isbitstype(V)) || continue
        V == Bool && m >= 2 && continue
        kvs = [rand(K) => rand(V) for _ in 1:m]
        d = D{N,K,V}(kvs)
        if K <: Integer
            @test_inferred filter(kv -> isodd(kv.first), d) filter(kv -> isodd(kv.first), Dict(d)) SmallDict(d)
        else
            v0 = rand_notin(V, values(d))
            @test_inferred filter(kv -> kv.second != v0, d) SmallDict(d)
            @test_inferred filter(kv -> kv.second == v0, d) empty(SmallDict(d))
        end

        D == MutableSmallDict || continue
        if K <: Integer
            e = copy(d)
            f = @test_inferred filter!(kv -> isodd(kv.first), e) filter!(kv -> isodd(kv.first), Dict(d)) e
            @test f === e
        else
            v0 = rand_notin(V, values(d))
            @test_inferred filter!(kv -> kv.second != v0, d) d
            e = copy(d)
            f = @test_inferred filter!(kv -> kv.second == v0, e) empty(e)
            @test f === e
        end
    end
end

@testset "SmallDict mergewith" begin
    op(x, y) = y
    op(x::Number, y::Number) = x*y
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types, m in (0, 1, N-1, N)
        D == SmallDict || (isbitstype(K) && isbitstype(V)) || continue
        K == TestEnum && length(instances(K)) <= m && continue
        (K == Bool || V == Bool) && m >= 2 && continue
        l = m÷3
        kvs1 = [rand(K) => rand(V) for _ in 1:l]
        kvs2 = [rand(K) => rand(V) for _ in 1:l]
        kvs3 = [rand(K) => rand(V) for _ in 1:m-2*l]
        d = D{N,K,V}([kvs1..., kvs2...])
        @test_inferred mergewith(op, d) SmallDict(d)
        e = Dict{K,V}([kvs2..., kvs3...])
        @test_inferred mergewith(op, d, e) mergewith!(op, Dict(d), e) SmallDict(d)
        f = Dict{K,V}([kvs1..., kvs3...])
        @test_inferred mergewith(op, d, e, f) mergewith!(op, Dict(d), e, f) SmallDict(d)
        D == MutableSmallDict || continue
        d2 = @test_inferred mergewith!(op, d, e) mergewith!(op, Dict(d), e) d
        @test d2 === d
    end
end

@testset "SmallDict rand" begin
    for D in DS, N in (1, 2, 9, 16), K in key_types, V in val_types
        D <: MutableSmallDict && !isbitstype(Tuple{K,V}) && continue
        d = @inferred rand(D{N,K,V})
        @test d isa D{N,K,V} && isvalid(d)
    end
end

"""
    $(@__MODULE__)

This packages provides several mutable and immutable collections that
can hold a fixed or limited (small) number of elements and are much more efficient
than `Set` and `Vector`, for example. This applies in particular to the immutable
variants because they don't allocate if `isbitstype` holds for the element type.
At present, `FixedVector`, `SmallVector`, `SmallDict` and `SmallSet` and their
mutable counterparts are defined as well as `PackedVector` and `SmallBitSet`.

If the package `BangBang.jl` is loaded, then many functions defined by
this package are also available in `!!`-form. For example, `setindex!!`
with a `SmallVector` as first argument calls [`setindex`](@ref).

Bounds checking can be skipped for the functions defined in this package
by using the `@inbounds` macro.

See [`AbstractFixedVector`](@ref), [`AbstractSmallDict`](@ref),
[`AbstractSmallSet`](@ref), [`AbstractSmallVector`](@ref),
[`PackedVector`](@ref), [`SmallBitSet`](@ref),
`Base.@inbounds`, `Base.isbitstype`,
[Section "BangBang support"](@ref sec-bangbang).
"""
module SmallCollections

using Base: @propagate_inbounds, @assume_effects, Fix1, Fix2, BitInteger, OneTo
using Base: _InitialValue as Void

using Random: Random, AbstractRNG, SamplerType

using BitIntegers: AbstractBitSigned, AbstractBitUnsigned,
    UInt256, UInt512, UInt1024

using LinearAlgebra: dot

dot_fast(v, w) = dot(v, w)
dot_fast(x::Number, y::Number) = @fastmath conj(x)*y

"""
    $(@__MODULE__).AbstractBitInteger

This type is the union of `Base.BitInteger`, `BitIntegers.AbstractBitSigned`
and `BitIntegers.AbstractBitUnsigned`.
"""
const AbstractBitInteger = Union{BitInteger,AbstractBitSigned,AbstractBitUnsigned}

const HWType = Union{Base.HWReal, Bool, Char, Enum}

inttype(TM) = signed(uinttype(TM))

@generated uinttype(::Val{M}) where M = Symbol(:UInt, max(8, nextpow(2, M)))

function uinttype(::Type{T}) where T
    @assert ishwtype(T)
    uinttype(Val(8*sizeof(T)))
end

@inline function smallint(N::Int)
    if N <= typemax(Int8)
        Int8(N)
    elseif N <= typemax(Int16)
        Int16(N)
    elseif N <= typemax(Int32)
        Int32(N)
    else
        Int64(N)
    end
end

export capacity, fasthash

capacity(::T) where T = capacity(T)
capacity(::Type) = error("capacity not defined for this type")

fasthash(x) = fasthash(x, UInt(0))

"""
    $(@__MODULE__).element_type(itr) -> Type
    $(@__MODULE__).element_type(::Type) -> Type

Return the element type of an iterator or its type. This differs from `eltype`
in that the element type of a `Tuple` or `NamedTuple` is determined via `promote_type`
instead of `promote_typejoin`. For all other iterators there is no difference.

See also `Base.eltype`, `Base.promote_type`, `Base.promote_typejoin`.

# Example
```jldoctest
julia> eltype((1, 2, 3.0))
Real

julia> $(@__MODULE__).element_type((1, 2, 3.0))
Float64
```
"""
element_type(::I) where I = element_type(I)
element_type(::Type{Union{}}) = error("not defined")   # for JET analysis
element_type(::Type{I}) where I = eltype(I)
element_type(::Type{<:Tuple{Vararg{T}}}) where T = T
element_type(::Type{<:Tuple{Vararg{T}}}) where T <: Pair = T

@assume_effects :foldable function element_type(::Type{I}) where I <: Union{Tuple,NamedTuple}
    promote_type(fieldtypes(I)...)
end

@assume_effects :foldable function element_type(::Type{I}) where I <: Tuple{Vararg{Pair}}
    K = promote_type(map(first∘fieldtypes, fieldtypes(I))...)
    V = promote_type(map(last∘fieldtypes, fieldtypes(I))...)
    Pair{K,V}
end

ntuple(f, n) = Base.ntuple(f, n)
@inline @generated ntuple(f, ::Val{N}) where N = :(Base.Cartesian.@ntuple $(Int(N)) i -> f($(typeof(N))(i)))

@noinline keyerror(key) = throw(KeyError(key))
@noinline dimensionmismatch(msg) = throw(DimensionMismatch(msg))
@noinline overflowerror(msg) = throw(OverflowError(msg))

include("bits.jl")
include("mapstyle.jl")

include("smallbitset.jl")

include("fixedvector.jl")
include("staticvectors.jl")

include("smallvector.jl")
include("mutablesmallvector.jl")
include("packedvector.jl")
include("fixedsmallvector.jl")
include("smalldict.jl")
include("smallset.jl")

if Sys.ARCH in (:x86_64, :i686)
    include("arch/x86.jl")
else
    const HAS_BEXTR = false
    const HAS_PEXT = false
    const HAS_COMPRESS = false

    hasshuffle(::Val, ::Type, ::Val) = false
end

if VERSION > v"1.11-alpha"
    eval(Expr(:public, :default, :isfasttype, :FixedVectorStyle, :SmallVectorStyle,
        :MapStyle, :LazyStyle, :EagerStyle, :RigidStyle, :StrictStyle, :Inbounds, :padtail,
        :AbstractFixedOrSmallVector, :AbstractFixedOrSmallOrPackedVector, :getindex0,
        :unsafe_delete, :unsafe_push,
        :bitsize, :unsafe_shl, :unsafe_lshr, :blsi, :blsr, :blsmsk, :pdep, :pext))
end

end

#
# small sets
#

export SmallBitSet, bits, delete, pop, push, exchange, first_as_set, smallbitsettype

using Base: hasfastin

import Base: show, ==, hash, copy, convert,
    empty, isempty, in, first, last, iterate,
    length, issubset, ⊊, maximum, minimum, extrema,
    union, intersect, setdiff, symdiff, filter,
    count, any, all, replace

isinteger(x) = x isa Number && Base.isinteger(x)

"""
    SmallBitSet{U<:Unsigned} <: AbstractSet{Int}

    SmallBitSet{U}([iter])
    SmallBitSet([iter])

`SmallBitSet{U}` is an immutable set that can hold integers between `1` and the bit length of `U`.
The argument `iter` can be any iterator giving such values. If `U` is omitted, then `UInt` is taken.
Called without an argument, the constructor returns an empty set.

All non-mutating functions for sets are supported. The non-mutating analogs
[`push`](@ref push(::SmallBitSet, ::Vararg{Any})), [`pop`](@ref pop(::SmallBitSet)) and
[`delete`](@ref) of the corresponding `!`-functions are also provided.

# Examples
```jldoctest
julia> SmallBitSet((1, 3, 5))
SmallBitSet{$UInt} with 3 elements:
  1
  3
  5

julia> s = SmallBitSet{UInt8}(2*k for k in 1:3)
SmallBitSet{UInt8} with 3 elements:
  2
  4
  6

julia> first(s), last(s)
(2, 6)

julia> 4.0 in s
true

julia> SmallBitSet{UInt32}(s)
SmallBitSet{UInt32} with 3 elements:
  2
  4
  6
```
"""
struct SmallBitSet{U<:Unsigned} <: AbstractSet{Int}
    mask::U
    global _SmallBitSet(mask::U) where U = new{U}(mask)
end

function show(io::IO, s::SmallBitSet{U}) where U
    print(io, "SmallBitSet")
    if bitsize(U) > bitsize(UInt) || get(io, :typeinfo, Any) != SmallBitSet{U}
        print(io, '{', U, '}')
    end
    print(io, "([")
    join(io, s, ", ")
    print(io, "])")
end

MapStyle(::Type{SmallBitSet}, ::Type{OneTo{T}}) where T = iffasttypes(StrictStyle(), T)
MapStyle(::Type{SmallBitSet{U}}, ::Type{OneTo{T}}) where {U,T} = iffasttypes(StrictStyle(), U, T)

==(s::SmallBitSet, t::SmallBitSet) = s.mask == t.mask

copy(s::SmallBitSet) = s

"""
    bits(s::SmallBitSet{U}) where U -> U

Return the bit mask used internally to store the elements of the set `s`.

See also [`convert(::Type{SmallBitSet}, ::Integer)`](@ref).
"""
bits(s::SmallBitSet) = s.mask

"""
    capacity(::Type{<:SmallBitSet}) -> Int
    capacity(s::SmallBitSet) -> Int

Return the largest number that the given set or `SmallBitSet` type can store.
"""
capacity(::Type{<:SmallBitSet}),
capacity(::SmallBitSet)

capacity(::Type{SmallBitSet{U}}) where U = bitsize(U)
capacity(::Type{SmallBitSet}) = capacity(SmallBitSet{UInt})

"""
    smallbitsettype(::Val{N}) where N -> Type{<:SmallBitSet}

Returns a type `SmallBitSet{U}` where `U <: Unsigned` has at least `N` bits.

# Examples
```jldoctest
julia> smallbitsettype(Val(30))
SmallBitSet{UInt32}

julia> smallbitsettype(Val(200))
SmallBitSet{BitIntegers.UInt256}
```
"""
smallbitsettype(::Val{N}) where N = SmallBitSet{uinttype(Val(N))}

"""
    fasthash(s::SmallBitSet [, h0::UInt]) -> UInt

Return a hash for `s` that can be computed fast. This hash is consistent across
all `SmallBitSet`s, but it is not compatible with the `hash` used for sets.

See also `Base.hash`.

# Examples
```jldoctest
julia> s = SmallBitSet(1:3);

julia> fasthash(s)
0x828a4cc485149963

julia> fasthash(s) == hash(s)
false

julia> t = SmallBitSet{UInt16}(s);

julia> fasthash(s) == fasthash(t)
true
```
"""
fasthash(s::SmallBitSet, h0::UInt) = hash(bits(s), h0)

"""
    convert(::Type{SmallBitSet{U}}, mask::Integer) where U -> SmallBitSet{U}
    convert(::Type{SmallBitSet}, mask::Integer) -> SmallBitSet{UInt}

Convert a bit mask to a `SmallBitSet` of the given type. This is the inverse operation to `bits`.

See also [`bits`](@ref).

# Examples
```jldoctest
julia> s = SmallBitSet{UInt16}([1, 5, 6]);

julia> u = bits(s)
0x0031

julia> convert(SmallBitSet, u)
SmallBitSet{$UInt} with 3 elements:
  1
  5
  6
```
"""
convert(::Type{SmallBitSet{U}}, ::Integer) where U <: Unsigned,
convert(::Type{SmallBitSet}, ::Integer)

convert(::Type{SmallBitSet{U}}, mask::Integer) where U = _SmallBitSet(U(mask))

convert(::Type{SmallBitSet}, mask::Integer) = convert(SmallBitSet{UInt}, mask)

@inline function _push(mask::U, iter) where U
    for n in iter
        @boundscheck if !isinteger(n) || n <= 0 || n > bitsize(U)
                error(LazyString(SmallBitSet{U}, " can only contain integers between 1 and ", bitsize(U)))
            end
        k = Integer(n)
        mask |= unsafe_shl(one(U), k-one(k))
    end
    _SmallBitSet(mask)
end

@propagate_inbounds SmallBitSet(args...) = SmallBitSet{UInt}(args...)

@inline function SmallBitSet{U}(s::SmallBitSet) where U
    mask = s.mask % U
    @boundscheck if mask != s.mask
        error(LazyString(SmallBitSet{U}, " can only contain integers between 1 and ", bitsize(U)))
    end
    _SmallBitSet(mask)
end

SmallBitSet{U}() where U = _SmallBitSet(zero(U))

@propagate_inbounds SmallBitSet{U}(iter) where U = _push(zero(U), iter)

@inline function SmallBitSet{U}(r::AbstractUnitRange{<:Integer}) where U
    r0, r1 = first(r), last(r)
    @boundscheck if r0 <= r1 && (r0 < 1 || r1 > bitsize(U))
        error(LazyString(SmallBitSet{U}, " can only contain integers between 1 and ", bitsize(U)))
    end
    m = one(U) << unsigned(r1-(r0-1)) - one(U)
    _SmallBitSet(unsafe_shl(m, r0-1))
end

isempty(s::SmallBitSet) = iszero(bits(s))

"""
    empty(s::S) where S <: SmallBitSet -> S

Return an empty `SmallBitSet` of the same type as `s`.
"""
empty(s::SmallBitSet)

empty(s::S) where S <: SmallBitSet = S()

default(::Type{S}) where S <: SmallBitSet = S()

length(s::SmallBitSet) = count_ones(bits(s))

# from https://discourse.julialang.org/t/faster-way-to-find-all-bit-arrays-of-weight-n/113658/12
iterate(s::SmallBitSet, m = bits(s)) =
    iszero(m) ? nothing : (trailing_zeros(m)+1, blsr(m))

@inline function first(s::SmallBitSet)
    @boundscheck isempty(s) && error("collection must be non-empty")
    trailing_zeros(bits(s))+1
end

@inline function last(s::SmallBitSet)
    @boundscheck isempty(s) && error("collection must be non-empty")
    top_set_bit(bits(s))
end

"""
    first_as_set(s::S) where S <: SmallBitSet -> S

Returns the smallest element of `s` as a singleton.
If `s` is empty, then an empty set is returned.

See also `Base.first`.

# Examples
```jldoctest
julia> s = SmallBitSet{UInt8}(3:5);

julia> first_as_set(s)
SmallBitSet{UInt8} with 1 element:
  3

julia> first_as_set(empty(s))
SmallBitSet{UInt8}([])
```
"""
first_as_set(s::SmallBitSet) = _SmallBitSet(blsi(s.mask))

function minimum(s::SmallBitSet; init = missing)
    if !isempty(s)
        @inbounds first(s)
    elseif init !== missing
        init
    else
        error("collection must be non-empty unless `init` is given")
    end
end

function maximum(s::SmallBitSet; init = missing)
    if !isempty(s)
        @inbounds last(s)
    elseif init !== missing
        init
    else
        error("collection must be non-empty unless `init` is given")
    end
end

extrema(v::SmallBitSet; init::Tuple{Any,Any} = (missing, missing)) =
    (minimum(v; init = init[1]), maximum(v; init = init[2]))

# hasfastin(::Type{<:SmallBitSet}) = true
# this is the default for AbstractSet

function in(n, s::SmallBitSet{U}) where U <: Unsigned
    isinteger(n) && 1 <= n <= bitsize(U) && begin
        k = Integer(n)
        !iszero(s.mask & unsafe_shl(one(U), k-one(k)))
    end
end

issubset(s::SmallBitSet, t::SmallBitSet) = isempty(setdiff(s, t))

⊊(s::SmallBitSet, t::SmallBitSet) = issubset(s, t) && s != t

"""
    push(s::S, xs...) where S <: SmallBitSet -> S

Return the `SmallBitSet` obtained from `s` by adding the other arguments `xs`.

See also `Base.push!`, `BangBang.push!!`, [`$(@__MODULE__).unsafe_push`](@ref).
"""
@propagate_inbounds push(s::SmallBitSet, ns...) = _push(s.mask, ns)

"""
    $(@__MODULE__).unsafe_push(s::S, x::Integer) where S <: SmallBitSet -> S

A faster, but unsafe version of `push` where `x` is assumed to lie in the range `1:capacity(S)`.
The value `0` is also allowed for `x` to indicate that no element is added.

See also [`push`](@ref push(::SmallBitSet, ::Any)), [`capacity`](@ref capacity(::SmallBitSet)).

Examples
```jldoctest
julia> using $(@__MODULE__): unsafe_push

julia> unsafe_push(SmallBitSet(1:2), 5)
SmallBitSet{$UInt} with 3 elements:
  1
  2
  5

julia> unsafe_push(SmallBitSet(1:2), 0)
SmallBitSet{$UInt} with 2 elements:
  1
  2
```
"""
function unsafe_push(s::SmallBitSet{U}, n::Integer) where U
    m = ifelse(iszero(n), zero(U), unsafe_shl(one(U), n-1))
    _SmallBitSet(s.mask | m)
end

MapStyle(::typeof(unsafe_push), ::Type{SmallBitSet{U}}, ::Type{T}) where {U <: Unsigned, T <: Integer} = iffasttypes(StrictStyle(), U, T)

"""
    pop(s::S) where S <: SmallBitSet -> Tuple{S, Int}

Return the pair `(t, x)` where `x` is the smallest element from `s` and
`t` is the set `s` with `x` deleted. The set `s` must be non-empty.

See also `Base.pop!`, `BangBang.pop!!`.
"""
@inline function pop(s::SmallBitSet)
    @boundscheck isempty(s) && error("collection must be non-empty")
    n = last(s)
    unsafe_delete(s, n), n
end

"""
    pop(s::S, x) where S <: SmallBitSet -> Tuple{S, Int}

Return the pair `(t, Int(x))` where `t` is the set `s` with `x` deleted.
The set `s` must contain `x`.

See also `Base.pop!`, `BangBang.pop!!`.
"""
@inline function pop(s::SmallBitSet, n)
    @boundscheck n in s || keyerror(n)
    unsafe_delete(s, unsafe_int(n)), unsafe_int(n)
end

"""
    pop(s::S, x, default::T) where S <: SmallBitSet -> Tuple{S, Union{Int,T}}

If `s` contains `x`, return the pair `(t, Int(x))` where `t` is the set `s` with `x` deleted.
Otherwise return `(s, default)`

See also `Base.pop!`, `BangBang.pop!!`.
"""
function pop(s::SmallBitSet, n, default)
    n in s ? (unsafe_delete(s, unsafe_int(n)), unsafe_int(n)) : (s, default)
end

"""
    delete(s::S, x) where S <: SmallBitSet -> S

If `s` contains `x`, return the set obtained by deleting that element.
Otherwise return `s`.

See also `Base.delete!`, `BangBang.delete!!`, [`$(@__MODULE__).unsafe_delete`](@ref).
"""
function delete(s::SmallBitSet{U}, n) where U
    if isinteger(n)
        k = Integer(n)
        m = one(U) << (k-one(k))
        _SmallBitSet(s.mask & ~m)
    else
        s
    end
end

MapStyle(::typeof(delete), ::Type{SmallBitSet{U}}, ::Type{T}) where {U <: Unsigned, T <: Integer} = iffasttypes(StrictStyle(), U, T)

"""
    $(@__MODULE__).unsafe_delete(s::S, x::Integer) where S <: SmallBitSet -> S

A faster, but unsafe version of `delete` where `x` is assumed to lie in the range `1:capacity(S)`.

See also [`delete`](@ref delete(::SmallBitSet, ::Any)), [`capacity`](@ref capacity(::SmallBitSet)).
"""
function unsafe_delete(s::SmallBitSet{U}, n::Integer) where U
    m = unsafe_shl(one(U), n-1)
    _SmallBitSet(s.mask & ~m)
end

MapStyle(::typeof(unsafe_delete), ::Type{SmallBitSet{U}}, ::Type{T}) where {U <: Unsigned, T <: Integer} = iffasttypes(StrictStyle(), U, T)

@inline function replace(s::SmallBitSet{U}, ps::Vararg{Pair,N}) where {U,N}
    @boundscheck all(ps) do p
        p[1] isa Integer && p[2] isa Integer && 1 <= minimum(p) && maximum(p) <= bitsize(U)
    end || error(LazyString(SmallBitSet{U}, " can only contain integers between 1 and ", bitsize(U)))

    v, u = foldl(ps; init = (bits(s), zero(U))) do (v, u), p
        m = v & unsafe_shl(U(1), p[1]-1)
        v & ~m, u | bitrotate(m, p[2]-p[1])
    end
    convert(SmallBitSet{U}, v | u)
end

"""
    exchange(s::S, i::Integer, j::Integer) where S <: SmallBitSet -> S

Return the set `s` with the element `i`, if present, replaced by `j` and vice versa.
If `i` equals `j`, then the set is not modified.

This function is faster than the equivalent `replace(s, i => j, j => i)`.

See also [`invreplace`](@ref), `Base.replace`.

# Examples
```jldoctest
julia> s = SmallBitSet((1, 2)); exchange(s, 1, 2)
SmallBitSet{$UInt} with 2 elements:
  1
  2

julia> s = SmallBitSet((1, 2)); exchange(s, 2, 3)
SmallBitSet{$UInt} with 2 elements:
  1
  3

julia> s = SmallBitSet((1, 2)); exchange(s, 3, 4)
SmallBitSet{$UInt} with 2 elements:
  1
  2

julia> s = SmallBitSet((1, 2)); exchange(s, 1, 1)
SmallBitSet{$UInt} with 2 elements:
  1
  2
```
"""
@inline function exchange(s::SmallBitSet{U}, i::Integer, j::Integer) where U
    @boundscheck (1 <= i <= bitsize(U) && 1 <= j <= bitsize(U)) ||
        error(LazyString(SmallBitSet{U}, " can only contain integers between 1 and ", bitsize(U)))
    t = unsafe_shl(one(U), i-1) ⊻ unsafe_shl(one(U), j-1) # xor needed for the case i == j
    m = bits(s)
    convert(SmallBitSet{U}, ifelse(iszero(m & t) || m & t == t, m, m ⊻ t))
end

"""
    any(f::Function, s::SmallBitSet{U}; [style::MapStyle]) where U
    all(f::Function, s::SmallBitSet{U}; [style::MapStyle]) where U
    count(f, s::SmallBitSet{U}; init = 0, [style::MapStyle]) where U
    filter(f, s::SmallBitSet{U}; [style::MapStyle]) where U

With a `SmallBitSet` `s` as second argument, these functions accept
the additional keyword argument `style`. If it equals `LazyStyle()`, then the
function `f` is only evaluated for elements of `s`. For any
other value of `style`, `f` is evaluated on all numbers between `1` and the
bit size of `U`. This is often faster for simple functions.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions.

See also [`$(@__MODULE__).MapStyle`](@ref).
"""
any(::Function, ::SmallBitSet),
all(::Function, ::SmallBitSet),
count(::Any, ::SmallBitSet),
filter(::Any, ::SmallBitSet)

filter(f, s::SmallBitSet; style::MapStyle = MapStyle(f, Int)) = smallbitset_filter(style, f, s)

function smallbitset_filter(::MapStyle, f::F, s::SmallBitSet{U}) where {F,U}
    N = bitsize(U)
    v = map(f, FixedVector{N}(1:N))
    eltype(v) == Bool || error("given function must return Bool values")
    _SmallBitSet((bits(v) % U) & bits(s))
end

function smallbitset_filter(::LazyStyle, f::F, s::SmallBitSet) where F
    m = bits(s)
    q = zero(m)
    while !iszero(m)
        p = blsr(m)
        n = trailing_zeros(m)+1
        if f(n)
            q |= m ⊻ p
        end
        m = p
    end
    _SmallBitSet(q)
end

function filter(f::Fix2{typeof(<=),T}, s::SmallBitSet{U}) where {T <: Real, U <: Unsigned}
    k = T <: Integer ? f.x : round(Int, f.x, RoundDown)
    s ∩ @inbounds SmallBitSet{U}(1:min(k, bitsize(U)))
end

function filter(f::Fix2{typeof(<),T}, s::SmallBitSet{U}) where {T <: Real, U <: Unsigned}
    k = T <: Integer ? f.x : round(Int, f.x, RoundUp)
    setdiff(s, @inbounds SmallBitSet{U}(max(k, 1):bitsize(U)))
end

function filter(f::Fix2{typeof(>=),T}, s::SmallBitSet{U}) where {T <: Real, U <: Unsigned}
    k = T <: Integer ? f.x : round(Int, f.x, RoundUp)
    s ∩ @inbounds SmallBitSet{U}(max(k, 1):bitsize(U))
end

function filter(f::Fix2{typeof(>),T}, s::SmallBitSet{U}) where {T <: Real, U <: Unsigned}
    k = T <: Integer ? f.x : round(Int, f.x, RoundDown)
    setdiff(s, @inbounds SmallBitSet{U}(1:min(k, bitsize(U))))
end

function any(f::F, s::SmallBitSet; style::MapStyle = MapStyle(f, Int)) where F <: Function
    if style isa LazyStyle
        invoke(any, Tuple{F, AbstractSet}, f, s)
    else
        !isempty(filter(f, s; style))
    end
end

function all(f::F, s::SmallBitSet; style::MapStyle = MapStyle(f, Int)) where F <: Function
    if style isa LazyStyle
        invoke(all, Tuple{F, AbstractSet}, f, s)
    else
        filter(f, s; style) == s
    end
end

count(f, s::SmallBitSet; init = 0, style::MapStyle = MapStyle(f, Int)) = smallbitset_count(style, f, s, init)

smallbitset_count(::LazyStyle, f::F, s, init) where F = invoke(count, Tuple{Any, AbstractSet}, f, s; init)

smallbitset_count(::MapStyle, f::F, s, init::T) where {F,T} = init + (length(filter(f, s)) % T)

union(s::SmallBitSet, t::SmallBitSet) = _SmallBitSet(s.mask | t.mask)

union(s::SmallBitSet, ts::SmallBitSet...) = foldl(union, ts; init = s)

intersect(s::SmallBitSet{U}, t::SmallBitSet) where U <: Unsigned = _SmallBitSet(s.mask & (t.mask % U))

function intersect(s::SmallBitSet{U}, t) where U <: Unsigned
    u = _SmallBitSet(zero(U))
    for n in (hasfastin(t) ? s : t)
        if n in (hasfastin(t) ? t : s)
            @inbounds u = push(u, n)
        end
    end
    u
end

intersect(s::SmallBitSet, ts...) = foldl(intersect, ts; init = s)

setdiff(s::SmallBitSet{U}, t::SmallBitSet) where U <: Unsigned = _SmallBitSet(s.mask & ~(t.mask % U))

function setdiff(s::SmallBitSet, t)
    if hasfastin(t)
        u = s
        for n in s
            if n in t
                u = delete(u, n)
            end
        end
        return u
    else
        foldl(delete, t; init = s)
    end
end

setdiff(s::SmallBitSet, ts...) = foldl(setdiff, ts; init = s)

symdiff(s::SmallBitSet, t::SmallBitSet) = _SmallBitSet(s.mask ⊻ t.mask)

symdiff(s::SmallBitSet, ts::SmallBitSet...) = foldl(symdiff, ts; init = s)

Random.rand(rng::AbstractRNG, ::SamplerType{SmallBitSet{U}}) where U <: Unsigned = _SmallBitSet(rand(rng, U))
Random.rand(rng::AbstractRNG, ::SamplerType{SmallBitSet}) = rand(rng, SmallBitSet{UInt})

# ordering and sorting

using Base: Order, Sort

"""
    isless(s::SmallBitSet, t::SmallBitSet) -> Bool

Compares `s` and `t` in the colexicographic ordering.

Currently, sorting with the default ordering given by `isless` is significantly
faster than specifiying one of the other orderings (including `Colex`).

See also [`$(@__MODULE__).Colex`](@ref).
"""
Base.isless(s::SmallBitSet, t::SmallBitSet) = Order.lt(Colex, s, t)

"""
    $(@__MODULE__).Colex <: Base.Order.Ordering

The colexicographic ordering for `SmallBitSet`.

See also [`$(@__MODULE__).Lex`](@ref), [`$(@__MODULE__).GradedColex`](@ref).
"""
const Colex = Order.ord(isless, bits, false)

"""
    $(@__MODULE__).GradedColex <: Base.Order.Ordering

The graded colexicographic ordering for `SmallBitSet`.
A smaller set either has smaller size,
or for equal size it is smaller in the colexicographic ordering.

See also [`$(@__MODULE__).GradedLex`](@ref), [`$(@__MODULE__).Colex`](@ref).
"""
const GradedColex = Order.ord(identity, false) do s::SmallBitSet, t::SmallBitSet
    (length(s) < length(t)) | ((length(s) == length(t)) & Order.lt(Colex, s, t))
end

"""
    $(@__MODULE__).Lex <: Base.Order.Ordering

The lexicographic ordering for `SmallBitSet`. This is the slowest among the available orderings.

See also [`$(@__MODULE__).Colex`](@ref), [`$(@__MODULE__).GradedLex`](@ref).
"""
const Lex = Order.ord(bits, false) do x::Unsigned, y::Unsigned
    a = blsi(x ⊻ y)
    b = ~blsmsk(x ⊻ y)
    (!iszero(x & a) & !iszero(y & b)) | (iszero(x & b) & !iszero(y & a))
end

"""
    $(@__MODULE__).GradedLex <: Base.Order.Ordering

The graded lexicographic ordering for `SmallBitSet`.
A smaller set either has smaller size,
or for equal size it is smaller in the lexicographic ordering.

See also [`$(@__MODULE__).Lex`](@ref), [`$(@__MODULE__).GradedColex`](@ref).
"""
const GradedLex = Order.ord(identity, false) do s::SmallBitSet, t::SmallBitSet
    u = first_as_set(symdiff(s, t))
    (length(s) < length(t)) | ((length(s) == length(t)) & !isempty(s ∩ u))
end

# The following definitions don't work for custom orderings, see julia#60184
Sort.uint_map(s::SmallBitSet, ::Order.ForwardOrdering) = bits(s)
Sort.uint_unmap(::Type{SmallBitSet{U}}, u::U, ::Order.ForwardOrdering) where U <: Unsigned = _SmallBitSet(u)
Sort.UIntMappable(::Type{SmallBitSet{U}}, ::Order.ForwardOrdering) where U <: Unsigned = U

# HWType conversion

from_hwvalue(::Type{SmallBitSet{U}}, x::U) where U <: Unsigned = _SmallBitSet(x)

#
# extensions of FixedVector
#

import Base: setindex, circshift, circshift!, reverse!, convert

export setindex, unsafe_circshift, unsafe_circshift!

"""
    setindex(v::AbstractFixedVector{N,T}, x, i::Integer) where {N,T} -> FixedVector{N,T}

Substitute `x` for the `i`-th component of `v` and return the result. The vector `v` is not modified.

See also `Base.setindex`, [`addindex`](@ref addindex(::AbstractFixedVector, ::Any, ::Integer)).
"""
setindex(::AbstractFixedVector, ::Any, ::Integer)

@inline function setindex(v::AbstractFixedVector{N,T}, x, i::Integer) where {N,T}
    @boundscheck checkbounds(v, i)
    if ishwtype(T) && N-1 <= typemax(uinttype(T))
        setindex_hw(v, convert(T, x), i)
    else
        i1 = i % SmallLength
        t = ntuple(Val(N % SmallLength)) do j
            j == i1 ? convert(T, x) : v[j]
        end
        FixedVector{N,T}(t)
    end
end

@generated function setindex_hw(v::AbstractFixedVector{N,T}, x::T, i::Integer) where {N,T}
    H = hwtype(T)
    L = llvm_type(H)
    U = uinttype(T)
    LU = llvm_type(U)
    w = join((string(LU, ' ', k) for k in 1:N), ", ")
    ir = """
        %x0 = insertelement <$N x $L> poison, $L %1, i8 0
        %xv = shufflevector <$N x $L> %x0, <$N x $L> poison, <$N x i32> zeroinitializer
        %i0 = insertelement <$N x $LU> poison, $LU %2, i8 0
        %iv = shufflevector <$N x $LU> %i0, <$N x $LU> poison, <$N x i32> zeroinitializer
        %f  = icmp eq <$N x $LU> <$w>, %iv
        %c  = select <$N x i1> %f, <$N x $L> %xv, <$N x $L> %0
        ret <$N x $L> %c
    """
    quote
        b = Base.llvmcall($ir, NTuple{N, VecElement{$H}}, Tuple{NTuple{N, VecElement{$H}}, $H, $U}, vec(v.t), hwvalue(x), i % $U)
        FixedVector(unvec(T, b))
    end
end

"""
    addindex(v::AbstractFixedVector{N,T}, x, i::Integer) where {N,T} -> FixedVector{N,T}

Add `x` to the `i`-th component of `v` and return the result. The vector `v` is not modified.

See also [`setindex`](@ref setindex(::AbstractFixedVector, ::Any, ::Integer)).
"""
@propagate_inbounds function addindex(v::AbstractFixedVector, x, i::Integer)
    v + setindex(zero(v), x, i)
end

"""
    $(@__MODULE__).padtail(v::AbstractFixedVector{N,T}, i::Integer, x = default(T)) where {N,T} -> FixedVector{N,T}

Replace the elements of `v` after the `i`-th position by `x` and return the new vector.
Providing an out-of-bounds index `i` does not produce an error.

See also [`$(@__MODULE__).default`](@ref).

# Example
```jldoctest
julia> v = FixedVector{4,Int}(1:4);

julia> $(@__MODULE__).padtail(v, 2)
4-element FixedVector{4, $Int}:
 1
 2
 0
 0

julia> $(@__MODULE__).padtail(v, 2, -1)
4-element FixedVector{4, $Int}:
  1
  2
 -1
 -1
```
"""
function padtail(v::AbstractFixedVector{N,T}, i::Integer, x) where {N,T}
    i = i % SmallLength
    t = ntuple(Val(N % SmallLength)) do j
        ifelse(j <= i, v[j], convert(T, x))
    end
    FixedVector{N,T}(t)
end

@inline function padtail(v::AbstractFixedVector{N,T}, i::Integer) where {N,T}
    ishwtype(T) ? padtail_hw(v, i) : padtail(v, i, default(T))
end

@inline @generated function padtail_hw(v::FixedVector{N,T}, n::Integer) where {N,T}
    H = hwtype(T)
    M = llvm_type(H)
    L = 8*sizeof(T)
    if log2(N) >= L
        L = bitsize(SmallLength)
    end
    U = Symbol(:UInt, L)
    s = join(("i$L $k" for k in 0:N-1), ", ")
    ir = """
        %b = insertelement <$N x i$L> poison, i$L %1, i8 0
        %c = shufflevector <$N x i$L> %b, <$N x i$L> poison, <$N x i32> zeroinitializer
        %d = icmp ult <$N x i$L> <$s>, %c
        %r = select <$N x i1> %d, <$N x $M> %0, <$N x $M> zeroinitializer
        ret <$N x $M> %r
        """
    quote
        @inline
        b = Base.llvmcall($ir, NTuple{N, VecElement{$H}}, Tuple{NTuple{N, VecElement{$H}}, $U}, vec(v), n % $U)
        FixedVector{N,T}(unvec(T, b))
    end
end

@inline @generated function fixedvector_range(::Val{N}, x::T, s::T) where {N,T}
    LT = llvm_type(T)
    t = join((string("$LT ", k) for k in 0:N-1), ", ")
    ir = """
        %s  = insertelement <$N x $LT> poison, $LT %1, i8 0
        %sv = shufflevector <$N x $LT> %s, <$N x $LT> poison, <$N x i32> zeroinitializer
        %u  = mul <$N x $LT> %sv, <$t>
        %x  = insertelement <$N x $LT> poison, $LT %0, i8 0
        %xv = shufflevector <$N x $LT> %x, <$N x $LT> poison, <$N x i32> zeroinitializer
        %w  = add <$N x $LT> %u, %xv
        ret <$N x $LT> %w
    """
    quote
        t = Base.llvmcall($ir, NTuple{N, VecElement{T}}, Tuple{T, T}, x, s)
        FixedVector{N,T}(unvec(t))
    end
end

pushfirst(v::FixedVector, xs...) = prepend(v, xs)

function prepend(v::FixedVector{N,T}, w::Union{AbstractVector,Tuple}) where {N,T}
    n = length(w)
    t = ntuple(Val(N)) do i
        @inbounds i <= n ? convert(T, w[i]) : v[i-n]
    end
    FixedVector{N,T}(t)
end

function popfirst(v::FixedVector{N,T}) where {N,T}
    if hasshuffle(v, Val(false))
        U = uinttype(T)
        u = FixedVector{N,U}(1:N)
        p = ifelse.(u .< U(N), u, -U(1))
        shuffle(v, p, Val(false)), v[1]
    else
        @inbounds popat(v, 1)
    end
end

@inline function insert(v::FixedVector{N,T}, i::Integer, x) where {N,T}
    @boundscheck checkbounds(v, i)
    v = Tuple(v)
    t = ntuple(Val(N)) do j
        if j < i
            v[j]
        elseif j == i
            convert(T, x)
        else
            v[j-1]
        end
    end
    FixedVector{N,T}(t)
end

@inline function duplicate(v::FixedVector{N,T}, i::Integer) where {N,T}
    @static if v"1.12" <= VERSION < v"1.13-" && Sys.ARCH == :x86_64
        # @inbounds leads to bug, similar to julia#59203
        checkbounds(v, i)
    else
        @boundscheck checkbounds(v, i)
    end
    t = if ishwtype(T)
        NN = smallint(N)
        ii = i % typeof(NN)
        c = circshift(v, 1)
        ntuple(Val(NN)) do j
            j <= ii ? v[j] : c[j]
        end
    else
        ntuple(Val(N)) do j
            j <= i ? v[j] : v[j-1]
        end
    end
    FixedVector{N,T}(t)
end

@propagate_inbounds deleteat(v::FixedVector, i::Integer) = first(popat(v, i))

@inline function popat(v::FixedVector{N,T}, i::Integer) where {N,T}
    @boundscheck checkbounds(v, i)
    if hasshuffle(v, Val(false))
        U = uinttype(T)
        ii = i % U
        w = first(@inline popfirst(v))
        t = ntuple(Val(N % U)) do j
            j < ii ? v[j] : w[j]
        end
    else
        t = ntuple(Val(N)) do j
            if j < i
                v[j]
            elseif j < N
                v[j+1]
            else
                default(T)
            end
        end
    end
    FixedVector{N,T}(t),
    @static if v"1.11" <= VERSION < v"1.13-" && Sys.ARCH == :x86_64
        # @inbounds leads to bug (with 1.12 not just for floats), see julia#59203
        v[i]
    else
        @inbounds v[i]
    end
end

"""
    circshift(v::AbstractFixedVector{N,T}, k::Integer) where {N,T} -> FixedVector{N,T}
    circshift(v::AbstractFixedVector{N,T}, ::Val{k}) where {N,T,k} -> FixedVector{N,T}

Rotate `v` by `k` positions towards higher indices and return the result.
A negative value of `k` corresponds to a rotation towards lower indices.

See also [`circshift!`](@ref circshift!(::MutableFixedVector, ::Union{Integer,Val})).

# Examples
```jldoctest
julia> v = FixedVector{4}(1:4);

julia> circshift(v, 1)
4-element FixedVector{4, $Int}:
 4
 1
 2
 3

julia> circshift(v, Val(-1))
4-element FixedVector{4, $Int}:
 2
 3
 4
 1
```
"""
circshift(::AbstractFixedVector, ::Union{Integer,Val})

"""
    unsafe_circshift(v::AbstractFixedVector{N,T}, k::Integer) where {N,T} -> FixedVector{N,T}
    unsafe_circshift!(v::MutableFixedVector, k::Integer) -> v

These are faster versions of `circshift` and `circshift!`. They assume `-N ≤ k < N`.
This avoids the comparatively costly integer division with remainder.

See also [`circshift`](@ref circshift(::AbstractFixedVector, ::Union{Integer,Val})),
[`circshift!`](@ref circshift!(::MutableFixedVector, ::Union{Integer,Val})).
"""
unsafe_circshift(::AbstractFixedVector, ::Integer),
unsafe_circshift!(::MutableFixedVector, ::Integer)

@inline function unsafe_circshift(v::AbstractFixedVector{N,T}, k::Integer) where {N,T}
    if N == 1
        FixedVector{N,T}(v)
    elseif ishwtype(T) && ispow2(N) && 8 <= bitsize(T)*N <= 64
        convert(FixedVector{N,T}, bitrotate(bits(v), bitsize(T)*k))
    elseif hasshuffle(v, Val(true))
        U = uinttype(T)
        u = FixedVector{N,U}(0:N-1)
        p = if ispow2(N)
            (u .- (k % U)) .& U(N-1)
        else
            l = k >= 0 ? k % U : (k+N) % U
            u1 = u .- l
            u2 = u1 .+ N % U
            ifelse.(u .< l, u2, u1)
        end
        shuffle(fixedvector(v), p, Val(true))
    else
        t = ntuple(Val(N % SmallLength)) do i
            k2 = ifelse(signbit(k), k+N, k) % SmallLength
            @inbounds if i <= k2
                v[(i-k2)+N]
            else
                v[i-k2]
            end
        end
        FixedVector{N,T}(t)
    end
end

@inline function circshift(v::AbstractFixedVector{N,T}, k::Integer) where {N,T}
    if N == 1
        FixedVector{N,T}(v)
    elseif ishwtype(T) && ispow2(N) && 8 <= bitsize(T)*N <= 128  # for Bool one could go up to 512 bits
        convert(FixedVector{N,T}, bitrotate(bits(v), bitsize(T)*k))
    else
        k1 = ispow2(N) ? k & (N-1) : unsafe_rem(k, UInt16(N))
        unsafe_circshift(v, k1)
    end
end

function circshift(v::AbstractFixedVector{N,T}, ::Val{K}) where {N,T,K}
    if v isa MutableFixedVector && ishwtype(T)
        circshift_hw(v, Val(K))
    else
        circshift(v, K)
    end
end

@inline @generated function circshift_hw(v::MutableFixedVector{N,T}, ::Val{K}) where {N,T,K}
    H = hwtype(T)
    M = llvm_type(H)
    b = sizeof(T)
    s = join(("i32 " * string(mod(i-K, N)) for i in 0:N-1), ", ")
    ir = VERSION > v"1.12-" ? """
        %a = load <$N x $M>, ptr %0, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        ret <$N x $M> %b
    """ : """
        %p = inttoptr i64 %0 to <$N x $M>*
        %a = load <$N x $M>, <$N x $M>* %p, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        ret <$N x $M> %b
    """
    quote
        b = Base.llvmcall($ir, NTuple{N,VecElement{$H}}, Tuple{Ptr{T}}, pointer(v))
        FixedVector{N,T}(unvec(T, b))
    end
end

"""
    circshift!(v::MutableFixedVector, k::Integer) -> v
    circshift!(v::MutableFixedVector, ::Val{k}) where k -> v

Rotate `v` in-place by `k` positions towards higher indices and return `v`.
A negative value of `k` corresponds to a rotation towards lower indices.

See also [`circshift`](@ref circshift(::AbstractFixedVector, ::Union{Integer,Val})).

# Examples
```jldoctest
julia> v = MutableFixedVector{4}(1:4);

julia> circshift!(v, 1)
4-element MutableFixedVector{4, $Int}:
 4
 1
 2
 3

julia> circshift!(v, Val(-1))  # undo previous step
4-element MutableFixedVector{4, $Int}:
 1
 2
 3
 4
```
"""
circshift!(::MutableFixedVector, ::Union{Integer,Val})

@inline function unsafe_circshift!(v::MutableFixedVector, k::Integer)
    v .= unsafe_circshift(v, k)
end

@inline function circshift!(v::MutableFixedVector, k::Integer)
    v .= circshift(v, k)
end

function circshift!(v::MutableFixedVector{N,T}, ::Val{K}) where {N,T,K}
    ishwtype(T) || return circshift!(v, K)
    vec_circshift!(pointer(v), Val(N), Val(K))
    v
end

@inline @generated function vec_circshift!(ptr::Ptr{T}, ::Val{N}, ::Val{K}) where {N,T,K}
    M = llvm_type(hwtype(T))
    b = sizeof(T)
    s = join(("i32 " * string(mod(i-K, N)) for i in 0:N-1), ", ")
    ir = VERSION > v"1.12-" ? """
        %a = load <$N x $M>, ptr %0, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        store <$N x $M> %b, ptr %0, align $b
        ret void
    """ : """
        %p = inttoptr i64 %0 to <$N x $M>*
        %a = load <$N x $M>, <$N x $M>* %p, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        store <$N x $M> %b, <$N x $M>* %p, align $b
        ret void
    """
    quote
        Base.llvmcall($ir, Cvoid, Tuple{Ptr{T}}, ptr)
    end
end

@inline @generated function reverse!(v::MutableFixedVector{N,T}) where {N,T}
    ishwtype(T) || return invoke(reverse!, Tuple{AbstractVector{T}})
    M = llvm_type(hwtype(T))
    b = sizeof(T)
    s = join(("i32 " * string(i) for i in N-1:-1:0), ", ")
    ir = VERSION > v"1.12-" ? """
        %a = load <$N x $M>, ptr %0, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        store <$N x $M> %b, ptr %0, align $b
        ret void
    """ : """
        %p = inttoptr i64 %0 to <$N x $M>*
        %a = load <$N x $M>, <$N x $M>* %p, align $b
        %b = shufflevector <$N x $M> %a, <$N x $M> poison, <$N x i32> <$s>
        store <$N x $M> %b, <$N x $M>* %p, align $b
        ret void
    """
    quote
        Base.llvmcall($ir, Cvoid, Tuple{Ptr{T}}, pointer(v))
        v
    end
end

# checked arithmetic

"""
    Base.Checked.checked_neg(v::AbstractFixedVector{N}) where N -> FixedVector{N}

Returns `-v`, but throws an `OverflowError` if an overflow occurs.
The elements of `v` must be integers.

See also [`Base.Checked.checked_sub`](@ref Base.Checked.checked_sub(::AbstractFixedVector, ::AbstractFixedVector)).
"""
Base.Checked.checked_neg(::AbstractFixedVector)

function Base.Checked.checked_neg(v::AbstractFixedVector{N,T}) where {N, T <: Integer}
    T <: Union{Bool, BigInt} && return -v
    u, s = Base.Checked.sub_with_overflow(zero(v), v)
    isempty(s) || overflowerror("overflow during negation")
    u
end

for op_with_name in ((:+, "add"), (:-, "sub"))
    global op, op_name = op_with_name
    global op_with_overflow = Symbol(op_name, "_with_overflow")
    global checked_op = Symbol("checked_", op_name)

    @eval begin
        example_ans = if op == :+
            (Int8[-128, 4, 4, -128], SmallBitSet{UInt8}([4]))
        else
            (Int8[-128, -2, 0, 126], SmallBitSet{UInt8}([1]))
        end

        """
            Base.Checked.$op_with_overflow(v::AbstractFixedVector{N,T}, w::AbstractFixedVector{N,T}) where {N,T} -> Tuple{FixedVector{N,T}, SmallBitSet}

        Returns `v$(op)w` as the first component of the resulting tuple.
        The second component is a `SmallBitSet` whose elements are the indices where an overflow occurred.
        The element type `T` must be a bit integer type.

        See also [`Base.Checked.$checked_op`](@ref Base.Checked.$checked_op(::AbstractFixedVector, ::AbstractFixedVector)).

        # Example
        ```jldoctest
        julia> v = FixedVector{4,Int8}((0, 1, 2, 127));

        julia> w = FixedVector{4,Int8}((-128, 3, 2, 1));

        julia> Base.Checked.$op_with_overflow(v, w)
        $example_ans
        ```
        """
        Base.Checked.$op_with_overflow(::AbstractFixedVector, ::AbstractFixedVector)

        @inline @generated function Base.Checked.$op_with_overflow(v::AbstractFixedVector{N,T}, w::AbstractFixedVector{N,T}) where {N, T <: AbstractBitInteger}
            L = llvm_type(T)
            VL = llvm_type(N, T)
            U = uinttype(Val(N))
            LU = llvm_type(U)
            bc = if bitsize(U) == N
                """
                    %d = bitcast <$N x i1> %c to $LU
                """
            else
                """
                    %d1 = bitcast <$N x i1> %c to i$N
                    %d = zext i$N %d1 to $LU
                """
            end
            s = T <: Signed ? 's' : 'u'
            ir = """
                declare {<$N x $L>, <$N x i1>} @llvm.$s$($op_name).with.overflow.$VL(<$N x $L>, <$N x $L>)
                define {<$N x $L>, $LU} @f(<$N x $L>, <$N x $L>) alwaysinline {
                    %a = call {<$N x $L>, <$N x i1>} @llvm.$s$($op_name).with.overflow.$VL(<$N x $L> %0, <$N x $L> %1)
                    %b = extractvalue {<$N x $L>, <$N x i1>} %a, 0
                    %c = extractvalue {<$N x $L>, <$N x i1>} %a, 1
                    $bc
                    %e = insertvalue {<$N x $L>, $LU} poison, <$N x $L> %b, 0
                    %f = insertvalue {<$N x $L>, $LU} %e, $LU %d, 1
                    ret {<$N x $L>, $LU} %f
                }
            """
            quote
                u, o = Base.llvmcall(($ir, "f"), Tuple{NTuple{N,VecElement{T}}, $U},
                    Tuple{NTuple{N,VecElement{T}}, NTuple{N,VecElement{T}}}, vec(v.t), vec(w.t))
                FixedVector(unvec(u)), _SmallBitSet(o)
            end
        end

    end
end

"""
    Base.Checked.checked_add(v::AbstractFixedVector{N}, ws::AbstractFixedVector{N}...) where N -> FixedVector{N}

Returns the sum of the argument vectors, but throws an `OverflowError` if an overflow occurs.
All arguments must have integer elements.

See also [`Base.Checked.add_with_overflow`](@ref Base.Checked.add_with_overflow(::AbstractFixedVector, ::AbstractFixedVector)).
"""
Base.Checked.checked_add(::AbstractFixedVector, ::AbstractFixedVector...)

Base.Checked.checked_add(v::AbstractFixedVector{N, <:Integer}) where N = +v

function Base.Checked.checked_add(v::AbstractFixedVector{N, <:Integer}, ws::Vararg{AbstractFixedVector{N, <:Integer}, M}) where {N,M}
    T = promote_type(eltype(v), map(eltype, ws)...)
    T <: Union{Bool, BigInt} && return +(v, ws...)
    U = uinttype(Val(N))
    u, s = foldl(ws; init = (FixedVector{N,T}(v), SmallBitSet{U}())) do (vv, s), ww
        uu, t = Base.Checked.add_with_overflow(vv, FixedVector{N,T}(ww))
        uu, union(s, t)
    end
    isempty(s) || overflowerror("overflow during addition")
    u
end

"""
    Base.Checked.checked_sub(v::AbstractFixedVector{N}, w::AbstractFixedVector{N}) where N -> FixedVector{N}

Returns `v-w`, but throws an `OverflowError` if an overflow occurs.
The elements of `v` and `w` must be integers.

See also [`Base.Checked.sub_with_overflow`](@ref Base.Checked.sub_with_overflow(::AbstractFixedVector, ::AbstractFixedVector)).
"""
Base.Checked.checked_sub(::AbstractFixedVector, ::AbstractFixedVector)

function Base.Checked.checked_sub(v::AbstractFixedVector{N,T1}, w::AbstractFixedVector{N,T2}) where {N, T1 <: Integer, T2 <: Integer}
    T = promote_type(T1, T2)
    T == Union{Bool, BigInt} && return v-w
    u, s = Base.Checked.sub_with_overflow(FixedVector{N,T}(v), FixedVector{N,T}(w))
    isempty(s) || overflowerror("overflow during subtraction")
    u
end

"""
    Base.Checked.mul_with_overflow(c::T, v::AbstractFixedVector{N,T}) where {N,T} -> Tuple{FixedVector{N,T}, SmallBitSet}
    Base.Checked.mul_with_overflow(v::AbstractFixedVector{N,T}, c::T) where {N,T} -> Tuple{FixedVector{N,T}, SmallBitSet}

Returns `c*v` as the first component of the resulting tuple.
The second component is a `SmallBitSet` whose elements are the indices where an overflow occurred.
The element type `T` must be a bit integer type.

See also [`Base.Checked.checked_mul`](@ref Base.Checked.checked_mul(::Integer, ::AbstractFixedVector)).

# Example
```jldoctest
julia> v = FixedVector{4,Int8}((0, 1, 2, 127));

julia> Base.Checked.mul_with_overflow(Int8(2), v)
(Int8[0, 2, 4, -2], SmallBitSet{UInt8}([4]))
```
"""
Base.Checked.mul_with_overflow(::Integer, ::AbstractFixedVector),
Base.Checked.mul_with_overflow(::AbstractFixedVector, ::Integer)

@inline @generated function Base.Checked.mul_with_overflow(c::T, v::AbstractFixedVector{N,T}) where {N, T <: AbstractBitInteger}
    L = llvm_type(T)
    VL = llvm_type(N, T)
    U = uinttype(Val(N))
    LU = llvm_type(U)
    bc = if bitsize(U) == N
        """
            %d = bitcast <$N x i1> %c to $LU
        """
    else
        """
            %d1 = bitcast <$N x i1> %c to i$N
            %d = zext i$N %d1 to $LU
        """
    end
    s = T <: Signed ? 's' : 'u'
    ir = """
        declare {<$N x $L>, <$N x i1>} @llvm.$(s)mul.with.overflow.$VL(<$N x $L>, <$N x $L>)
        define {<$N x $L>, $LU} @f(<$N x $L>, <$N x $L>) alwaysinline {
            %a = call {<$N x $L>, <$N x i1>} @llvm.$(s)mul.with.overflow.$VL(<$N x $L> %0, <$N x $L> %1)
            %b = extractvalue {<$N x $L>, <$N x i1>} %a, 0
            %c = extractvalue {<$N x $L>, <$N x i1>} %a, 1
            $bc
            %e = insertvalue {<$N x $L>, $LU} poison, <$N x $L> %b, 0
            %f = insertvalue {<$N x $L>, $LU} %e, $LU %d, 1
            ret {<$N x $L>, $LU} %f
        }
    """
    quote
        w = FixedVector(ntuple(Returns(c), Val(N)))
        u, o = Base.llvmcall(($ir, "f"), Tuple{NTuple{N,VecElement{T}}, $U},
            Tuple{NTuple{N,VecElement{T}}, NTuple{N,VecElement{T}}}, vec(v.t), vec(w.t))
        FixedVector(unvec(u)), _SmallBitSet(o)
    end
end

Base.Checked.mul_with_overflow(v::AbstractFixedVector{N,T}, c::T) where {N, T <: AbstractBitInteger} = Base.Checked.mul_with_overflow(c, v)

"""
    Base.Checked.checked_mul(c, v::AbstractFixedVector{N}) where N -> FixedVector{N}
    Base.Checked.checked_mul(v::AbstractFixedVector{N}, c) where N -> FixedVector{N}

Returns `c*v`, but throws an `OverflowError` if an overflow occurs.
The scalar `c` and the elements of `v` must be integers.

See also [`Base.Checked.mul_with_overflow`](@ref Base.Checked.mul_with_overflow(::Integer, ::AbstractFixedVector)).
"""
Base.Checked.checked_mul(::Integer, ::AbstractFixedVector),
Base.Checked.checked_mul(::AbstractFixedVector, ::Integer)

function Base.Checked.checked_mul(c::T1, v::AbstractFixedVector{N,T2}) where {N, T1 <: Integer, T2 <: Integer}
    T = promote_type(T1, T2)
    T <: Union{Bool, BigInt} && return c*v
    u, s = Base.Checked.mul_with_overflow(T(c), FixedVector{N,T}(v))
    isempty(s) || overflowerror("overflow during multiplication")
    u
end

Base.Checked.checked_mul(v::AbstractFixedVector{N,T1}, c::T2) where {N, T1 <: Integer, T2 <: Integer} = Base.Checked.checked_mul(c, v)

"""
    $(@__MODULE__).default(::Type{T}) where T -> T
    $(@__MODULE__).default(::T) where T -> T

Return the default value of type `T` used for filling unused elements of an `AbstractSmallVector`.
This must be defined as `zero(T)` if `T` supports algebraic operations. Otherwise it can
be any value of type `T`.

This function has methods for number types, bits types, `Symbol`, `AbstractChar`, `AbstractString`,
`Tuple`, `NamedTuple`, `AbstractFixedVector`, `AbstractSmallVector` und `SmallBitSet`.
Methods for other types must be defined explicitly, see the examples below.

See also `Base.isbitstype`.

# Examples

We start by defining a default value for an immutable struct.
```jldoctest default
julia> import $(@__MODULE__): default

julia> struct A x::Int end

julia> default(::Type{A}) = A(0);
```
For a mutable struct one needs to create an object first.
```jldoctest default
julia> mutable struct B x::Int end

julia> const b0 = B(0);

julia> default(::Type{B}) = b0;
```
For mutable parametric types one can use a generated function.
```jldoctest default
julia> mutable struct C{T} x::T end

julia> @generated default(::Type{C{T}}) where T = C(default(T));

julia> default(C{Bool})
C{Bool}(false)

julia> default(C{Bool}) === default(C{Bool})  # do we always get the same object?
true
```
"""
default(::T) where T = default(T)

function default(::Type{T}) where T
    if isbitstype(T)
        default_bitstype(T)
    elseif Int <: T
        0
    else
        error(LazyString("no default value defined for type ", T))
    end
end

@assume_effects :total function default_bitstype(::Type{T}) where T
    m8, m1 = divrem(Base.packedsize(T), 8)
    t8 = ntuple(Returns(UInt64(0)), Val(m8))
    t1 = ntuple(Returns(UInt8(0)), Val(m1))
    reinterpret(T, (t8, t1))
end

default(::Type{T}) where T <: Number = zero(T)
default(::Type{T}) where T <: AbstractChar = T(0)
default(::Type{<:AbstractString}) = ""
default(::Type{Symbol}) = Symbol()

default(::Type{T}) where T <: Tuple = ntuple(i -> default(fieldtype(T, i)), Val(fieldcount(T)))
default(::Type{NamedTuple{K,T}}) where {K,T} = NamedTuple{K}(default(T))
default(::Type{Pair{K,V}}) where {K,V} = default(K) => default(V)

default(::Type{V}) where {N,T,V<:AbstractFixedVector{N,T}} = V(default(NTuple{N,T}))

#
# bit conversions
#

function hwtype(::Type{T}) where T
# the resulting type must have the same size as T
    !ismutabletype(T) && isstructtype(T) && fieldcount(T) == 1 ? hwtype(fieldtype(T, 1)) : T
end

ishwtype(::Type{T}) where T = hwtype(T) <: HWType

hwvalue(x::HWType) = x

function hwvalue(x::T) where T
    @assert !ismutabletype(T) && isstructtype(T) && fieldcount(T) == 1 "default method does not apply to type $T"
    hwvalue(getfield(x, 1))
end

from_hwvalue(::Type{T}, x::T) where T <: HWType = x

@generated function from_hwvalue(::Type{T}, x) where T
    @assert !ismutabletype(T) && isstructtype(T) && fieldcount(T) == 1 "default method does not apply to type $T"
    Expr(:new, T, Expr(:call, :from_hwvalue, fieldtype(T, 1), :x))
end

@inline vec(t::Union{NTuple{N}, AbstractFixedVector{N}}) where N = ntuple(i -> VecElement(hwvalue(t[i])), Val(N))

@inline unvec(t::NTuple{N,VecElement}) where N = ntuple(i -> t[i].value, Val(N))
@inline unvec(::Type{T}, t::NTuple{N,VecElement}) where {T,N} = ntuple(i -> from_hwvalue(T, t[i].value), Val(N))

"""
    bits(v::AbstractFixedVector{N,T}) where {N,T} -> Unsigned

Convert the given vector to an unsigned integer. The element type `T` must ultimately be a subtype of `$HWType`.
Here "ultimately" means that it can also be a `struct` with a single field of such a type or a nested sequence
of such structs. For example, `SmallBitSet{UInt8}` or `FixedVector{16,SmallBitSet{UInt8}}` are allowed.

For bit integers, hardware floats, `Char` and `Enum` types this is the same as `reinterpret(U, Tuple(v))`
on little-endian host machines, provided that `U` is an unsigned integer type with `N*bitsize(T)` bits,
possibly defined by the package `BitIntegers`. Otherwise the result will be zero-extended to the next
unsigned integer type `U` whose bit length is a power of `2`. The resulting integer is independent of
the endianness of the host machine.

If the element type is `Bool`, then each element only takes one bit in the return value.
If `N` is less than `8` or not a power of `2`, then the result will again be zero-extended.

The inverse operation can be done with `convert`.

See also
[`Base.convert`](@ref convert(::Type{<:AbstractFixedVector}, ::Unsigned)),
[`$(@__MODULE__).bitsize`](@ref), `Base.HWReal`, `Base.reinterpret`, `BitIntegers`.

# Examples
```jldoctest
julia> FixedVector{4,Int8}(1:4) |> bits
0x04030201

julia> FixedVector{3}('a':'c') |> bits
0x00000000630000006200000061000000

julia> m = FixedVector{6,SmallBitSet{UInt32}}(SmallBitSet(1:k) for k in 1:6) |> bits
0x00000000000000000000003f0000001f0000000f000000070000000300000001

julia> typeof(m)
BitIntegers.UInt256

julia> FixedVector{22}(map(isodd, 1:22)) |> bits
0x00155555
```
"""
function bits(v::AbstractFixedVector{N,T}) where {N,T}
    if ishwtype(T)
        bits(map(hwvalue, v))
    else
        error(LazyString("element type ", T, " not supported"))
    end
end

@inline @generated function bits(v::AbstractFixedVector{N,T}) where {N, T <: HWType}
    M = nextpow(2, N)
    b = M*bitsize(T)
    U = uinttype(Val(b))
    L = llvm_type(T)
    ir = """
        %b = bitcast <$M x $L> %0 to i$b
        ret i$b %b
    """
    quote
        w = fixedvector(v, Val($M))
        t = Tuple(map(htol, w))
        m = Base.llvmcall($ir, $U, Tuple{NTuple{$M, VecElement{T}}}, vec(t))
        ltoh(m)
    end
end

#=
@generated function bits(v::AbstractFixedVector{N,T}) where {N, T <: Union{Int128,UInt128}}
    n = nextpow(2, N)
    U = Symbol(:UInt, n*128)
    z = ntuple(Returns(zero(T)), Val(n-N))
    quote
        t = (Tuple(v)..., $z...)
        reinterpret($U, t)
    end
end
=#

@inline @generated function bits(v::AbstractFixedVector{N,Bool}) where N
    U = uinttype(Val(N))
    M = bitsize(U)
    ir = """
        %b = trunc <$M x i8> %0 to <$M x i1>
        %c = bitcast <$M x i1> %b to i$M
        ret i$M %c
    """
    quote
        w = fixedvector(v, Val($M))
        m = Base.llvmcall($ir, $U, Tuple{NTuple{$M, VecElement{Bool}}}, vec(w))
        ltoh(m)
    end
end

"""
    convert(::Type{V}, x::Unsigned) where {N, T, V <: AbstractFixedVector{N,T}} -> V

Convert the unsigned integer `x` to a `FixedVector{N,T}` or `MutableFixedVector{N,T}`.
The bits of `x` are split into groups of size `bitsize(T)` and reinterpreted as elements of type `T`.
Unused bits are ignored and missing bits are taken as `0`. This is the inverse operation to `bits`,
and the restriction on the element type `T` stated there apply here as well.

See also [`bits`](@ref bits(::AbstractFixedVector)), [`$(@__MODULE__).bitsize`](@ref).

# Examples
```jldoctest
julia> v = convert(FixedVector{4,Int8}, 0x030201)
4-element FixedVector{4, Int8}:
 1
 2
 3
 0

julia> bits(v)
0x00030201

julia> convert(FixedVector{6,Bool}, 0xf0)
6-element FixedVector{6, Bool}:
 0
 0
 0
 0
 1
 1

julia> x = FixedVector{2,Char}('a':'b') |> bits
0x6200000061000000

julia> convert(FixedVector{2,Char}, x)
2-element FixedVector{2, Char}:
 'a': ASCII/Unicode U+0061 (category Ll: Letter, lowercase)
 'b': ASCII/Unicode U+0062 (category Ll: Letter, lowercase)

julia> using BitIntegers

julia> convert(FixedVector{4,SmallBitSet{UInt64}}, uint256"0x300000000000000020000000000000001")
4-element FixedVector{4, SmallBitSet{UInt64}}:
 SmallBitSet([1])
 SmallBitSet([2])
 SmallBitSet([1, 2])
 SmallBitSet([])
```
"""
convert(::Type{<:AbstractFixedVector}, ::Unsigned)

function convert(::Type{V}, x::Unsigned) where {N, T, V <: AbstractFixedVector{N,T}}
    H = hwtype(T)
    H <: HWType || error(LazyString("element type ", T, " not supported"))
    V(map(Fix1(from_hwvalue, T), convert(FixedVector{N,H}, x)))
end

@generated function convert(::Type{V}, x::U) where {N, T <: HWType, V <: AbstractFixedVector{N,T}, U <: Unsigned}
    M = llvm_type(T)
    b = N*bitsize(T)
    c = bitsize(U)
    if b == c
        ir = """
            %b = bitcast i$b %0 to <$N x $M>
            ret <$N x $M> %b
        """
    elseif b > c
        ir = """
            %b = zext i$c %0 to i$b
            %a = bitcast i$b %b to <$N x $M>
            ret <$N x $M> %a
        """
    else
        ir = """
            %b = trunc i$c %0 to i$b
            %a = bitcast i$b %b to <$N x $M>
            ret <$N x $M> %a
        """
    end
    quote
        $(Expr(:meta, :inline))
        v = Base.llvmcall($ir, NTuple{N, VecElement{T}}, Tuple{$U}, x)
        V(unvec(v))
    end
end

@generated function convert(::Type{V}, x::U) where {N, V <: AbstractFixedVector{N,Bool}, U <: Unsigned}
    c = bitsize(U)
    N2 = nextpow(2, N)   # work around an LLVM bug
    if N2 == c
        ir = """
            %b = bitcast i$N2 %0 to <$N2 x i1>
            %c = zext <$N2 x i1> %b to <$N2 x i8>
            ret <$N2 x i8> %c
        """
    elseif N2 > c
        ir = """
            %a = zext i$c %0 to i$N2
            %b = bitcast i$N2 %a to <$N2 x i1>
            %c = zext <$N2 x i1> %b to <$N2 x i8>
            ret <$N2 x i8> %c
        """
    else
        ir = """
            %a = trunc i$c %0 to i$N2
            %b = bitcast i$N2 %a to <$N2 x i1>
            %c = zext <$N2 x i1> %b to <$N2 x i8>
            ret <$N2 x i8> %c
        """
    end
    quote
        $(Expr(:meta, :inline))
        v2 = Base.llvmcall($ir, NTuple{$N2, VecElement{Bool}}, Tuple{$U}, x)
        v = ntuple(Base.Fix1(getindex, v2), Val(N))
        V(unvec(v))
    end
end

@generated function compress(v::AbstractFixedVector{N,T}, s::SmallBitSet{U}) where {N,T,U}
    @assert ishwtype(T)
    H = hwtype(T)
    L = llvm_type(H)
    NL = llvm_type(N, H)
    M = bitsize(U)
    resize2 = if M == N
        "select i1 1, i$N %2, i$N 0"
    elseif M > N
        "trunc i$M %2 to i$N"
    else # M < N
        "zext i$M %2 to i$N"
    end
    ir = if VERSION > v"1.12-"
        """
        declare void @llvm.masked.compressstore.$NL (<$N x $L>, ptr, <$N x i1>)
        define void @compress(ptr, <$N x $L>, i$M) alwaysinline {
            %a = $resize2
            %b = bitcast i$N %a to <$N x i1>
            call void @llvm.masked.compressstore.$NL(<$N x $L> %1, ptr %0, <$N x i1> %b)
            ret void
        }
        """
    else
        """
        declare void @llvm.masked.compressstore.$NL (<$N x $L>, ptr, <$N x i1>)
        define void @compress(i64, <$N x $L>, i$M) alwaysinline {
            %a = $resize2
            %b = bitcast i$N %a to <$N x i1>
            %p = inttoptr i64 %0 to <$N x $L>*
            call void @llvm.masked.compressstore.$NL(<$N x $L> %1, <$N x $L>* %p, <$N x i1> %b)
            ret void
        }
        """
    end
    quote
        @inline
        w = default(MutableFixedVector{N,T})
        Base.llvmcall(($ir, "compress"), Cvoid, Tuple{Ptr{T}, NTuple{N,VecElement{$H}}, U}, pointer(w), vec(v), bits(s))
        FixedVector(w)
    end
end

using Test, SmallCollections, BitIntegers

using SmallCollections: LazyStyle, EagerStyle, RigidStyle, StrictStyle, SmallLength

using Unitful: Unitful, Quantity, @u_str, dimension, ustrip

numerictype(::Type{T}) where T = T
numerictype(::Type{<:Quantity{T}}) where T = T

setnumerictype(::Type, ::Type{S}) where S = S
setnumerictype(::Type{Quantity{T,D,U}}, ::Type{S}) where {T,D,U,S} = Quantity{S,D,U}

unitrange(a, b) = a:b
unitrange(a::Quantity, b::Quantity) = a:oneunit(a):b

@inline Base.isodd(x::Quantity) = isodd(ustrip(x))  # otherwise we get an infinite recursion

macro test_inferred(expr, good, goodtype = missing)
    msg = """

        expression:      $expr
        expected result: $good
        expected type:   $(goodtype === missing ? "type of expected result" : goodtype)
        location:        $(something(__source__.file, :none)):$(__source__.line)

        """
    quote
        let good = $good, goodtype = $goodtype,
                result = try
                    @inferred($expr)
                catch e
                    printstyled($msg; bold = true, color = :magenta)
                    rethrow(e)
                end
            if goodtype === missing
                goodtype = typeof(good)
            elseif !(goodtype isa Type)
                goodtype = typeof(goodtype)
            end
            testresult = @test isequal(result, good)
            if testresult isa Test.Pass
                testresult = @test result isa goodtype
            end
            testresult isa Test.Pass || printstyled($msg; bold = true, color = :magenta)
            result
        end
    end |> esc
end

BitIntegers.@define_integers 440

@enum TestEnum::Int16 begin
    Item1 = 5
    Item2 = 7
    Item3 = 8
end

using StructEqualHash: @struct_equal_hash

abstract type AbstractTestStruct end

struct TestStruct1 <: AbstractTestStruct
    x::SmallBitSet{UInt32}
end

struct TestStruct2 <: AbstractTestStruct
    x::TestStruct1
    y::UInt16
end

@struct_equal_hash TestStruct1
@struct_equal_hash TestStruct2

# custom rand settings

using Random: Random, AbstractRNG, SamplerType

Random.rand(rng::AbstractRNG, ::SamplerType{String}) = string(rand(Char, 3)...)
Random.rand(rng::AbstractRNG, ::SamplerType{Symbol}) = Symbol((rand_notin(Char, ('\0',)) for _ in 1:3)...)
Random.rand(rng::AbstractRNG, ::SamplerType{T}) where T <: Enum = rand(instances(T))
Random.rand(rng::AbstractRNG, ::SamplerType{T}) where T <: AbstractTestStruct = T(map(rand, fieldtypes(T))...)

function rand_notin(::Type{T}, c) where T
    local x
    while true
        x = rand(T)
        x in c || break
    end
    x
end

rand_unique(::Type{T}, m::Integer) where T = foldl((v, _) -> push!(v, rand_notin(T, v)), 1:m; init = T[])

test_types = (Int8, UInt64, typeof(Int128(1)u"m"), UInt256, typeof(Float32(1)u"s"), Float64, Char, String, Symbol, TestEnum, TestStruct1, TestStruct2)

# isvalid

function isvalid(v::AbstractSmallVector{N,T}) where {N,T}
    n = length(v)
    0 <= n <= N && all(==(SmallCollections.default(T)), view(v.b, n+1:N))
end

function isvalid(v::PackedVector{U,N,T}) where {U,N,T}
    n = length(v)
    mask = one(U) << (n*N) - one(U)
    iszero(v.m & ~mask)
end

isvalid(d::AbstractSmallDict) = isvalid(d.keys) && isvalid(d.vals) && allunique(d.keys) && length(d.keys) == length(d.vals)

isvalid(s::AbstractSmallSet) = isvalid(s.d)

# run test files

if isempty(ARGS)
    push!(ARGS,
        "bits.jl", "smallbitset.jl", "fixedvector.jl", "smallvector.jl",
        "packedvector.jl", "smalldict.jl", "smallset.jl", "bangbang.jl")
end

foreach(include, ARGS)

#
# small dictionaries
#

export AbstractSmallDict, SmallDict, MutableSmallDict, capacity,
    setindex, push, delete, pop, invget,
    popmin, popmax, popmin!, popmax!

import Base: keys, values, copy, length, iterate, haskey,
    empty, getindex, get, getkey, setindex, filter, mergewith,
    setindex!, get!, empty!, delete!, pop!, filter!, mergewith!,
    replace!, push!, findmin, findmax, findall

"""
    AbstractSmallDict{N,K,V} <: AbstractDict{K,V}

This is the supertype of `SmallDict{N,K,V}` and `MutableSmallDict{N,K,V}`.

See also [`SmallDict`](@ref), [`MutableSmallDict`](@ref).
"""
abstract type AbstractSmallDict{N,K,V} <: AbstractDict{K,V} end

"""
    SmallDict{N,K,V} <: AbstractSmallDict{N,K,V}

    SmallDict{N,K,V}()
    SmallDict{N,K,V}(itr; unique = itr isa AbstractDict)
    SmallDict{N,K,V}(key1 => val1, (key2, val2), ...; unique = false)

An immutable dictionary with key type `K` and value type `V` that can store up to `N` entries.
All entries come from the key-value iterator `itr` provided at construction time or from the
explicitly given pairs or tuples.

If the key and value types are omitted, they will be inferred from the pairs or, if possible,
from the iterator. If `unique` is set to `true`, then the elements of `itr` are assumed to have
distinct keys.

See also [`AbstractSmallDict`](@ref), [`MutableSmallDict`](@ref).

# Examples
```jldoctest
julia> SmallDict{8}(Int16(1) => 2, Int32(3) => 4.0)
SmallDict{8, Int32, Float64} with 2 entries:
  1 => 2.0
  3 => 4.0

julia> SmallDict{8,Char,Int}('a'+k => k^2 for k in 0:2; unique = true)
SmallDict{8, Char, $Int} with 3 entries:
  'a' => 0
  'b' => 1
  'c' => 4
```
"""
struct SmallDict{N,K,V} <: AbstractSmallDict{N,K,V}
    keys::SmallVector{N,K}
    vals::SmallVector{N,V}
    SmallDict{N,K,V}(keys::AbstractSmallVector, vals::AbstractSmallVector) where {N,K,V} = new{N,K,V}(keys, vals)
    SmallDict(keys::AbstractSmallVector{N,K}, vals::AbstractSmallVector{N,V}) where {N,K,V} = new{N,K,V}(keys, vals)
end

SmallDict(d::AbstractSmallDict{N,K,V}) where {N,K,V} = SmallDict{N,K,V}(d)

SmallDict{N,K,V}() where {N,K,V} = SmallDict(SmallVector{N,K}(), SmallVector{N,V}())

to_pair(kv::Pair) = kv
to_pair((k, v)::Tuple) = k => v

@inline function keys_vals_unique(::Val{N}, ::Type{K}, ::Type{V}, itr) where {N,K,V}
    keys = MutableSmallVector{N,K}()
    vals = MutableSmallVector{N,V}()
    i = 0
    for ikv::Tuple{Int,Pair} in enumerate(to_pair(kv) for kv in itr)
        i, (key, val) = ikv
        i <= N || error(LazyString("dictionary cannot have more than ", N, " elements"))
        unsafe_setindex!(keys, key, i)
        unsafe_setindex!(vals, val, i)
    end
    vals.n = keys.n = i % SmallLength
    keys, vals
end

function SmallDict{N,K,V}(itr; unique = itr isa AbstractDict) where {N,K,V}
    if unique && isbitstype(Tuple{K,V})
        SmallDict(keys_vals_unique(Val(N), K, V, itr)...)
    elseif !isbitstype(Tuple{K,V})
        foldl(itr; init = SmallDict{N,K,V}()) do d, kv
            push(d, to_pair(kv))
        end::SmallDict{N,K,V}   # type annotation needed for inference
    else
        d = MutableSmallDict{N,K,V}()
        if itr isa Tuple
            @inline push!(d, map(to_pair, itr)...)
        else
            for p in itr
                @inline push!(d, to_pair(p))
            end
        end
        SmallDict(d)
    end
end

function SmallDict{N,K,V}(d::AbstractSmallDict; unique = false) where {N,K,V}
    SmallDict{N,K,V}(d.keys, d.vals)
end

"""
    MutableSmallDict{N,K,V} <: AbstractSmallDict{N,K,V}

    MutableSmallDict{N,K,V}()
    MutableSmallDict{N,K,V}(itr; unique = itr isa AbstractDict)
    MutableSmallDict{N,K,V}(key1 => val1, key2 => val2, ...; unique = false)

An dictionary with key type `K` and value type `V` that can store up to `N` entries.
The dictionary is mutable and implements Julia's dictionary interface.

If the key and value types are omitted, they will be inferred from the pairs or, if possible,
from the iterator. If `unique` is set to `true`, then the elements of `itr` are assumed to have
distinct keys.

See also [`AbstractSmallDict`](@ref), [`SmallDict`](@ref).

# Examples
```jldoctest
julia> d = MutableSmallDict{8}('a' => 0, 'b' => 1, 'c' => 4)
MutableSmallDict{8, Char, $Int} with 3 entries:
  'a' => 0
  'b' => 1
  'c' => 4


julia> delete!(d, 'b')
MutableSmallDict{8, Char, $Int} with 2 entries:
  'a' => 0
  'c' => 4
```
"""
struct MutableSmallDict{N,K,V} <: AbstractSmallDict{N,K,V}
    keys::MutableSmallVector{N,K}
    vals::MutableSmallVector{N,V}
    MutableSmallDict{N,K,V}(keys::AbstractSmallVector, vals::AbstractSmallVector) where {N,K,V} = new{N,K,V}(keys, vals)
    MutableSmallDict(keys::AbstractSmallVector{N,K}, vals::AbstractSmallVector{N,V}) where {N,K,V} = new{N,K,V}(keys, vals)
end

MutableSmallDict(d::AbstractSmallDict{N,K,V}) where {N,K,V} = MutableSmallDict{N,K,V}(d)

MutableSmallDict{N,K,V}() where {N,K,V} = MutableSmallDict(SmallVector{N,K}(), SmallVector{N,V}())

function MutableSmallDict{N,K,V}(itr; unique = itr isa AbstractDict) where {N,K,V}
    if unique
        MutableSmallDict(keys_vals_unique(Val(N), K, V, itr)...)
    else
        foldl(itr; init = MutableSmallDict{N,K,V}()) do d, kv
            push!(d, to_pair(kv))
        end
    end
end

function MutableSmallDict{N,K,V}(d::AbstractSmallDict; unique = false) where {N,K,V}
    MutableSmallDict{N,K,V}(MutableSmallVector{N,K}(d.keys), MutableSmallVector{N,V}(d.vals))
end

function (::Type{D})(itr::I; kw...) where {N, D <: AbstractSmallDict{N}, I}
    Base.IteratorEltype(I) isa Base.HasEltype || error("cannot determine element type")
    KV = element_type(I)
    D{fieldtypes(KV)...}(itr; kw...)
end

SmallDict{N,K,V}(kvs::Pair...; kw...) where {N,K,V} = SmallDict{N,K,V}(kvs; kw...)
MutableSmallDict{N,K,V}(kvs::Pair...; kw...) where {N,K,V} = MutableSmallDict{N,K,V}(kvs; kw...)
(::Type{D})(kvs::Pair...; kw...) where {N, D <: AbstractSmallDict{N}} = D(kvs; kw...)

keys(d::AbstractSmallDict) = SmallVector(d.keys)

values(d::AbstractSmallDict) = SmallVector(d.vals)

"""
    capacity(::Type{<:AbstractSmallDict}) -> Int
    capacity(d::AbstractSmallDict) -> Int

Return the largest number of elements the given dictionary type can hold.
"""
capacity(::Type{<:AbstractSmallDict}),
capacity(::AbstractSmallDict)

capacity(::Type{<:AbstractSmallDict{N}}) where N = N

copy(d::SmallDict) = d
copy(d::MutableSmallDict) = MutableSmallDict(d)

length(d::AbstractSmallDict) = length(d.keys)

function iterate(d::AbstractSmallDict{N,K,V}, i = 1) where {N,K,V}
    i <= length(d) ? (@inbounds Pair{K,V}(d.keys[i], d.vals[i]), i+1) : nothing
end

@inline token(d::AbstractSmallDict, key) = findfirst(isequal(key), d.keys)

haskey(d::AbstractSmallDict, key) = token(d, key) !== nothing

Base.hasfastin(::Type{D}) where D <: AbstractSmallDict = Base.hasfastin(fieldtype(D, :keys))

function getindex(d::AbstractSmallDict, key)
    i = token(d, key)
    if i === nothing
        keyerror(key)
    else
        @inbounds d.vals[i]
    end
end

function get(d::AbstractSmallDict, key, default)
    i = token(d, key)
    i === nothing ? default : @inbounds d.vals[i]
end

function getkey(d::AbstractSmallDict, key, default)
    i = token(d, key)
    i === nothing ? default : @inbounds d.keys[i]
end

"""
    invget(d::AbstractSmallDict{N,K}, val) where {N,K} -> K

Return a key in `d` whose value is equal to `val` (in the sense of `isequal`).
If there is no such key, an error is raised.

This reverse lookup is as fast as "forward" lookup by keys.
The key returned is the first matching one in `keys(d)`.
"""
function invget(d::AbstractSmallDict, val)
    key = invget(d, val, Void())
    key isa Void ? error("value not found") : key
end

"""
    invget(d::AbstractSmallDict{N,K}, val, default::T) where {N,K,T} -> Union{K,T}

Return a key in `d` whose value is equal to `val` (in the sense of `isequal`).
If there is no such key, return `default`.

This reverse lookup is as fast as "forward" lookup by keys.
The key returned is the first matching one in `keys(d)`.
"""
function invget(d::AbstractSmallDict{N,K,V}, val, default) where {N,K,V}
    i = findfirst(isequal(val), d.vals)
    i === nothing ? default : @inbounds d.keys[i]
end

@inline unsafe_get(d::AbstractSmallDict, i::Int) = @inbounds d.keys[i] => d.vals[i]

for g in (:findmin, :findmax)
    @eval @propagate_inbounds $g(d::AbstractSmallDict) = $g(identity, d)
    @eval @propagate_inbounds function $g(f::F, d::AbstractSmallDict{N,K,V}; style = MapStyle(f, V)) where {F,N,K,V}
        v, i = $g(f, d.vals; style)
        @inbounds v, d.keys[i]
    end
end

"""
    push(d::AbstractSmallDict{N,K,V}, key1 => val1, key2 => val2, ...) where {N,K,V} -> Tuple{SmallDict{N,K,V}, V}

Return the dictionary that is obtained from `d` by adding the mappings given as arguments.

See also `Base.push!`, [`setindex`](@ref setindex(::AbstractSmallDict, ::Any, ::Any)).
"""
@propagate_inbounds function push(d::AbstractSmallDict{N,K,V}, kvs::Vararg{Pair,M}) where {N,K,V,M}
    if isbitstype(Tuple{K,V}) && N >= 8
        e = MutableSmallDict(d)
        @inline push!(e, kvs...)
        SmallDict(e)
    else
        foldl(kvs; init = SmallDict(d)) do d, (key, val)
            setindex(d, val, key)
        end
    end
end

"""
    setindex(d::AbstractSmallDict{N,K,V}, val, key) where {N,K,V} -> Tuple{SmallDict{N,K,V}, V}

Return the dictionary that is obtained from `d` by adding the mapping `key => val`.

See also `Base.setindex!`, [`push`](@ref push(::AbstractSmallDict, ::Pair)).
"""
@propagate_inbounds function setindex(d::AbstractSmallDict, val, key)
    i = token(d, key)
    if i === nothing
        keys = push(d.keys, key)
        vals = @inbounds push(d.vals, val)
    else
        keys = @inbounds setindex(d.keys, key, i)
        vals = @inbounds setindex(d.vals, val, i)
    end
    SmallDict(keys, vals)
end

"""
    empty(d::AbstractSmallDict{N,K,V}) where {N,K,V} -> AbstractSmallDict{N,K,V}
    empty(d::AbstractSmallDict{N,K,V}, W::Type) where {N,K,V,W} -> AbstractSmallDict{N,K,W}
    empty(d::AbstractSmallDict{N,K,V}, L::Type, W::Type) where {N,K,V,L,W} -> AbstractSmallDict{N,L,W}

Return an empty `AbstractSmallDict` with the same capacity as `d`,
and with `valtype` changed to `W` and `keytype` changed to `L` if so specified.
The resulting dictionary is mutable if and only if `d` is so.
"""
empty(::AbstractSmallDict),
empty(::AbstractSmallDict, ::Type),
empty(::AbstractSmallDict, ::Type, ::Type)

empty(d::SmallDict{N,K,V}, ::Type{W} = V) where {N,K,V,W} = SmallDict{N,K,W}()
empty(d::MutableSmallDict{N,K,V}, ::Type{W} = V) where {N,K,V,W} = MutableSmallDict{N,K,W}()
empty(d::SmallDict{N}, ::Type{L}, ::Type{W}) where {N,L,W} = SmallDict{N,L,W}()
empty(d::MutableSmallDict{N}, ::Type{L}, ::Type{W}) where {N,L,W} = MutableSmallDict{N,L,W}()

@inline function unsafe_pop(d::AbstractSmallDict, i::Int)
    @inbounds keys, key = popat(d.keys, i)
    @inbounds vals, val = popat(d.vals, i)
    SmallDict(keys, vals), key => val
end

"""
    delete(d::AbstractSmallDict{N,K,V}, key) where {N,K,V} -> SmallDict{N,K,V}

Remove the mapping for `key` from `d` (if it exists) and return the new dictionary.

See also `Base.delete!`, [`pop`](@ref pop(::AbstractSmallDict, ::Any)).
"""
function delete(d::AbstractSmallDict, key)
    i = token(d, key)
    i === nothing ? SmallDict(d) : first(unsafe_pop(d, i))
end

"""
    pop(d::AbstractSmallDict{N,K,V}) where {N,K,V} -> Tuple{SmallDict{N,K,V}, Pair{<:K,<:V}}

Remove a mapping `key => val` from `d` and return the new dictionary together with the mapping.
The dictionary `d` must not be empty.

See also `Base.pop!`.
"""
@propagate_inbounds function pop(d::AbstractSmallDict)
    keys, key = pop(d.keys)
    @inbounds vals, val = pop(d.vals)
    SmallDict(keys, vals), key => val
end

"""
    pop(d::AbstractSmallDict{N,K,V}, key) where {N,K,V} -> Tuple{SmallDict{N,K,V}, V}

Remove the mapping for `key` from `d` and return the new dictionary together with the value `d[key]`.

See also `Base.pop!`, [`delete`](@ref delete(::AbstractSmallDict, ::Any)).
"""
function pop(d::AbstractSmallDict{N,K,V}, key) where {N,K,V}
    if isbitstype(Tuple{K,V})
        e = MutableSmallDict(d)
        val = @inline pop!(e, key)
        return SmallDict(e), val
    end
    i = token(d, key)
    i === nothing && keyerror(key)
    e, kv = unsafe_pop(d, i)
    e, last(kv)
end

"""
    pop(d::AbstractSmallDict{N,K,V}, key, default::U) where {N,K,V,U} -> Tuple{SmallDict{N,K,V}, Union{V,U}}

If `d` has the key `key`, remove it and return the new dictionary together with `d[key]`.
Otherwise return the tuple `(SmallDict(d), default)`.

See also `Base.pop!`.
"""
function pop(d::AbstractSmallDict, key, default)
    i = token(d, key)
    i === nothing && return SmallDict(d), default
    e, kv = unsafe_pop(d, i)
    e, last(kv)
end

"""
    popmin(d::AbstractSmallDict) -> Tuple{SmallDict{N,K,V}, Pair{<:K,<:V}}
    popmax(d::AbstractSmallDict) -> Tuple{SmallDict{N,K,V}, Pair{<:K,<:V}}

Find a key-values pair that realizes the minimum (or maximum) among the values
of the non-empty dictionary `d`. Return the pair together with a dictionary
obtained from `d` by removing that pair.

See also [`popmin!`](@ref), `Base.findmin`, `Base.findmax`.
"""
popmin, popmax

@propagate_inbounds popmin(d::AbstractSmallDict) = unsafe_pop(d, last(findmin(d.vals)))
@propagate_inbounds popmax(d::AbstractSmallDict) = unsafe_pop(d, last(findmax(d.vals)))

function filter(f, d::AbstractSmallDict{N,K,V}) where {N,K,V}
    if isbitstype(Tuple{K,V})
        e = MutableSmallDict(d)
        @inline filter!(f, e)
        return SmallDict(e)
    end
    keys = SmallVector{N,K}()
    vals = SmallVector{N,V}()
    for (k, v) in zip(d.keys, d.vals)
        f(Pair{K,V}(k, v))::Bool || continue
        keys = @inbounds push(keys, k)
        vals = @inbounds push(vals, v)
    end
    SmallDict(keys, vals)
end

function mergewith(op, d::AbstractSmallDict{N,K,V}, e::AbstractDict) where {N,K,V}
    foldl(e; init = SmallDict(d)) do d, (key, val)
        i = token(d, key)
        newval = i === nothing ? val : op(@inbounds(d.vals[i]), val)
        setindex(d, newval, key)
    end::SmallDict{N,K,V}
end

function mergewith(op, d::AbstractSmallDict, es::AbstractDict...)
    foldl((d, e) -> mergewith(op, d, e), es; init = SmallDict(d))
end

@inline function setindex!(d::MutableSmallDict, val, key)
    i = token(d, key)
    if i === nothing
        @inline push!(d.keys, key)
        @inbounds push!(d.vals, val)
    else
        @inbounds d.vals[i] = val
    end
    d
end

push!(d::MutableSmallDict) = d
push!(d::MutableSmallDict, (key, val)::Pair) = @inline setindex!(d, val, key)
push!(d::MutableSmallDict, p::Pair, ps::Vararg{Pair,M}) where M = @inline push!(push!(d, p), ps...)

function get!(f::Base.Callable, d::MutableSmallDict{N,K,V}, key) where {N,K,V}
    i = token(d, key)
    if i === nothing
        val::V = f()   # we convert to V because get! for Dict does so
        push!(d.keys, key)
        @inbounds push!(d.vals, val)
        val
    else
        d.vals[i]
    end
end

empty!(d::MutableSmallDict) = (empty!(d.keys); empty!(d.vals); d)

@inline function unsafe_pop!(d::MutableSmallDict, i::Int)
    @inbounds key = pop!(d.keys)
    @inbounds val = pop!(d.vals)
    if i <= length(d)
        @inbounds key, _ = d.keys[i], unsafe_setindex!(d.keys, key, i)
        @inbounds val, _ = d.vals[i], unsafe_setindex!(d.vals, val, i)
    end
    key => val
end

function delete!(d::MutableSmallDict, key)
    i = token(d, key)
    i === nothing || unsafe_pop!(d, i)
    d
end

@propagate_inbounds function pop!(d::MutableSmallDict)
    key = pop!(d.keys)
    val = @inbounds pop!(d.vals)
    key => val
end

function pop!(d::MutableSmallDict, key)
    i = token(d, key)
    i === nothing && keyerror(key)
    last(unsafe_pop!(d, i))
end

function pop!(d::MutableSmallDict, key, default)
    i = token(d, key)
    i === nothing && return default
    last(unsafe_pop!(d, i))
end

"""
    popmin!(d::MutableSmallDict) -> Pair{<:K,<:V}
    popmax!(d::MutableSmallDict) -> Pair{<:K,<:V}

Find a key-values pair that realizes the minimum (or maximum) among the values
of the non-empty dictionary `d`. Return that pair and delete it from `d`.

See also [`popmin`](@ref).
"""
popmin!, popmax!

@propagate_inbounds popmin!(d::MutableSmallDict) = unsafe_pop!(d, last(findmin(d.vals)))
@propagate_inbounds popmax!(d::MutableSmallDict) = unsafe_pop!(d, last(findmax(d.vals)))

function filter!(f, d::MutableSmallDict{N,K,V}) where {N,K,V}
    j = 0
    n = length(d)
    for i in 1:n
        key, val = @inbounds d.keys[i], d.vals[i]
        f(key => val) || continue
        j += 1
        @inbounds d.keys[j], d.vals[j] = key, val
    end
    for i in j+1:n
        @inbounds d.keys[i], d.vals[i] = default(K), default(V)
    end
    d.vals.n = d.keys.n = j % SmallLength
    d
end

function mergewith!(op, d::MutableSmallDict, e::AbstractDict)
    for (key, val) in e
        i = token(d, key)
        if i === nothing
            d[key] = val
            # push!(d.keys, key)
            # @inbounds push!(d.vals, val)
        else
            @inbounds d.vals[i] = op(d.vals[i], val)
        end
    end
    d
end

function smalldict_replace!(d, count, ps::Tuple{Pair})
    (oldkey, oldval), (newkey, newval) = only(ps)
    i = token(d, oldkey)
    @inbounds if count > 0 && i !== nothing && isequal(d.vals[i], oldval)
        j = token(d, newkey)
        if j === nothing
            d.keys[i] = newkey
            d.vals[i] = newval
        else
            d.vals[j] = newval
            unsafe_pop!(d, i)
        end
    end
    d
end

function smalldict_replace!(d0, count, ps::Tuple{Vararg{Pair}})
    d1 = empty(d0)
    for ((oldkey, oldval), (newkey, newval)) in ps
        i = token(d0, oldkey)
        if count > 0 && i !== nothing && isequal(@inbounds(d0.vals[i]), oldval)
            unsafe_pop!(d0, i)
            d1[newkey] = newval
            count -= one(count)
        end
    end
    @inline merge!(d0, d1)
end

function replace!(d::MutableSmallDict, ps::Vararg{Pair{<:Pair,<:Pair},M}; count::Integer = typemax(Int)) where M
    smalldict_replace!(d, count, ps)
end

function replace(d::AbstractSmallDict, ps::Vararg{Pair{<:Pair,<:Pair},M}; count::Integer = typemax(Int)) where M
    e = MutableSmallDict(d)
    @inline smalldict_replace!(e, count, ps)
    SmallDict(e)
end

findall(d::AbstractSmallDict) = findall(identity, d)

"""
    findall(f::Function, d::AbstractSmallDict{N,K}; [style::MapStyle]) where {N,K} -> SmallVector{N,K}

With an `AbstractSmallDict` `d` as second argument, this function accepts
the keyword argument `style`. If it equals `LazyStyle()`, then the
function `f` is only evaluated on the actual values of `d`. For any
other value of `style`, `f` is evaluated on `values(d)` as well as on
the default values used for padding this `SmallVector`. This is often faster for simple functions.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions.

See also [`$(@__MODULE__).default`](@ref), [`$(@__MODULE__).MapStyle`](@ref).
"""
function findall(f::F, d::AbstractSmallDict{N,K}; kw...) where {F<:Function,N,K}
    @inline
    SmallVector{N,K}(@inbounds(d.keys[i]) for i in support(AssertBool(f), d.vals; kw...))
end

function Random.rand(rng::AbstractRNG, ::SamplerType{SmallDict{N,K,V}}) where {N,K,V}
    keys = SmallVector{N,K}()
    for _ in 1:rand(0:N)
        key = rand(K)
        if !(key in keys)
            keys = @inbounds push(keys, key)
        end
    end
    vals = smallvector_rand(rng, Val(N), V, length(keys))
    SmallDict(keys, vals)
end

function Random.rand(rng::AbstractRNG, ::SamplerType{MutableSmallDict{N,K,V}}) where {N,K,V}
    keys = MutableSmallVector{N,K}()
    for _ in 1:rand(0:N)
        key = rand(K)
        key in keys || @inbounds push!(keys, key)
    end
    vals = smallvector_rand(rng, Val(N), V, length(keys))
    MutableSmallDict(keys, vals)
end

SS = (SmallSet, MutableSmallSet)

@testset "SmallSet" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, N-1, N)
        S == SmallSet || isbitstype(T) || continue
        v = T[rand(T) for _ in 1:m]
        n = length(unique(v))
        s = @test_inferred S{N,T}(v) Set{T}(v) S{N,T}

        @test_inferred capacity(s) N
        @test_inferred length(s) n
        @test_inferred Set(collect(s)) Set(v)

        t = Tuple(v)
        @test_inferred S{N,T}(t) Set{T}(t) S{N,T}
        w = unique(v)
        @test_inferred S{N,T}(w; unique = true) Set{T}(w) S{N,T}
        t = Tuple(w)
        @test_inferred S{N,T}(t; unique = true) Set{T}(t) S{N,T}
        d = Set{T}(v)
        @test_inferred S{N,T}(d) d S{N,T}
        s = SmallSet{N,T}(v)
        @test_inferred S{N,T}(s) s S{N,T}
        if isbitstype(T)
            s = MutableSmallSet{N,T}(v)
            @test_inferred S{N,T}(s) s S{N,T}
        end

        @test_inferred S{N}(v) Set(v) S{N,T}
        t = Tuple(v)
        if !isempty(t)
            @test_inferred S{N}(t) Set(t) S{N,T}
        end
        w = unique(v)
        @test_inferred S{N}(w; unique = true) Set(w) S{N,T}
        t = Tuple(w)
        if !isempty(t)
            @test_inferred S{N}(t; unique = true) Set(t) S{N,T}
        end
        d = Set{T}(v)
        @test_inferred S{N}(d) d S{N,T}
        s = SmallSet{N}(v)
        @test_inferred S{N,T}(s) s S{N,T}
        if isbitstype(T)
            s = MutableSmallSet{N,T}(v)
            @test_inferred S{N}(s) s S{N,T}
        end
    end
end

@testset "SmallSet in" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, N÷2, N)
        S == SmallSet || isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= m && continue
        v = T[rand(T) for _ in 1:m]
        s = S{N,T}(v)
        for x in v
            @test_inferred x in s true
        end
        y = rand_notin(T, s)
        @test_inferred y in s false
    end

    s = SmallSet{4,Float32}((0.0, 1.0, NaN))
    @test_inferred 1 in s true
    @test_inferred NaN in s true
    @test_inferred -0.0 in s false
end

@testset "SmallSet empty" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, N÷2, N)
        S == SmallSet || isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= m && continue
        v = T[rand(T) for _ in 1:m]
        s = S{N,T}(v)
        @test_inferred isempty(s) iszero(m)
        @test_inferred empty(s) S{N,T}()
        @test_inferred empty(s, Char) S{N,Char}()
        ismutable(s) || continue
        t = @inferred empty!(s)
        @test t === s & isempty(t)
    end
end

@testset "SmallSet push/pop" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, N÷2, N)
        S == SmallSet || isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= m && continue
        s = S{N,T}(rand_unique(T, m))
        x = rand_notin(T, s)
        if m == N
            @test_throws Exception push(s, x)
        else
            @test_inferred push(s, x) push!(Set(s), x) SmallSet{N,T}
            y = rand(T)
            if m <= N-2
                @test_inferred push(s, x, y) push!(Set(s), x, y) SmallSet{N,T}
            end
        end

        if m == 0
            @test_throws Exception pop(s)
        else
            (t, x) = @inferred pop(s)
            @test t isa SmallSet{N,T} && x isa T && !(x in t)
            @test push(t, x) == s
            @test push(s, x) == s

            @test_inferred pop(s, x) (t, x)
            @test_inferred delete(s, x) t
            T <: Union{Bool,Enum} && continue
            y = rand_notin(T, s)
            @test_throws KeyError pop(s, y)
            @test_inferred delete(s, y) SmallSet(s)
            @test_inferred pop(s, x, y) (t, x)
            @test_inferred pop(s, y, x) (SmallSet(s), x)
        end
    end

    s = SmallSet{4}((0.0, 1.0))
    @test_inferred 1 in s true
    @test_inferred -0.0 in s false
    @test_throws KeyError pop(s, -0.0)
    @test_inferred pop(s, 1) pop(s, 1.0)
    @test_inferred delete(s, 1) delete(s, 1.0)
    @test_inferred pop(s, 1, 2.0) pop(s, 1.0, 2.0)
end

@testset "SmallSet push!/pop!" begin
    for N in (1, 2, 9, 16), T in test_types, m in (0, 1, N÷2, N)
        isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= m && continue
        s = MutableSmallSet{N,T}(rand_unique(T, m))
        x = rand_notin(T, s)
        if m == N
            @test_throws Exception push!(copy(s), x)
        else
            t = copy(s)
            u = @test_inferred push!(t, x) push!(Set(s), x) t
            @test u === t
            y = rand(T)
            if m <= N-2
                @test_inferred push!(copy(s), x, y) push!(Set(s), x, y) s
            end
        end

        if m == 0
            @test_throws Exception pop!(copy(s))
        else
            t = copy(s)
            x = @inferred pop!(t)
            @test t isa MutableSmallSet{N,T} && x isa T && !(x in t)
            @test push!(copy(t), x) == s
            @test push!(copy(s), x) == s

            @test_inferred pop!(copy(s)) x
            u = copy(s)
            w = @test_inferred delete!(u, x) t
            @test w === u
            T <: Union{Bool,Enum} && continue
            y = rand_notin(T, s)
            @test_throws KeyError pop!(copy(s), y)
            u = copy(s)
            w = @test_inferred delete!(u, y) s
            @test w === u
            u = copy(s)
            @test_inferred pop!(u, x, y) x
            @test !(x in u)
            u = copy(s)
            @test_inferred pop!(u, y, x) x
            @test u == s
        end
    end

    s = MutableSmallSet{4}((0.0, 1.0))
    @test_throws KeyError pop!(copy(s), -0.0)
    @test_inferred pop!(copy(s), 1) pop!(copy(s), 1.0)
    @test_inferred delete!(copy(s), 1) delete!(copy(s), 1.0)
    @test_inferred pop!(copy(s), 1, 2.0) pop!(copy(s), 1.0, 2.0)
end

@testset "SmallSet filter" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, N÷2, N)
        S == SmallSet || isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= m && continue
        s = S{N,T}(rand_unique(T, m))
        if T <: Integer
            @test_inferred filter(isodd, s) filter(isodd, Set(s)) SmallSet(s)
        else
            x = rand_notin(T, s)
            @test_inferred filter(!=(x), s) SmallSet(s)
            @test_inferred filter(==(x), s) empty(SmallSet(s))
        end

        S == MutableSmallSet || continue
        if T <: Integer
            t = copy(s)
            u = @test_inferred filter!(isodd, t) filter!(isodd, Set(s)) t
            @test u === t
        else
            x = rand_notin(T, s)
            @test_inferred filter!(!=(x), s) s
            t = copy(s)
            u = @test_inferred filter!(==(x), t) empty(s)
            @test u === t
        end
    end
end

@testset "SmallSet union etc" begin
    for S in SS, T in test_types
        isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= 5 && continue
        N = 8
        v, w, x, y, z = rand_unique(T, 5)
        s = S{N,T}((v, w, x, y))
        t = S{N,T}((x, y, z))
        @test_inferred union(s, t) union(Set(s), Set(t)) SmallSet{N,T}
        @test_inferred intersect(s, t) intersect(Set(s), Set(t)) SmallSet{N,T}
        @test_inferred setdiff(s, t) setdiff(Set(s), Set(t)) SmallSet{N,T}
        @test_inferred symdiff(s, t) symdiff(Set(s), Set(t)) SmallSet{N,T}
    end
end

@testset "SmallSet union! etc" begin
    N = 8
    for T in test_types, S in [SmallSet{N,T}, MutableSmallSet{N,T}, Set{T}]
        isbitstype(T) || continue
        T == TestEnum && length(instances(T)) <= 5 && continue
        v, w, x, y, z = rand_unique(T, 5)
        s = MutableSmallSet{N,T}((v, w, x, y))
        t = S((x, y, z))
        u = copy(s)
        w = @test_inferred union!(u, t) union!(Set(s), Set(t)) s
        @test w === u
        u = copy(s)
        w = @test_inferred intersect!(u, t) intersect!(Set(s), Set(t)) s
        @test w === u
        u = copy(s)
        w = @test_inferred setdiff!(u, t) setdiff!(Set(s), Set(t)) s
        @test w === u
        u = copy(s)
        w = @test_inferred symdiff!(u, t) symdiff!(Set(s), Set(t)) s
        @test w === u
    end
end

@testset "SmallSet rand" begin
    for S in SS, N in (1, 2, 9, 16), T in test_types
        S <: MutableSmallSet && !isbitstype(T) && continue
        s = @inferred rand(S{N,T})
        @test s isa S{N,T} && isvalid(s)
    end
end

module StaticArraysExt

using SmallCollections, StaticArrays

"""
    FixedVector(v::StaticVector{N,T}) where {N,T} -> FixedVector{N,T}
    MutableFixedVector(v::StaticVector{N,T}) where {N,T} -> MutableFixedVector{N,T}

Convert a `StaticVector` to a `FixedVector` or `MutableFixedVector`.
The length `N` is inferred from the given vector `v`.
For example, `v` can be an `SVector` or `MVector`.

These methods are only available if the package `StaticArrays.jl` is loaded.

See also [`AbstractFixedVector`](@ref), `StaticArrays.StaticVector`.
"""
FixedVector, MutableFixedVector

SmallCollections.FixedVector(v::StaticVector{N}) where N = FixedVector{N}(v)
SmallCollections.MutableFixedVector(v::StaticVector{N}) where N = MutableFixedVector{N}(v)

"""
    SVector(v::AbstractFixedVector{N,T}) where {N,T} -> SVector{N,T}
    MVector(v::AbstractFixedVector{N,T}) where {N,T} -> MVector{N,T}

Convert an `AbstractFixedVector` to an `SVector` or `MVector`.
The length `N` is inferred from the argument.

These methods are only available if the package `StaticArrays.jl` is loaded.

See also `StaticArrays.SVector`, `StaticArrays.MVector`,
[`AbstractFixedVector`](@ref).
"""
SVector, MVector

StaticArrays.SVector(v::AbstractFixedVector{N}) where N = SVector{N}(v)
StaticArrays.MVector(v::AbstractFixedVector{N}) where N = MVector{N}(v)

SmallCollections.hasfixedlength(::Type{<:StaticArray}) = true

end

module BangBangExt

using SmallCollections

using BangBang: BangBang, NoBang, Mutator, Extras

BangBang.implements(::Mutator, ::Type{<:Union{SmallDict, SmallSet, SmallBitSet}}) = false

for f in (:push, :pop, :delete)
    @eval NoBang.$f(c::SmallDict, x::Pair) = $f(c, x)
    @eval NoBang.$f(c::Union{SmallSet, SmallBitSet}, x) = $f(c, x)
end

NoBang.pop(c::Union{SmallDict, SmallSet, SmallBitSet}) = pop(c)

function Extras.modify!!(f, d::SmallDict, key)
    i = SmallCollections.token(d, key)
    if i === nothing
        ret = f(nothing)
        if ret !== nothing
            keys = push(d.keys, key)
            vals = @inbounds push(d.vals, something(ret))
        end
    else
        ret = f(Some(@inbounds(d.vals[i])))
        if ret !== nothing
            keys = @inbounds setindex(d.keys, key, i)
            vals = @inbounds setindex(d.vals, something(ret), i)
        end
    end
    SmallDict(keys, vals), ret
end

const CapacityVector = Union{SmallVector, PackedVector}

BangBang.implements(::Mutator, ::Type{<:Union{FixedVector,CapacityVector}}) = false

for f in (:push, :pop, :pushfirst, :popfirst, :deleteat, :append)
    @eval NoBang.$f(v::CapacityVector, args...) = $f(v, args...)
end

BangBang.NoBang._setindex(v::Union{FixedVector,CapacityVector}, args...) = Base.setindex(v, args...)
# otherwise a Vector is returned

BangBang.add!!(v::Union{FixedVector,CapacityVector}, w::AbstractVector) = v+w
# faster than without this line

end # module

using Chairmarks

macro bs(args...)
    b = esc(Expr(:macrocall, Symbol("@b"), __source__, args...))
    quote
        io = IOBuffer()
        show(io, MIME"text/plain"(), $b)
        String(take!(io))
    end
end

using Markdown: parse

using SmallCollections, StaticArrays, FixedSizeArrays, Collects
using SmallCollections: push, pop
using Base: Fix1, Fix2

newcollect(v::Vector{T}, w) where T = collect(T, w)
newcollect(v::V, w) where V <: AbstractVector = V(w)

newsum(v) = sum(v)
newsum(v::Union{AbstractFixedVector,AbstractSmallVector}) = sum_fast(v)

function benchmark_vec(::Val{N}, ::Type{T}, M) where {N,T}
    pp = [sizehint!(rand(T, rand(1:N-1)), N) for _ in 1:M]
    qq = [sizehint!(rand(T, length(pp[k])), N) for k in 1:M]
    pp2 = [rand(T, N) for _ in 1:M]
    qq2 = [rand(T, N) for k in 1:M]

    pq = [(pp, qq),
        (map(FixedSizeVectorDefault, pp2), map(FixedSizeVectorDefault, qq2)),
        (map(MutableSmallVector{N}, pp), map(MutableSmallVector{N}, qq)),
        (map(MutableFixedVector{N}, pp2), map(MutableFixedVector{N}, qq2)),
        (map(MVector{N}, pp2), map(MVector{N}, qq2)),
        (map(SmallVector{N}, pp), map(SmallVector{N}, qq)),
        (map(FixedVector{N}, pp2), map(FixedVector{N}, qq2)),
        (map(SVector{N}, pp2), map(SVector{N}, qq2)),
    ]

    a = fill("", length(pq), 11)

    for (i, (p, q)) in enumerate(pq)
        V = eltype(p)

        a[i, 1] = string('`', eltype(p), '`')

        # @bd similar(p) map!(newcollect, _, $p)
        r = map(collect, p)
        a[i, 2] = @bs similar(p) map!(newcollect, _, $p, $r)

        e = [rand(T) for _ in 1:M]
        # a[i, 3] = @bs similar(p) map!(v -> newcollect(v, T(x) for x in 1:length(v)), _, $e)
        a[i, 3] = if V <: Vector
            @bs similar(p) map!(y -> collect(k+y for k in T(1):T(N)), _, $e)
        elseif V <: FixedSizeVector
            @bs similar(p) map!(y -> collect_as(FixedSizeVectorDefault{T}, k+y for k in T(1):T(N)), _, $e)
        elseif V <: MutableSmallVector
            @bs similar(p) map!(y -> MutableSmallVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        elseif V <: SmallVector
            @bs similar(p) map!(y -> SmallVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        elseif V <: MutableFixedVector
            @bs similar(p) map!(y -> MutableFixedVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        elseif V <: FixedVector
            @bs similar(p) map!(y -> FixedVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        elseif V <: MVector
            @bs similar(p) map!(y -> MVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        elseif V <: SVector
            @bs similar(p) map!(y -> SVector{N,T}(k+y for k in T(1):T(N)), _, $e)
        end

        a[i, 4] = if false # V <: Union{AbstractFixedVector,AbstractSmallVector}
            @bs p sum(sum_fast, _)
        else
            @bs p sum(sum, _)
        end

        a[i, 5] = if V <: MutableFixedVector
            @bs similar(p, FixedVector{N,T}) map!(+, _, $p, $q)
        elseif V <: MutableSmallVector
            @bs similar(p, SmallVector{N,T}) map!(+, _, $p, $q)
        elseif V <: MVector
            @bs similar(p, SVector{N,T}) map!((x, y) -> SVector{N,T}(x+y), _, $p, $q)
        else
            @bs similar(p) map!(+, _, $p, $q)
        end

        a[i, 6] = if V <: Union{Vector,FixedSizeVector,MutableSmallVector,MVector,MutableFixedVector}
            @bs deepcopy(p) for (v, w) in zip(_, $q) v .+= w end evals = 1
        else
            "n/a"
        end

        c = map(v -> v[(length(v)+1)÷2], p)
        a[i, 7] = if V <: Union{Vector,MutableSmallVector}
            @bs deepcopy(p) for (v, x) in zip(_, $c) push!(v, x) end evals = 1
        elseif V <: SmallVector
            @bs copy(p) map!(SmallCollections.push, _, $p, $c)
        elseif V <: SVector
            @bs similar(p, SVector{N+1,T}) map!(StaticArrays.push, _, $p, $c)
        elseif V <: MVector
            @bs similar(p, MVector{N+1,T}) map!(StaticArrays.push, _, $p, $c)
        else
            "n/a"
        end

        a[i, 8] = if V <: Union{Vector,MutableSmallVector}
            @bs deepcopy(p) foreach(pop!, _) evals = 1
        elseif V <: SmallVector
            @bs similar(p) map!(first∘SmallCollections.pop, _, $p)
        elseif V <: SVector
            @bs similar(p, SVector{N-1,T}) map!(StaticArrays.pop, _, $p)
        elseif V <: MVector
            @bs similar(p, MVector{N-1,T}) map!(StaticArrays.pop, _, $p)
        else
            "n/a"
        end

        # a[i, 9] = @bs similar(p, Int) map!((v, x) -> findfirst(==(x), v)::Int, _, $p, $c)
        e = rand(T)
        # a[i, 9] = @bs similar(p, Int) map!(Fix1(count, isodd), _, $p)
        a[i, 9] = @bs similar(p, Int) map!(Fix1(count, >($e)), _, $p)

        a[i, 10] = @bs similar(p, Bool) map!(==, _, $p, $q)
        a[i, 11] = @bs similar(p, Bool) map!(==, _, $p, $(deepcopy(p)))

        # a[i, 9] = @bs similar(p, Int) map!(Fix1(newcount, isodd), _, $p)
        # d = [rand(typemax(T)-10:typemax(T)) for _ in 1:1000]
        # a[i, 9] = @bs similar(p, Bool) map!((v, x) -> all(<(x), v), _, $p, $d)
        # a[i, 11] = @bs similar(p, Bool) map!(Fix1(any, iszero), _, $p)
    end

    return a
end

function make_table_vec(a)
    b = ["| " * join(a[i, :], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | create vec | create itr | `sum` | add | add! | `push(!)` | `pop(!)` | `count` | eq min | eq max |
        | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    c = replace(c, r"FixedSizeArray{([[:alnum:]]+), \d+, Memory{[[:alnum:]]+}}" => s"FixedSizeVectorDefault{\1}")

    # c = replace(c, r"000 allocs: [^)]*" => " A")
    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
    return c
end

function make_table_vec_raw(a)
    cols = [1, 5, 6, 4, 7, 9]
    b = ["| " * join(a[i, cols], " | ") * " |" for i in axes(a, 1)]

    c = """
        | type | `v + w` | `v .+= w` |`sum(v)` | `push(!)(v, c)` | `count(>(c), v)` |
        | --- | --- | --- | --- | --- | --- |
        """

    c *= join(b, '\n') * '\n'

    c = replace(c, r"FixedSizeArray{([[:alnum:]]+), \d+, Memory{[[:alnum:]]+}}" => s"FixedSizeVectorDefault{\1}")

    # c = replace(c, r"000 allocs: [^)]*" => " A")
    c = replace(c, r"\((\d)[^)]*\)" => s"**(\1)**", r"\bns\b" => "**ns**")
    return c
end

M = 1000

for (N, T) in [(16, Int16), (32, Int16), (32, Int8), (64, Int8)]
    bs = benchmark_vec(Val(N), T, M)
    display(parse(make_table_vec(bs)))
    println()
    println(make_table_vec_raw(bs))
    println()
end

#
# small vectors
#

export AbstractSmallVector, SmallVector, fixedvector, bits, resize,
    sum_fast, dot_fast, extrema_fast,
    capacity, support, setindex, addindex, push, pop, pushfirst, popfirst,
    insert, duplicate, deleteat, popat, append, prepend, unsafe_circshift

import Base: ==, Tuple, empty, iterate,
    length, size, IndexStyle, getindex, setindex, rest, split_rest,
    zeros, ones, zero, map, reverse, in,
    +, -, *, sum, prod, maximum, minimum, extrema, replace,
    circshift

import Base.FastMath: eq_fast, mul_fast

import LinearAlgebra: dot

"""
    AbstractSmallVector{N,T} <: AbstractVector{T}

`AbstractSmallVector{N,T}` is the supertype of `SmallVector{N,T}` and `MutableSmallVector{N,T}`.

See also [`SmallVector`](@ref), [`MutableSmallVector`](@ref).
"""
abstract type AbstractSmallVector{N,T} <: AbstractVector{T} end

const SmallLength = Int16

"""
    SmallVector{N,T} <: AbstractSmallVector{N,T}

    SmallVector{N,T}()
    SmallVector{N,T}(iter)
    SmallVector{N}(iter)
    SmallVector(v::PackedVector)
    SmallVector(v::Union{AbstractSmallVector, AbstractFixedVector})

`SmallVector{N,T}` is an immutable vector type that can hold up to `N` elements of type `T`.
Here `N` can be any (small) positive integer. However, at least for bit integer
and hardware float types, one usually takes `N` to be a power of `2`.

The element type `T` can be omitted when creating the `SmallVector` from an iterator
that has an element type, for example from an `AbstractVector` or a tuple.
In the latter case, `T` is determined by promoting the element types of the tuple.
If no argument is given, then an empty vector is returned.
If the `SmallVector` is created from an `AbstractSmallVector`, `AbstractFixedVector` or `PackedVector` `v`
and the parameter `N` is omitted, then it is set to capacity of `v`.

The unused elements of a `SmallVector{N,T}` are filled with the value `default(T)`, which is
predefined for many types including `Number` and all bits types. Default values for other types
must be defined explicitly.

Addition and subtraction of two `SmallVector`s is possible even if the vectors have different
capacity. (Of course, their lengths must agree.) The capacity of the result is the smaller
of the arguments' capacities in this case.

See also [`MutableSmallVector`](@ref), [`capacity`](@ref capacity(::Type{<:AbstractSmallVector})), [`$(@__MODULE__).default`](@ref),
`Base.IteratorEltype`, `promote_type`.

# Examples
```jldoctest
julia> v = SmallVector{8,Int8}(2*x for x in 1:3)
3-element SmallVector{8, Int8}:
 2
 4
 6

julia> w = SmallVector{9}((1, 2.5, 4))
3-element SmallVector{9, Float64}:
 1.0
 2.5
 4.0

julia> v+w
3-element SmallVector{8, Float64}:
  3.0
  6.5
 10.0

julia> struct A x::Int; y::Char end

julia> SmallVector{4,A}(A(k, '@'+k) for k in 1:3)
3-element SmallVector{4, A}:
 A(1, 'A')
 A(2, 'B')
 A(3, 'C')
```
"""
struct SmallVector{N,T} <: AbstractSmallVector{N,T}
    b::FixedVector{N,T}
    n::SmallLength
end

SmallVector(v::AbstractFixedVector, n::Integer) = SmallVector(fixedvector(v), n % SmallLength)

const AbstractFixedOrSmallVector{N,T} = Union{AbstractFixedVector{N,T}, AbstractSmallVector{N,T}}

"""
    fixedvector(v::AbstractSmallVector{N,T}) where {N,T} -> FixedVector{N,T}

Return the `FixedVector` underlying `v`. It agrees with `v` at all positions up to `length(v)`;
the remaining elements are equal to `default(T)`.

See also [`$(@__MODULE__).default`](@ref), [`fixedvector(::AbstractFixedVector)`](@ref).

# Example
```jldoctest
julia> v = SmallVector{4}(1:2)
2-element SmallVector{4, $Int}:
 1
 2

julia> fixedvector(v)
4-element FixedVector{4, $Int}:
 1
 2
 0
 0
```
"""
fixedvector(v::AbstractSmallVector) = v.b

"""
    fixedvector(v::AbstractSmallVector{N,T}, ::Val{M}) where {N,T,M} -> FixedVector{M,T}

Return the `FixedVector` underlying `v`, resized to capacity `M`.
It agrees with `v` at all positions up to `min(length(v), M)`;
the remaining elements are equal to `default(T)`.

The purpose of this function is to make is easier to write code
that works for both `AbstractFixedVector` and `AbstractSmallVector`.

See also [`$(@__MODULE__).default`](@ref), [`fixedvector(::AbstractSmallVector)`](@ref),
[`fixedvector(::AbstractFixedVector, ::Val)`](@ref).
"""
fixedvector(::AbstractSmallVector, ::Val)

"""
    bits(v::AbstractSmallVector) -> Unsigned

Return the bit representation of `fixedvector(v)`.

See also [`fixedvector`](@ref fixedvector(::AbstractSmallVector)), [`bits(::AbstractFixedVector)`](@ref).

# Example
```jldoctest
julia> SmallVector{4,Int8}(1:3) |> bits
0x00030201
```
"""
bits(v::AbstractSmallVector) = bits(fixedvector(v))

for cmp in (:(==), :(eq_fast))
    @eval $cmp(v::AbstractSmallVector, w::AbstractSmallVector) =
        length(v) == length(w) && all(map($cmp, v.b, w.b))
end

"""
    fasthash(v::AbstractSmallVector [, h0::UInt]) -> UInt

Return a hash for `v` that may be computed faster than the standard `hash`
for vectors. This new hash is consistent across all `AbstractSmallVector`s
of the same element type, but it may not be compatible with `hash` or
with `fasthash` for a `AbstractSmallVector` having a different element type.

Currently, `fasthash` differs from `hash` only if the element type of `v`
is a bit integer type with at most 32 bits, `Bool` or `Char`.

See also `Base.hash`.

# Examples
```jldoctest
julia> v = SmallVector{8,Int8}([1, 5, 6]);

julia> fasthash(v)
0x6466067ab41d0916

julia> fasthash(v) == hash(v)
false

julia> w = SmallVector{16,Int8}(v); fasthash(v) == fasthash(w)
true

julia> w = SmallVector{8,Int16}(v); fasthash(v) == fasthash(w)
false
```
"""
fasthash(::AbstractSmallVector, ::UInt)

function fasthash(v::AbstractSmallVector{N,T}, h0::UInt) where {N,T}
    if (T <: BitInteger && bitsize(T) <= 32) || T == Bool || T == Char
        fasthash(v.b, hash(length(v), h0))
    else
        hash(v, h0)
    end
end

convert(::Type{V}, v::V) where V <: AbstractSmallVector = v
convert(::Type{V}, v::Union{AbstractVector,Tuple}) where V <: AbstractSmallVector = V(v)

Tuple(v::AbstractSmallVector) = ntuple(i -> v[i], length(v))
# this seems to be fast for length(v) <= 10

size(v::AbstractSmallVector{N}) where N = (llvm_range(v.n % Int, Val(0:N)),)

"""
    capacity(::Type{<:AbstractSmallVector{N}}) where N -> N
    capacity(v::AbstractSmallVector{N}) where N -> N

Return the largest number of elements this vector type can hold.
"""
capacity(::Type{<:AbstractSmallVector}),
capacity(::AbstractSmallVector)

@inline function iterate(v::AbstractSmallVector, i = 1)
    i <= length(v) ? (@inbounds v[i], i+1) : nothing
end

rest(v::AbstractSmallVector, i = 1) = @inbounds v[i:end]

if VERSION >= v"1.9"
    @inline function split_rest(v::AbstractSmallVector, n::Int, i = 1)
        m = length(v)-n
        @boundscheck (n >= 0 && m >= i-1) || error("impossible number of elements requested")
        @inbounds v[i:m], v[m+1:end]
    end
end

IndexStyle(::Type{<:AbstractSmallVector}) = IndexLinear()

@inline function getindex(v::AbstractSmallVector, i::Int)
    @boundscheck checkbounds(v, i)
    @inbounds v.b[i]
end

"""
    setindex(v::AbstractSmallVector{N,T}, x, i::Integer) where {N,T} -> SmallVector{N,T}

Substitute `x` for the `i`-th component of `v` and return the new vector.

See also `Base.setindex`, [`addindex`](@ref addindex(::AbstractSmallVector, ::Any, ::Integer)).
"""
@inline function setindex(v::AbstractSmallVector, x, i::Integer)
    @boundscheck checkbounds(v, i)
    SmallVector((@inbounds setindex(v.b, x, i)), length(v))
end

"""
    addindex(v::AbstractSmallVector{N,T}, x, i::Integer) where {N,T} -> SmallVector{N,T}

Add `x` to the `i`-th component of `v` and return the new vector.

See also [`setindex`](@ref setindex(::AbstractSmallVector, ::Any, ::Integer)).
"""
@inline function addindex(v::AbstractSmallVector, x, i::Integer)
    @boundscheck checkbounds(v, i)
    @inbounds v + setindex(zero(v), x, i)
end

"""
    empty(v::V) where V <: AbstractSmallVector -> V
    empty(v::AbstractSmallVector{N}, T::Type) where {N,T} -> AbstractSmallVector{N,T}

In the first form, return an empty `AbstractSmallVector` of the same type as `v`.
In the second form, the capacity is the same as for `v`,
but the element type is `T`.
"""
empty(::AbstractSmallVector),
empty(::AbstractSmallVector, ::Type)

empty(v::SmallVector{N,T}, ::Type{U} = T) where {N,T,U} = SmallVector{N,U}()

"""
    resize(v::AbstractSmallVector{N,T}, n::Integer) -> SmallVector{N,T}

Return a vector of length `n` by making `v` longer or shorter. If the new vector
is longer, then the new elements are initialized with `default(T)`.

See also `Base.resize!`, [`$(@__MODULE__).default`](@ref).
"""
@inline function resize(v::AbstractSmallVector{N}, n::Integer) where N
    @boundscheck 0 <= n <= N || error(LazyString("length must be between 0 and ", N))
    SmallVector(padtail(v.b, n), n)
end

default(::Type{V}) where V <: AbstractSmallVector = V()

@inline zero(v::V) where V <: AbstractSmallVector = V(zero(v.b), length(v))

"""
    zeros(::Type{V}, n::Integer) where V <: AbstractSmallVector -> V

Return an `AbstractSmallVector` of type `V` containing `n` zeros.

See also [`ones`](@ref ones(::Type{<:AbstractSmallVector}, ::Integer)).
"""
zeros(::Type{<:AbstractSmallVector}, ::Integer)

@inline function zeros(::Type{V}, n::Integer) where {N, T, V <: AbstractSmallVector{N,T}}
    @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    V(zero(FixedVector{N,T}), n)
end

"""
    ones(::Type{V}, n::Integer) where V <: AbstractSmallVector -> V

Return an `AbstractSmallVector` of type `V` containing `n` ones.

See also [`zeros`](@ref zeros(::Type{<:AbstractSmallVector}, ::Integer)).
"""
ones(::Type{<:AbstractSmallVector}, ::Integer)

function ones(::Type{V}, n::Integer) where {N, T, V <: AbstractSmallVector{N,T}}
    n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    t = ntuple(Val(N)) do i
        i <= n ? oneunit(T) : zero(T)
    end
    V(FixedVector{N,T}(t), n)
end

(::Type{V})() where {N,T,V<:AbstractSmallVector{N,T}} = V(default(FixedVector{N,T}), 0)

@inline function SmallVector{N,T}(v::AbstractFixedOrSmallVector{M}) where {N,T,M}
    @boundscheck M <= N || length(v) <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    w = fixedvector(v)
    t = ntuple(Val(N)) do i
        i <= M ? convert(T, w[i]) : default(T)
    end
    SmallVector{N,T}(t, length(v))
end

@inline function SmallVector{N,T}(r::OrdinalRange) where {N, T <: Integer}
    T <: HWType || return invoke(SmallVector{N,T}, Tuple{Any}, r)
    n = unsafe_length(r)
    @boundscheck n == 0 || begin
        T(first(r)), T(last(r))  # check if we can convert
        n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    end
    v = fixedvector_range(Val(N), first(r) % T, step(r) % T)
    SmallVector(padtail(v, n), n % SmallLength)
end

@propagate_inbounds function SmallVector{N,T}(s::SmallBitSet{U}) where {N, T <: Integer, U <: Unsigned}
    (T <: HWType && N <= typemax(T) && bitsize(U) <= N) || return invoke(SmallVector{N,T}, Tuple{Any}, s)
    v = FixedVector{N,T}(1:N)
    @inbounds v[s]
end

@propagate_inbounds function SmallVector{N,T}(iter) where {N,T}
    isbitstype(T) && return @inline SmallVector(MutableSmallVector{N,T}(iter))
    b = default(FixedVector{N,T})
    n = 0
    for (i, x) in enumerate(iter)
        (n = i) <= N || error(LazyString("vector cannot have more than ", N, " elements"))
        b = @inbounds setindex(b, x, i)
    end
    SmallVector{N,T}(b, n)
end

@propagate_inbounds function (::Type{V})(iter::I) where {N,V<:AbstractSmallVector{N},I}
    Base.IteratorEltype(I) isa Base.HasEltype || error("cannot determine element type")
    T = element_type(I)
    V{T}(iter)
end

@propagate_inbounds function (::Type{V})(v::AbstractFixedOrSmallVector{M,T}) where {N, V <: AbstractSmallVector{N}, M, T}
    V{T}(v)
end

function (::Type{V})(v::AbstractFixedOrSmallVector{N}) where {V <: AbstractSmallVector, N}
    V{N}(v)
end

using Base: broadcasted
using Base.Broadcast: materialize

@propagate_inbounds +(vs::Vararg{AbstractSmallVector,N}) where N = materialize(broadcasted(+, vs...))
@propagate_inbounds -(vs::Vararg{AbstractSmallVector,N}) where N = materialize(broadcasted(-, vs...))

@inline mul_fast(c::Number, v::AbstractSmallVector) = mul_fast.(c, v)
@inline mul_fast(v::AbstractSmallVector, c::Number) = mul_fast.(v, c)

*(c::Number, v::AbstractSmallVector) = c .* v
*(v::AbstractSmallVector, c::Number) = v .* c

function sum(v::AbstractSmallVector{N,T}) where {N,T}
    if T <: Base.BitSignedSmall
        sum(Int, v.b)
    elseif T <: Base.BitUnsignedSmall
        sum(UInt, v.b)
    elseif T <: Base.BitInteger
        sum(v.b)
    else
        n = length(v)
        n == 0 && return zero(T)
        @inbounds s = v[1]
        for i in 2:n
            @inbounds s += v[i]
        end
        s
    end
end

"""
    sum_fast(v::AbstractSmallVector{N,T}; [init]) where {N,T}

Return the `@fastmath` sum of the elements of `v`.
Unlike for `sum`, the default return value always has the element type of `v`, even
for small bit integers. This can be changed by supplying an `init` keyword argument.

See also `Base.sum`, `Base.@fastmath`.

# Example
```jldoctest
julia> v = SmallVector{4}([-0.0, -0.0])
2-element SmallVector{4, Float64}:
 -0.0
 -0.0

julia> sum(v), sum_fast(v)
(-0.0, 0.0)

julia> v = SmallVector{4}(Int8[80, 90])
2-element SmallVector{4, Int8}:
 80
 90

julia> sum(v), sum_fast(v)
(170, -86)

julia> sum_fast(v; init = Int16(0))
170
```
"""
sum_fast(v::AbstractSmallVector; kw...) = @fastmath foldl(+, v.b; kw...)

@propagate_inbounds function dot(v::AbstractSmallVector, w::AbstractSmallVector)
    u = dot.(v, w)
    T = eltype(u)
    foldl(+, isfasttype(T) ? u.b : u; init = zero(T))
end

"""
    dot_fast(v::AbstractSmallVector, w::AbstractSmallVector)

Return the `@fastmath` dot product of `v` and `w`
by recursively applying `dot_fast` to pairs of elements from `v` and `w`.
For elements not supporting `dot_fast` this is the same as applying `dot`.

See also `LinearAlgebra.dot`.
"""
@propagate_inbounds function dot_fast(v::AbstractSmallVector, w::AbstractSmallVector)
    sum_fast(dot_fast.(v, w))
end

function prod(v::AbstractSmallVector{N,T}) where {N,T}
    if T <: Base.BitInteger
        b = padtail(v.b, length(v), one(T))
        if T <: Base.BitSignedSmall
            prod(Int, b)
        elseif T <: Base.BitUnsignedSmall
            prod(UInt, b)
        else
            prod(b)
        end
    else
        n = length(v)
        n == 0 && return one(T)
        @inbounds s = v[1]
        for i in 2:n
            @inbounds s *= v[i]
        end
        s
    end
end

function maximum(v::AbstractSmallVector{N,T}; init = missing) where {N,T}
    if isempty(v)
        if init === missing
            error("collection must be non-empty unless `init` is given")
        else
            return init
        end
    elseif T <: Unsigned && T <: Base.HWReal
        maximum(v.b)
    elseif T <: Integer && T <: Base.HWReal
        @inbounds maximum(padtail(v.b, length(v), typemin(T)))
    else
        invoke(maximum, Tuple{AbstractVector}, v)
    end
end

@fastmath function maximum(v::AbstractSmallVector{N,T}; init = missing) where {N,T}
    if isempty(v)
        if init === missing
            error("collection must be non-empty unless `init` is given")
        else
            return init
        end
    elseif T <: Unsigned && T <: Base.HWReal
        maximum(v.b)
    elseif T <: Base.HWReal
        @inbounds maximum(padtail(v.b, length(v), typemin(T)))
    else
        invoke(maximum, Tuple{AbstractVector}, v)
    end
end

function minimum(v::AbstractSmallVector{N,T}; init = missing) where {N,T}
    if isempty(v)
        if init === missing
            error("collection must be non-empty unless `init` is given")
        else
            return init
        end
    elseif T <: Integer && T <: Base.HWReal
        @inbounds minimum(padtail(v.b, length(v), typemax(T)))
    else
        invoke(minimum, Tuple{AbstractVector}, v)
    end
end

@fastmath function minimum(v::AbstractSmallVector{N,T}; init = missing) where {N,T}
    if isempty(v)
        if init === missing
            error("collection must be non-empty unless `init` is given")
        else
            return init
        end
    elseif T <: Base.HWReal
        @inbounds minimum(padtail(v.b, length(v), typemax(T)))
    else
        invoke(minimum, Tuple{AbstractVector}, v)
    end
end

extrema(v::AbstractSmallVector; init::Tuple{Any,Any} = (missing, missing)) =
    (minimum(v; init = init[1]), maximum(v; init = init[2]))

"""
    extrema_fast(v::AbstractSmallVector; [init])

Return the `@fastmath` minimum and maximum of the elements of `v`.
The `init` keyword argument may not be used.

See also `Base.extrema`, `Base.@fastmath`.
"""
extrema_fast(v::AbstractSmallVector; init::Tuple{Any,Any} = (missing, missing)) =
    @fastmath (minimum(v; init = init[1]), maximum(v; init = init[2]))

@inline function reverse(v::AbstractSmallVector, start::Integer, stop::Integer)
    @boundscheck 0 < start <= stop+1 <= length(v)+1 || Base.throw_boundserror(v, start:stop)
    @inbounds b = reverse(v.b, start, stop)
    SmallVector(b, length(v))
end

@inline function reverse(v::AbstractSmallVector{N,T}, start::Integer = 1) where {N,T}
    @boundscheck 0 < start <= length(v)+1 || Base.throw_boundserror(v, start)
    if hasshuffle(v, Val(false))
        U = uinttype(T)
        k = start % U
        l = (length(v) % U) + k
        u = FixedVector{N,U}(1:N)
        p = ifelse.(u .< k, u, l .- u) .- U(1)
        SmallVector(shuffle(fixedvector(v), p, Val(false)), length(v))
    else
        reverse(v, start, length(v))
    end
end

for g in (:sum, :prod, :minimum, :maximum, :extrema)
    @eval $g(f::F, v::AbstractSmallVector; kw...) where F = $g(map(f, v);  kw...)
end

"""
    any(f::Function, v::AbstractSmallVector; dims = :, [style::MapStyle])
    all(f::Function, v::AbstractSmallVector; dims = :, [style::MapStyle])
    allequal(f, v::AbstractSmallVector; [style::MapStyle})
    allunique(f, v::AbstractSmallVector; [style::MapStyle])
    findall(f::Function, v::AbstractSmallVector; [style::MapStyle])
    findfirst(f::Function, v::AbstractSmallVector; [style::MapStyle])
    findlast(f::Function, v::AbstractSmallVector; [style::MapStyle])
    findnext(f::Function, v::AbstractSmallVector, k::Integer; [style::MapStyle])
    findprev(f::Function, v::AbstractSmallVector, k::Integer; [style::MapStyle])
    count(f, v::AbstractSmallVector; dims = :, init = 0, [style::MapStyle])
    filter(f, v::AbstractSmallVector; [style::MapStyle])
    filter!(f, v::MutableSmallVector; [style::MapStyle])

With an `AbstractSmallVector` `v` as second argument, these functions accept
the additional keyword argument `style`. If it equals `LazyStyle()`, then the
function `f` is only evaluated until the result has been determined. For any
other value of `style`, `f` is evaluated on all elements of `v` as well as on
the default values used for padding. This is often faster for simple functions.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions.

See also [`$(@__MODULE__).default`](@ref), [`$(@__MODULE__).MapStyle`](@ref).
"""
any(::Function, ::AbstractSmallVector),
all(::Function, ::AbstractSmallVector),
allequal(::Any, ::AbstractSmallVector),
allunique(::Any, ::AbstractSmallVector),
findall(::Function, ::AbstractSmallVector),
findfirst(::Function, ::AbstractSmallVector),
findlast(::Function, ::AbstractSmallVector),
findnext(::Function, ::AbstractSmallVector, ::Integer),
findprev(::Function, ::AbstractSmallVector, ::Integer),
count(::Any, ::AbstractSmallVector)

Base.hasfastin(::Type{V}) where V <: AbstractSmallVector = Base.hasfastin(fieldtype(V, :b))

if VERSION < v"1.14-"
    in(x, v::AbstractSmallVector) = findfirst(==(x), v) !== nothing
end

function replace(v::AbstractSmallVector{N,T}, ps::Vararg{Pair,M}; kw...) where {N,T,M}
    if ishwtype(T) && isempty(kw)
        b = replace(v.b, ps...)
        if default(T) in map(first, ps)
            b = padtail(b, length(v))
        end
        SmallVector(b, v.n)
    else
        SmallVector(invoke(replace, Tuple{AbstractVector,Vararg{Pair,M}}, v, ps...; kw...))
    end
end

"""
    push(v::AbstractSmallVector{N,T}, xs...) where {N,T} -> SmallVector{N,T}

Return the `SmallVector` obtained from `v` by appending the arguments `xs`.

See also `Base.push!`, `BangBang.push!!`.
"""
@propagate_inbounds push(v::AbstractSmallVector, xs...) = append(v, xs)

@propagate_inbounds function push(v::AbstractSmallVector{N,T}, x) where {N,T}
    n = length(v)
    @boundscheck n < N || error(LazyString("vector cannot have more than ", N, " elements"))
    @inbounds SmallVector(setindex(v.b, x, n+1), n+1)
end

"""
    pop(v::AbstractSmallVector{N,T}) where {N,T} -> Tuple{SmallVector{N,T}, T}

Return the tuple `(w, x)` where `x` is the last element of `v`
and `w` obtained from `v` by dropping this element.
The vector `v` must not be empty.

See also `Base.pop!`, `BangBang.pop!!`.
"""
pop(::AbstractSmallVector)

@inline function pop(v::AbstractSmallVector{N,T}) where {N,T}
    n = length(v)
    @boundscheck iszero(n) && error("vector must not be empty")
    @inbounds SmallVector(setindex(v.b, default(T), n), n-1), v[n]
end

"""
    pushfirst(v::AbstractSmallVector{N,T}, xs...) where {N,T} -> SmallVector{N,T}

Return the `SmallVector` obtained from `v` by prepending the arguments `xs`.

See also `Base.pushfirst!`, `BangBang.pushfirst!!`.
"""
@inline function pushfirst(v::AbstractSmallVector{N}, xs...) where N
    n = length(xs)+length(v)
    @boundscheck n <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    SmallVector(pushfirst(v.b, xs...), n)
end

"""
    popfirst(v::AbstractSmallVector{N,T}) where {N,T} -> Tuple{SmallVector{N,T}, T}

Return the tuple `(w, x)` where `x` is the first element of `v`
and `w` obtained from `v` by dropping this element.
The vector `v` must not be empty.

See also `Base.popfirst!`, `BangBang.popfirst!!`.
"""
@inline function popfirst(v::AbstractSmallVector)
    n = length(v)
    @boundscheck iszero(n) && error("vector must not be empty")
    c, x = popfirst(v.b)
    SmallVector(c, n-1), x
end

"""
    insert(v::AbstractSmallVector{N,T}, i::Integer, x) where {N,T} -> SmallVector{N,T}

Return the `SmallVector` obtained from `v` by inserting `x` at position `i`.
The position `i` must be between `1` and `length(v)+1`.

This is the non-mutating analog of `Base.insert!`.

See also [`duplicate`](@ref duplicate(::AbstractSmallVector, ::Integer)).
"""
@inline function insert(v::AbstractSmallVector{N}, i::Integer, x) where N
    n = length(v)
    @boundscheck begin
        1 <= i <= n+1 || boundserror(v, i)
        n < N || error(LazyString("vector cannot have more than ", N, " elements"))
    end
    @inbounds SmallVector(insert(v.b, i, x), n+1)
end

"""
    duplicate(v::AbstractSmallVector{N,T}, i::Integer) where {N,T} -> SmallVector{N,T}

Duplicate the `i`-th entry of `v` by inserting it at position `i+1` and return the new vector.

See also [`insert`](@ref insert(::AbstractSmallVector, ::Integer, ::Any)).

# Example
```jldoctest
julia> v = SmallVector{8,Int8}(1:3)
3-element SmallVector{8, Int8}:
 1
 2
 3

julia> duplicate(v, 2)
4-element SmallVector{8, Int8}:
 1
 2
 2
 3
```
"""
@inline function duplicate(v::AbstractSmallVector{N,T}, i::Integer) where {N,T}
    @boundscheck begin
        checkbounds(v, i)
        length(v) < N || error(LazyString("vector cannot have more than ", N, " elements"))
    end
    @inbounds SmallVector(duplicate(v.b, i), length(v)+1)
end

"""
    deleteat(v::AbstractSmallVector{N,T}, i::Integer) where {N,T} -> SmallVector{N,T}

Return the `SmallVector` obtained from `v` by deleting the element at position `i`.
The latter must be between `1` and `length(v)`.

See also `Base.deleteat!`, `BangBang.deleteat!!`.
"""
@propagate_inbounds deleteat(v::AbstractSmallVector, i::Integer) = first(popat(v, i))

"""
    popat(v::AbstractSmallVector{N,T}, i::Integer) where {N,T} -> Tuple{SmallVector{N,T}, T}

Return the tuple `(w, x)` where `w` obtained from `v` by deleting the element `x`
at position `i`. The latter must be between `1` and `length(v)`.

See also `Base.popat!`, `BangBang.popat!!`.
"""
@inline function popat(v::AbstractSmallVector, i::Integer)
    n = length(v)
    @boundscheck checkbounds(v, i)
    c, x = @inbounds popat(v.b, i)
    SmallVector(c, n-1), x
end

"""
    append(v::AbstractSmallVector{N,T}, ws...) where {N,T} -> SmallVector{N,T}

Append all elements of the collections `ws` to `v` and return the new vector.
Note that the resulting `SmallVector` has the same capacity as `v`.

See also `Base.append!`, `BangBang.append!!`.
"""
@propagate_inbounds append(v::AbstractSmallVector, ws...) = foldl(append, ws; init = SmallVector(v))

@propagate_inbounds append(v::AbstractSmallVector, w) = foldl(push, w; init = SmallVector(v))

@inline function append(v::AbstractSmallVector{N,T}, w::Union{AbstractVector,Tuple}) where {N,T}
    if isbitstype(T) && N >= 8
        u = MutableSmallVector(v)
        append!(u, w)
        return SmallVector(u)
    end
    n = length(v)
    m = n+length(w)
    @boundscheck m <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    t = ntuple(Val(N)) do i
        @inbounds n < i <= m ? convert(T, w[i-n]) : v.b[i]
    end
    SmallVector{N,T}(FixedVector{N,T}(t), m)
end

"""
    prepend(v::AbstractSmallVector{N,T}, ws...) where {N,T} -> SmallVector{N,T}

Prepend all elements of the collections `ws` to `v` and return the new vector.
Note that the resulting `SmallVector` has the same capacity as `v`.

See also `Base.prepend!`.
"""
@propagate_inbounds function prepend(v::AbstractSmallVector, ws...)
    foldr((w, v) -> prepend(v, w), ws; init = SmallVector(v))
end

@inline function prepend(v::AbstractSmallVector{N,T}, w::Union{AbstractVector,Tuple}) where {N,T}
    n = length(v)
    m = n+length(w)
    @boundscheck m <= N || error(LazyString("vector cannot have more than ", N, " elements"))
    SmallVector{N,T}(prepend(v.b, w), m)
end

prepend(v::AbstractSmallVector{N,T}, w) where {N,T} = append(SmallVector{N,T}(w), v)

function unsafe_circshift(v::AbstractSmallVector{N,T}, k::Integer) where {N,T}
    if hasshuffle(v, Val(true))
        U = uinttype(T)
        u = FixedVector{N,U}(0:N-1)
        l = k >= 0 ? k % U : (k+length(v)) % U
        u1 = u .- l
        u2 = u1 .+ length(v) % U
        p = ifelse.(u .< l, u2, u1)
        w = shuffle(fixedvector(v), p, Val(true))
        SmallVector(padtail(w, length(v)), length(v))
    elseif N <= 16 || !isbitstype(T)
        n2 = length(v)
        k2 = ifelse(signbit(k), (k % SmallLength) + v.n, k % SmallLength)
        t = ntuple(Val(N % SmallLength)) do i
            @inbounds if i <= k2
                v[(i-k2)+n2]
            elseif i <= n2 % SmallLength
                v[i-k2]
            else
                default(T)
            end
        end
        SmallVector{N,T}(t, n2)
    else
        n3 = length(v)
        k3 = ifelse(signbit(k), k+n3, k) % Int
        u = MutableSmallVector(v)
        w = similar(v)
        unsafe_copyto!(pointer(w, k3+1), pointer(u, 1), n3-k3)
        unsafe_copyto!(pointer(w, 1), pointer(u, n3-k3+1), k3)
        SmallVector(w)
    end
end

function circshift(v::AbstractSmallVector{N,T}, k::Integer) where {N,T}
    if isempty(v)
        SmallVector(v)
    else
        unsafe_circshift(v, unsafe_rem(k, unsigned(v.n)))
    end
end

# checked arithmetic

"""
    Base.Checked.checked_neg(v::AbstractSmallVector{N,T}) where {N,T} -> SmallVector{N,T}

Returns `-v`, but throws an `OverflowError` if an overflow occurs.
The elements of `v` must be integers.

See also [`Base.Checked.checked_sub`](@ref Base.Checked.checked_sub(::AbstractSmallVector, ::AbstractSmallVector)).
"""
Base.Checked.checked_neg(::AbstractSmallVector)

function Base.Checked.checked_neg(v::AbstractSmallVector{N,T}) where {N, T <: Integer}
    b = Base.Checked.checked_neg(v.b)
    SmallVector(b, length(v))
end

for op_with_name in ((:+, "add"), (:-, "sub"))
    global op, op_name = op_with_name
    global op_with_overflow = Symbol(op_name, "_with_overflow")
    global checked_op = Symbol("checked_", op_name)

    @eval begin
        example_ans = if op == :+
            (Int8[-128, 4, 4, -128], SmallBitSet{UInt8}([4]))
        else
            (Int8[-128, -2, 0, 126], SmallBitSet{UInt8}([1]))
        end

        """
            Base.Checked.$op_with_overflow(v::AbstractSmallVector{N,T}, w::AbstractSmallVector{N,T}) where {N,T} -> Tuple{SmallVector{N,T}, SmallBitSet}

        Returns `v$(op)w` as the first component of the resulting tuple.
        The second component is a `SmallBitSet` whose elements are the indices where an overflow occurred.
        The element type `T` must be a bit integer type.

        See also [`Base.Checked.$checked_op`](@ref Base.Checked.$checked_op(::AbstractSmallVector, ::AbstractSmallVector)).

        # Example
        ```jldoctest
        julia> v = SmallVector{8,Int8}((0, 1, 2, 127));

        julia> w = SmallVector{8,Int8}((-128, 3, 2, 1));

        julia> Base.Checked.$op_with_overflow(v, w)
        $example_ans
        ```
        """
        Base.Checked.$op_with_overflow(::AbstractSmallVector, ::AbstractSmallVector)

        @inline function Base.Checked.$op_with_overflow(v::AbstractSmallVector{N,T}, w::AbstractSmallVector{N,T}) where {N, T <: AbstractBitInteger}
            @boundscheck length(v) == length(w) || dimensionmismatch("vectors must have the same length")
            b, s = Base.Checked.$op_with_overflow(v.b, w.b)
            SmallVector(b, length(v)), s
        end

    end
end

"""
    Base.Checked.checked_add(v::AbstractSmallVector, ws::AbstractSmallVector...) -> SmallVector

Returns the sum of the argument vectors, but throws an `OverflowError` if an overflow occurs.
All arguments must have integer elements.

See also [`Base.Checked.add_with_overflow`](@ref Base.Checked.add_with_overflow(::AbstractSmallVector, ::AbstractSmallVector)).
"""
Base.Checked.checked_add(::AbstractSmallVector, ::AbstractSmallVector...)

@inline function Base.Checked.checked_add(v::AbstractSmallVector{<:Any, <:Integer}, ws::Vararg{AbstractSmallVector{<:Any, <:Integer}, M}) where M
    vs = (v, ws...)
    @static if VERSION < v"1.11"
        @boundscheck allequal(map(length, vs)) || dimensionmismatch("vectors must have the same length")
    else
        @boundscheck allequal(length, vs) || dimensionmismatch("vectors must have the same length")
    end
    N = minimum(capacity, vs)
    vvs = map(Fix2(fixedvector, Val(N)), vs)
    b = Base.Checked.checked_add(vvs...)
    SmallVector(b, length(v))
end

"""
    Base.Checked.checked_sub(v::AbstractSmallVector, w::AbstractSmallVector) -> SmallVector

Returns `v-w`, but throws an `OverflowError` if an overflow occurs.
The elements of `v` and `w` must be integers.

See also [`Base.Checked.sub_with_overflow`](@ref Base.Checked.sub_with_overflow(::AbstractSmallVector, ::AbstractSmallVector)).
"""
Base.Checked.checked_sub(::AbstractSmallVector, ::AbstractSmallVector)

@inline function Base.Checked.checked_sub(v::AbstractSmallVector{N1,T1}, w::AbstractSmallVector{N2,T2}) where {N1, T1 <: Integer, N2, T2 <: Integer}
    @boundscheck length(v) == length(w) || dimensionmismatch("vectors must have the same length")
    N = min(N1, N2)
    vv = fixedvector(v, Val(N))
    ww = fixedvector(w, Val(N))
    b = Base.Checked.checked_sub(vv, ww)
    SmallVector(b, length(v))
end

"""
    Base.Checked.mul_with_overflow(c::T, v::AbstractSmallVector{N,T}) where {N,T} -> Tuple{SmallVector{N,T}, SmallBitSet}
    Base.Checked.mul_with_overflow(v::AbstractSmallVector{N,T}, c::T) where {N,T} -> Tuple{SmallVector{N,T}, SmallBitSet}

Returns `c*v` as the first component of the resulting tuple.
The second component is a `SmallBitSet` whose elements are the indices where an overflow occurred.
The element type `T` must be a bit integer type.

See also [`Base.Checked.checked_mul`](@ref Base.Checked.checked_mul(::Integer, ::AbstractSmallVector)).

# Example
```jldoctest
julia> v = SmallVector{8,Int8}((0, 1, 2, 127));

julia> Base.Checked.mul_with_overflow(Int8(2), v)
(Int8[0, 2, 4, -2], SmallBitSet{UInt8}([4]))
```
"""
Base.Checked.mul_with_overflow(::Integer, ::AbstractSmallVector),
Base.Checked.mul_with_overflow(::AbstractSmallVector, ::Integer)

function Base.Checked.mul_with_overflow(c::T, v::AbstractSmallVector{N,T}) where {N, T <: AbstractBitInteger}
    b, s = Base.Checked.mul_with_overflow(c, v.b)
    SmallVector(b, length(v)), s
end

Base.Checked.mul_with_overflow(v::AbstractSmallVector{N,T}, c::T) where {N, T <: AbstractBitInteger} = Base.Checked.mul_with_overflow(c, v)

"""
    Base.Checked.checked_mul(c, v::AbstractSmallVector{N}) where N -> SmallVector{N}
    Base.Checked.checked_mul(v::AbstractSmallVector{N}, c) where N -> SmallVector{N}

Returns `c*v`, but throws an `OverflowError` if an overflow occurs.
The scalar `c` and the elements of `v` must be integers.

See also [`Base.Checked.mul_with_overflow`](@ref Base.Checked.mul_with_overflow(::Integer, ::AbstractSmallVector)).
"""
Base.Checked.checked_mul(::Integer, ::AbstractSmallVector),
Base.Checked.checked_mul(::AbstractSmallVector, ::Integer)

function Base.Checked.checked_mul(c::T1, v::AbstractSmallVector{N,T2}) where {N, T1 <: Integer, T2 <: Integer}
    b = Base.Checked.checked_mul(c, v.b)
    SmallVector(b, length(v))
end

Base.Checked.checked_mul(v::AbstractSmallVector{N,T1}, c::T2) where {N, T1 <: Integer, T2 <: Integer} = Base.Checked.checked_mul(c, v)

"""
    support(v::AbstractSmallVector) -> SmallBitSet

Return the `SmallBitSet` with the indices of the non-zero elements of `v`.
If `v` has `Bool` elements, then this means the elements that are `true`.

See also [`SmallBitSet`](@ref), [`support(::Any, ::AbstractSmallVector)`](@ref).

# Example
```jldoctest
julia> v = SmallVector{8,Int8}([1, 0, 2, 0, 0, 3]);

julia> support(v)
SmallBitSet{UInt8} with 3 elements:
  1
  3
  6
```
"""
support(v::AbstractSmallVector) = support(v.b)
# here we assume that the padding is via zeros

"""
    support(f, v::AbstractSmallVector; [style::MapStyle]) -> SmallBitSet

Return the `SmallBitSet` with the indices of the elements `x` of `v` for which `f(x)` is non-zero.
If `f` has `Bool` values, then this means that `f(x)` has to be `true`.

The `style` keyword argument determines how the padding used for `AbstractSmallVector` is treated.
As discussed under `MapStyle`, the default value is based on a list of known functions.

See also [`SmallBitSet`](@ref), [`support(::AbstractSmallVector)`](@ref),
[`$(@__MODULE__).MapStyle`](@ref).

# Example
```jldoctest
julia> v = SmallVector{8,Int8}(3:8);

julia> support(isodd, v)
SmallBitSet{UInt8} with 3 elements:
  1
  3
  5
```
"""
support(::Any, ::AbstractSmallVector)

function support(f::F, v::AbstractSmallVector{N,T}; style::MapStyle = MapStyle(f, T)) where {F,N,T}
    @inline
    if style isa LazyStyle
        support(map(f, v; style))
    else
        s = support(f, v.b)
        @static if VERSION > v"1.13-"
            style isa EagerStyle ? filter(<=(length(v)), s) : s
        else
            style isa EagerStyle ? filter(<=(unsigned(v.n)), s) : s
        end
    end
end

#
# map
#

"""
    map(f, v::AbstractSmallVector...; [style::MapStyle]) -> SmallVector

Apply `f` to the argument vectors elementwise and stop when one of them is exhausted.
Note that the capacity of the resulting `SmallVector` is the minimum of the argument
vectors' capacities.

The `style` keyword argument determines how `map` treats the padding used for
`AbstractSmallVector`. As discussed under `MapStyle`, the default value is based on
a list of known functions.

See also [`capacity`](@ref capacity(::Type{<:AbstractSmallVector})), `Base.map(f, v::AbstractVector...)`,
[`$(@__MODULE__).MapStyle`](@ref), [Section "Broadcasting"](@ref sec-broadcasting).

# Examples
```jldoctest
julia> v = SmallVector{8}(1:3); w = SmallVector{4}(2.0:4.0); map(*, v, w)
3-element SmallVector{4, Float64}:
  2.0
  6.0
 12.0

julia> v = SmallVector{8}('a':'e'); w = SmallVector{4}('x':'z'); map(*, v, w)
3-element SmallVector{4, String}:
 "ax"
 "by"
 "cz"
```
"""
function map(f::F, vs::Vararg{AbstractSmallVector,M}; style::MapStyle = MapStyle(f, map(eltype, vs)...)) where {F,M}
    @inline
    n, eq = minlength(vs)
    if style isa LazyStyle
        @inline smallvector_bc(LazyStyle(), n, f, vs...)
    elseif style isa StrictStyle || (style isa RigidStyle && (M == 1 || eq))
        @inline smallvector_bc(StrictStyle(), n, f, vs...)
    else
        @inline smallvector_bc(EagerStyle(), n, f, vs...)
    end
end

function minlength(vs)
    foldl(vs[2:end]; init = (length(vs[1]), true)) do (n, eq), v
        min(n, length(v)), eq & (n == length(v))
    end
end

function smallvector_rand(rng::AbstractRNG, ::Val{N}, ::Type{T}, n::Integer) where {N,T}
    SmallVector(padtail(rand(rng, FixedVector{N,T}), n), n)
end

function smallvector_rand(rng::AbstractRNG, ::Val{N}, ::Type{Nothing}, n::Integer) where N
    vals = SmallVector(default(FixedVector{N,Nothing}), n)
end

function Random.rand(rng::AbstractRNG, ::SamplerType{SmallVector{N,T}}) where {N,T}
    smallvector_rand(rng, Val(N), T, rand(0:N))
end

#
# broadcast
#

using Base.Broadcast: AbstractArrayStyle, DefaultArrayStyle, Style, Broadcasted, broadcasted, flatten
import Base.Broadcast: BroadcastStyle, materialize

"""
    $(@__MODULE__).SmallVectorStyle <: Broadcast.AbstractArrayStyle{1}

The broadcasting style used for `AbstractSmallVector`.

See also [`AbstractSmallVector`](@ref), `Broadcast.AbstractArrayStyle`.
"""
struct SmallVectorStyle <: AbstractArrayStyle{1} end

BroadcastStyle(::Type{<:AbstractSmallVector}) = SmallVectorStyle()
BroadcastStyle(::SmallVectorStyle, ::DefaultArrayStyle{0}) = SmallVectorStyle()
BroadcastStyle(::SmallVectorStyle, ::DefaultArrayStyle{N}) where N = DefaultArrayStyle{N}()
BroadcastStyle(::SmallVectorStyle, ::Style{Tuple}) = DefaultArrayStyle{1}()

@propagate_inbounds materialize(bc::Broadcasted{SmallVectorStyle}) = copy(bc)
# the size of the resulting vector is determined below in `copy`

bc_return_type(x) = _eltype(x)

function bc_return_type(bc::Broadcasted)
    TT = map(bc_return_type, bc.args)
    Core.Compiler.return_type(bc.f, Tuple{TT...})
end

bc_mapstyle(::Any) = EagerStyle()
bc_mapstyle(::AbstractSmallVector) = StrictStyle()

function bc_mapstyle(bc::Broadcasted)
    TT = map(bc_return_type, bc.args)
    all(T -> isconcretetype(T) || T <: DataType, TT) || return LazyStyle()
    fstyle = MapStyle(bc.f, TT...)
    argstyles = map(bc_mapstyle, bc.args)
    if fstyle isa LazyStyle || any(Fix2(isa, LazyStyle), argstyles)
        LazyStyle()
    elseif fstyle isa RigidStyle && all(Fix2(isa, StrictStyle), argstyles)
        StrictStyle()
    elseif fstyle isa StrictStyle && any(Fix2(isa, StrictStyle), argstyles)
        StrictStyle()
    else
        EagerStyle()
    end
end

@inline function copy(bc::Broadcasted{SmallVectorStyle})
    bcflat = flatten(bc)
    i = findfirst(v -> v isa AbstractSmallVector, bcflat.args)
    n = length(bcflat.args[i])
    @boundscheck any(v -> v isa AbstractSmallVector && length(v) != n, bcflat.args) &&
        dimensionmismatch("vectors must have the same length")
    smallvector_bc(bc_mapstyle(bc), n, bcflat.f, bcflat.args...)
end

_capacity(::Type{T}) where T <: AbstractSmallVector = capacity(T)
_capacity(::T) where T = _capacity(T)

_getindex(v::AbstractSmallVector, i) = @inbounds v.b[i]

@inline function smallvector_bc(::StrictStyle, n, f::F, vs::Vararg{Any,M}) where {F,M}
    SmallVector(map_fixedvector(f, vs...), n)
end

@inline function smallvector_bc(::EagerStyle, n, f::F, vs::Vararg{Any,M}) where {F,M}
    SmallVector(padtail(map_fixedvector(f, vs...), n), n)
end

_eltype(v::Union{AbstractVector}) = eltype(v)
_eltype(x::Base.RefValue{T}) where T = T
_eltype(x::T) where T = T

function smallvector_bc(::LazyStyle, n, f::F, vs::Vararg{Any,M}) where {F,M}
    N = minimum(_capacity, vs)
    TT = map(_eltype, vs)
    U = Core.Compiler.return_type(f, Tuple{TT...})
    if isconcretetype(U)
        tt = ntuple(Val(N)) do i
            ntuple(j -> _getindex(vs[j], i), Val(M))
        end
        t = ntuple(Val(N)) do i
            i <= n ? f(tt[i]...) : default(U)
        end
        SmallVector(FixedVector{N,U}(t), n)
    else
        VT = map(vs) do v
            T = typeof(v)
            T <: AbstractSmallVector ? AbstractVector{eltype(T)} : T
        end
        w = invoke(map, Tuple{F,VT...}, f, vs...)
        SmallVector{N}(w)
    end
end

using BangBang

@testset "SmallBitSet !!" begin
    s = SmallBitSet(1:3)
    t = SmallBitSet(3:5)
    x = 6
    @test_inferred push!!(s, x) push(s, x)
    @test_inferred pop!!(s) pop(s)
    @test_inferred delete!!(s, x) delete(s, x)
    @test_broken filter!!(isodd, s) == filter(isodd, s)
    @test_inferred union!!(s, t) union(s, t)
    @test_inferred intersect!!(s, t) intersect(s, t)
    @test_inferred setdiff!!(s, t) setdiff(s, t)
    @test_inferred symdiff!!(s, t) symdiff(s, t)
end

@testset "SmallSet !!" begin
    s = SmallSet{8}(1:3)
    t = SmallSet{8}(3:5)
    x = 6
    @test_inferred push!!(s, x) push(s, x)
    @test_inferred pop!!(s) pop(s)
    @test_inferred delete!!(s, x) delete(s, x)
    @test_broken isdefined(BangBang, :filter!!)
    @test_inferred union!!(s, t) union(s, t)
    @test_inferred intersect!!(s, t) intersect(s, t)
    @test_inferred setdiff!!(s, t) setdiff(s, t)
    @test_inferred symdiff!!(s, t) symdiff(s, t)
end

@testset "MutableSmallSet !!" begin
    s = MutableSmallSet{8}(1:3)
    t = SmallSet{8}(3:5)
    x = 6
    u = copy(s)
    uu = @test_inferred push!!(u, x) push!(copy(s), x)
    @test uu === u
    u = copy(s)
    uu, y = @inferred pop!!(u)
    @test uu === u && y == pop!(copy(s))
    u = copy(s)
    uu = @test_inferred delete!!(u, x) delete!(copy(s), x)
    @test uu === u
    @test_broken isdefined(BangBang, :filter!!)
    u = copy(s)
    uu = @test_inferred union!!(u, t) union!(copy(s), t)
    @test uu === u
    u = copy(s)
    uu = @test_inferred intersect!!(u, t) intersect!(copy(s), t)
    @test uu === u
    u = copy(s)
    uu = @test_inferred setdiff!!(u, t) setdiff!(copy(s), t)
    @test uu === u
    u = copy(s)
    uu = @test_inferred symdiff!!(u, t) symdiff!(copy(s), t)
    @test uu === u
end

@testset "SmallDict !!" begin
    d = SmallDict{8}('a' => 1, 'b' => 2)
    e = SmallDict{8}('b' => 3, 'c' => 4)
    x = 'x' => -1
    @test_inferred push!!(d, x) push(d, x)
    @test_inferred pop!!(d) pop(d)
    @test_inferred delete!!(d, x) delete(d, x)
    @test_broken isdefined(BangBang, :filter!!)
    @test_inferred mergewith!!(+, d, e) mergewith(+, d, e)
end

@testset "MutableSmallDict !!" begin
    d = MutableSmallDict{8}('a' => 1, 'b' => 2)
    e = SmallDict{8}('b' => 3, 'c' => 4)
    x = 'x' => -1
    u = copy(d)
    uu = @test_inferred push!!(u, x) push!(copy(d), x)
    @test uu === u
    u = copy(d)
    uu, y = @inferred pop!!(u)
    @test uu === u && y == pop!(copy(d))
    u = copy(d)
    uu = @test_inferred delete!!(u, x) delete!(copy(d), x)
    @test uu === u
    @test_broken isdefined(BangBang, :filter!!)
    u = copy(d)
    uu = @test_inferred mergewith!!(+, u, e) mergewith!(+, copy(d), e)
    @test uu === u
end

@testset "FixedVector !!" begin
    v = FixedVector{6}(1:6)
    w = FixedVector{6}(4:9)
    x = -1
    i = 5
    @test_inferred setindex!!(v, x, i) setindex(v, x, i)
    @test_broken isdefined(BangBang, :map!!)
    @test_inferred add!!(v, w) v+w
end

@testset "MutableFixedVector !!" begin
    v = MutableFixedVector{6}(1:6)
    w = FixedVector{6}(4:9)
    x = -1
    i = 5
    u = copy(v)
    uu = @test_inferred setindex!!(u, x, i) setindex!(copy(u), x, i)
    @test uu === u
    @test_broken isdefined(BangBang, :map!!)
    u = copy(v)
    uu = @test_inferred add!!(u, w) v+w u
    @test uu === u
end

@testset "SmallVector !!" begin
    v = SmallVector{8}(1:6)
    w = SmallVector{8}(4:9)
    x = -1
    i = 5
    @test_inferred setindex!!(v, x, i) setindex(v, x, i)
    @test_inferred push!!(v, x) push(v, x)
    @test_inferred pushfirst!!(v, x) pushfirst(v, x)
    @test_inferred pop!!(v) pop(v)
    @test_inferred popfirst!!(v) popfirst(v)
    @test_broken insert!!(v, i, x) == insert(v, i, x)
    @test_inferred deleteat!!(v, i) deleteat(v, i)
    @test_inferred append!!(v, (x,)) append(v, (x,))
    @test_broken prepend!!(v, (x,)) == prepend(v, (x,))
    @test_broken filter!!(isodd, v) == filter(isodd, v)
    @test_broken isdefined(BangBang, :map!!)
    @test_inferred add!!(v, w) v+w
end

@testset "MutableSmallVector !!" begin
    v = MutableSmallVector{8}(1:6)
    w = SmallVector{8}(4:9)
    x = -1
    i = 5
    u = copy(v)
    uu = @test_inferred setindex!!(u, x, i) setindex!(copy(u), x, i)
    @test uu === u
    u = copy(v)
    uu = @test_inferred push!!(u, x) push!(copy(u), x)
    @test uu === u
    u = copy(v)
    uu = @test_inferred pushfirst!!(u, x) pushfirst!(copy(u), x)
    @test uu === u
    u = copy(v)
    uu, y = @inferred pop!!(u)
    @test uu === u && y == pop!(copy(v))
    u = copy(v)
    uu, y = @inferred popfirst!!(u)
    @test uu === u && y == popfirst!(copy(v))
    u = copy(v)
    @test_broken insert!!(u, i, x) == insert!(copy(u), i, x)
    u = copy(v)
    uu = @test_inferred deleteat!!(u, i) deleteat!(copy(v), i)
    @test uu === u
    u = copy(v)
    uu = @test_inferred append!!(u, (x,)) append!(copy(u), (x,))
    @test uu === u
    u = copy(v)
    @test_broken prepend!!(u, (x,)) == prepend!(copy(u), (x,))
    u = copy(v)
    @test_broken filter!!(isodd, u) == filter!(isodd, copy(z))
    @test_broken isdefined(BangBang, :map!!)
    u = copy(v)
    uu = @test_inferred add!!(u, w) v+w u
    @test uu === u
end

@testset "PackedVector !!" begin
    v = PackedVector{UInt64,8,Int8}(1:6)
    w = PackedVector{UInt64,8,Int8}(4:9)
    x = -1
    i = 5
    @test_inferred setindex!!(v, x, i) setindex(v, x, i)
    @test_inferred push!!(v, x) push(v, x)
    @test_inferred pushfirst!!(v, x) pushfirst(v, x)
    @test_inferred pop!!(v) pop(v)
    @test_inferred popfirst!!(v) popfirst(v)
    @test_broken insert!!(v, i, x) == insert(v, i, x)
    @test_inferred deleteat!!(v, i) deleteat(v, i)
    @test_inferred append!!(v, (x,)) append(v, (x,))
    @test_broken prepend!!(v, (x,)) == prepend(v, (x,))
    @test_broken filter!!(isodd, v) == filter(isodd, v)
    @test_broken isdefined(BangBang, :map!!)
    @test_inferred add!!(v, w) v+w
end

using SmallCollections, Chairmarks
using SmallCollections: uinttype, cpufeature, hasshuffle
import SmallCollections: shuffle

@info first(Sys.cpu_info()).model

@inline function shuffle(::Val{:default}, v, p::FixedVector{N,U}, _) where {N,U}
    if N > typemax(U)
        @inbounds v[p .+ one(UInt16)]
    else
        @inbounds v[p .+ one(U)]
    end
end

@inline function shuffle(::Val{:none}, v, p::FixedVector{N,U}, _) where {N,U}
    if N > typemax(U)
        map(i -> @inbounds(v[i+one(UInt16)]), p)
    else
        map(i -> @inbounds(v[i+one(U)]), p)
    end
end

for M in [16, 32, 64, 128, 256, 512, 1024]
    modes = [:default, :none]
    if Sys.ARCH in (:x86_64, :i686)
        cpufeature(:AVX) && M == 16 && push!(modes, :avx)
        cpufeature(:AVX2) && M == 32 && push!(modes, :avx2)
        cpufeature(:AVX512VBMI) && M <= 64 && push!(modes, :avx512)
        cpufeature(:AVX512VBMI) && M >= 128 && push!(modes, :avx512merge)
    end
    @show M, modes

    assert_ex = Expr(:comparison, [isodd(i) ? :(shuffle(Val($(QuoteNode(modes[(i+1)÷2]))), v, p, Val(true))) : :(==) for i in 1:2*length(modes)-1]...)

    vv = Expr(:$, :v)
    pp = Expr(:$, :p)
    bench_ex = Expr(:tuple, [:(shuffle(Val($(QuoteNode(mode))), $vv, $pp, Val(true))) for mode in modes]...)

    aa = Expr(:$, :a)
    bb = Expr(:$, :b)
    bench_map_ex = Expr(:tuple, [:(map!((v, p) -> shuffle(Val($(QuoteNode(mode))), v, p, Val(true)), $aa, $aa, $bb)) for mode in modes]...)

    @eval for T in [Int8, UInt8, Bool, Int16, UInt16, Float16, Int32, UInt32, Float32, Char, Int64, UInt64, Float64]
        N = $M ÷ sizeof(T)
        hasshuffle(Val(N), T, Val(true)) || continue
        U = uinttype(T)
        print("$T\t")
        v = rand(FixedVector{N,T})
        p = FixedVector{N,U}(rand(0:min(N-1, typemax(U)), N))
        @assert $assert_ex
        show(stdout, MIME("text/plain"), @b $bench_ex)
        print("\t\t")
        a = rand(FixedVector{N,T}, 1000)
        b = [FixedVector{N,U}(rand(0:min(N-1, typemax(U)), N)) for _ in 1:1000]
        show(stdout, MIME("text/plain"), @b $bench_map_ex)
        println()
    end
end

using SmallCollections: default, bitsize, getindex0

using Base.FastMath: eq_fast
using LinearAlgebra: LinearAlgebra, dot

const VS = (SmallVector, MutableSmallVector)

@testset "SmallVector" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = rand(T, m)
        v = @inferred V{N,T}(u)
        if ismutabletype(V)
            @test v == @inferred(copy(v)) !== v
        else
            @test v === @inferred copy(v)
        end
        @test_inferred capacity(v) N Int
        @test_inferred fixedvector(v) [i <= length(v) ? v[i] : default(T) for i in 1:N] FixedVector{N,T}
        @test_inferred fixedvector(v, Val(N)) fixedvector(v)
        @test_inferred fixedvector(v, Val(N+3)) [i <= length(v) ? v[i] : default(T) for i in 1:N+3] FixedVector{N+3,T}
        @test_inferred v == u true
        @test isvalid(v)
        @test_inferred collect(v) u Vector{T}
        v2 = V{N,T}(u)
        @test_inferred v == v2 true
        v3 = V{2*N,T}(u)
        @test_inferred v == v3 true
        if T <: Number
            @test_inferred eq_fast(v, v2) true
            @test_inferred eq_fast(v, v3) true
            numerictype(T) <: Integer && bitsize(T) >= bitsize(Float64) && continue
            v4 = V{N,setnumerictype(T, Float64)}(u)
            @test_inferred v == v4 true
            @test_inferred eq_fast(v, v4) true
        end
        if !isempty(u)
            i = rand(1:m)
            x = rand(T)
            while x == v[i]
                x = rand(T)
            end
            v5 = setindex(v, x, i)
            @test_inferred v == v5 false
            if T <: Number
                @test_inferred eq_fast(v, v5) false
            end
        end
        v6 = V{N+2,T}(push!(copy(u), rand(T)))
        @test_inferred v == v6 false
        if T <: Number
            @test_inferred eq_fast(v, v6) false
        end
        if !isempty(u)
            u7 = copy(u)
            pop!(u7)
            v7 = V{N+2,T}(u7)
            @test_inferred v == v7 false
            if T <: Number
                @test_inferred eq_fast(v, v7) false
            end
        end
        @test_inferred hash(v) hash(u) UInt
        v8 = V{2*N,T}(u)
        @test_inferred fasthash(v) fasthash(v8) UInt
        @test_inferred length(v) length(u) Int
        @test_inferred V{N,T}() V{N,T}(())
        @test_inferred empty(v) V{N,T}()
        @test_inferred empty(v, Char) V{N,Char}()
    end

    for V in VS, W in (FixedVector, MutableFixedVector), N in (9, 16), T in test_types
        w = rand(W{N,T})
        @test_inferred V(w) w V{N,T}
    end
end

@testset "SmallVector indices" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = rand(T, m)
        v = V{N,T}(u)
        if isempty(u)
            @test_throws Exception first(v)
            @test_throws Exception last(v)
        else
            @test_inferred first(v) first(u) T
            @test_inferred last(v) last(u) T
        end
        x = rand(T)
        for i in -1:length(u)+1
            if 1 <= i <= length(u)
                @test_inferred v[i] u[i] T
                w = @test_inferred setindex(v, x, i) setindex!(copy(u), x, i) SmallVector(v)
                @test isvalid(w)
                if T <: Number
                    w = @test_inferred addindex(v, x, i) setindex!(copy(u), u[i]+x, i) SmallVector(v)
                    @test isvalid(w)
                end
                if ismutabletype(V) && isbitstype(T)
                    w = @test_inferred setindex!(copy(v), x, i) setindex!(copy(u), x, i) v
                    @test isvalid(w)
                end
            else
                @test_throws Exception v[i]
                @test_throws Exception setindex(v, x, i)
                T <: Number && @test_throws Exception addindex(v, x, i)
                if ismutabletype(V) && isbitstype(T)
                    @test_throws Exception setindex!(v, x, i)
                end
            end
        end
        for i in 0:m, j in i-1:m+1
            if checkbounds(Bool, u, i:j)
                w = @test_inferred v[i:j] u[i:j] SmallVector(v)
                @test isvalid(w)
            else
                @test_throws Exception v[i:j]
            end
        end
    end
end

@testset "SmallVector bool inds" begin
    for N in (1, 2, 9, 16), T in (Bool, Int16), V in (SmallVector, MutableSmallVector), m in Set((0, 1, N÷2, N))
        u = rand(T, m)
        v = V{N,T}(u)

        if m > 0
            jj = rand(Bool, m-1)
            iis = Any[SmallVector{N+2}(jj), PackedVector{UInt32,1,Bool}(jj)]
            m > 1 && pushfirst!(iis, FixedVector{m-1}(jj))
            for ii in iis
                @test_throws Exception v[ii]
            end
        end

        jj = rand(Bool, m)
        iis = Any[SmallVector{N+2}(jj), PackedVector{UInt32,1,Bool}(jj)]
        m > 0 && pushfirst!(iis, FixedVector{m}(jj))
        for ii in iis
            @test_inferred v[ii] u[jj] SmallVector{N,T}
        end
    end
end

@testset "SmallVector vec inds" begin
    for N in (1, 2, 8, 11, 32, 72, 128), T in (Int8, Char), V in (SmallVector, MutableSmallVector), m in Set((0, 1, N÷2, N))
        N*sizeof(T) <= 256 || continue
        u = rand(T, m)
        v = V{N,T}(u)

        ii = 1:max(0, m-2)
        @test_inferred v[ii] u[ii] SmallVector{N,T}
        ii = collect(ii)
        @test_inferred v[ii] u[ii] MutableSmallVector{N,T}  # type chosen in Base via `similar`

        m > 0 || continue

        M = 7
        for jj in [rand(UInt8(1):UInt8(m), M), Int16[]]
            ii = SmallVector{M+1}(jj)
            @test_inferred v[ii] u[ii] SmallVector{M+1,T}
            ii0 = SmallVector{M}(jj .- UInt8(1))
            @test_inferred getindex0(v, ii0) u[ii] SmallVector{M,T}
            ii = PackedVector{UInt128,12,Int16}(jj)
            @test_inferred v[ii] u[ii] u
            ii = 2:min(m, 5)
            @test_inferred v[ii] u[ii] SmallVector{N,T}
            ii = 1:2:min(m, 7)
            @test_inferred v[ii] u[ii] SmallVector{N,T}
            isempty(jj) && continue
            ii = FixedVector{M}(jj)
            @test_inferred v[ii] u[ii] FixedVector{M,T}
            ii0 = FixedVector{M}(jj .- UInt8(1))
            @test_inferred getindex0(v, ii0) u[ii] FixedVector{M,T}
        end
    end
end

@testset "SmallVector zeros" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        T <: Number || continue
        u = zeros(T, m)
        v = V{N,T}(u)
        @test_inferred iszero(v) true
        w = @test_inferred zero(v) u v
        @test isvalid(w)
        w = @test_inferred zeros(V{N,T}, m) v
        @test isvalid(w)
        w = @test_inferred ones(V{N,T}, m) ones(T, m) V{N,T}
        @test isvalid(w)
    end
end

@testset "SmallVector reverse" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = rand(T, m)
        v = V{N,T}(u)
        @test_inferred reverse(v) reverse(u) SmallVector(v)
        for i in 0:m+2
            if 1 <= i <= m+1
                @test_inferred reverse(v, i) reverse(u, i) SmallVector(v)
            else
                @test_throws Exception reverse(v, i)
            end
            for j in i-2:m+1
                if 1 <= i <= m+1 && i-1 <= j <= m
                    @test_inferred reverse(v, i, j) reverse(u, i, j) SmallVector(v)
                else
                    @test_throws Exception reverse(v, i, j)
                end
            end
        end
        (V <: MutableFixedVector && isbitstype(T)) || continue
        w = @test_inferred reverse!(v) reverse(u) v
        @test w === v
    end
end

@testset "SmallVector push/pop" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = rand(T, m)
        v = V{N,T}(u)
        x = rand(T)
        y = rand(T)
        @test_inferred push(v) SmallVector(v)
        @test_inferred pushfirst(v) SmallVector(v)
        if length(u) == N
            @test_throws Exception push(v, x)
            @test_throws Exception push(v, x, y)
            @test_throws Exception pushfirst(v, x)
            @test_throws Exception pushfirst(v, x, y)
        else
            w = @test_inferred push(v, x) push!(copy(u), x) SmallVector(v)
            @test isvalid(w)
            w = @test_inferred pushfirst(v, x) pushfirst!(copy(u), x) SmallVector(v)
            @test isvalid(w)
            if length(u) <= N-2
                w = @test_inferred push(v, x, y) push(push(v, x), y)
                @test isvalid(w)
                w = @test_inferred pushfirst(v, x, y) pushfirst(pushfirst(v, y), x)
                @test isvalid(w)
            end
        end
        if isempty(u)
            @test_throws Exception pop(v)
            @test_throws Exception popfirst(v)
        else
            w, _ = @test_inferred pop(v) (deleteat!(copy(u), length(u)), last(u)) (SmallVector(v), last(v))
            @test isvalid(w)
            w, _ = @test_inferred popfirst(v) (deleteat!(copy(u), 1), first(u)) (SmallVector(v), first(v))
            @test isvalid(w)
        end
        for i in (-1, 0, 1, 2, length(u), length(u)+1)
            if 1 <= i <= length(u)+1 && length(u) < N
                w = @test_inferred insert(v, i, x) insert!(copy(u), i, x) SmallVector(v)
                @test isvalid(w)
                if i <= length(u)
                    w = @test_inferred duplicate(v, i) insert(v, i, v[i])
                    @test isvalid(w)
                else
                    @test_throws Exception duplicate(v, i)
                end
            else
                @test_throws Exception insert(v, i, x)
                @test_throws Exception duplicate(v, i)
            end
            if 1 <= i <= length(u)
                w = @test_inferred deleteat(v, i) deleteat!(copy(u), i) SmallVector(v)
                @test isvalid(w)
            else
                @test_throws Exception deleteat(v, i)
            end
        end
        @test_inferred append(v) SmallVector(v)
        @test_inferred prepend(v) SmallVector(v)
        xy = [x, y]
        if length(u) <= N-2
            w = @test_inferred append(v, SmallVector{4}(xy)) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred append(v, xy[i] for i in 1:2) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred append(v, (x,), [y]) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, SmallVector{4}(xy)) pushfirst(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, xy[i] for i in 1:2) pushfirst(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, (x,), [y]) pushfirst(v, x, y)
            @test isvalid(w)
        else
            @test_throws Exception append(v, SmallVector{4}(xy))
            @test_throws Exception append(v, xy[i] for i in 1:2)
            @test_throws Exception append(v, (x,), [y])
            @test_throws Exception prepend(v, SmallVector{4}(xy))
            @test_throws Exception prepend(v, xy[i] for i in 1:2)
            @test_throws Exception prepend(v, (x,), [y])
        end
        if numerictype(T) <: Integer
            @test_inferred filter(isodd, v) filter(isodd, u) SmallVector(v)
        end
    end
end

@testset "SmallVector push!/pop!" begin
    for V in (MutableSmallVector,), N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        isbitstype(T) || continue
        u = rand(T, m)
        v = V{N,T}(u)
        x = rand(T)
        y = rand(T)
        @test_inferred push!(copy(v)) v
        @test_inferred pushfirst!(copy(v)) v
        if length(u) == N
            @test_throws Exception push!(copy(v), x)
            @test_throws Exception push!(copy(v), x, y)
            @test_throws Exception pushfirst!(copy(v), x)
            @test_throws Exception pushfirst!(copy(v), x, y)
        else
            w = @test_inferred push!(copy(v), x) push!(copy(u), x) v
            @test isvalid(w)
            w = @test_inferred pushfirst!(copy(v), x) pushfirst!(copy(u), x) v
            @test isvalid(w)
            if length(u) <= N-2
                w = @test_inferred push!(copy(v), x, y) push!(push!(copy(v), x), y)
                @test isvalid(w)
                w = @test_inferred pushfirst!(copy(v), x, y) pushfirst!(pushfirst!(copy(v), y), x)
                @test isvalid(w)
            end
        end
        if isempty(u)
            @test_throws Exception pop!(copy(v))
            @test_throws Exception popfirst!(copy(v))
        else
            @test_inferred pop!(copy(v)) pop!(copy(u)) T
            @test_inferred popfirst!(copy(v)) popfirst!(copy(u)) T
        end
        for i in (-1, 0, 1, 2, length(u), length(u)+1)
            if 1 <= i <= length(u)+1 && length(u) < N
                w = @test_inferred insert!(copy(v), i, x) insert!(copy(u), i, x) v
                @test isvalid(w)
                if i <= length(u)
                    w = @test_inferred duplicate!(copy(v), i) insert!(copy(v), i, v[i])
                    @test isvalid(w)
                else
                    @test_throws Exception duplicate!(copy(v), i)
                end
            else
                @test_throws Exception insert!(copy(v), i, x)
                @test_throws Exception duplicate!(copy(v), i)
            end
            if 1 <= i <= length(u)
                w = @test_inferred deleteat!(copy(v), i) deleteat!(copy(u), i) v
                @test isvalid(w)
            else
                @test_throws Exception deleteat!(copy(v), i)
            end
        end
        @test_inferred append!(v) v
        @test_inferred prepend!(v) v
        xy = [x, y]
        if length(u) <= N-2
            w = @test_inferred append!(copy(v), SmallVector{4}(xy)) push!(copy(v), x, y)
            @test isvalid(w)
            w = @test_inferred append!(copy(v), xy[i] for i in 1:2) push!(copy(v), x, y)
            @test isvalid(w)
            w = @test_inferred append!(copy(v), (x,), [y]) push!(copy(v), x, y)
            @test isvalid(w)
            w = @test_inferred prepend!(copy(v), SmallVector{4}(xy)) pushfirst!(copy(v), x, y)
            @test isvalid(w)
            w = @test_inferred prepend!(copy(v), xy[i] for i in 1:2) pushfirst!(copy(v), x, y)
            @test isvalid(w)
            w = @test_inferred prepend!(copy(v), (x,), [y]) pushfirst!(copy(v), x, y)
            @test isvalid(w)
        else
            @test_throws Exception append!(copy(v), SmallVector{4}(xy))
            @test_throws Exception append!(copy(v), xy[i] for i in 1:2)
            @test_throws Exception append!(copy(v), (x,), [y])
            @test_throws Exception prepend!(copy(v), SmallVector{4}(xy))
            @test_throws Exception prepend!(copy(v), xy[i] for i in 1:2)
            @test_throws Exception prepend!(copy(v), (x,), [y])
        end
        if numerictype(T) <: Integer
            @test_inferred filter!(isodd, copy(v)) filter!(isodd, copy(u)) v
        end
    end
end

@testset "SmallVector cmp" begin
    base_isless(v, w) = invoke(isless, Tuple{AbstractVector{UInt8},AbstractVector{UInt8}}, v, w)
    base_le(v::AbstractVector{T}, w::AbstractVector{T}) where T = invoke(<=, Tuple{AbstractVector{T},AbstractVector{T}}, v, w)

    for N in [8, 16], _ in 1:250
        v = SmallVector{N,UInt8}(rand((0, 255), rand(0:N)))
        w = MutableSmallVector{N,UInt8}(rand((0, 255), rand(0:N)))
        @test_inferred isless(v, w) base_isless(v, w)
        @test_inferred isless(v, v) base_isless(v, v)
    end

    for T in [UInt8, Int32, Char], N in [8, 13]
        v = rand(SmallVector{N,T})
        w = rand(SmallVector{N+2,T})
        @test_inferred v <= w base_le(v, w)
        @test_inferred v <= v base_le(v, v)
    end
end

@testset "SmallVector circshift" begin
    for V in VS, N in [1, 2, 9, 16, 128], T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        N == 128 && !(T in (Int8, UInt8, Bool)) && continue
        u = rand(T, m)
        v = V{N,T}(u)
        for k in (-2*N, -2*N+1, -3, -1, 0, 1, 7, N+5, 2*N+7)
            @test_inferred circshift(v, k) circshift(u, k) SmallVector(v)
            @test isvalid(circshift(v, k))
            V <: MutableSmallVector || continue
            v2 = copy(v)
            v3 = @test_inferred circshift!(v2, k) circshift(u, k) v2
            @test v3 === v2
        end
    end
end

@testset "SmallVector shuffle 256" begin
    T = Int8
    U = UInt8
    for N in [128, 127, 256, 255], n in N-2:N
        v = SmallVector{N}(rand(T, n))
        vv = collect(v)
        for k in [-n, -n+1, -n+2, -2, -1, 0, 1, 2, n-2, n-1, n]
            @test circshift(v, k) == circshift(vv, k)
            @test circshift!(MutableSmallVector(v), k) == circshift(vv, k)
        end
        for k in [1, 2, 3, n-1, n, n+1]
            @test reverse(v, k) == reverse(vv, k)
            @test reverse!(MutableSmallVector(v), k) == reverse(vv, k)
        end
        @test first(popfirst(v)) == deleteat!(copy(vv), 1)
        @test (w = MutableSmallVector(v); popfirst!(w); w) == deleteat!(copy(vv), 1)
        for k in [1, 2, 3, n-2, n-1, n]
            n < N || continue
            @test duplicate(v, k) == [vv[1:k]; vv[k:n]]
            @test first(popat(v, k)) == deleteat!(copy(vv), k)
            @test duplicate!(MutableSmallVector(v), k) == [vv[1:k]; vv[k:n]]
            @test deleteat!(MutableSmallVector(v), k) == deleteat!(copy(vv), k)
        end
        for k in [1, 2, 3, n-2, n-1, n], l in [k-1, k, n-1, n]
            @test v[k:l] == vv[k:l]
        end
        n < typemax(U) || continue
        for M in [128, 127, 256, 255], m in [0, 1, 2, M-2, M-1, M]
            ii = SmallVector{M,U}(rand(0:n-1, m))
            @test v[ii .+ U(1)] == vv[ii .+ 1]
        end
    end
end

using Base.FastMath: mul_fast

@testset "SmallVector add/mul" begin
    for V in VS, N in (1, 2, 9, 16), T1 in test_types, m in (1, round(Int, 0.7*N), N-1, N)
        T1 <: Number || continue
        if T1 <: Unsigned
            u1 = rand(unitrange(T1(1), T1(9)), m)
        else
            u1 = rand(unitrange(T1(-9), T1(9)), m)
        end
        v1 = V{N}(u1)
        w = @test_inferred +v1 u1 SmallVector(v1)
        @test isvalid(w)
        w = @test_inferred -v1 -u1 SmallVector(v1)
        @test isvalid(w)
        for T2 in test_types
            T2 <: Number || continue
            if numerictype(T2) <: Unsigned
                u2 = rand(unitrange(T2(1), T2(9)), m)
                c = rand(unitrange(T2(1), T2(9)))
            else
                u2 = rand(unitrange(T2(-9), T2(9)), m)
                c = rand(unitrange(T2(-9), T2(9)))
            end
            v2 = V{N}(u2)
            T1T2 = eltype(c*u1)
            w = @test_inferred c*v1 c*u1 SmallVector{N,T1T2}
            @test isvalid(w)
            if numerictype(T1T2) <: Unsigned && (minimum(v1; init = zero(T1)) < zero(T1) ||
                    (c < zero(c) && !(isempty(v1) && SmallCollections.MapStyle(mul_fast, T2, T1) isa SmallCollections.LazyStyle)))
                # Julia bug, see julia#58188
                @test_broken mul_fast(c, v1) == mul_fast.(c, u1)
            else
                w = @inferred mul_fast(c, v1)
                @test isapprox(w, mul_fast.(c, u1)) && w isa SmallVector{N,T1T2}
                @test isvalid(w)
            end
            @test_inferred v1*c c*v1
            dimension(T1) == dimension(T2) || continue
            T = promote_type(T1, T2)
            for op in (+, -)
                w = @test_inferred op(v1, v2) op(u1, u2) SmallVector{N,T}
                @test isvalid(w)
                v3 = V{N+4}(u2)
                w = @test_inferred op(v1, v3) op(u1, u2) SmallVector{N,T}
                @test isvalid(w)
                w = @test_inferred op(v3, v1) op(u2, u1) SmallVector{N,T}
                @test isvalid(w)
            end
        end
    end

    N = 8
    T = Float64
    u = T[-Inf, -1, 0, 1, Inf, NaN]
    for V in VS
        v = V{8,Float64}(u)
        for c in (Inf, -Inf, NaN)
            w = @test_inferred c*v c*u SmallVector{N,T}
            @test isvalid(w)
        end
    end
end

@testset "SmallVector sum/max" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        T <: Number || continue
        r = T <: Unsigned ? unitrange(T(1), T(9)) : unitrange(T(-9), T(9))
        u = rand(r, m)
        v = V{N}(u)
        for f in (maximum, minimum)
            if isempty(u)
                @test_throws Exception f(v)
                @test_inferred f(v; init = zero(T)) f(u; init = zero(T))
            else
                @test_inferred f(v) f(u)
            end
        end
        if isempty(u)
            @test_throws Exception extrema(v)
            @test_inferred extrema(v; init = (oneunit(T), zero(T))) extrema(u; init = (oneunit(T), zero(T)))
        else
            @test_inferred extrema(v) extrema(u)
        end
        @test_inferred sum(v) sum(u)
        s = @inferred sum_fast(v)
        @test s ≈ sum(u)
        if T <: SmallCollections.AbstractBitInteger
            @test_inferred sum_fast(v; init = Int32(0)) sum(v) promote_type(T, Int32)
        end
        if T <: Quantity
            @test prod(v) == prod(u)
        else
            @test_inferred prod(v) prod(u)
        end

        u2 = rand(r, m) * im
        v2 = V{N}(u2)
        du = dot(u2, u)
        if (VERSION < v"1.11" || pkgversion(LinearAlgebra) < v"1.12") &&
                m == 0 && (numerictype(T) <: Union{AbstractFloat, Complex{<:AbstractFloat}})
            # dot for empty vectors is not always the zero element (w.r.t. isequal)
            # see LinearAlgebra.jl#1483
            d = @inferred dot(v2, v)
            @test d ≈ du && typeof(d) == typeof(du)
            @test_broken isequal(dot(v2, v), du)
        else
            @test_inferred dot(v2, v) du
        end
        d = @inferred dot_fast(v2, v)
        @test d ≈ du && typeof(d) == typeof(du)

        T <: AbstractFloat || continue
        u = fill(-T(0), m)
        v = V{N}(u)
        @test_inferred sum(v) sum(u)
        @test_inferred prod(-v) prod(-u)
    end
    for V in VS, N in (5, 16), T in (Float32, Float64), x in (Inf, -Inf, NaN)
        u = T[x, -1, 0, 1]
        v = V{N}(u)
        @test_inferred maximum(v) maximum(u)
        @test_inferred minimum(v) minimum(u)
        @test_inferred sum(v) sum(u)
        if isnan(prod(u))
            @test_inferred isnan(prod(v)) true
        else
            @test_inferred prod(v) prod(u)
        end
    end
    for V in VS, N in (5, 16), T in (Float32, Float64)
        u = T[NaN, -1, 0, 1]
        v = V{N}(u)
        @test_inferred isnan(maximum(v)) true
        @test_inferred isnan(minimum(v)) true
        @test_inferred isnan(sum(v)) true
        @test_inferred isnan(prod(v)) true
    end
end

@testset "SmallVector overflow" begin
    for N in (1, 8, 13, 16, 25, 32), T in (Int8, UInt16, Int32), m in [0, 1, N-1, N]
        S = smallbitsettype(Val(N))
        vv = rand(T, m)
        if m > 0
            vv[1] = rand((typemin(T), zero(T)))
        end
        v = MutableSmallVector{N}(vv)
        w = SmallVector{N}(rand(T, m))
        ww = SmallVector{N+2}(w)

        u = -v
        uu = -collect(Int, v)
        s = S(i for i in 1:m if u[i] != uu[i])
        if isempty(s)
            @test_inferred Base.Checked.checked_neg(v) u
        else
            @test_throws OverflowError Base.Checked.checked_neg(v)
        end

        u = v+w
        uu = collect(Int, v) + collect(Int, w)
        s = S(i for i in 1:m if u[i] != uu[i])
        @test_inferred Base.Checked.add_with_overflow(v, w) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_add(v, ww) u
        else
            @test_throws OverflowError Base.Checked.checked_add(v, ww)
        end
        if m < N
            www = push(w, zero(T))
            @test_throws DimensionMismatch Base.Checked.add_with_overflow(v, www)
        end
        www = push(ww, zero(T))
        @test_throws DimensionMismatch Base.Checked.checked_add(v, www)

        u = v+w+v
        uu = collect(Int, v) + collect(Int, w) + collect(Int, v)
        s = S(i for i in 1:m if u[i] != uu[i])
        if isempty(s)
            @test_inferred Base.Checked.checked_add(v, ww, v) u
        else
            @test_throws OverflowError Base.Checked.checked_add(v, ww, v)
        end

        u = v-w
        uu = collect(Int, v) - collect(Int, w)
        s = S(i for i in 1:m if u[i] != uu[i])
        @test_inferred Base.Checked.sub_with_overflow(v, w) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_sub(v, ww) u
        else
            @test_throws OverflowError Base.Checked.checked_sub(v, ww)
        end
        if m < N
            www = push(w, zero(T))
            @test_throws DimensionMismatch Base.Checked.sub_with_overflow(v, www)
        end
        www = push(ww, zero(T))
        @test_throws DimensionMismatch Base.Checked.checked_sub(v, www)

        c = T(2)
        u = c*v
        uu = Int(c) * v
        s = S(i for i in 1:m if u[i] != uu[i])
        @test_inferred Base.Checked.mul_with_overflow(c, v) (u, s)
        @test_inferred Base.Checked.mul_with_overflow(v, c) (u, s)
        if isempty(s)
            @test_inferred Base.Checked.checked_mul(c, v) u
            @test_inferred Base.Checked.checked_mul(v, c) u
        else
            @test_throws OverflowError Base.Checked.checked_mul(c, v)
            @test_throws OverflowError Base.Checked.checked_mul(v, c)
        end
    end
end

@testset "SmallVector map" begin
    f(x) = Int32(2)*x
    f(x, y) = 2*x + y
    g(x) = iszero(x) ? 1 : 1.0
    for V in VS, N in (1, 2, 9, 16), T1 in test_types, m in (0, 1, round(Int, 0.7*N), N-1)
        T1 <: Number || continue
        u1 = rand(T1, m)
        v1 = V{N}(u1)
        u3 = map(f, u1)
        w = @test_inferred map(f, v1) u3 SmallVector{N,eltype(u3)}
        @test isvalid(w)
        for T2 in test_types
            (T2 <: Number && dimension(T1) == dimension(T2)) || continue
            u2 = rand(T2, m+1)
            v2 = V{N+2}(u2)
            u4 = map(f, u1, u2)
            w = @test_inferred map(f, v1, v2) u4 SmallVector{N,eltype(u4)}
            @test isvalid(w)
        end
    end
    for V in VS,  m in (0, 1, 3)
        v = V{8}(1:m)
        u = collect(v)
        u5 = map(g, u)
        w = map(g, v)
        @test w == u5
        @test eltype(w) == eltype(u5)
    end
end

@testset "SmallVector find" begin
    for N in (1, 2, 9, 16), T in [Bool, test_types...], V in (SmallVector, MutableSmallVector), m in (0, 1, N-1, N)
        T <: Number || continue
        k = max(m ÷ 2, 1)
        for u in (rand(T(0):oneunit(T):(T == Bool ? true : T(2)), m), zeros(T, m), ones(T, m))
            v = V{N,T}(u)
            for style in (LazyStyle(), EagerStyle(), RigidStyle(), StrictStyle())
                @test_inferred support(!iszero, v; style) Set(findall(!iszero, u)) SmallBitSet
                i = @inferred Nothing findfirst(!iszero, v; style)
                @test i == findfirst(!iszero, u)
                i = @inferred Nothing findlast(!iszero, v; style)
                @test i == findlast(!iszero, u)
                if !isempty(v)
                    i = @inferred Nothing findnext(!iszero, v, k; style)
                    @test i == findnext(!iszero, u, k)
                    i = @inferred Nothing findprev(!iszero, v, k; style)
                    @test i == findprev(!iszero, u, k)
                end
            end
            if !isempty(v)
                @test_inferred findmin(v) findmin(u) Tuple{T, Int}
                @test_inferred findmax(v) findmax(u) Tuple{T, Int}
                if T != Bool
                    @test_inferred findmin(-, v) findmin(-, u) Tuple{T, Int}
                    @test_inferred findmax(-, v) findmax(-, u) Tuple{T, Int}
                end
            end
            @test_inferred allequal(v) allequal(u) Bool
            VERSION >= v"1.11" && @test_inferred allequal(isodd, v) allequal(isodd, u) Bool
            @test_inferred allunique(v) allunique(u) Bool
            VERSION >= v"1.11" && @test_inferred allunique(-, v) allunique(-, u) Bool
            @test_inferred any(isodd, v) any(isodd, u) Bool
            @test_inferred all(isodd, v) all(isodd, u) Bool
            @test_inferred findall(!iszero, v) findall(!iszero, u) SmallVector{N,SmallLength}
            if VERSION > v"1.13-" && SmallCollections.MapStyle(!iszero, T) == SmallCollections.LazyStyle()
                # work around type instability for `count`, see julia#59869
                try
                    @inferred count(!iszero, v; init = Int32(0))
                    @test_broken true
                catch
                    @test_broken false
                end
            else
                @test_inferred count(!iszero, v; init = Int32(0)) count(!iszero, u; init = Int32(0)) Int32
            end
            if T == Bool
                @test_inferred support(v) Set(findall(u)) SmallBitSet
                @test_inferred findall(v) findall(u) SmallVector{N,SmallLength}
                @test_inferred any(v) any(u) Bool
                @test_inferred all(v) all(u) Bool
                @test_inferred count(v) count(u) Int
            end
        end
    end
end

@testset "SmallVector issorted" begin
    for T in [Int8, Float32, BigInt, Char], u in [Int[], [1], [1,2,3], [1,2,2], [1,2,1], [3,2,1], [3,2,2], [1,1,1,1]],
            N in max(length(u), 1):length(u)+2
        v = SmallVector{N,T}(u)
        w = collect(T, u)
        bys = T == Char ? (identity, uppercase) : (identity, -, x -> 2.0*x)
        for lt in (isless, >), by in bys, rev in (false, true), strict in (false, true)
            if strict
                @test_inferred issorted(v; lt, by, rev, strict) issorted(w; lt, by, rev) & allunique(w)
            else
                @test_inferred issorted(v; lt, by, rev, strict) issorted(w; lt, by, rev)
            end
        end
    end
end

@testset "SmallVector rest" begin
    for V in VS
        v = V{8}(1:2)
        W = typeof(SmallVector(v))
        w..., = v
        @test w == v && w isa W && isvalid(w)
        x1, w... = v
        @test w == v[2:end] && w isa W && isvalid(w)
        x1, x2, w... = v
        @test w == v[3:end] && w isa W && isvalid(w)
        @test_throws Exception x1, x2, x3, w... = v

        if VERSION >= v"1.9"
            v = V{8,UInt8}(1:3)
            W = typeof(SmallVector(v))
            w..., y1 = v
            @test w == v[1:end-1] && w isa W && isvalid(w) && y1 === v[end]
            x1, w..., y1 = v
            @test w == v[2:end-1] && w isa W && isvalid(w) && y1 === v[end]
            x1, x2, w..., y1 = v
            @test w == v[3:end-1] && w isa W && isvalid(w) && y1 === v[end]
            @test_throws Exception x1, x2, x3, w..., y1 = v

            v = SmallVector{8,Int16}(1:4)
            W = typeof(SmallVector(v))
            w..., y1, y2 = v
            @test w == v[1:end-2] && w isa W && isvalid(w) && y1 === v[end-1] && y2 === v[end]
            x1, w..., y1, y2 = v
            @test w == v[2:end-2] && w isa W && isvalid(w) && y1 === v[end-1] && y2 === v[end]
            x1, x2, w..., y1, y2 = v
            @test w == v[3:end-2] && w isa W && isvalid(w) && y1 === v[end-1] && y2 === v[end]
            @test_throws Exception x1, x2, x3, w..., y1, y2 = v
        end
    end
end

@testset "SmallVector support" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        T <: Number || continue
        u = rand(unitrange(T(0), T(2)), m)
        v = V{N,T}(u)
        @test_inferred support(v) Set{Int}(i for i in 1:m if !iszero(u[i])) SmallBitSet
    end
end

@testset "SmallVector rand" begin
    for V in VS, N in (1, 2, 9, 16), T in test_types, m in (0, 1, round(Int, 0.7*N), N-1, N)
        v = @inferred rand(V{N,T})
        @test v isa V{N,T} && isvalid(v)
    end
end

@testset "broadcast" begin
    N = 8
    for V in VS, T in (Int, Float64), m in (0, 1, 3, 8)
        u = collect(T, 1:m)
        v = V{N}(u)
        c = T(2)
        uu = m < N ? push!(copy(u), c) : copy(u)
        vv = SmallVector{N}(uu)
        w = @test_inferred v .+ v u .+ u SmallVector{N,T}
        @test isvalid(w)
        w = @test_inferred v .- v u .- u SmallVector{N,T}
        @test isvalid(w)
        w = @test_inferred v .* v u .* u SmallVector{N,T}
        @test isvalid(w)
        w = @test_inferred (c .* v) (c .* u) SmallVector{N,T}
        @test isvalid(w)

        w = abs.(-v)
        @test w == v && w isa SmallVector{N,T} && isvalid(w)

        f(x, y) = x + 2*y
        # @test_inferred map(f, v, v) map(f, u, u) SmallVector{N,T}
        # @test_inferred map(f, vv, v) map(f, uu, u) SmallVector{N,T}
        w = f.(v, v)
        @test w == f.(u, u) && w isa SmallVector{N,T}
        w = f.(v, c)
        @test w == f.(u, c) && w isa SmallVector{N,T}

        w = @test_inferred (v .^ 2) (u .^ 2) SmallVector{N,T}
        @test isvalid(w)
        @test v .^ -2 == u .^ -2  # TODO: @test_inferred doesn't work
        @test isvalid(v .^ -2)

        w = @test_inferred (v .* Ref(v)) (u .* Ref(u)) SmallVector{N,SmallVector{N,T}}
        @test isvalid(w)
    end

    for T in (Int16, Float32)
        if T <: Integer
            u1 = T[2, -1, 4, -3, 7]
            u2 = T[-3, 9, 4, -1, -5, 6]
        else
            u1 = 10 .* rand(T, 5) .- 5
            u2 = 10 .* rand(T, 6) .- 5
        end
        v1 = SmallVector{8,T}(u1)
        v2 = SmallVector{8,T}(u2)
        for f in (+, -, *, /, ==, !=, <, >, <=, >=, ===, isequal)
            ww = map(f, u1, u2)
            w = @test_inferred map(f, v1, v2) ww SmallVector{8,eltype(ww)}
            @test isvalid(w)
        end
        for f in (round, floor, ceil, trunc, abs, abs2, sign, sqrt, signbit)
            if f === sqrt
                uu = map(abs, u1)
                vv = map(abs, v1)
                ww = map(f, uu)
                w = @test_inferred map(f, vv) ww SmallVector{8,eltype(ww)}
                @test isvalid(w)
            else
                ww = map(f, u1)
                w = @test_inferred map(f, v1) ww SmallVector{8,eltype(ww)}
                @test isvalid(w)
            end
        end
        T <: Integer || continue
        for f in (&, |, xor, nand, nor)
            w = @test_inferred map(f, v1, v2) map(f, u1, u2) SmallVector{8,T}
            @test isvalid(w)
        end
        for f in (~,)
            w = @test_inferred map(f, v1) map(f, u1) SmallVector{8,T}
            @test isvalid(w)
        end
    end

    for V in VS
        u = [7, 8]
        v = V{3}(u)
        a = [1 2; 3 4]
        @test a .+ v == a .+ u

        u = ['a', 'b', 'c']
        v = V{5}(u)
        w = v .* 'x'
        @test w == u .* 'x' && w isa SmallVector{5,String}
    end
end

#
# small sets
#

export AbstractSmallSet, SmallSet, MutableSmallSet, capacity,
    push, pop, delete, sum_fast, extrema_fast

import Base: show, copy, length, iterate, values, in, empty, empty!,
    push!, pop!, delete!, filter!, filter,
    union!, intersect!, setdiff!, symdiff!,
    union, intersect, setdiff, symdiff

"""
    AbstractSmallSet{N,T} <: AbstractSet{T}

This is the supertype of `SmallSet{N,T}` and `MutableSmallSet{N,T}`.

See also [`SmallSet`](@ref), [`MutableSmallSet`](@ref).
"""
abstract type AbstractSmallSet{N,T} <: AbstractSet{T} end

"""
    SmallSet{N,T} <: AbstractSmallSet{N,T}

    SmallSet{N,T}()
    SmallSet{N,T}(itr; unique = itr isa AbstractSet)

An immutable set with element type `T` that can store up to `N` entries.
All entries come from the iterator `itr` provided at construction time.

If the element type is omitted, it will be inferred from the iterator, if possible.
If `unique` is set to `true`, then the elements of `itr` are assumed to be distinct.

See also [`AbstractSmallSet`](@ref), [`MutableSmallSet`](@ref).
"""
struct SmallSet{N,T} <: AbstractSmallSet{N,T}
    d::SmallDict{N,T,Nothing}
    SmallSet(::Nothing, d::AbstractSmallDict{N,T,Nothing}) where {N,T} = new{N,T}(d)
end

_SmallSet(d) = SmallSet(nothing, d)

"""
    MutableSmallSet{N,T} <: AbstractSmallSet{N,T}

    MutableSmallSet{N,T}()
    MutableSmallSet{N,T}(itr; unique = itr isa AbstractSet)

A set with element type `T` that can store up to `N` entries.
The set is mutable and implements Julia's set interface.

If the element type is omitted, it will be inferred from the iterator, if possible.
If `unique` is set to `true`, then the elements of `itr` are assumed to be distinct.

See also [`AbstractSmallSet`](@ref), [`SmallSet`](@ref).
"""
struct MutableSmallSet{N,T} <: AbstractSmallSet{N,T}
    d::MutableSmallDict{N,T,Nothing}
    MutableSmallSet(::Nothing, d::AbstractSmallDict{N,T,Nothing}) where {N,T} = new{N,T}(d)
end

_MutableSmallSet(d) = MutableSmallSet(nothing, d)

function SmallSet{N,T}(itr; unique = itr isa Union{AbstractSet,OrdinalRange}) where {N,T}
    if unique
        keys = SmallVector{N,T}(itr)
        vals = SmallVector(default(FixedVector{N,Nothing}), length(keys))
        d = SmallDict(keys, vals)
    elseif itr isa Tuple
        d = SmallDict{N,T,Nothing}(map(x -> x => nothing, itr))
    else
        d = SmallDict{N,T,Nothing}(x => nothing for x in itr)
    end
    _SmallSet(d)
end

SmallSet{N,T}(s::AbstractSmallSet; unique = false) where {N,T} =
    _SmallSet(SmallDict{N,T,Nothing}(s.d))

function MutableSmallSet{N,T}(itr; unique = itr isa Union{AbstractSet,OrdinalRange}) where {N,T}
    if unique
        keys = MutableSmallVector{N,T}(itr)
        vals = MutableSmallVector{N,Nothing}(undef, length(keys))
        d = MutableSmallDict(keys, vals)
    else
        d = MutableSmallDict{N,T,Nothing}(x => nothing for x in itr)
    end
    _MutableSmallSet(d)
end

MutableSmallSet{N,T}(s::AbstractSmallSet; unique = false) where {N,T} =
    _MutableSmallSet(MutableSmallDict{N,T,Nothing}(s.d))

function (::Type{S})(itr::I; kw...) where {N,S<:AbstractSmallSet{N},I}
    Base.IteratorEltype(I) isa Base.HasEltype || error("cannot determine element type")
    T = element_type(I)
    S{T}(itr; kw...)
end

(::Type{S})() where {N,T,S<:AbstractSmallSet{N,T}} = S((); unique = true)

SmallSet(s::AbstractSmallSet{N,T}) where {N,T} = SmallSet{N,T}(s)
MutableSmallSet(s::AbstractSmallSet{N,T}) where {N,T} = MutableSmallSet{N,T}(s)

function show(io::IO, s::S) where {N, T, S <: AbstractSmallSet{N,T}}
    print(io, S <: SmallSet ? "SmallSet" : "MutableSmallSet")
    print(io, '{', N)
    if isempty(s)
        print(io, ", ", T, "}()")
    else
        print(io, "}(")
        (isconcretetype(T) && (T == Int || !(T <: Signed))) || get(io, :typeinfo, Any) == S || print(io, T)
        print(io, '[')
        for (i, x) in enumerate(s)
            i == 1 || print(io, ", ")
            show(io, x)
        end
        print(io, "])")
    end
end

"""
    capacity(::Type{<:AbstractSmallSet}) -> Int
    capacity(d::AbstractSmallSet) -> Int

Return the largest number of elements the given dictionary type can hold.
"""
capacity(::Type{<:AbstractSmallSet}),
capacity(::AbstractSmallSet)

capacity(::Type{<:AbstractSmallSet{N}}) where N = N

copy(s::SmallSet) = s
copy(s::MutableSmallSet) = MutableSmallSet(s)

length(s::AbstractSmallSet) = length(s.d)

iterate(s::AbstractSmallSet, state...) = iterate(s.d.keys, state...)

"""
    values(s::AbstractSmallSet{N,T}) where {N,T} -> SmallVector{N,T}

Return the values of the set `s` as a `SmallVector`.
"""
values(s::AbstractSmallSet) = keys(s.d)

Base.hasfastin(::Type{S}) where S <: AbstractSmallSet = Base.hasfastin(fieldtype(S, :d))

in(x, s::AbstractSmallSet) = haskey(s.d, x)

"""
    empty(s::AbstractSmallSet{N,T}) where {N,T} -> AbstractSmallSet{N,T}
    empty(s::AbstractSmallSet{N,T}, U::Type) where {N,T,U} -> AbstractSmallSet{N,U}

Return an empty `AbstractSmallSet` with the same capacity as `s`,
and with element type changed to `U` if so specified.
The resulting dictionary is mutable if and only if `s` is so.
"""
empty(::AbstractSmallSet),
empty(::AbstractSmallSet, ::Type)

empty(s::SmallSet{N,T}, ::Type{U} = T) where {N,T,U} = SmallSet{N,U}()
empty(s::MutableSmallSet{N,T}, ::Type{U} = T) where {N,T,U} = MutableSmallSet{N,U}()

Base.copymutable(s::AbstractSmallSet) = MutableSmallSet(s)
Base.emptymutable(s::AbstractSmallSet{N,T}, ::Type{U} = T) where {N,T,U} = MutableSmallSet{N,U}()

"""
    push(s::AbstractSmallSet{N,T}, xs...) where {N,T} -> Tuple{SmallSet{N,T}, T}

Return the set that is obtained from `s` by adding the elements given as arguments.

See also `Base.push!`.
"""
function push(s::AbstractSmallSet, xs::Vararg{Any,M}) where M
    _SmallSet(push(s.d, map(x -> x => nothing, xs)...))
end

"""
    delete(s::AbstractSmallSet{N,T}, x) where {N,T} -> SmallSet{N,T}

Remove the element `x` from `s` (if it exists) and return the new set.

See also `Base.delete!`, [`pop`](@ref pop(::AbstractSmallSet, ::Any)).
"""
delete(s::AbstractSmallSet, x) = _SmallSet(delete(s.d, x))

"""
    pop(s::AbstractSmallSet{N,T}) where {N,T} -> Tuple{SmallSet{N,T}, T}

Remove an element `x` from `s` and return the new set together with `x`.
The set `s` must not be empty.

See also `Base.pop!`.
"""
function pop(s::AbstractSmallSet)
    d, kv = pop(s.d)
    _SmallSet(d), first(kv)
end

"""
    pop(s::AbstractSmallSet{N,T}, x) where {N,T} -> Tuple{SmallSet{N,T}, T}

Remove the element `x` from `s` and return the new set together with the stored element equal to `x`.

See also `Base.pop!`, [`delete`](@ref delete(::AbstractSmallSet, ::Any)).
"""
function pop(s::AbstractSmallSet, x)
    i = token(s.d, x)
    i === nothing && keyerror(x)
    d, kv = unsafe_pop(s.d, i)
    _SmallSet(d), first(kv)
end

"""
    pop(s::AbstractSmallSet{N,T}, x, default::U) where {N,T,U} -> Tuple{SmallSet{N,T}, Union{T,U}}

If `s` has the element `x`, remove it and return the new set together with the stored element equal to `x`.
Otherwise return the tuple `(SmallSet(d), default)`.

See also `Base.pop!`.
"""
function pop(s::AbstractSmallSet, x, default)
    i = token(s.d, x)
    i === nothing && return SmallSet(s), default
    d, kv = unsafe_pop(s.d, i)
    _SmallSet(d), first(kv)
end

"""
    filter(f, v::AbstractSmallSet; [style::MapStyle])
    filter!(f, v::MutableSmallSet; [style::MapStyle])

With an `AbstractSmallSet` `s` as second argument, these functions accept
the additional keyword argument `style`. If it equals `LazyStyle()`, then the
function `f` is only evaluated until the result has been determined. For any
other value of `style`, `f` is evaluated on all elements of `s` as well as on
the default values used for padding. This is often faster for simple functions.

As discussed under `MapStyle`, the default value for `style` is based on a list
of known functions.

See also [`$(@__MODULE__).default`](@ref), [`$(@__MODULE__).MapStyle`](@ref).
"""
filter(f, s::AbstractSmallSet),
filter!(f, s::MutableSmallSet)

filter(f::F, s::AbstractSmallSet{N}; kw...) where {F,N} = SmallSet{N}(filter(f, values(s); kw...); unique = true)

function replace(s::AbstractSmallSet, ps::Vararg{Pair,M}; kw...) where M
    qs = map(p -> (p[1] => nothing) => (p[2] => nothing), ps)
    _SmallSet(replace(s.d, qs...; kw...))
end

empty!(s::MutableSmallSet) = (@inline empty!(s.d); s)

function push!(s::MutableSmallSet, xs...)
    @inline push!(s.d, map(x -> x => nothing, xs)...)
    s
end

delete!(s::MutableSmallSet, x) = (@inline(delete!(s.d, x)); s)

pop!(s::MutableSmallSet) = first(pop!(s.d))

function pop!(s::MutableSmallSet, x)
    i = token(s.d, x)
    i === nothing && keyerror(x)
    first(unsafe_pop!(s.d, i))
end

function pop!(s::MutableSmallSet, x, default)
    i = token(s.d, x)
    i === nothing && return default
    first(unsafe_pop!(s.d, i))
end

function filter!(f::F, s::MutableSmallSet; kw...) where F
    @inline
    filter!(f, s.d.keys; kw...)
    resize!(s.d.vals, length(s.d.keys))
    s
end

function replace!(s::MutableSmallSet, ps::Vararg{Pair,M}; kw...) where M
    qs = map(p -> (p[1] => nothing) => (p[2] => nothing), ps)
    replace!(s.d, qs...; kw...)
    s
end

function smallset_union!(s::MutableSmallSet, t)
    for x in t
        @inline push!(s, x)
    end
    s
end

function smallset_intersect!(s::MutableSmallSet, t)
    if Base.hasfastin(t)
        @inline filter!(in(t), s)
    else
        u = copy(s)
        @inline empty!(s)
        for x in t
            x in u && @inline push!(s, x)
        end
    end
    s
end

function smallset_setdiff!(s::MutableSmallSet, t)
    if Base.hasfastin(t) && length(s) < 2*length(t)
        @inline filter!(!in(t), s)
    else
        for x in t
            @inline delete!(s, x)
        end
        s
    end
end

function smallset_symdiff!(s::MutableSmallSet, t)
    for x in t
        @inline(pop!(s, x, Void())) isa Void && @inline(push!(s, x))
    end
    s
end

for g in (:union, :intersect, :setdiff, :symdiff)
    g! = Symbol(g, '!')
    gsmall = Symbol("smallset_", g!)
    if g in (:intersect, :setdiff)
        def_u = :(u = MutableSmallSet(s))
    else
        def_u = :(U = promote_type(T, eltype(t)); u = MutableSmallSet{N,U}(s))
    end
    # we need both methods for g! to avoid method ambiguities
    @eval $g!(s::MutableSmallSet, t) = @inline $gsmall(s, t)
    @eval $g!(s::MutableSmallSet, t::AbstractSet) = @inline $gsmall(s, t)
    @eval function $g(s::AbstractSmallSet{N,T}, t) where {N,T}
        isbitstype(T) || error("not implemented") # TODO
        $def_u
        @inline $g!(u, t)
        SmallSet(u)
    end
end

for g in (:sum, :prod, :minimum, :maximum, :extrema)
    @eval $g(s::AbstractSmallSet; kw...) = $g(values(s); kw...)
    @eval $g(f::F, s::AbstractSmallSet; kw...) where F = $g(f, values(s); kw...)
end

"""
    sum_fast(s::AbstractSmallSet{N,T}; [init]) where {N,T}

Return the `@fastmath` sum of the elements of `s`.
Unlike for `sum`, the default return value always has the element type of `s`, even
for small bit integers. This can be changed by supplying an `init` keyword argument.

See also `Base.sum`, `Base.@fastmath`.
"""
sum_fast(s::AbstractSmallSet; kw...) = sum_fast(values(s); kw...)

"""
    extrema_fast(s::AbstractSmallSet; [init])

Return the `@fastmath` minimum and maximum of the elements of `s`.
The `init` keyword argument may not be used.

See also `Base.extrema`, `Base.@fastmath`.
"""
extrema_fast(s::AbstractSmallSet; kw...) = extrema_fast(values(s); kw...)

function Random.rand(rng::AbstractRNG, ::SamplerType{SmallSet{N,T}}) where {N,T}
    _SmallSet(rand(rng, SmallDict{N,T,Nothing}))
end

function Random.rand(rng::AbstractRNG, ::SamplerType{MutableSmallSet{N,T}}) where {N,T}
    _MutableSmallSet(rand(rng, MutableSmallDict{N,T,Nothing}))
end

using SmallCollections: bitsize

function checkvalue(::Type{Bool}, N, x::T) where T
    @assert bitsize(T) >= N
    if bitsize(T) == N
        true
    elseif T <: Signed
        -one(T) << (N-1) <= x < one(T) << (N-1)
    else
        x < one(T) << N
    end
end

function packed_rand(N, T)
    if T <: Unsigned || T == Bool
        rand(T(0):T(BigInt(2)^N-1))
    else
        rand(T(-BigInt(2)^(N-1)):T(BigInt(2)^(N-1)-1))
    end
end

packed_rand(N, T, n) = T[packed_rand(N, T) for _ in 1:n]

@testset "PackedVector" begin
    for T in (Bool, Int8, UInt16, Int64, UInt128), N in (1, 2, 5, 8, max(1, bitsize(T)÷2-1), bitsize(T)), U in (UInt8, UInt32, UInt64, UInt128)
        if bitsize(T) < N
            @test_throws Exception PackedVector{U,N,T}()
            continue
        end
        c = bitsize(U)÷N
        c == 0 && continue
    for m in (0, 1, round(Int, 0.7*c), c-1, c)
        u = packed_rand(N, T, m)
        v = @inferred PackedVector{U,N,T}(u)
        @test v === @inferred copy(v)
        @test_inferred capacity(v) c Int
        @test_inferred v == u true
        @test isvalid(v)
        @test_inferred collect(v) u Vector{T}
        v2 = PackedVector{U,N,T}(u)
        @test_inferred v == v2 true
        if (N+1)*m <= bitsize(U) && N+1 <= bitsize(T)
            v3 = PackedVector{U,N+1,T}(u)
            @test_inferred v == v3 true
        end
        if !isempty(u)
            i = rand(1:m)
            x = packed_rand(N, T)
            while x == v[i]
                x = packed_rand(N, T)
            end
            v5 = setindex(v, x, i)
            @test_inferred v == v5 false
        end
        if m < c
            v6 = PackedVector{U,N,T}(push!(copy(u), packed_rand(N, T)))
            @test_inferred v == v6 false
        end
        if !isempty(u)
            u7 = copy(u)
            pop!(u7)
            v7 = PackedVector{U,N,T}(u7)
            @test_inferred v == v7 false
        end
        @test_inferred hash(v) hash(u) UInt
        if bitsize(U) < bitsize(UInt256)
            v1 = PackedVector{UInt256,N,T}(u)
            @test_inferred fasthash(v) fasthash(v1) UInt
        end
        let uu = map(x -> clamp(x, 0, BigInt(2)^(N-1)-1), u)
            w1 = PackedVector{U,N,signed(T)}(uu)
            w2 = PackedVector{U,N,unsigned(T)}(uu)
            @test_inferred fasthash(w1) fasthash(w2) UInt
        end
        @test_inferred length(v) length(u) Int
        @test_inferred PackedVector{U,N,T}() PackedVector{U,N,T}(())
        @test_inferred empty(v) PackedVector{U,N,T}()
        N <= bitsize(Int) && @test_inferred empty(v, Int) PackedVector{U,N,Int}()
    end
    end
end

@testset "PackedVector indices" begin
    for T in (Bool, Int8, UInt16, Int64, UInt128), N in (1, 2, 5, 8, max(1, bitsize(T)÷2-1), bitsize(T)), U in (UInt8, UInt32, UInt64, UInt128)
        bitsize(T) < N && continue
        c = bitsize(U)÷N
        c == 0 && continue
    for m in (0, 1, round(Int, 0.7*c), c-1, c)
        u = packed_rand(N, T, m)
        v = @inferred PackedVector{U,N,T}(u)
        if isempty(u)
            @test_throws Exception first(v)
            @test_throws Exception last(v)
        else
            @test_inferred first(v) first(u) T
            @test_inferred last(v) last(u) T
        end
        x = packed_rand(N, T)
        for i in -1:length(u)+1
            if 1 <= i <= length(u)
                @test_inferred v[i] u[i] T
                w = @test_inferred setindex(v, x, i) setindex!(copy(u), x, i) v
                @test isvalid(w)
            else
                @test_throws Exception v[i]
                @test_throws Exception setindex(v, x, i)
            end
        end
        for i in 0:m, j in i-1:m+1
            if checkbounds(Bool, u, i:j)
                w = @test_inferred v[i:j] u[i:j] v
                @test isvalid(w)
            else
                @test_throws Exception v[i:j]
            end
        end
    end
    end
end

@testset "PackedVector bool inds" begin
    for T in (Bool, Int32), M in (1, 8, max(1, bitsize(T)÷2-1), bitsize(T)), U in (UInt8, UInt32, UInt64)
        bitsize(T) < M && continue
        N = bitsize(U)÷M
        N == 0 && continue
    for m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = packed_rand(M, T, m)
        v = PackedVector{U,M,T}(u)

        if m > 0
            jj = rand(Bool, m-1)
            iis = Any[SmallVector{N+2}(jj), PackedVector{UInt64,1,Bool}(jj)]
            m > 1 && pushfirst!(iis, FixedVector{m-1}(jj))
            for ii in iis
                @test_throws Exception v[ii]
            end
        end

        jj = rand(Bool, m)
        iis = Any[SmallVector{N+2}(jj), PackedVector{UInt64,1,Bool}(jj)]
        m > 0 && pushfirst!(iis, FixedVector{m}(jj))
        for ii in iis
            @test_inferred v[ii] u[jj] v
        end
    end
    end
end

@testset "PackedVector vec inds" begin
    for T in (Bool, Int32), M in (1, 8, max(1, bitsize(T)÷2-1), bitsize(T)), U in (UInt8, UInt32, UInt64)
        bitsize(T) < M && continue
        N = bitsize(U)÷M
        N == 0 && continue
    for m in (0, 1, round(Int, 0.7*N), N-1, N)
        u = packed_rand(M, T, m)
        v = PackedVector{U,M,T}(u)

        ii = 1:max(0, m-2)
        @test_inferred v[ii] u[ii] v
        ii = collect(ii)
        @test_inferred v[ii] u[ii] Vector{T}

        m > 0 || continue

        let M = 7
            jj = rand(Int8(1):Int8(m), M)
            ii = jj
            @test_inferred v[ii] u[ii] u
            ii = FixedVector{M}(jj)
            @test_inferred v[ii] u[ii] FixedVector{M,T}
            ii = SmallVector{M+1}(jj)
            @test_inferred v[ii] u[ii] SmallVector{M+1,T}
            ii = PackedVector{UInt128,9,Int16}(jj)
            @test_inferred v[ii] u[ii] u
            ii = 2:min(m, 5)
            @test_inferred v[ii] u[ii] v
            ii = 1:2:min(m, 7)
            @test_inferred v[ii] u[ii] v
        end
    end
    end
end

@testset "PackedVector zeros" begin
    for T in (Bool, Int8, UInt16, Int64, UInt128), N in (1, 2, 5, 8, max(1, bitsize(T)÷2-1), bitsize(T)), U in (UInt8, UInt32, UInt64, UInt128)
        bitsize(T) < N && continue
        c = bitsize(U)÷N
        c == 0 && continue
    for m in (0, 1, round(Int, 0.7*c), c-1, c)
        u = zeros(T, m)
        v = PackedVector{U,N,T}(u)
        @test_inferred iszero(v) true
        w = @test_inferred zero(v) u v
        @test isvalid(w)
        w = @test_inferred zeros(PackedVector{U,N,T}, m) v
        @test isvalid(w)
        T <: Signed && N == 1 && continue
        w = @test_inferred ones(PackedVector{U,N,T}, m) ones(T, m) PackedVector{U,N,T}
        @test isvalid(w)
    end
    end
end

@testset "PackedVector push/pop" begin
    for T in (Bool, Int8, UInt16, Int64, UInt128),
            N in (1, 2, 5, 8, max(1, bitsize(T)÷2-1), bitsize(T)),
            U in (UInt8, UInt32, UInt64, UInt128)
        bitsize(T) < N && continue
        c = bitsize(U)÷N
        c == 0 && continue
    for m in (0, 1, round(Int, 0.7*c), c-1, c)
        u = packed_rand(N, T, m)
        v = @inferred PackedVector{U,N,T}(u)
        x = packed_rand(N, T)
        y = packed_rand(N, T)
        @test_inferred push(v) v
        @test_inferred pushfirst(v) v
        if length(u) == c
            @test_throws Exception push(v, x)
            @test_throws Exception push(v, x, y)
            @test_throws Exception pushfirst(v, x)
            @test_throws Exception pushfirst(v, x, y)
        else
            w = @test_inferred push(v, x) push!(copy(u), x) v
            @test isvalid(w)
            w = @test_inferred pushfirst(v, x) pushfirst!(copy(u), x) v
            @test isvalid(w)
            if length(u) <= c-2
                w = @test_inferred push(v, x, y) push(push(v, x), y)
                @test isvalid(w)
                w = @test_inferred pushfirst(v, x, y) pushfirst(pushfirst(v, y), x)
                @test isvalid(w)
            end
        end
        if isempty(u)
            @test_throws Exception pop(v)
            @test_throws Exception popfirst(v)
        else
            w, _ = @test_inferred pop(v) (deleteat!(copy(u), length(u)), last(u)) (v, last(v))
            @test isvalid(w)
            w, _ = @test_inferred popfirst(v) (deleteat!(copy(u), 1), first(u)) (v, first(v))
            @test isvalid(w)
        end
        for i in (-1, 0, 1, 2, length(u), length(u)+1)
            if 1 <= i <= length(u)+1 && length(u) < c
                w = @test_inferred insert(v, i, x) insert!(copy(u), i, x) v
                @test isvalid(w)
                if i <= length(u)
                    w = @test_inferred duplicate(v, i) insert(v, i, v[i])
                    @test isvalid(w)
                else
                    @test_throws Exception duplicate(v, i)
                end
            else
                @test_throws Exception insert(v, i, x)
                @test_throws Exception duplicate(v, i)
            end
            if 1 <= i <= length(u)
                w = @test_inferred deleteat(v, i) deleteat!(copy(u), i) v
                @test isvalid(w)
            else
                @test_throws Exception deleteat(v, i)
            end
        end
        @test_inferred append(v) v
        @test_inferred prepend(v) v
        xy = [x, y]
        if length(u) <= c-2
            w = @test_inferred append(v, PackedVector{U,N,T}(xy)) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred append(v, xy[i] for i in 1:2) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred append(v, (x,), [y]) push(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, PackedVector{U,N,T}(xy)) pushfirst(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, xy[i] for i in 1:2) pushfirst(v, x, y)
            @test isvalid(w)
            w = @test_inferred prepend(v, (x,), [y]) pushfirst(v, x, y)
            @test isvalid(w)
        else
            @test_throws Exception append(v, PackedVector{U,N,T}(xy))
            @test_throws Exception append(v, xy[i] for i in 1:2)
            @test_throws Exception append(v, (x,), [y])
            @test_throws Exception prepend(v, PackedVector{U,N,T}(xy))
            @test_throws Exception prepend(v, xy[i] for i in 1:2)
            @test_throws Exception prepend(v, (x,), [y])
        end
        if T <: Integer
            @test_inferred filter(isodd, v) filter(isodd, u) v
        end
    end
    end
end

@testset "PackedVector circshift" begin
    for U in (UInt8, UInt16, UInt32, UInt64, UInt128),
            T in (Int8, UInt8, Int16, UInt16, Int32, UInt32),
            N in 1:3:bitsize(T)
        c = bitsize(U)÷N
        c == 0 && continue
        for n in 0:4:c
            w = packed_rand(N, T, n)
            v = PackedVector{U,N,T}(w)
            for k in (-2*c, -2*c+1, -3, -1, 0, 1, 7, c+5, 2*c+7)
                @test_inferred circshift(v, k) circshift(w, k) v
                @test isvalid(circshift(v, k))
            end
        end
    end
end

function red_mod(N, v::AbstractVector{T}) where T <: Integer
    k = bitsize(T)-N
    map(x -> (x << k) >> k, v)
end

@testset "PackedVector add/mul" begin
    for U in (UInt8, UInt16, UInt32, UInt64, UInt128),
            T in (Int8, UInt8, Int16, UInt16, Int32, UInt32),
            N in 1:bitsize(T)
        c = bitsize(U)÷N
        c == 0 && continue
        for n in 0:c
            u1 = packed_rand(N, T, n)
            v1 = PackedVector{U,N,T}(u1)
            u2 = packed_rand(N, T, n)
            v2 = PackedVector{U,N,T}(u2)
            w = @test_inferred +v1 red_mod(N, +u1) v1
            @test isvalid(w)
            w = @test_inferred -v1 red_mod(N, -u1) v1
            @test isvalid(w)
            w = @test_inferred v1+v2 red_mod(N, u1+u2) v1
            @test isvalid(w)
            w = @test_inferred v1-v2 red_mod(N, u1-u2) v1
            @test isvalid(w)
            cc = packed_rand(N, T)
            w = @test_inferred cc*v1 red_mod(N, cc*u1) v1
            @test isvalid(w)
            for i in -1:length(u1)+1
                x = packed_rand(N, T)
                if checkbounds(Bool, u1, i) && checkvalue(Bool, N, u1[i]+x)
                    w = @test_inferred addindex(v1, x, i) setindex!(copy(u1), u1[i]+x, i) v1
                    @test isvalid(w)
                else
                    @test_throws Exception addindex(v1, x, i)
                end
            end
        end
    end
end

@testset "PackedVector sum/max" begin
    for U in (UInt8, UInt16, UInt32, UInt64, UInt128),
        T in (Bool, Int8, UInt8, Int16, UInt16, Int32, UInt32),
        N in 1:bitsize(T)
        c = bitsize(U)÷N
        c == 0 && continue
        for n in 0:c
            u = packed_rand(N, T, n)
            v = PackedVector{U,N,T}(u)
            @test_inferred sum(v) sum(u)
            for f in (maximum, minimum)
                if isempty(u)
                    @test_throws Exception f(v)
                    @test_inferred f(v; init = zero(T)) f(u; init = zero(T))
                else
                    @test_inferred f(v) f(u)
                end
            end
        end
    end
end

@testset "PackedVector rest" begin
    v = PackedVector{UInt64,4,Int16}(1:2)
    w..., = v
    @test w == v && typeof(w) == typeof(v) && isvalid(w)
    x1, w... = v
    @test w == v[2:end] && typeof(w) == typeof(v) && isvalid(w)
    x1, x2, w... = v
    @test w == v[3:end] && typeof(w) == typeof(v) && isvalid(w)
    @test_throws Exception x1, x2, x3, w... = v

    if VERSION >= v"1.9"
        v = PackedVector{UInt32,5,UInt8}(1:3)
        w..., y1 = v
        @test w == v[1:end-1] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end]
        x1, w..., y1 = v
        @test w == v[2:end-1] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end]
        x1, x2, w..., y1 = v
        @test w == v[3:end-1] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end]
        @test_throws Exception x1, x2, x3, w..., y1 = v

        v = PackedVector{UInt128,7,Int32}(1:4)
        w..., y1, y2 = v
        @test w == v[1:end-2] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end-1] && y2 === v[end]
        x1, w..., y1, y2 = v
        @test w == v[2:end-2] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end-1] && y2 === v[end]
        x1, x2, w..., y1, y2 = v
        @test w == v[3:end-2] && typeof(w) == typeof(v) && isvalid(w) && y1 === v[end-1] && y2 === v[end]
        @test_throws Exception x1, x2, x3, w..., y1, y2 = v
    end
end

@testset "PackedVector support" begin
    for U in (UInt8, UInt32, UInt128), T in (Int8, UInt32), N in 1:bitsize(T)
        c = bitsize(U)÷N
        c == 0 && continue
        for m in 0:min(c, bitsize(UInt))
            u = T <: Unsigned ? rand(T(0):T(1), m) : rand(T(-1):T(0), m)
            v = @inferred PackedVector{U,N,T}(u)
            @test_inferred support(v) Set{Int}(i for i in 1:m if u[i] != 0) SmallBitSet
        end
    end
end

@testset "PackedVector rand" begin
    for U in (UInt8, UInt32, UInt128), T in (Bool, Int8, UInt32), M in 1:3:bitsize(T)
        c = bitsize(U)÷M
        c == 0 && continue
        v = @inferred rand(PackedVector{U,M,T})
        @test v isa PackedVector{U,M,T} && isvalid(v)
    end
end

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Small dictionaries](@id sec-abstractsmalldict)

```@docs
AbstractSmallDict
SmallDict
MutableSmallDict
capacity(::Type{<:AbstractSmallDict})
empty(::AbstractSmallDict)
setindex(::AbstractSmallDict, ::Any, ::Any)
invget
push(::AbstractSmallDict, ::Pair)
pop(::AbstractSmallDict)
pop(::AbstractSmallDict, ::Any)
pop(::AbstractSmallDict, ::Any, Any)
delete(::AbstractSmallDict, ::Any)
popmin
popmin!
findall(::Function, ::AbstractSmallDict)
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Small vectors](@id sec-smallvector)

```@docs
AbstractSmallVector
SmallVector
MutableSmallVector
capacity(::Type{<:AbstractSmallVector})
fixedvector(::AbstractSmallVector)
fixedvector(::AbstractSmallVector, ::Val)
bits(::AbstractSmallVector)
fasthash(::AbstractSmallVector, ::UInt)
unsafe_copyto!(::MutableSmallVector{N}, ::AbstractSmallVector{N}) where N
unsafe_copyto!(::MutableSmallVector, ::Union{NTuple, AbstractFixedVector})
resize
empty(::AbstractSmallVector)
getindex(::AbstractSmallVector, ::SmallBitSet)
setindex(::AbstractSmallVector, ::Any, ::Integer)
addindex(::AbstractSmallVector, ::Any, ::Integer)
push(::AbstractSmallVector, ::Vararg)
pop(::AbstractSmallVector)
pushfirst(::AbstractSmallVector, ::Vararg)
popfirst(::AbstractSmallVector)
insert(::AbstractSmallVector, ::Integer, ::Any)
duplicate(::AbstractSmallVector, ::Integer)
deleteat(::AbstractSmallVector, ::Integer)
popat(::AbstractSmallVector, ::Integer)
append(::AbstractSmallVector, ::Vararg)
prepend(::AbstractSmallVector, ::Vararg)
zeros(::Type{<:AbstractSmallVector}, ::Integer)
ones(::Type{<:AbstractSmallVector}, ::Integer)
sum_fast(::AbstractSmallVector)
dot_fast(::AbstractSmallVector, ::AbstractSmallVector)
extrema_fast(::AbstractSmallVector)
Base.Checked.checked_neg(::AbstractSmallVector)
Base.Checked.checked_add(::AbstractSmallVector, ::AbstractSmallVector...)
Base.Checked.checked_sub(::AbstractSmallVector, ::AbstractSmallVector)
Base.Checked.checked_mul(::Integer, ::AbstractSmallVector)
Base.Checked.add_with_overflow(::AbstractSmallVector, ::AbstractSmallVector)
Base.Checked.sub_with_overflow(::AbstractSmallVector, ::AbstractSmallVector)
Base.Checked.mul_with_overflow(::Integer, ::AbstractSmallVector)
any(::Function, ::AbstractSmallVector)
issorted(::AbstractSmallVector)
map
support(::AbstractSmallVector)
support(::Any, ::AbstractSmallVector)
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Small sets](@id sec-abstractsmallset)

```@docs
AbstractSmallSet
SmallSet
MutableSmallSet
capacity(::Type{<:AbstractSmallSet})
empty(::AbstractSmallSet)
values(::AbstractSmallSet)
push(::AbstractSmallSet, ::Pair)
pop(::AbstractSmallSet)
pop(::AbstractSmallSet, ::Any)
pop(::AbstractSmallSet, ::Any, Any)
delete(::AbstractSmallSet, ::Any)
sum_fast(::AbstractSmallSet)
extrema_fast(::AbstractSmallSet)
filter(::Any, ::AbstractSmallSet)
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Fixed-length vectors](@id sec-abstractfixedvector)

```@docs
AbstractFixedVector
FixedVector
MutableFixedVector
capacity(::Type{<:AbstractFixedVector})
fixedvector(::AbstractFixedVector)
fixedvector(::AbstractFixedVector, ::Val)
bits(::AbstractFixedVector)
convert(::Type{<:AbstractFixedVector}, ::Unsigned)
fasthash(::AbstractFixedVector, ::UInt)
setindex(::AbstractFixedVector, ::Any, ::Integer)
addindex(::AbstractFixedVector, ::Any, ::Integer)
circshift(::AbstractFixedVector, ::Union{Integer,Val})
circshift!(::MutableFixedVector, ::Union{Integer,Val})
sum_fast(::AbstractFixedVector)
dot_fast(::AbstractFixedVector, ::AbstractFixedVector)
extrema_fast(::AbstractFixedVector)
extrema_fast(::Any, ::AbstractFixedVector)
Base.Checked.checked_neg(::AbstractFixedVector)
Base.Checked.checked_add(::AbstractFixedVector, ::AbstractFixedVector...)
Base.Checked.checked_sub(::AbstractFixedVector, ::AbstractFixedVector)
Base.Checked.checked_mul(::Integer, ::AbstractFixedVector)
Base.Checked.add_with_overflow(::AbstractFixedVector, ::AbstractFixedVector)
Base.Checked.sub_with_overflow(::AbstractFixedVector, ::AbstractFixedVector)
Base.Checked.mul_with_overflow(::Integer, ::AbstractFixedVector)
any(::Function, ::AbstractFixedVector)
issorted(::AbstractFixedVector)
support(::AbstractFixedVector)
support(::Any, ::AbstractFixedVector)
StaticArrays.SVector
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Small bit sets](@id sec-smallbitset)

```@docs
SmallBitSet
bits(::SmallBitSet)
convert(::Type{SmallBitSet}, ::Integer)
capacity(::Type{<:SmallBitSet})
smallbitsettype
fasthash(::SmallBitSet, ::UInt)
empty(::SmallBitSet)
first_as_set
push(::SmallBitSet, ::Vararg)
pop(::SmallBitSet)
pop(::SmallBitSet, ::Any)
pop(::SmallBitSet, ::Any, ::Any)
delete(::SmallBitSet, ::Any)
exchange
invreplace
any(::Function, ::SmallBitSet)
checkbounds
```

## Orderings

The following orderings are available to compare one `SmallBitSet` to another.

```@docs
isless(::SmallBitSet, ::SmallBitSet)
SmallCollections.Lex
SmallCollections.Colex
SmallCollections.GradedLex
SmallCollections.GradedColex
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Broadcasting](@id sec-broadcasting)

All vector types defined by this package can participate in broadcasting.
Efficient implementations exist for `AbstractFixedVector` and `AbstractSmallVector`,
including broadcasted assignments to a `MutableFixedVector` or `MutableSmallVector`.
Without assignment, the result is a `FixedVector` if at least one argument is an
`AbstractFixedVector` and all remaining arguments (if any) are `Tuple`s or scalars.
The result is a `SmallVector` if at least one argument is an `AbstractSmallVector`
and all remaining arguments (if any) are scalars. Otherwise Julia's generic broadcasting
method applies. The capacity of a resulting `SmallVector` is the minimum of the
capacities of the `AbstractSmallVector` arguments.

See also [`map`](@ref), [`capacity`](@ref capacity(::Type{<:AbstractSmallVector})),
[`SmallCollections.FixedVectorStyle`](@ref), [`SmallCollections.SmallVectorStyle`](@ref).

### Examples
```jldoctest
julia> v = MutableSmallVector{8}(1:3); w = SmallVector{6}(2:4); v .* w .- 1.0
3-element SmallVector{6, Float64}:
  1.0
  5.0
 11.0

julia> v .+= 3 .* w
3-element MutableSmallVector{8, Int64}:
  7
 11
 15

julia> v = FixedVector{3}(1:3); t = (2, 3, 4); v .* t
3-element FixedVector{3, Int64}:
  2
  6
 12

julia> v = SmallVector{8}('a':'c'); w = SmallVector{4}('p':'r'); uppercase.(v .* w .* 'x')
3-element SmallVector{4, String}:
 "APX"
 "BQX"
 "CRX"
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# [BangBang support](@id sec-bangbang)

If the package [`BangBang.jl`](https://github.com/JuliaFolds2/BangBang.jl)
is loaded, then the functions
`push`,
`pop` and
`delete`
for `SmallDict`, `SmallSet` and `SmallBitSet`,
`union`,
`intersect`,
`setdiff` and
`symdiff`
for `SmallSet` and `SmallBitSet` as well as
[`setindex`](@ref setindex(::AbstractSmallVector, ::Any, ::Integer)),
[`push`](@ref push(::AbstractSmallVector, ::Vararg)),
[`pushfirst`](@ref pushfirst(::AbstractSmallVector, ::Vararg)),
[ `pop`](@ref pop(::AbstractSmallVector)),
[`popfirst`](@ref popfirst(::AbstractSmallVector)),
[`deleteat`](@ref deleteat(::AbstractSmallVector, ::Integer)) and
[`append`](@ref append(::AbstractSmallVector, ::Vararg))
for `AbstractSmallVector` as well as `PackedVector`
are also available in `!!`-form.
For example, `setindex!!` with a `SmallVector` as first argument calls `setindex`.
(`BangBang.jl` does not define `insert!!`, `prepend!!`, `filter!!` and `map!!`.)
Moreover, `add!!(v, w)` is a synonym for `v+w` for the immutable vector types defined by this package.

This allows to write efficient code that works for both mutable and immutable arguments.
For example, the function
```julia
f!!(v, ws...) = foldl(add!!, ws; init = v)
```
adds up its arguments, mutating the first argument `v` if possible.

```@meta
DocTestSetup = :(using SmallCollections)
```

# [Packed vectors](@id sec-packedvector)

```@docs
PackedVector
capacity(::Type{<:PackedVector})
bits(::PackedVector)
fasthash(::PackedVector, ::UInt)
empty(::PackedVector)
getindex(::PackedVector, ::SmallBitSet)
setindex(::PackedVector, ::Any, ::Integer)
addindex(::PackedVector, ::Any, ::Integer)
push(::PackedVector, ::Vararg)
pop(::PackedVector)
pushfirst(::PackedVector, ::Vararg)
popfirst(::PackedVector)
insert(::PackedVector, ::Integer, ::Any)
duplicate(::PackedVector, ::Integer)
deleteat(::PackedVector, ::Integer)
popat(::PackedVector, ::Integer)
append(::PackedVector, ::Vararg)
prepend(::PackedVector, ::Vararg)
zeros(::Type{<:PackedVector}, ::Integer)
ones(::Type{<:PackedVector}, ::Integer)
SmallCollections.unsafe_add
SmallCollections.unsafe_sub
support(::PackedVector)
```

```@meta
DocTestSetup = :(using SmallCollections)
```

# Non-exported names

## Public names

### Functionality for small and fixed vectors

```@docs
SmallCollections.default
SmallCollections.isfasttype
SmallCollections.MapStyle
SmallCollections.FixedVectorStyle
SmallCollections.SmallVectorStyle
SmallCollections.padtail
SmallCollections.getindex0
SmallCollections.unsafe_circshift
```

### Functionality for `SmallBitSet`

```@docs
SmallCollections.unsafe_delete
SmallCollections.unsafe_push
```

### Function wrappers

```@docs
SmallCollections.Inbounds
```

### Bit operations

```@docs
SmallCollections.bitsize
SmallCollections.unsafe_shl
SmallCollections.unsafe_lshr
SmallCollections.blsi
SmallCollections.blsr
SmallCollections.blsmsk
SmallCollections.pdep
SmallCollections.pext
```

## Internal names

These names are not public and may change in future versions.

```@docs
SmallCollections.element_type
SmallCollections.AbstractBitInteger
SmallCollections.top_set_bit
SmallCollections.hasshuffle
SmallCollections.shuffle
```
